Package: ChemmineR
Type: Package
Title: Cheminformatics Toolkit for R
Version: 3.52.0
Date: 2023-01-31
Author: Y. Eddie Cao, Kevin Horan, Tyler Backman, Thomas Girke
Maintainer: Thomas Girke <thomas.girke@ucr.edu>
Description: ChemmineR is a cheminformatics package for analyzing drug-like small molecule data in R. Its latest version contains functions for efficient processing of large numbers of molecules, physicochemical/structural property predictions, structural similarity searching, classification and clustering of compound libraries with a wide spectrum of algorithms. In addition, it offers visualization functions for compound clustering results and chemical structures.
License: Artistic-2.0
Depends: R (>= 2.10.0), methods
biocViews: Cheminformatics, BiomedicalInformatics, Pharmacogenetics,
        Pharmacogenomics, MicrotitrePlateAssay, CellBasedAssays,
        Visualization, Infrastructure, DataImport, Clustering,
        Proteomics,Metabolomics
Imports: rjson, graphics, stats, RCurl, DBI, digest, BiocGenerics, Rcpp
        (>= 0.11.0), ggplot2,grid,gridExtra,
        png,base64enc,DT,rsvg,jsonlite,stringi
Suggests: RSQLite, scatterplot3d, gplots, fmcsR, snow, RPostgreSQL,
        BiocStyle, knitr, knitcitations, knitrBootstrap, ChemmineDrugs,
        png,rmarkdown, BiocManager,bibtex
Enhances: ChemmineOB
URL: https://github.com/girke-lab/ChemmineR
VignetteBuilder: knitr
LinkingTo: Rcpp, BH
SystemRequirements: GNU make
git_url: https://git.bioconductor.org/packages/ChemmineR
git_branch: RELEASE_3_17
git_last_commit: 444df16
git_last_commit_date: 2023-04-25
Date/Publication: 2023-04-25
NeedsCompilation: yes
Packaged: 2023-04-25 20:32:43 UTC; biocbuild

 ChemmineR is a cheminformatics package for analyzing drug-like small molecule data in R. Its latest version contains functions for efficient processing of large numbers of molecules, physicochemical/structural property predictions, structural similarity searching, classification and clustering of compound libraries with a wide spectrum of algorithms. In addition, it offers visualization functions for compound clustering results and chemical structures.

  ChemmineR is hosted on [Bioconductor](http://www.bioconductor.org) where you can find the [Release](http://www.bioconductor.org/packages/2.14/bioc/html/ChemmineR.html) version and the [Development](http://www.bioconductor.org/packages/devel/bioc/html/ChemmineR.html) version.

changelog
    
    version 2.29.4
        - fixed bug in aromaticity assignment
    
    version 2.23.5-2.29.3
        - various updates
    
    version 2.23.2 - 2.23.5
        - ported vignette to R Markdown
        - vignette updates

    version 2.15.17 - 2.21.7
        - biocViews updates

    version 2.15.15 - 2.15.16
        - fixed trailing character problem in importer

    version 2.13.21 - 2.15.15
        - various updates

	version 2.13.18 - 2.13.21
        - vignette updates
        
    version 2.13.17
        - introduced new SMIset class
        
	version 2.13.15 - 2.13.16
        - ChemmineOB functions
        
	version 2.13.13 - 2.13.14
        - vignette updates

    version 2.13.12
        - fixed atom align when writing SDFs
		- support for plotting other bond types than 1-3

    version 2.13.3 - 2.13.11
        - updates of SQLite database

	version 2.13.2
		- fixed but in SDF importer
	
	version 2.11.10
		- improved performance of jarvisPatrick function
	
	version 2.11.9
		- fixed bug in jarvisPatrick function with pre-generated NN matrix
	
	version 2.11.8
		- speed improvement of cmp.cluster with FPset objects
	
	version 2.11.7
		- fixed division by zero error in fpSim 
	
	version 2.11.6
		- fixed cmp.cluster support for FPset 

	version 2.11.5
		- added jarvisPatrick function
	
	version 2.11.4
		- vignette updates 
	
        version 2.11.2-2.11.3
		- added FP/FPset classes 
		- vignette updates 

	version 2.11.1
		- fixed read.AP 
	
	version 2.9.23
		- solved import problem with SciTegic SDFs
	
	version 2.9.22
		- groups function will now always return matrix
	
	version 2.9.21
		- support for restarting sdfStream at specific line position
 
	version 2.9.20
		- faster read.SDFindex by establishing a single file connection 

	version 2.9.17-2.9.19
		- vignette updates
		- added NEWS file
	
        version 2.9.16
		- atom pair fingerprint support
	
	version 2.9.15
		- improved exception/error handling of sdf2ap
                - added read.AP
	
        version 2.9.14
		- vignette updates

	version 2.9.13
		- added streaming functionality for SD files by adding sdfStream and read.SDFindex
		- updates to sdf2ap and validSDF
		- SD file parsing supports now bond strings with three digit atom numbers
	
	version 2.9.12
		- read.SDFstr accepts now character vector 
	
	version 2.9.11
		- added terminal nitriles and acetylenes to group function
	
	version 2.9.4-2.9.10
		- vignette changes
	
	version 2.9.3
		- added write.SDFsplit function
	
	version 2.9.2
		- fix for sdf2ap for molecules where no atom pairs can be returned by .gen_atom_pair 
	
	version 2.9.1
		- added support for substructure viewing

	version 2.7.2
		- updated 'atomsubset' function
	
        version 2.7.1
		- SDFset() constructor
        
	version 2.5.8
		- corrected sim.R file 
        
	version 2.5.7
		- updated 'atomsubset' function
	
	version 2.5.6
		- added 'atomsubset' function for returning substructure from SDF/SDFset

	version 2.5.5
		- Documentation updates

	version 2.5.4
		- added 'rings' function for ring perception and aromaticity assignment  
                - added 'groups' function for counting functional groups

	version 2.5.3
		- fixes for plotStruc/plot to show charges, disconnected
                  atoms and missing hydrogens of non-C atoms

	version 2.5.1 - 2.5.2
		- Utilities for adding missing hydrogens: includes new 'bonds' function
                  that is used by functions 'atomcount', 'MW', 'MF', 'atomcountMA'
		
        version 2.2.16 - 2.2.18
                - Added conMA function to create connection matrices
                - Documentation updates

        version 2.2.15
                - documentation updates
		- renamed searchSub() to searchSim()
		- wrapped web service code in man files with \dontrun{} 

	version 2.2.14
		- introduced support for ChemMine Web Tools including PubChem searches

        version 2.2.12 - 2.2.13
                - help file updates
                - fix for SDF import to support Drug Bank data
	
        version 2.2.0 - 2.2.11
		- added support for PubChem fingerprints
	
        version 2.1.5
		- added validSDF function

	version 2.1.4
		- minor bug fixes
	
        version 2.1.3
		- minor bug fixes
        
        version 2.1.2
		- minor bug fixes

	version 2.1.1
		- introduced S4 classes for all object types
		- added full support for processing SD files
		- added compound depictions with R's graphics device
	
	version 1.2.4
		- bug fix for 1.2.3

	version 1.2.3
		- enhance cluster visualization 

	version 1.2.2
		- minor bugfixes

	version 1.2.1
		- use ChemmineR Performance Pack (ChemmineRpp) when available

	version 1.1.1
		- updated Vignette
		- sdf.visualize now accepts dataframe for argument 'extra'
		- sdf.visualize now accepts names for reference.note
		- cluster.sizestat now handles clustering result with multiple cutoffs

	version 1.1.0
		- enhanced cluster.visualize
		- add db.subset

	version 1.0.9
		- check cmp.similarity arguments
		- improved compound visualization: now allow a reference compound
		- now search has built-in visualization

	version 1.0.8
		- sdf.visualize reads CIDs and allows extra description on
		  compounds
		- in cmp.cluster, is.similarity is now the default
		- db.explain now returns value rather than printing it
		- cluster.visualize now outputs to EPS and PDF

	version 1.0.7
		- document changes
		- add `quite' options to many functions
		- more robust parsing
		- better handling of progress messages

	version 1.0.6
		- add sdf.visualize

	version 1.0.5
		- use readLines instead of scan in parsing MOL table

	version 1.0.4
		- fix unclosed I/O connections

	version 1.0.3
		- add cmp.duplicated
		- rename 'cluster' to 'cmp.cluster'
		- column names of clustering result now contain no space
	
	version 1.0.2
		- cluster now accepts ... arguments for cmp.similarity

	version 1.0.1
		- add sdf.subset
		- add db.explain
		- add cluster.sizestat
		- add cluster.visualize

# db: the compound descriptor db. generated with cmp.parse(..)
# cutoff: cutoff used to build the clusters. Cutoff is the distance cutoff, not
# similarity cutoff. It can be a vector
# is.similarity: set when the cutoff is a similarity rather than a distance
# cutoff
# save.distance: whether to compute and save the distance matrix before
# clustering. It will prompt for a filename to save the distance matrix for
# future use.
# use.distance: the pre-computed distance matrix to use, if you have any.
# RETURN: a matrix giving the cluster ID for each compound in the db under
# different cutoffs. Each row corresponds to one compound, and each column
# corresponds to a cutoff

cmp.cluster <- function(db, cutoff, is.similarity=TRUE, save.distances=FALSE,
        use.distances=NULL, quiet=FALSE, ...)
{
    ## ThG: added for compatibility with new S4 classes APset/AP
    dbtype <- as.character(class(db))
    if(dbtype=="APset") { db <- apset2descdb(db) }
    if(dbtype=="FPset") { db <- list(descdb=as.list(as.data.frame(t(as.matrix(db)))), cids=cid(db), sdfsegs=NULL, source="FPset", type="FPset") }
    ## Note: 7-8 times better time performance if fingerprints are stored in list instead of matrix!!!
    ## ThG: end of lines
    
    # see if db if file-backed
    dbcon <- NULL
    intsize <- 4
    if (db$type == 'file-backed') {
        for (i in 1:length(db$descdb)) {
            if (.is.file.backed.desc(db$descdb[[i]])) {
                dbcon <- file(paste(db$descdb[[i]][[2]], '.cdb', sep=''), 'rb')
                seek(dbcon, 16)
                intsize <- readBin(dbcon, integer(), n=1, size=1)
                break
            }
        }
    }
    # prepare column names from cutoffs
    colname_f <- function(x) {paste("CLID_", x, collapse="", sep="")}
    colname <- apply(as.array(cutoff), 1, colname_f)
    o_colname <- colname

    # prepare cutoffs for real computation
    if (is.similarity)
        cutoff <- 1 - cutoff

    if (save.distances != FALSE) {
        distmat <- .calc.distmat(db$descdb, quiet=quiet, 
            dbcon.a=dbcon, dbcon.b=dbcon,
            db.intsize.a=intsize, db.intsize.b=intsize,
        ...)
        if ('character' %in% class(save.distances)) {
            save(distmat, file=save.distances)
        }
        distf <- function(i, j) {
            return(distmat[i, j])
        }
    }
    else if (! is.null(use.distances)) {
        distf <- function(i, j) {
            return(use.distances[i, j])
        }
    } 
    ## ThG: added to make function easier to use with new S4 classes APset/AP
    else if (db$type=="FPset") {
        distf <- function(i, j) {
            return(1-fpSim(db$descdb[[i]], db$descdb[[j]], top=1, ...))
        }
    ## ThG: end of lines
    } else {
        distf <- function(i,j) {
            args <- list(...)
            if (! is.null(args$worst) || ! is.null(args$mode))
                return(1 - .cmp.similarity(db$descdb[[i]], db$descdb[[j]], 
                        dbcon.a=dbcon, dbcon.b=dbcon,
                        db.intsize.a=intsize, db.intsize.b=intsize,
                        ...))
            else
                return(1 - .cmp.similarity(db$descdb[[i]], db$descdb[[j]], 
                        dbcon.a=dbcon, dbcon.b=dbcon,
                        db.intsize.a=intsize, db.intsize.b=intsize,
                        mode=1, worst=1 - cutoff[[1]], ...))
        }
    }
    if (!is.null(dbcon)) close(dbcon)

    # sort cutoffs decreasingly
    o <- order(cutoff, decreasing=TRUE)
    cutoff <- cutoff[o]
    colname <- colname[o]
    n_cutoff <- length(cutoff)
    # record of current clustering result
    cluster_id <- matrix(0, ncol=n_cutoff, nrow=length(db$descdb))
    colnames(cluster_id) <- colname

    # all nodes to label/cluster
    all <- 1:length(db$descdb)
    # for progress bar
    perstep <- round(length(db$descdb) / 100) + 1
    for (i in all) {
        # has i already been clustered?
        if (cluster_id[[i, 1]] != 0)
            next
        # else, use i as the lead to get all neighbors
        cluster_id <- .cluster_g(i, all, distf, cutoff, cluster_id, quiet=quiet)
        # progress bar
        ratio <- floor(sum(cluster_id[, 1] != 0) / perstep)
        if (! quiet) .progress_bar(paste(min(ratio, 100), "%", collapse=""))
    }
    cat("\n")

    cluster_id <- as.data.frame(cluster_id)
    cluster_id$ids <- 1:length(cluster_id[,1])
    # convert each column to factor; compute cluster size
    for(i in 1:n_cutoff) {
        col_label <- colname[[i]]
        # size
        clsize <- as.data.frame(table(cluster_id[,col_label]))
        # add column of cluster size
        cluster_id <- merge(cluster_id, clsize, by.x=col_label, by.y=1, all.x=T)
        names(cluster_id)[length(cluster_id)] <- gsub('CLID', 'CLSZ', col_label)
    }

    cat("sorting result...")
    # reorder columns based on user-supplied order
    all_col_labels = array("ids")
    for (i in 1:n_cutoff) {
        all_col_labels[[2 * i]] <- gsub('CLID', 'CLSZ', o_colname[[i]])
        all_col_labels[[2 * i + 1]] <- o_colname[[i]]
    }
    cluster_id <- cluster_id[,all_col_labels]
    # sort by cluster size corresponding to the first clustering cutoff
    if (n_cutoff == 1)
        cluster_id <- cluster_id[order(-cluster_id[,2], cluster_id[,3],
                cluster_id[,1]),]
    else
        cluster_id <- cluster_id[order(-cluster_id[,2], cluster_id[,3],
                -cluster_id[,4], cluster_id[,5], cluster_id[,1]),]

    cat("\n")
    rownames(cluster_id) <- cluster_id[,1]
    ## ThG: added to make function easier to use with new S4 classes APset/AP
    if(dbtype=="APset") { cluster_id[,"ids"] <- db$cids[cluster_id[,"ids"]] }
    if(dbtype=="FPset") { cluster_id[,"ids"] <- db$cids[cluster_id[,"ids"]] }
    ## ThG: end of lines
    return(cluster_id)
}

.calc.distmat <- function(descdb, quiet=FALSE, ...) {
	if(class(descdb)=="FPset") {
    		return(1 - sapply(cid(descdb), function(x) fpSim(descdb[x], descdb, sorted=FALSE)))
	} else { 
  		if (!quiet) cat("calculating distance matrix\n")
		len = length(descdb)
		distmat <- matrix(1, ncol=len, nrow=len)
		distmat[len,len] <- 0 #we never reach i=len in loop below, so set this diagonal element here
		for (i in 1:(len-1)) {
			distmat[i, i] <- 0
			for (j in (i+1):len) {
					d <- 1 - .cmp.similarity(descdb[[i]], descdb[[j]], ...)
					distmat[i, j] <- d
					distmat[j, i] <- d
        		}
        		prog_ratio <- i / (len - 1)
        		prog_ratio <- prog_ratio * 2 - prog_ratio * prog_ratio
        		if (! quiet)
            		.progress_bar(paste(min(prog_ratio * 100, 100), "%", collapse=""))
		}
	if (!quiet) cat("distance matrix is successfully generated\n")
	return(distmat)
	}
}

# will only consider the first cluster cutoff, if multiple cutoffs are used
# generating the cluster
cluster.sizestat <- function(cls, cluster.result=1)
{
   st <- data.frame(table(factor(cls[,cluster.result * 2])))
   # count clusters of each size
   st[,2] <- st[,2] / as.numeric(as.vector(st[,1]))
   names(st) <- c("cluster size", "count")
   return(st)
}

# visualize a cluster. db is the database generated by cmp.parse. cls is the 
# cluster generated by cluster, and size_cutoff the cutoff size for the
# clusters to be considered - clusters with smaller size will be ignored in the
# visualization. The distance matrix will be calculated on fly for compounds in
# the cluster under concern, but you can provide the (full) distance matrix in
# distmat, which must cover all compounds in db. colors of points will be
# selected randomly, but you can also provide color.vector.
# non.interactive can be set to a filename
cluster.visualize <- function(db, cls, size.cutoff, distmat=NULL,
        color.vector=NULL, non.interactive="", cluster.result=1,
        dimensions=2, quiet=FALSE, highlight.compounds=NULL, 
        highlight.color=NULL, ...)
{
    ## ThG: added for compatibility with new S4 classes APset/AP
    dbtype <- as.character(class(db))
    if(dbtype=="APset") { db <- apset2descdb(db) }
    ## ThG: end of lines
    cluster_col <- cluster.result * 2 + 1
    cls_is_large <- cls[,2] >= size.cutoff
    cls_sel <- cls[cls_is_large,]
    cluster_ids <- levels(as.factor(cls_sel[,cluster_col]))

    if (is.null(color.vector)) {
        .colors <- rainbow(length(cluster_ids))
        color.vector <- sample(.colors, length(.colors))
    }

    if (is.null(distmat)) {
        descdb_sel <- db$descdb[cls_sel[,1]]
        distmat_sel <- .calc.distmat(descdb_sel, quiet=quiet, ...)
    } else
        distmat_sel <- distmat[cls_sel[,1], cls_sel[,1]]
    mds_points <- cmdscale(distmat_sel, k=dimensions)

    if (dimensions != 2) {
        coord <- cbind(mds_points, cls_sel[,cluster_col])
        rownames(coord) <- cls_sel$ids 
        colnames(coord) <-
            c(paste('V', 1:dimensions, sep=''), colnames(cls_sel)[cluster_col])
        return(coord)
    }
 
    if (non.interactive != "") {
        if (length(grep('\\.pdf$', non.interactive)) != 0)
            pdf(non.interactive)
    else if (length(grep('\\.ps$', non.interactive)) != 0 ||
            length(grep('\\.eps$', non.interactive)) != 0)
            postscript(non.interactive, onefile=TRUE, horizontal=FALSE)
    else {
            warning("The filename you supplied has an unsupported extension.",
                " We will add .pdf to the name.")
            pdf(paste(non.interactive, 'pdf', sep='.'))
    }
    }
    
    # set up the plot
    plot(range(mds_points[,1]), range(mds_points[,2]), type="n", xlab="",
        ylab="", main="Clustering Result")

    # check highlight
    if (!is.null(highlight.compounds)) {
        cls_is_highlight <- cls[,1] %in% highlight.compounds
        cls_sel_is_highlight <- cls_is_highlight[cls_is_large]
    }
    
    for (i in 1:length(cluster_ids)) {
        col <- color.vector[i%%length(color.vector) + 1]
        cid <- cluster_ids[[i]]
        if (! quiet) {
            cat(paste("cluster", cid, "colored", col))
            cat("\n")  
        }
        # indices of points in this cluster
        in_cluster <- seq(1, length(cls_sel[,1]))[cls_sel[,cluster_col] == cid]
        points(mds_points[in_cluster,1], mds_points[in_cluster,2], col=col)
        # check highlight
        if (!is.null(highlight.compounds)) {
            highlight_in_cluster <- cls_sel_is_highlight & cls_sel[,cluster_col] == cid
            if (is.null(highlight.color)) .col <- col
            else .col <- highlight.color
            points(mds_points[highlight_in_cluster,1], mds_points[highlight_in_cluster,2], col=.col, pch=19)
        }
    }

    # interactive
    all.clicked <- rep(FALSE, length(cls_sel[,1]))
    if (non.interactive == "") {
        cat("=============================================================\n")
        cat("| Click points in a plot to get information on compounds    |\n")
        cat("| they represent.                                           |\n")
        cat("|                                                           |\n")
        g_dev <- .Platform$GUI
        if (is.character(g_dev) && g_dev == 'X11') 
            cat(
            "| right click on the plot to stop.                          |\n")
        else
            cat(
            "| press ESC key in the plot window to stop.                 |\n")
        cat("=============================================================\n\n")
        while(TRUE) {
            clicked <- identify(mds_points[,1], y=mds_points[,2],
                            labels=cls_sel$ids, n=1)
            if (length(clicked) == 0) break
            index <- cls_sel$ids[clicked]
            all.clicked[clicked] <- TRUE
            output <- data.frame(c(db$cids[index], cls[cls$ids==index,]))
            names(output) <- c('Compound ID', colnames(cls))
            print(output)
        }
    } else {
        dev.off()
    }

    coord <- cbind(mds_points, cls_sel[,cluster_col], all.clicked)
    rownames(coord) <- cls_sel$ids 
    colnames(coord) <- c(paste('V', 1:dimensions, sep=''),
                        colnames(cls_sel)[cluster_col], 'Clicked')
    return(coord)
}

# fast detection of duplicated compounds
# first all descriptors are concatenated as character strigns. then `duplicated'
# are called to detect (potentially) duplicated compounds
cmp.duplicated <- function(db, sort=FALSE, type=1)
{
    ## ThG: added for compatability with new S4 classes APset/AP
    dbtype <- as.character(class(db))
    if(dbtype=="APset") { db <- apset2descdb(db) }
    ## ThG: end of lines
    if (!sort)
        f <- function(x) {paste(x, collapse=" ")}
    else
        f <- function(x) {paste(sort(x), collapse=" ")}

    db_str <- lapply(db$descdb, f)
    ## ThG: added to also return duplicates in a cluster data frame
    if(type==1) { 
	dup <- duplicated(db_str) 
    }
    if(type==2) {
    	names(db_str) <- db$cids; 
    	db_str <- tapply(names(db_str), as.character(db_str), paste)
    	names(db_str) <- 1:length(db_str)
    	clsz <- sapply(db_str, length)
    	dup <- data.frame(ids=unlist(db_str), CLSZ_100=rep(clsz, clsz), CLID_100=rep(1:length(db_str), clsz))
    }
    ## ThG: end of lines
    return(dup)
}

# helper function used by cluster.visualization
# given a set of points and a point, find the nearest match of point in the set
.search.nearest <- function(mds_points, point)
{
    best <- 1
    dist <- (mds_points[1,1] - point$x)^2  + (mds_points[1,2] - point$y)^2
    for (i in 2:length(mds_points[,1])) {
        d <- (mds_points[i,1] - point$x)^2 + (mds_points[i,2] - point$y)^2
        if (d < dist) {
           best <- i
           dist <- d
        }
    }
    return(best)
}

# intertanl cluster procedure. It takes a leader compounds, and use graph
# traversal to find all compounds that should be grouped in the cluster leaded
# by the leader. If multiple cutoffs are given, it will use the loosest one;
# but at the same time, clusters for stricter cutoffs are also built as a
# desired side-effect, without need to recompute the distance.
# RETURN: the new cluster_id matrix
.cluster_g <- function(lead, all, dist_func, cutoff, cluster_id,
symmetric=TRUE, quiet=FALSE)
{
    n_cutoff <- length(cutoff)
    # where to start in finding the elements in cluster
    start_from <- 1
    if (symmetric)
        start_from <- lead + 1
    # queue to store the visited and to-visit nodes
    # queue will be sorted by number of "unknowns"
    queue <- c(lead)
    if (cluster_id[lead, 1] == 0)
        cluster_id[lead,] <- lead
    current_id <- cluster_id[lead, ]
    # head points to node currently being visited
    head <- 1
    # tail points to tail of queue, ie where to add new nodes
    tail <- 2
    # do we really need to search?
    if (start_from > length(all))
        return(cluster_id)
    while (head != tail) {
        if (! quiet) .progress_bar()
        # pop from head
        elem <- queue[[head]]
        # init cluster IDs for elem: clear the unknowns
        cluster_id[elem,cluster_id[elem,] == 0] <- elem
        # find neighbors
        for (i in all[start_from:length(all)]) {
            # does i contain any unknown? only need to check
            # strictest cutoff
            if (cluster_id[i,n_cutoff] != 0)
                next
            # else, update
            d = dist_func(elem, i)
            indices <- (d <= cutoff)
            cluster_id[i, indices] <- cluster_id[elem, indices]
            # satisfying the loosest cutoff?
            if (indices[[1]]) {
                # add i to queue
                num_unknowns <- sum(cluster_id[i,] == 0)
                # is it already in the queue?
                if (length(queue[queue == i]))
                    pos <- (1:length(queue))[queue == i]
                else {
                    pos <- tail
                    tail <- tail + 1
                }
                while (pos > head && num_unknowns <
                        sum(cluster_id[queue[[pos - 1]],] == 0)) {
                    queue[[pos]] <- queue[[pos - 1]]
                    pos <- pos - 1
                }
                queue[[pos]] <- i
            }
        }
        head <- head + 1
    }
    return(cluster_id)
}


jarvisPatrick_c <- function(neighbors,minNbrs,fast=TRUE,bothDirections=FALSE,linkage = "single"){

			linkage = if(linkage == "single") 0
						 else if(linkage == "average") 1
						 else if(linkage == "complete") 2

			n=if(is.list(neighbors)) Map(as.integer,neighbors)
				else if(is.matrix(neighbors))  matrix(as.integer(neighbors),nrow(neighbors),ncol(neighbors))
				else stop("neighbors must be an integer valued list or matrix, but found: ",class(neighbors))
	      .Call("jarvis_patrick",n,as.integer(minNbrs),
					as.integer(fast),as.integer(bothDirections),as.integer(linkage))
}

###############################
## Jarvis-Patrick Clustering ##
###############################
## Added by ThG on 28-Oct-12
## Function to perform Jarvis-Patrick clustering. The algorithm requires a
## nearest neighbor table, which consists of 'j' nearest neighbors for each item
## in the dataset. This information is then used to join items into clusters
## with the following requirements: 
##       (a) they are contained in each other's neighbor list
##       (b) they share at least 'k' nearest neighbors
## The values for 'j' and 'k' are user-defined parameters. The jarvisPatrick() 
## function can generate the nearest neighbor table for APset and FPset objects 
## and then perform Jarvis-Patrick clustering on that table. It also accepts 
## a precomputed nearest neighbor table in form of an object of class matrix. 
## The output is a cluster vector with the item labels in the name slot and the 
## cluster IDs in the data slot. Alternatively, the function can return the nearest 
## neighbor matrix. As third parameter the user can set a minimum similarity value for generating 
## the nearest neighbor table. The latter is an optional setting that is not part 
## of the original Jarvis-Patrick algorithm. It allows to generate more tight 
## clusters and minimizes some limitations of this method, such as joining unrelated
## items when clustering small datasets.  
#jarvisPatrick <- function(x, j, k, cutoff=NA, type="cluster", mode="a1a2b", linkage="single", ...) {      
#        ## Check inputs
#        if(!any(c("APset", "FPset", "matrix") %in% class(x))) stop("class(x) needs to be APset, FPset or matrix")
#        if(!any(c("a1a2b", "a1b", "b") %in% mode)) stop("mode argument can only be assigned a1a2b, a1b or b")
#        ## If class(x) is APset or FPset, generate nearest neighbor matrix (nnm)
#        if(any(c("APset", "FPset") %in% class(x))) {
#                if(is.na(cutoff)) { # Standard Jarvis-Patrick clustering without cutoff
#                        if(class(x)=="FPset") {
#										  nameToNum = 1:length(x)
#										  names(nameToNum)=cid(x)
#                                nnm <- t(sapply(seq(along=x), function(y) nameToNum[names(fpSim(x[y], x, top=j, ...))]))
#                        } 
#                        if(class(x)=="APset") {
#                                nnm <- t(sapply(seq(along=x), function(y) cmp.search(x, x[y], type=1, cutoff=j, quiet = TRUE, ...)))
#                        }
#								rownames(nnm) <- cid(x)
#								colnames(nnm) <- seq(along=nnm[1,])
#                } 
#                if(is.numeric(cutoff) & cutoff <= 1) { # Non-standard Jarvis-Patrick clustering with cutoff
#                        #nnm <- matrix(NA, length(x), j)
#								nnm <- vector("list",length(x))
#								names(nnm) = cid(x)
#
#                        if(class(x)=="FPset") {
#										  nameToNum = 1:length(x)
#										  names(nameToNum)=cid(x)
#                                for(i in seq(length(x))) {
#                                        #tmp <- names(fpSim(x[i], x, cutoff=cutoff, top=j, ...))
#                                        #nnm[i,1:length(tmp)] <- nameToNum[tmp]
#                                        nnm[[i]] <- as.integer(nameToNum[names(fpSim(x[i], x, cutoff=cutoff, ...))])
#                                }
#                        }
#                        if(class(x)=="APset") {
#                                for(i in seq(length(x))) {
#                                        #tmp <- cmp.search(x, x[i], type=1, cutoff=cutoff, quiet = TRUE, ...)[1:j]
#                                        #nnm[i,1:length(tmp)] <- tmp
#                                        nnm[[i]] <- cmp.search(x, x[i], type=1, cutoff=cutoff, quiet = TRUE, ...)
#
#                                }
#                        }
#                }
#        }
#        if(type=="matrix") {
#                return(nnm) 
#        }
#	## Run Jarvis-Patrick clustering on nearest neighbor matrix (nnm)
#	if(type=="cluster") {
#		if(any(c("matrix", "data.frame") %in% class(x))) nnm <- x # If pre-generated matrix is provided
#
#		#print(nnm)
#		clusters = if(mode=="a1a2b")
#						jarvisPatrick_c(nnm,k,fast=TRUE,bothDirections=TRUE,linkage=linkage)
#					else if(mode=="a1b")
#						jarvisPatrick_c(nnm,k,fast=TRUE,bothDirections=FALSE,linkage=linkage)
#					else   # if(mode=="b") only remaining option
#						jarvisPatrick_c(nnm,k,fast=FALSE,linkage=linkage)
#		clusters=rownames(nnm,do.NULL=FALSE,prefix="cl")[clusters]
#		names(clusters)=rownames(nnm,do.NULL=FALSE,prefix="cl")
#		#print(clusters)
#		
#		## Assign continuous numbers as cluster names
#		clusterstmp <- sort(clusters)
#		tmp <- 1:length(unique(clusterstmp)); names(tmp) <- unique(clusterstmp)
#		tmp <- tmp[as.character(clusterstmp)]; names(tmp) <- names(clusterstmp)
#		clusters <- tmp[names(clusters)]
#		return(clusters)
#	}
#}



###############################
## Jarvis-Patrick Clustering ##
###############################
## Added by ThG on 28-Oct-12
## Function to perform Jarvis-Patrick clustering. The algorithm requires a
## nearest neighbor table, which consists of neighbors for each item
## in the dataset. This information is then used to join items into clusters
## with the following requirements: 
##       (a) they are contained in each other's neighbor list
##       (b) they share at least 'k' nearest neighbors
## The mode parameter can be used to relax some of these requirements. If mode='a1a2b' (default),
## then all requirements are used, if mode='a1b' than condition a is relaxed to just
## require that one item is contained in the others neighbors list. If mode='b', than
## only condition b is used. This mode increases the time complexity from linear to
## quadratic in the number of items hoewever.
## The linkage parameter can be used to set the cluster merging criteria to either
## 'single' (default), 'average', or 'complete'.
## The output is a cluster vector with the item labels in the name slot and the 
## cluster IDs in the data slot. 
jarvisPatrick <- function(nnm,  k, mode="a1a2b", linkage="single") {      
	## Run Jarvis-Patrick clustering on nearest neighbor matrix (nnm)

	#print(nnm)
	clusters = if(mode=="a1a2b")
					jarvisPatrick_c(nnm$indexes,k,fast=TRUE,bothDirections=TRUE,linkage=linkage)
				else if(mode=="a1b")
					jarvisPatrick_c(nnm$indexes,k,fast=TRUE,bothDirections=FALSE,linkage=linkage)
				else   # if(mode=="b") only remaining option
					jarvisPatrick_c(nnm$indexes,k,fast=FALSE,linkage=linkage)

	#print(clusters)

	origClusterNames = unique(clusters)
	origToNewNames = 1:length(origClusterNames)
	names(origToNewNames) = origClusterNames
	clusters = origToNewNames[as.character(clusters)]
	names(clusters)=nnm$names
	#print(clusters)

	return(clusters)
}
## Usage:
# library(ChemmineR)
# data(apset)
# fpset <- desc2fp(apset)
# jarvisPatrick(x=apset, j=6, k=5)
# jarvisPatrick(x=fpset, j=6, k=2, cutoff=0.4)
# jarvisPatrick(x=fpset, j=2, k=2, type="matrix")


nearestNeighbors <- function(x, numNbrs=NULL,cutoff=NULL,...){

	if(any(c("APset", "FPset") %in% class(x))) {
			 if(!is.null(numNbrs) && is.null(cutoff)) { # Standard Jarvis-Patrick clustering without cutoff

						buildNnm = function(set,simFun){
							  nameToNum = 1:length(set)
							  names(nameToNum)=cid(set)
							  nnm = list()
							  for(i in 1:length(set)){
									sim = simFun(set[i],set)
									nnm$indexes = rbind(nnm$indexes, nameToNum[names(sim)])
									#nnm$names = rbind(nnm$names, names(sim))
									nnm$similarities = rbind(nnm$similarities,sim)
							  }
							  nnm
						}

						if(class(x)=="FPset") {
								  nnm = buildNnm(x,function(item,set) fpSim(item,set,top=numNbrs,...))
						} 
						if(class(x)=="APset") {
								  nnm = buildNnm(x,function(item,set) cmp.search(set,item,type=2,cutoff=numNbrs,quiet=TRUE,...))
						}
						#rownames(nnm) <- cid(x)
						#colnames(nnm) <- seq(along=nnm[1,])
			 } 
			 else if(! is.null(cutoff) && is.numeric(cutoff) && cutoff <= 1) {  # Non-standard Jarvis-Patrick clustering with cutoff
						buildNnm = function(set,simFun){

							nnm=list()
							N=length(set)
							nnm$indexes <- vector("list",N)
							nnm$names <- vector("list",N)
							nnm$similarities<- vector("list",N)
							#names(nnm) = cid(x)

						   nameToNum = 1:N
						   names(nameToNum)=cid(set) 
						   for(i in 1:N) {
								 sim = simFun(set[i],set)
								 nnm$indexes[[i]] = as.integer(nameToNum[names(sim)])
								 #nnm$names[[i]] = names(sim)
								 nnm$similarities[[i]]=as.numeric(sim)
						   }
							nnm
						}

						if(class(x)=="FPset") {
							  nnm = buildNnm(x,function(item,set) fpSim(item,set,cutoff=cutoff,...))
						}
						if(class(x)=="APset") {
							  nnm = buildNnm(x,function(item,set) cmp.search(set,item,type=2,cutoff=cutoff,quiet=TRUE,...))
						}
			 }
			 else
				 stop("some input requirement not met. Either numNbrs or cutoff must be given, if cutoff is given, ",
						"it must be a number between 0 and 1")
	}else
		stop("class(x) needs to be APset or FPset")

	nnm$names=cid(x)
	nnm

}

trimNeighbors <- function(nnm,cutoff){

	if(is.matrix(nnm$similarities) ){
		for(i in 1:nrow(nnm$similarities)){
				 nonMatches = nnm$similarities[i,] < cutoff 
				 nnm$similarities[i,nonMatches] = NA
				 nnm$indexes[i,nonMatches] = NA
				 #nnm$names[i,nonMatches] = NA
		}
	}else if(is.list(nnm$similarities) ){
		for(i in 1:length(nnm$similarities)){
				 matches = nnm$similarities[[i]] >= cutoff
				 nnm$similarities[[i]] = nnm$similarities[[i]][matches]
				 nnm$indexes[[i]] = nnm$indexes[[i]][matches]
				 #nnm$names[[i]] = nnm$names[[i]][matches]
		}
	}else
		stop("don't know how to handle nnm$similarities of type ",class(nnm$similarities))

	nnm
}

fromNNMatrix<- function(data,names=rownames(data)){
	list(indexes = data, names=names)
}
byCluster <- function(clustering,excludeSingletons=TRUE){

		if(excludeSingletons)
			sizes = table(clustering)

		clusters = list()
		for(mol in names(clustering)){
			cid = as.character(clustering[[mol]])
			if(!excludeSingletons || (excludeSingletons && sizes[[cid]] > 1))
				clusters[[cid]] = c(clusters[[cid]], mol)
		}
		clusters
}

ErrorClass <- "try-error" 


postgresqlWriteTable <- function(con, name, value, field.types, row.names = TRUE,
                                 overwrite = FALSE, append = FALSE, ..., allow.keywords = FALSE) {
	 if(!require(RPostgreSQL))
		 stop("The RPostgreSQL package is required to use this function (postgresqlWriteTable)")
    if(overwrite && append)
        stop("overwrite and append cannot both be TRUE")
    if(!is.data.frame(value))
        value <- as.data.frame(value)
    if(row.names){
        value <- cbind(row.names(value), value)  ## can't use row.names= here
        names(value)[1] <- "row.names"
    }
    if(missing(field.types) || is.null(field.types)){
        ## the following mapping should be coming from some kind of table
        ## also, need to use converter functions (for dates, etc.)
        field.types <- sapply(value, dbDataType, dbObj = con)
    }

    i <- match("row.names", names(field.types), nomatch=0)
    if(i>0) ## did we add a row.names value?  If so, it's a text field.
        ## MODIFIED -- Sameer
        field.types[i] <- dbDataType(dbObj=con, field.types[row.names])
    new.con <- con

    if(dbExistsTable(con,name)){
        if(overwrite){
            if(!dbRemoveTable(con, name)){
                warning(paste("table", name, "couldn't be overwritten"))
                return(FALSE)
            }
        }
        else if(!append){
            warning(paste("table",name,"exists in database: aborting assignTable"))
            return(FALSE)
        }
    }
    if(!dbExistsTable(con,name)){      ## need to re-test table for existance
        ## need to create a new (empty) table
        sql1 <- paste("create table ", postgresqlTableRef(name), "\n(\n\t", sep="")
        sql2 <- paste(paste(postgresqlQuoteId(names(field.types)), field.types), collapse=",\n\t",
                      sep="")
        sql3 <- "\n)\n"
        sql <- paste(sql1, sql2, sql3, sep="")
        rs <- try(dbSendQuery(new.con, sql))
        if(inherits(rs, ErrorClass)){
            warning("could not create table: aborting assignTable")
            return(FALSE)
        } else {
            dbClearResult(rs)
        }
    }

    ## convert columns we can't handle in C code
    value[] <- lapply(value, function(z) {
        if(is.object(z) && !is.factor(z)) as.character(z) else z
    })
    oldenc <- dbGetQuery(new.con, "SHOW client_encoding")
    postgresqlpqExec(new.con, "SET CLIENT_ENCODING TO 'UTF8'")
    sql4 <- paste("COPY  ", postgresqlTableRef(name),"(",paste(names(value),collapse=","),") FROM STDIN")
    postgresqlpqExec(new.con, sql4)
    postgresqlCopyInDataframe(new.con, value)
    rs<-postgresqlgetResult(new.con)

    retv <- TRUE
    if (inherits(rs, ErrorClass)) {
        warning("could not load data into table")
        retv <- FALSE
    }

    dbClearResult(rs)
    sql5 <- paste("SET CLIENT_ENCODING TO '", oldenc, "'", sep="")
    dbGetQuery(new.con, sql5)

    retv
}

# This file was automatically generated by SWIG (http://www.swig.org).
# Version 2.0.7
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

##   Generated via the command line invocation:
##	 swig -c++ -Isrc -module ChemmineR -o src/r_wrap.cc -r -outdir R swig.i


#                         srun.swg                            #
#
# This is the basic code that is needed at run time within R to
# provide and define the relevant classes.  It is included
# automatically in the generated code by copying the contents of
# srun.swg into the newly created binding code.


# This could be provided as a separate run-time library but this
# approach allows the code to to be included directly into the
# generated bindings and so removes the need to have and install an
# additional library.  We may however end up with multiple copies of
# this and some confusion at run-time as to which class to use. This
# is an issue when we use NAMESPACES as we may need to export certain
# classes.

######################################################################

if(length(getClassDef("RSWIGStruct")) == 0) 
  setClass("RSWIGStruct", representation("VIRTUAL"))



if(length(getClassDef("ExternalReference")) == 0) 
# Should be virtual but this means it loses its slots currently
#representation("VIRTUAL")
  setClass("ExternalReference", representation( ref = "externalptr"))



if(length(getClassDef("NativeRoutinePointer")) == 0) 
  setClass("NativeRoutinePointer", 
              representation(parameterTypes = "character",
                             returnType = "character",
                             "VIRTUAL"), 
              contains = "ExternalReference")

if(length(getClassDef("CRoutinePointer")) == 0) 
  setClass("CRoutinePointer", contains = "NativeRoutinePointer")


#if(length(getClassDef("EnumerationValue")) == 0) 
  #setClass("EnumerationValue", contains = "integer")


if(!isGeneric("copyToR")) 
 setGeneric("copyToR",
            function(value, obj = new(gsub("Ref$", "", class(value)))) 
               standardGeneric("copyToR"
           ))

setGeneric("delete", function(obj) standardGeneric("delete"))


RSWIG_createNewRef = 
function(className, ..., append = TRUE)
{
  f = get(paste("new", className, sep = "_"), mode = "function")

  f(...)
}

if(!isGeneric("copyToC")) 
 setGeneric("copyToC", 
             function(value, obj = RSWIG_createNewRef(class(value)))
              standardGeneric("copyToC"
            ))


# 
#defineEnumeration =
#function(name, .values, where = topenv(parent.frame()), suffix = "Value")
#{
#   # Mirror the class definitions via the E analogous to .__C__
#  defName = paste(".__E__", name, sep = "")
#  assign(defName,  .values,  envir = where)
#
#  if(nchar(suffix))
#    name = paste(name, suffix, sep = "")
#
#  setClass(name, contains = "EnumerationValue", where = where)
#}

enumToInteger <- function(name,type)
{
   if (is.character(name)) {
   ans <- as.integer(get(paste(".__E__", type, sep = ""))[name])
   if (is.na(ans)) {warning("enum not found ", name, " ", type)}
   ans
   } 
}

enumFromInteger =
function(i,type)
{
  itemlist <- get(paste(".__E__", type, sep=""))
  names(itemlist)[match(i, itemlist)]
}

coerceIfNotSubclass =
function(obj, type) 
{
    if(!is(obj, type)) {as(obj, type)} else obj
}


#setClass("SWIGArray", representation(dims = "integer"), contains = "ExternalReference")

#setMethod("length", "SWIGArray", function(x) x@dims[1])


#defineEnumeration("SCopyReferences",
#                   .values = c( "FALSE" = 0, "TRUE" = 1, "DEEP" = 2))

assert = 
function(condition, message = "")
{
  if(!condition)
    stop(message)

  TRUE
}


if(FALSE) {
print.SWIGFunction =
function(x, ...)
 {
 }
}


#######################################################################

R_SWIG_getCallbackFunctionStack =
function()
{
    # No PACKAGE argument as we don't know what the DLL is.
  .Call("R_SWIG_debug_getCallbackFunctionData")
}

R_SWIG_addCallbackFunctionStack =
function(fun, userData = NULL)
{
    # No PACKAGE argument as we don't know what the DLL is.
  .Call("R_SWIG_R_pushCallbackFunctionData", fun, userData)
}


#######################################################################


setClass('C++Reference', contains = 'ExternalReference')
setClass('_p_Descriptors', contains = 'C++Reference')



#setMethod('[', "ExternalReference",
#function(x,i,j, ..., drop=TRUE) 
#if (!is.null(x$"__getitem__")) 
#sapply(i, function(n) x$"__getitem__"(i=as.integer(n-1))))
#
#setMethod('[<-' , "ExternalReference",
#function(x,i,j, ..., value) 
#if (!is.null(x$"__setitem__")) {
#sapply(1:length(i), function(n) 
#x$"__setitem__"(i=as.integer(i[n]-1), x=value[n]))
#x
#})

#setAs('ExternalReference', 'character',
#function(from) {if (!is.null(from$"__str__")) from$"__str__"()})

setMethod('print', 'ExternalReference',
function(x) {print(as(x, "character"))})

# Start of new_Descriptors

`Descriptors` = function()
{
  ;ans = .Call('R_swig_new_Descriptors', PACKAGE='ChemmineR');
  class(ans) <- "_p_Descriptors";
  
  reg.finalizer(ans, delete_Descriptors)
  ans
  
}

attr(`Descriptors`, 'returnType') = '_p_Descriptors'
class(`Descriptors`) = c("SWIGFunction", class('Descriptors'))

# Start of Descriptors_parse_sdf

`Descriptors_parse_sdf` = function(self, sdf, .copy = FALSE)
{
  sdf = as(sdf, "character"); 
  ;.Call('R_swig_Descriptors_parse_sdf', self, sdf, as.logical(.copy), PACKAGE='ChemmineR');
  
}

attr(`Descriptors_parse_sdf`, 'returnType') = 'integer'
attr(`Descriptors_parse_sdf`, "inputTypes") = c('_p_Descriptors', 'character')
class(`Descriptors_parse_sdf`) = c("SWIGFunction", class('Descriptors_parse_sdf'))

# Start of Descriptors_parse_sdfile

`Descriptors_parse_sdfile` = function(self, sdfile, .copy = FALSE)
{
  sdfile = as(sdfile, "character"); 
  ;.Call('R_swig_Descriptors_parse_sdfile', self, sdfile, as.logical(.copy), PACKAGE='ChemmineR');
  
}

attr(`Descriptors_parse_sdfile`, 'returnType') = 'integer'
attr(`Descriptors_parse_sdfile`, "inputTypes") = c('_p_Descriptors', 'character')
class(`Descriptors_parse_sdfile`) = c("SWIGFunction", class('Descriptors_parse_sdfile'))

# Start of Descriptors_parse_smiles

`Descriptors_parse_smiles` = function(self, smile, .copy = FALSE)
{
  smile = as(smile, "character"); 
  ;.Call('R_swig_Descriptors_parse_smiles', self, smile, as.logical(.copy), PACKAGE='ChemmineR');
  
}

attr(`Descriptors_parse_smiles`, 'returnType') = 'integer'
attr(`Descriptors_parse_smiles`, "inputTypes") = c('_p_Descriptors', 'character')
class(`Descriptors_parse_smiles`) = c("SWIGFunction", class('Descriptors_parse_smiles'))

# Start of Descriptors_get_descriptor

`Descriptors_get_descriptor` = function(self, i, .copy = FALSE)
{
  if(length(i) > 1) {
    warning("using only the first element of i");
  };
  
  ;.Call('R_swig_Descriptors_get_descriptor', self, i, as.logical(.copy), PACKAGE='ChemmineR');
  
}

attr(`Descriptors_get_descriptor`, 'returnType') = 'integer'
attr(`Descriptors_get_descriptor`, "inputTypes") = c('_p_Descriptors', 'integer')
class(`Descriptors_get_descriptor`) = c("SWIGFunction", class('Descriptors_get_descriptor'))

# Start of Descriptors_get_len

`Descriptors_get_len` = function(self, .copy = FALSE)
{
  ;.Call('R_swig_Descriptors_get_len', self, as.logical(.copy), PACKAGE='ChemmineR');
  
}

attr(`Descriptors_get_len`, 'returnType') = 'integer'
attr(`Descriptors_get_len`, "inputTypes") = c('_p_Descriptors')
class(`Descriptors_get_len`) = c("SWIGFunction", class('Descriptors_get_len'))

# Start of delete_Descriptors

`delete_Descriptors` = function(self)
{
  ;.Call('R_swig_delete_Descriptors', self, PACKAGE='ChemmineR');
  
}

attr(`delete_Descriptors`, 'returnType') = 'void'
attr(`delete_Descriptors`, "inputTypes") = c('_p_Descriptors')
class(`delete_Descriptors`) = c("SWIGFunction", class('delete_Descriptors'))

# Start of accessor method for Descriptors
#setMethod('$', '_p_Descriptors', function(x, name)
#
#{
#  accessorFuns = list('parse_sdf' = Descriptors_parse_sdf, 'parse_sdfile' = Descriptors_parse_sdfile, 'parse_smiles' = Descriptors_parse_smiles, 'get_descriptor' = Descriptors_get_descriptor, 'get_len' = Descriptors_get_len);
#  ;        idx = pmatch(name, names(accessorFuns));
#  if(is.na(idx)) 
#  return(callNextMethod(x, name));
#  f = accessorFuns[[idx]];
#  function(...){
#    f(x, ...)
#  };
#}
#);
# end of accessor method for Descriptors
setMethod('delete', '_p_Descriptors', function(obj) {delete_Descriptors(obj)})
# Start of similarity

`similarity` = function(d1, d2, .copy = FALSE)
{
  ;.Call('R_swig_similarity', d1, d2, as.logical(.copy), PACKAGE='ChemmineR');
  
}

attr(`similarity`, 'returnType') = 'numeric'
attr(`similarity`, "inputTypes") = c('_p_Descriptors', '_p_Descriptors')
class(`similarity`) = c("SWIGFunction", class('similarity'))

#!/usr/bin/env Rscript

library(ChemmineR)


#data(sdfsample)
#sdfset = sdfsample

sdfFile = commandArgs(trailingOnly=TRUE)

fpsetDataName = paste(sdfFile,"-fpset",".Rdata",sep="")
sdfsetDataName = paste(sdfFile,".Rdata",sep="")

if(!file.exists(fpsetDataName)){
	if(!file.exists(sdfsetDataName)){
		sdfset = read.SDFset(sdfFile)
		message("done loading")
		sdfset = sdfset[validSDF(sdfset)]
		#sdfset = smiles2sdf(sdf2smiles(sdfset))
		save(sdfset,file=sdfsetDataName)
	}
	else
		load(sdfsetDataName)

	fpset = desc2fp(sdf2ap(sdfset))
	message("desc time: ",ChemmineR:::times$descT)
	message("fac time: ",ChemmineR:::times$facT)
	message("vec time: ",ChemmineR:::times$vecT)
	message("uniquify time: ",ChemmineR:::times$uniqueT)

	save(fpset,file=fpsetDataName)

}else
	load(fpsetDataName)



eval(fpset) #force evaluation
#fpset=c(fpset,fpset,fpset)
message("starting test of ",length(fpset), " FPs")

print(system.time(params<<- genParameters(fpset)))

#print(system.time(ChemmineR:::fpSimOrig(fpset[[1]],fpset)))
#print(system.time(fpSim(fpset[[1]],fpset)))

library(ChemmineR)


v2kLines = read.SDFstr("~/runs/v3000/DrugLike-0_2-3K3K_1.v2k.sdf")
v3kLines = read.SDFstr("~/runs/v3000/DrugLike-0_2-3K3K_1.sdf")


message("v3000: ")
system.time(read.SDFset(v3kLines))

message("header time: ", ChemmineR:::v3kTimes$header)
message("atom time: ", ChemmineR:::v3kTimes$atom)
message("atom core time: ", ChemmineR:::v3kTimes$atomCore)
message("bond time: ", ChemmineR:::v3kTimes$bond)
message("data time: ", ChemmineR:::v3kTimes$data)

message("v2000: ")
system.time(read.SDFset(v2kLines))
message("header time: ", ChemmineR:::v2kTimes$header)
message("atom time: ", ChemmineR:::v2kTimes$atom)
message("bond time: ", ChemmineR:::v2kTimes$bond)
message("data time: ", ChemmineR:::v2kTimes$data)

################################################
## Class and Method Definitions for ChemmineR ##
################################################
## SDF format definition: 
        # http://www.epa.gov/ncct/dsstox/MoreonSDF.html
	# http://www.symyx.com/downloads/public/ctfile/ctfile.jsp

#################################################
## (1) Class and Method Definitions for SDFstr ##
#################################################
## Download PubChem SDF samples for code testing 
## This function is not intended to be used by users.
.sdfDownload <- function(mypath="ftp://ftp.ncbi.nih.gov/pubchem/Compound/CURRENT-Full/SDF/", myfile="Compound_00650001_00675000.sdf.gz") {
	system(paste("wget ", mypath, myfile, sep=""))
	system(paste("gunzip ", myfile))
}
# .sdfDownload(mypath="ftp://ftp.ncbi.nih.gov/pubchem/Compound/CURRENT-Full/SDF/", myfile="Compound_00650001_00675000.sdf.gz") 

## Import SD File and Return SDFstr Class (list-like) 
read.SDFstr <- function(sdfstr) {
        if(length(sdfstr) > 1) { # Support for passing on SD File content as character vector
                mysdf <- sdfstr
        } else {
                mysdf <- readLines(sdfstr) # Reads file line-wise into vector
        }
        y <- regexpr("^\\${4,4}", mysdf, perl=TRUE) # identifies all fields that start with a '$$$$' sign
        index <- which(y!=-1)


		  #if the last non-empty line of mysdf is not "$$$$". Only search from the last "$$$$" found
		  # to the end of the file
		  start = if(length(index)==0) 1 else index[length(index)]
		  if("$$$$" != Find(function(line) line !="", mysdf[start:length(mysdf)]
								 ,right=TRUE)){
			  # we have a MOL file, so just insert the $$$$ at the end
			  mysdf <- c(mysdf,"$$$$")
			  index <- c(index,length(mysdf))
		  }

        indexDF <- data.frame(start=c(1, index[-length(index)]+1), end=index)
        mysdf_list <- lapply(seq(along=indexDF[,1]), function(x) mysdf[seq(indexDF[x,1], indexDF[x,2])])
        if(class(mysdf_list) != "list") { mysdf_list <- list(as.vector(mysdf_list)) }
        names(mysdf_list) <- 1:length(mysdf_list)
        mysdf_list <- new("SDFstr", a=mysdf_list)
        return(mysdf_list)
}

## Define SDFstr class
setClass("SDFstr", representation(a = "list"))

## Accessor method for SDFstr
setGeneric(name="sdfstr2list", def=function(x) standardGeneric("sdfstr2list"))
setMethod(f="sdfstr2list", signature="SDFstr", definition=function(x) {return(x@a)}) 

## Replacement method for SDFstr using accessor method
setGeneric(name="sdfstr2list<-", def=function(x, value) standardGeneric("sdfstr2list<-"))
setReplaceMethod(f="sdfstr2list", signature="SDFstr", definition=function(x, value) {
	x@a <- value 
	return(x)
})

## Replacement method for SDFstr using "[" operator 
## It doesn't provide here full set of expected functionalities.
setReplaceMethod(f="[", signature="SDFstr", definition=function(x, i, j, value) {
	x@a[i] <- sdfstr2list(value)
	return(x)
})

## Define behavior of "[" operator for SDFstr 
setMethod(f="[", signature="SDFstr", definition=function(x, i, ..., drop) {
		x@a <- x@a[i]                   
		return(x)
})

## Behavior of "[[" operator to convert single SDFstr component to character vector
setMethod(f="[[", signature="SDFstr",
	definition=function(x, i, ..., drop) {
		return(x@a[[i]])                 
})

## Replacement method for SDFstr using "[" operator 
setReplaceMethod(f="[", signature="SDFstr", definition=function(x, i, value) {
	x@a[i] <- value
	return(x)
})

## Replacement method for SDFstr using "[[" operator 
setReplaceMethod(f="[[", signature="SDFstr", definition=function(x, i, value) {
	x@a[[i]] <- value
	return(x)
})

## Define print behavior for SDFstr
setMethod(f="show", signature="SDFstr",
	definition=function(object) { 
		cat("An instance of ", "\"", class(object), "\"", " with ", length(sdfstr2list(object)), " molecules", "\n", sep="")
})

## Length function
setMethod(f="length", signature="SDFstr",
    definition=function(x) {
    	return(length(sdfstr2list(x)))
})

## Write SDF/SDFstr/SDFset Objects to SD File 
write.SDF <- function(sdf, file, cid=FALSE, ...) {
	if(class(sdf)=="SDF") sdfstr <- as(sdf, "SDFstr")
	if(class(sdf)=="SDFstr") sdfstr <- sdf
	if(class(sdf)=="SDFset") {
		if(cid==TRUE) {	sdflist <- lapply(cid(sdf), function(x) sdf2str(sdf=sdf[[x]], cid=x, ...)) }	
		if(cid==FALSE) { sdflist <- lapply(cid(sdf), function(x) sdf2str(sdf=sdf[[x]], ...)) } 
		sdfstr <- as(sdflist, "SDFstr") 
	}
	cat(unlist(sdfstr2list(sdfstr)), sep="\n", file=file)
} 

## Coerce Methods for SDFstr Class
## SDFstr to list
setAs(from="SDFstr", to="list", 
	def=function(from) { 
		sdfstr2list(from)
})

## List to SDFstr
setAs(from="list", to="SDFstr", 
	def=function(from) {
		new("SDFstr", a=from)
})

## List to SDFstr
setAs(from="character", to="SDFstr", 
	def=function(from) {
		new("SDFstr", a=list(from))
})

################################################
## (2) Class and Method Definitions for SDF ##
################################################
setClass("ExternalReference")
setClassUnion("ExternalReferenceOrNULL",members=c("ExternalReference","NULL"))
setClass("SDF", representation(header="character", atomblock="matrix", 
										 bondblock="matrix", datablock="character",
										 obmolRef="ExternalReferenceOrNULL",
										 version="character"),
			prototype=list(obmolRef=NULL,version="V2000"))

## Convert SDFstr to SDF Class
## SDFstr Parser Function



.sdfParse <- function(sdf, datablock=TRUE, tail2vec=TRUE,extendedAttributes=TRUE) {
	countpos <- grep("V\\d\\d\\d\\d$", sdf, perl=TRUE)
	if(length(countpos)==0)  
		countpos <- grep("V {0,}\\d\\d\\d\\d$", sdf, perl=TRUE) 
	if(length(countpos)==0 || length(countpos)>1) 
		 countpos <- 4 

	countline <- sdf[countpos]

	if(length(grep("V3000$",countline))!=0) # we have a V3000 formatted file
		return(.parseV3000(sdf,datablock,tail2vec,extendedAttributes))

   if(nchar(gsub("\\d| ", "", substring(countline, 1, 6))) != 0) 
		countline <- "  0  0"  # Create dummy countline if it contains non-numeric values 

	Natom <- as.numeric(substring(countline, 1, 3))
	Nbond <- as.numeric(substring(countline, 4, 6))
	start <- c(header=1, atom=countpos+1, bond=countpos+Natom+1, extradata=countpos+Natom+Nbond+1)
	index <- cbind(start=start, end=c(start[2:3], start[4], length(sdf)+1)-1)
	
	## Header block
	header <- sdf[index["header",1]:index["header",2]]
	if(length(header)==4) names(header) <- c("Molecule_Name", "Source", "Comment", "Counts_Line")	
	
	## Atom block
	## format: x y z <atom symbol> 
	ab2matrix <- function(ct=sdf[index["atom",1]:index["atom",2]]) {
		if((index["atom","end"] - index["atom","start"]) < 1) {
			ctma <- matrix(rep(0,2), 1, 2, dimnames=list("0", c("C1", "C2"))) # Creates dummy matrix in case there is none.
		} else {
			ct <- gsub("^ {1,}", "", ct)
			ctlist <- strsplit(ct, " {1,}")
			ctma <- tryCatch(matrix(unlist(ctlist), 
											ncol=length(ctlist[[1]]), 
											nrow=length(ct), 
											byrow=TRUE), 
								  warning=function(w) NULL)
			# If rows in atom block are of variable length, use alternative/slower approach
			if(length(ctma)==0) { 
			  maxcol <- max(sapply(ctlist, length))
			  ctma <- matrix(0, nrow=length(ct), ncol=maxcol)
			  for(i in seq(along=ctma[,1])) 
				  ctma[i, 1:length(ctlist[[i]])] <- ctlist[[i]]
			}
			myrownames <- paste(ctma[,4], 1:length(ctma[,4]), sep="_")
		   # Ncol <- length(ctlist[[1]])
		   Ncol <- length(ctma[1, , drop = FALSE])
			ctma <- matrix(as.numeric(ctma[,-4]), 
								nrow=length(ct), 
								ncol=Ncol-1, 
								dimnames=list(myrownames, paste("C", c(1:3, 5:Ncol), sep="")))	
		}
		return(ctma)
	}
	atomblock <- ab2matrix(ct=sdf[index["atom",1]:index["atom",2]])
	
	## Bond block
	bb2matrix <- function(ct=sdf[index["bond",1]:index["bond",2]]) {
		#if((index["bond","end"] - index["bond","start"]) < 1) {
		if(((index["bond","end"] - index["bond","start"])+1) < 1) {
                        ctma <- matrix(rep(0,2), 1, 2, dimnames=list("0", c("C1", "C2"))) # Creates dummy matrix in case there is none.
                } else {
                    ct <- gsub("^(...)(...)(...)(...)(...)(...)(...)", "\\1 \\2 \\3 \\4 \\5 \\6 \\7", ct)
                    ct <- gsub("(^..\\d)(\\d)", "\\1 \\2", ct) # Splits bond strings where one or both of the atoms have 3 digit numbers
		    ct <- gsub("^ {1,}", "", ct)
                    ctlist <- strsplit(ct, " {1,}")
                    ctma <- matrix(unlist(ctlist), ncol=length(ctlist[[1]]), nrow=length(ct), byrow=TRUE)
                    Ncol <- length(ctlist[[1]])
                    ctma <- matrix(as.numeric(ctma), nrow=length(ct), ncol=Ncol, dimnames=list(1:length(ct), paste("C", 1:Ncol, sep="")))	
		}
                return(ctma)
	}
	bondblock <- bb2matrix(ct=sdf[index["bond",1]:index["bond",2]])
	
	
	if(tail2vec==TRUE) {
		extradata <- ex2vec(extradata=sdf[index["extradata",1]:index["extradata",2]])
	} else {	
		extradata <- sdf[index["extradata",1]:index["extradata",2]]
	}

	## Assemble components in object of class SDF
	if(datablock==TRUE) {
		sdf <- new("SDF", header=header, atomblock=atomblock, bondblock=bondblock, datablock=extradata)
	} else {
		sdf <- new("SDF", header=header, atomblock=atomblock, bondblock=bondblock)
	}
	return(sdf)
}
## SDF name/value block
ex2vec <- function(extradata) {
                exstart <- grep("^>", extradata)
		if(length(exstart)==0) { 
                        exvec <- vector("character", length=0) 
                } else {
                    names(exstart) <- gsub("^>.*<|>", "", extradata[exstart])
                    exindex <- cbind(start=exstart, end=c(exstart[-1], length(extradata))-1) # Changed 'length(extradata)+1' to 'length(extradata)' on Mar 22, 2014
		    exvec <- sapply(rownames(exindex), function(x) paste(extradata[(exindex[x,1]+1):(exindex[x,2]-1)], collapse=" __ "))
		}
                return(exvec)
	}


findPositions = function(sdf){

	patterns = c("BEGIN CTAB","COUNTS","BEGIN ATOM","END ATOM", 
					 "BEGIN BOND", "END BOND","M  END")

	tagPositions = lapply(patterns,function(pattern) grep(pattern,sdf,fixed=TRUE))
	tagPositions[which(lapply(tagPositions,length)==0)] = -1 # ensure unlist does not remove undefined entries
	tagPositions = unlist(tagPositions)

	unfound = which(tagPositions == -1)
	if(length(unfound) != 0){ # some tags are missing
		warning("malformed SDF V3000 file, could not find tags ",
				  paste("\"",patterns[unfound],"\"",sep="",collapse=","))
	}

	tagPositions

}

.parseV3000 <- function(sdf, datablock=TRUE, tail2vec=TRUE,extendedAttributes=TRUE) {
	#message("found V3000 formatted compound")
	sdfLength = length(sdf)

	tagPositions=findPositions(sdf)


	ctabPos = tagPositions[1]
	if(ctabPos == -1){
		header = sdf[1:4]
	}else
		header = sdf[1:(ctabPos-1)]
	
	if(length(header)==4) 
		names(header) <- c("Molecule_Name", "Source", "Comment", "Counts_Line")	

	countLinePos = tagPositions[2]
	if(countLinePos != -1)
		header["Counts_Line"] = sdf[countLinePos]
	


	#message("parsing atomblock")
	atomPos = tagPositions[3]
	if(atomPos == -1){
		warning("No ATOM block found in ",sdf[1]," returning a dummy atom block")
		atomblock <- matrix(rep(0,2), 1, 2, dimnames=list("0", c("C1", "C2"))) # Creates dummy matrix in case there is none.
	}else{
		#message("atomPos: ",atomPos," class: ",class(atomPos))
		atomEndPos = tagPositions[4]
		if(atomEndPos == -1){
				warning("Could not find the end of the ATOM block in ",sdf[1])
				atomEndPos = atomPos + 1 #assume and emtpy atom block
		}

		
		data = Reduce(rbind,Map(function(line) {
				parts = cstrsplit(line)
				attrs = if(length(parts) > 8)
								paste(parts[9:length(parts)],collapse=" ")
						  else ""
				c(parts[3:7],attrs)
			}, sdf[(atomPos+1):(atomEndPos-1)]))  #TODO: check for empty range
		#if(extendedAttributes)
		#	extAtomAttrs = parseAttributes(data[,6])
		extAtomAttrs = parseAttributes(data[,6])


		# we need to tranlate certain "Standard" attribute values from v3k back
		# into the v2k format to make things consistent
		#
		# <mass difference>  MASS  v2k: offset from pt v3k: actual value
		# <charge>   CHG           v2k: value of 1-7   v3k: actual charge value
		# <atom stereo parity>  CFG
		# <hydrogen count +1>   HCOUNT
		# <stereo care box>  STBOX
		# <valence>   VAL			v2k: 15 indicates 0  v3: -1 indicates 0
		standardAttrs = matrix(0,nrow(data),7)
		for(i in seq(along=extAtomAttrs)){ # for each atom
			mass = extAtomAttrs[[i]]$MASS
			if(!is.null(mass)){
				massDiff = mass - AW[data[i,2]]
				standardAttrs[i,1] = massDiff
			}
			chg= extAtomAttrs[[i]]$CHG
			if(!is.null(chg)){
				chg= 4 - as.numeric(chg)
				if(chg == 4) # undo shift for 0 values
					chg = 0
				if(chg < 1 || chg > 7) 
					chg = 0 # chg not in [1,7] => 0
				standardAttrs[i,2] = chg 
			}
			cfg = extAtomAttrs[[i]]$CFG
			if(!is.null(cfg)){
				standardAttrs[i,3] = cfg
			}
			hcount = extAtomAttrs[[i]]$HCOUNT
			if(!is.null(hcount)){
				standardAttrs[i,4] = hcount
			}
			stbox = extAtomAttrs[[i]]$STBOX
			if(!is.null(stbox)){
				standardAttrs[i,5] = stbox
			}
			val = extAtomAttrs[[i]]$val
			if(!is.null(val)){
				if(val == -1) # means 0 in v3k
					val = 15   # translate to 0 in v2k 
				standardAttrs[i,6] = val
			}
		}

    	#print(extAtomAttrs)
		atomblock =cbind(data[,3:5],standardAttrs)
		mode(atomblock)="numeric"
		#print(atomblock)
		colnames(atomblock) = paste("C",c(1:3,5:11),sep="")
		rownames(atomblock) = paste(data[,2],data[,1],sep="_")
	}


	#message("parsing bond block")
	bondPos = tagPositions[5]
	if(bondPos == -1){
		warning("No BOND block found in ",sdf[1]," returning a dummy bond block")
		bondblock <- matrix(rep(0,2), 1, 2, dimnames=list("0", c("C1", "C2"))) # Creates dummy matrix in case there is none.
	}else{
		bondEndPos = tagPositions[6]
		if(bondEndPos == -1){
	  		warning("Could not find the end of the BOND block in ",sdf[1])
	  		bondEndPos = bondPos + 1 #assume and emtpy atom block
		}

		data = Reduce(rbind,Map(function(line) {
				#cstrsplit(line)[3:6]
				parts = cstrsplit(line)
				attrs=  if(length(parts) > 6)
								paste(parts[7:length(parts)],collapse=" ")
						  else ""
				c(parts[3:6],attrs)
			}, sdf[(bondPos+1):(bondEndPos-1)]))  #TODO: check for empty range
		extBondAttrs = parseAttributes(data[,5])  # +2.6s

		# CFG  bond configuration(stereo)  change: 0 -> 0, 1-> 1, 2-> 4, 3->6
		# empty slot
		# TOPO  same
		# RXCTR same
		standardAttrs = matrix(0,nrow(data),4)  # +0.8s
		for(i in seq(along=extBondAttrs)){  # +1.3s
			cfg=extBondAttrs[[i]]$CFG
			if(!is.null(cfg)){
				#cfg = extBondAttrs[[i]]$CFG
				if(cfg == 2) cfg = 4
				else if(cfg == 3) cfg = 6
				standardAttrs[i,1] = cfg
			}
			topo=extBondAttrs[[i]]$TOPO
			if(!is.null(topo)){
				standardAttrs[i,3] = topo
			}
			rxctr=extBondAttrs[[i]]$rxctr
			if(!is.null(rxctr)){
				standardAttrs[i,4] = rxctr
			}
		}

		bondblock = cbind(data[,c(3,4,2)],standardAttrs) # +0.5s
		#bondblock = data[,c(3,4,2)]
		mode(bondblock)="numeric"
		colnames(bondblock) = paste("C",1:7,sep="")
		rownames(bondblock) = data[,1]
	}


	#message("parsing extra data")
	endPos = tagPositions[7]
	if(endPos == -1){
		warning("no END tag found in ",sdf[1])
		extradata = vector("character",length=0)
	}else{
		if(endPos+2 < sdfLength){
			extradata = if(tail2vec==TRUE) ex2vec(sdf[(endPos+1):sdfLength])
							else sdf[(endPos+1):sdfLength]
		}
		else
			extradata = vector("character",length=0)
	}

	## Assemble components in object of class SDF
	className = "SDF"
	args = list( header=header, atomblock=atomblock, bondblock=bondblock,version="V3000")
	if(datablock==TRUE) 
		args = c(args,datablock=list(extradata))
	
	if(extendedAttributes==TRUE) {
		className = "ExtSDF"
		args = c(args,extendedAtomAttributes =list(extAtomAttrs),
					extendedBondAttributes = list(extBondAttrs) )
	}
	#message("className: ",className," args: ")
	#print(str(args))

	sdf = do.call("new",c(className,args))

	return(sdf)

}
trim <- function(str) gsub("^\\s+|\\s+$","",str)
parseAttributes <- function(attributes){
	#message("attributes: ")
	#print(attributes)

	if(all(attributes=="")){
		return(sapply(seq(along=attributes),function(i) list()))
	}


	starts = gregexpr("(^|\\s)[a-zA-Z0-9]+=",attributes)
	sapply(seq(along=attributes),function(i) {
			 if(attributes[i]=="")
				 list()
			 else{
				 starts[[i]][length(starts[[i]])+1] = nchar(attributes[i])
	#			 message("starts[[",i,"]]:")
	#			 print(starts[[i]])
				 sapply(1:(length(starts[[i]])-1),function(j){
						pair = unlist(strsplit(
											  substring(attributes[i],starts[[i]][j],starts[[i]][j+1])
											  ,"=",fixed=TRUE) )
	#					print(pair)
						if(length(pair) != 2)
							warning("bad key value pair found:
									  ",substring(attributes[i],starts[[i]][j],starts[[i]][j+1]))
						l=list()
						l[[trim(pair[1])]] = trim(pair[2])
						l
				
				})
			 }
	 })
}
attributesAsString<- function(attributes){
	sapply(attributes,
			 function(x){ 
				 return(
						  if(length(x) > 0) 
							  paste(apply(cbind(names(x),E="=",x),1,function(row) paste(row,collapse="") ),collapse=" ")  
						  else "") })

}
## Accessor methods for SDF class
setGeneric(name="sdf2list", def=function(x) standardGeneric("sdf2list"))
setMethod(f="sdf2list", signature="SDF", definition=function(x) {return(list(header=header(x), atomblock=atomblock(x), bondblock=bondblock(x), datablock=datablock(x)))}) 
setGeneric(name="header", def=function(x) standardGeneric("header"))
setMethod(f="header", signature="SDF", definition=function(x) {return(x@header)}) 
setGeneric(name="sdfid", def=function(x, tag=1) standardGeneric("sdfid"))
setMethod(f="sdfid", signature="SDF", definition=function(x, tag=1) {return(x@header[tag])}) 
setGeneric(name="atomblock", def=function(x) standardGeneric("atomblock"))
setMethod(f="atomblock", signature="SDF", definition=function(x) {return(x@atomblock)}) 
setGeneric(name="atomcount", def=function(x, addH=FALSE, ...) standardGeneric("atomcount"))
setMethod(f="atomcount", signature="SDF", definition=function(x, addH=FALSE, ...) {
	if(addH==TRUE) { 
		return(table(c(gsub("_.*", "", rownames(x@atomblock)), rep("H", bonds(x, type="addNH")))))
	} else {
		return(table(gsub("_.*", "", rownames(x@atomblock))))
	}
})
setGeneric(name="bondblock", def=function(x) standardGeneric("bondblock"))
setMethod(f="bondblock", signature="SDF", definition=function(x) {return(x@bondblock)}) 
setGeneric(name="datablock", def=function(x) standardGeneric("datablock"))
setMethod(f="datablock", signature="SDF", definition=function(x) {return(x@datablock)}) 
setGeneric(name="datablocktag", def=function(x, tag) standardGeneric("datablocktag"))
setMethod(f="datablocktag", signature="SDF", definition=function(x, tag) {return(x@datablock[tag])}) 

setGeneric(name="obmol",def=function(x) standardGeneric("obmol"))
setMethod(f="obmol",signature="SDF",definition= function(x) {
	.ensureOB()
	if(is.null(x@obmolRef))
		x@obmolRef = sdf2OBMol(x)
	x@obmolRef
})

## Define print behavior for SDF
setMethod(f="show", signature="SDF",                
   definition=function(object) {
         cat("An instance of ", "\"", class(object), "\"", "\n", sep="")
         cat("\n<<header>>", "\n", sep="")
         print(header(object))
         cat("\n<<atomblock>>", "\n", sep="")
         if(length(atomblock(object)[,1])>=5) {
             print(as.data.frame(rbind(atomblock(object)[1:2,], ...=rep("...", length(atomblock(object)[1,])), 
             atomblock(object)[(length(atomblock(object)[,1])-1):length(atomblock(object)[,1]),])))
         } else {
             print(atomblock(object))}
         cat("\n<<bondblock>>", "\n", sep="")
         if(length(bondblock(object)[,1])>=5) {
             print(as.data.frame(rbind(bondblock(object)[1:2,], ...=rep("...", length(bondblock(object)[1,])), 
             bondblock(object)[(length(bondblock(object)[,1])-1):length(bondblock(object)[,1]),])))
         } else {
             print(bondblock(object))}
         cat("\n<<datablock>> (", length(datablock(object)), " data items)", "\n", sep="")
         if(length(datablock(object))>=5) {
         	print(c(datablock(object)[1:4], "..."))
         } else {
         	print(datablock(object))}
})

## Behavior of "[" operator for SDF
setMethod(f="[", signature="SDF",
	definition=function(x, i, ..., drop) {
		return(sdf2list(x)[i]) 
})

## Replacement method for SDF using "[" operator 
setReplaceMethod(f="[", signature="SDF", definition=function(x, i, j, value) {
	if(i==1) x@header <- value
	if(i==2) x@atomblock <- value 
	if(i==3) x@bondblock <- value
	if(i==4) x@datablock <- value
	if(i=="header") x@header <- value
	if(i=="atomblock") x@atomblock <- value 
	if(i=="bondblock") x@bondblock <- value
	if(i=="datablock") x@datablock <- value
	obmolRef=NULL
	return(x)
})

## Behavior of "[[" operator for SDF
setMethod(f="[[", signature="SDF",
	definition=function(x, i, ..., drop) {
		return(sdf2list(x)[[i]]) 
})

## Replacement method for SDF using "[[" operator 
setReplaceMethod(f="[[", signature="SDF", definition=function(x, i, j, value) {
	if(i==1) x@header <- value
	if(i==2) x@atomblock <- value 
	if(i==3) x@bondblock <- value
	if(i==4) x@datablock <- value
	if(i=="header") x@header <- value
	if(i=="atomblock") x@atomblock <- value 
	if(i=="bondblock") x@bondblock <- value
	if(i=="datablock") x@datablock <- value
	obmolRef=NULL
	return(x)
})

## Coerce Methods for SDF Class 
## Character vector to SDF
setAs(from="character", to="SDF", 
	def=function(from) {
		.sdfParse(sdf=from) 
})

## SDF to list
setAs(from="SDF", to="list", 
	def=function(from) {
		list(header=header(from), atomblock=atomblock(from), bondblock=bondblock(from), datablock=datablock(from))
})

## SDF to SDFstr
setAs(from="SDF", to="SDFstr", 
	def=function(from) {
		new("SDFstr", a=list(as(from, "character")))		
})

## list (w. SDF components) to SDF  
setAs(from="list", to="SDF", 
	def=function(from) {
		new("SDF", bondblock=from$bondblock, header=from$header, atomblock=from$atomblock, datablock=from$datablock)
})

################################################# 
##  ExtSDF
################################################# 

setClass("ExtSDF",representation(extendedAtomAttributes="list",
											extendedBondAttributes="list"),contains="SDF")

setGeneric(name="getAtomAttr", def=function(x,atomId,tag) standardGeneric("getAtomAttr"))
setMethod(f="getAtomAttr", signature="ExtSDF",definition = 
			 function(x,atomId,tag) x@extendedAtomAttributes[[atomId]][[tag]])

setGeneric(name="getBondAttr", def=function(x,bondId,tag) standardGeneric("getBondAttr"))
setMethod(f="getBondAttr", signature="ExtSDF",definition = 
			 function(x,bondId,tag) x@extendedBondAttributes[[bondId]][[tag]])
setMethod(f="show", signature="ExtSDF",                
   definition=function(object) {
		callNextMethod(object)
		nonEmptyAtoms = which(sapply(object@extendedAtomAttributes,
											  function(x) length(x)!=0))
		message("<<Extended Atom Attributes>>")
		count = min(5,length(nonEmptyAtoms))
		for(i in nonEmptyAtoms[seq(1,count,length.out=count)]){
			message("Atom ",i)
			print(object@extendedAtomAttributes[[i]])
		}

		nonEmptyBonds = which(sapply(object@extendedBondAttributes,
											  function(x) length(x)!=0))
		message("<<Extended Bond Attributes>>")
		count = min(5,length(nonEmptyBonds))
		for(i in nonEmptyBonds[seq(1,count,length.out=count)]){
			message("Bond ",i)
			print(object@extendedBondAttributes[[i]])
		}
	})
 
################################################# 
## (3) Class and Method Definitions for SDFset ##
#################################################
setClass("SDFset", representation(SDF="list", ID="character"))

## Store many SDFs in SDFset Object
read.SDFset <- function(sdfstr=sdfstr,skipErrors=FALSE, ...) {
	## If a file name is provided run read.SDFstr function first
	if(is.character(sdfstr)) { 
		sdfstr <- read.SDFstr(sdfstr=sdfstr) 
	}
	## Iterate over SDFstr components	
	sdfset <- lapply(seq(along=sdfstr@a), 
						  function(x){
							  tryCatch(
								  .sdfParse(sdfstr2list(sdfstr)[[x]], ...),
								  error=function(error){
									  if(skipErrors){
										  warning("failed to parse item ",x,": ",error)
										  NA
									  }else
										  stop("failed to parse item ",x,": ",error)
								  }
								)
						  })
	failedToParse <- is.na(sdfset)
	if(sum(failedToParse) != 0)
		warning("Failed to parse input compounds at indexe(s) (",paste(which(failedToParse),collapse=", "),
				  "). These have been removed from the output.")
	sdfset <- sdfset[!failedToParse]
	sdfset <- new("SDFset", SDF=sdfset, ID=paste("CMP", seq(along=sdfset), sep=""))
	## Validity check of SDFs based on atom/bond block column numbers
	badsdf <- sum(!validSDF(sdfset))
	if(sum(badsdf)!=0) warning(paste(c(sum(badsdf), " invalid SDFs detected. To fix, run: valid <- validSDF(sdfset); sdfset <- sdfset[valid]")))
	return(sdfset)
}

## Accessor methods for SDFset class
setGeneric(name="SDFset2list", def=function(x) standardGeneric("SDFset2list"))
setMethod(f="SDFset2list", signature="SDFset", definition=function(x) {
	SDFlist <- x@SDF
	charlist <- lapply(seq(along=SDFlist), function(x) as(SDFlist[[x]], "list"))
	names(charlist) <- x@ID
	return(charlist)
}) 
setGeneric(name="SDFset2SDF", def=function(x) standardGeneric("SDFset2SDF"))
setMethod(f="SDFset2SDF", signature="SDFset", definition=function(x) { tmp <- x@SDF; names(tmp) <- x@ID; return(tmp)}) 
setMethod(f="header", signature="SDFset", definition=function(x) { return(lapply(SDFset2SDF(x), header))}) 
setMethod(f="sdfid", signature="SDFset", definition=function(x, tag=1) {return(as.vector(sapply(SDFset2SDF(x), sdfid, tag)))}) 
setGeneric(name="cid", def=function(x) standardGeneric("cid"))
setMethod(f="cid", signature="SDFset", definition=function(x) {return(x@ID)}) 
setMethod(f="atomblock", signature="SDFset", definition=function(x) {return(lapply(SDFset2SDF(x), atomblock))}) 
setMethod(f="atomcount", signature="SDFset", definition=function(x, addH, ...) {
	atomcounts <- lapply(SDFset2SDF(x), function(y) atomcount(y, addH, ...))
	return(atomcounts)
}) 
setMethod(f="bondblock", signature="SDFset", definition=function(x) {return(lapply(SDFset2SDF(x), bondblock))}) 
setMethod(f="datablock", signature="SDFset", definition=function(x) {return(lapply(SDFset2SDF(x), datablock))}) 
setMethod(f="datablocktag", signature="SDFset", definition=function(x, tag) {return(as.vector(sapply(SDFset2SDF(x), datablocktag, tag)))}) 
setMethod(f="obmol",signature="SDFset",definition= function(x) lapply(SDFset2SDF(x),obmol))

## Replacement method for SDF component of SDFset using accessor methods
setGeneric(name="SDFset2SDF<-", def=function(x, value) standardGeneric("SDFset2SDF<-"))
setReplaceMethod(f="SDFset2SDF", signature="SDFset", definition=function(x, value) {
	x@SDF <- value 
	return(x)
})

## Replacement method for ID component of SDFset using accessor methods
setGeneric(name="cid<-", def=function(x, value) standardGeneric("cid<-"))
setReplaceMethod(f="cid", signature="SDFset", definition=function(x, value) {
	x@ID <- value 
	if(any(duplicated(x@ID))) { 
		warning("The values in the CMP ID slot are not unique anymore. To fix this, run: cid(sdfset) <- makeUnique(cid(sdfset))")
	}
	return(x)
})

## Replacement method for SDFset using "[" operator 
## It doesn't provide here full set of expected functionalities.
setReplaceMethod(f="[", signature="SDFset", definition=function(x, i, j, value) {
	x@SDF[i] <- SDFset2SDF(value)
	return(x)
})

## Behavior of "[" operator for SDFset 
setMethod(f="[", signature="SDFset", definition=function(x, i, ..., drop) {
	if(is.logical(i)) {
                i <- which(i)
        }
        if(is.character(i)) { 
		ids <-seq(along=x@ID); names(ids) <- x@ID
		i <- ids[i]
	}
	x@SDF <- x@SDF[i]                   
	x@ID <- x@ID[i]                   
	if(any(duplicated(i))) {
		warning("The values in the CMP ID slot are not unique anymore. To fix this, run: cid(sdfset) <- makeUnique(cid(sdfset))")
	}
	return(x)
})

## Replacement method for SDFset using "[" operator 
setReplaceMethod(f="[", signature="SDFset", definition=function(x, i, value) {
	x@SDF[i] <- value
	return(x)
})

## Replacement method for SDFset using "[[" operator 
setReplaceMethod(f="[[", signature="SDFset", definition=function(x, i, value) {
	x@SDF[[i]] <- value
	return(x)
})

## Behavior of "[[" operator for SDFset to convert single SDFset component to SDF 
setMethod(f="[[", signature="SDFset", definition=function(x, i, ..., drop) {
	if(is.character(i)) { i <- which(x@ID %in% i) }
	return(x@SDF[[i]])                 
})

## Batch replacement of header, atomblock, bondblock and datablock sections for
## one to all SDF objects in an SDFset.
.gsubsdfsec <- function(sdfset, what, secdata) {
	if(any(class(secdata) %in% c("data.frame", "matrix"))) { 
		secdata <- as.matrix(secdata)
		tmp <- as.list(seq(along=secdata[,1]))
		for(i in seq(along=tmp)) {
			vec <- as.character(secdata[i,])
			names(vec) <- colnames(secdata)
			tmp[[i]] <- vec
		}
		secdata <- tmp
	}
	if(length(sdfset) != length(secdata)) { stop("The length of the two data sets needs to match.") }
	sdfsec <- list(header=header(sdfset), atomblock=atomblock(sdfset), bondblock=bondblock(sdfset), datablock=datablock(sdfset))
	sdfsec[[what]] <- secdata
	sdflist <- lapply(seq(along=sdfsec[[1]]), function(x) as(list(header=sdfsec$header[[x]], atomblock=sdfsec$atomblock[[x]], bondblock=sdfsec$bondblock[[x]], datablock=sdfsec$datablock[[x]]), "SDF")) 
	names(sdflist) <- cid(sdfset)
	return(as(sdflist, "SDFset"))
}

setGeneric(name="header<-", def=function(x, value) standardGeneric("header<-"))
setReplaceMethod(f="header", signature="SDFset", definition=function(x, value) {
	sdfset <- .gsubsdfsec(sdfset=x, what=1, secdata=value) 
	return(sdfset)
})

setGeneric(name="atomblock<-", def=function(x, value) standardGeneric("atomblock<-"))
setReplaceMethod(f="atomblock", signature="SDFset", definition=function(x, value) {
	sdfset <- .gsubsdfsec(sdfset=x, what=2, secdata=value) 
	return(sdfset)
})

setGeneric(name="bondblock<-", def=function(x, value) standardGeneric("bondblock<-"))
setReplaceMethod(f="bondblock", signature="SDFset", definition=function(x, value) {
	sdfset <- .gsubsdfsec(sdfset=x, what=3, secdata=value) 
	return(sdfset)
})

setGeneric(name="datablock<-", def=function(x, value) standardGeneric("datablock<-"))
setReplaceMethod(f="datablock", signature="SDFset", definition=function(x, value) {
	sdfset <- .gsubsdfsec(sdfset=x, what=4, secdata=value) 
	return(sdfset)
})


## Length function
setMethod(f="length", signature="SDFset",
    definition=function(x) {
    	return(length(SDFset2SDF(x)))
})

## Print behavior for SDFset
setMethod(f="show", signature="SDFset",
	definition=function(object) { 
		cat("An instance of ", "\"", class(object), "\"", " with ", length(object), " molecules", "\n", sep="")
		if(any(duplicated(object@ID))) {
			warning("The values in the CMP ID slot are not unique. To fix this, run: cid(sdfset) <- makeUnique(cid(sdfset))")
		}
})

## Concatenate function for SDFset
## Note: is currently limited to 2 arguments!
setMethod(f="c", signature="SDFset", definition=function(x, y) {
	sdflist1 <- as(x, "SDF")
	sdflist2 <- as(y, "SDF")
	sdflist <- c(sdflist1, sdflist2)
	sdfset <- as(sdflist, "SDFset")
	if(any(duplicated(cid(sdfset)))) {
		warning("The values in the CMP ID slot are not unique anymore, makeUnique() can fix this!")
	}
	return(sdfset)
})

## Convert SDF to SDFstr Class for Export to File
## Function allows to customize output via optional arguments 
setGeneric(name="sdf2str", def=function(sdf, head, ab, bb, db, cid=NULL, sig=FALSE, ...) standardGeneric("sdf2str"))
setMethod(f="sdf2str", signature="SDF", definition = function(sdf, head, ab, bb, db, cid=NULL, sig=FALSE, ...) {
	## Checks
	if(class(sdf)!="SDF" && class(sdf) != "ExtSDF") stop("Function expects molecule object of class SDF as input!")	

	if(.hasSlot(sdf,"version") && sdf@version == "V3000"){
		if(extends(class(sdf),"ExtSDF"))
			return(writeV3000(sdf,head,ab,bb,db,cid,sig))
		else #not enough info for V3000 output, but need to at least fix count line to make compatible with V2000
			sdf[[1]]["Counts_Line"] = paste0("", nrow(atomblock(sdf)), " ", nrow(bondblock(sdf)), "  0  0  0  0  0  0  0  0999 V2000")  
	}
	
	## Header
	if(missing(head)) {
		head <- as.character(sdf[[1]])
		if(sig==TRUE) head[2] <- paste("ChemmineR-", format(Sys.time(), "%m%d%y%H%M"), "XD", sep="")	
		if(length(cid)==1) head[1] <- cid
	}
	
	## Atom block
	if(missing(ab)) {
		ab <- sdf[[2]]
		#ab <- cbind(Indent="", format(ab[,1:3], width=9, justify="right"), A=format(gsub("_.*", "", rownames(ab)), width=1, justify="right"), Space="", format(ab[,-c(1:3)], width=2, justify="right")) # Changed on 26-Aug-13
		ab <- cbind(Indent="", format(ab[,1:3], width=9, justify="right"), A=format(gsub("_.*", "", rownames(ab)), width=1, justify="left"),  Space="", format(ab[,-c(1:3)], width=2, justify="right"))
		ab <- sapply(seq(along=ab[,1]), function(x) paste(ab[x, ], collapse=" "))
	}

	## Bond block
	if(missing(bb)) {
		bb <- sdf[[3]]
		bb <- cbind(Indent="", format(bb, width=3, justify="right"))
		bb <- sapply(seq(along=bb[,1]), function(x) paste(bb[x, ], collapse=""))
	}

	## Data block
	if(missing(db)) {
		db <- sdf[[4]]
		if(length(db)>0) {
			dbnames <- paste("> <", names(db), ">", sep="")
			dbvalues <- gsub(" __ ",if(.Platform$OS.type=="unix")"\n" else "\r\n", as.character(db))
			db <- as.vector(rbind(dbnames, dbvalues, ""))
		} else {
			db <- NULL
		}
	}
	
	## Assemble in character vector
	sdfstrvec <- c(head, ab, bb, "M  END", db, "$$$$")
   return(sdfstrvec)
})

writeV3000 <- function(sdf,head,ab,bb,db,cid=NULL, sig=FALSE) {
	## Header
	if(missing(head)) {
		head <- as.character(sdf[[1]])
		if(sig==TRUE) head[2] <- paste("ChemmineR-", format(Sys.time(), "%m%d%y%H%M"), "XD", sep="")	
		if(length(cid)==1) head[1] <- cid
	}
	head[4] = "0 0 0 0 0 999 V3000"
	
	## Atom block
	if(missing(ab)) {
		ab <- sdf[[2]]
		ab <- cbind(Prefix="M  V30", 
						seq(along=ab[,1]),
						A=gsub("_.*", "", rownames(ab)), # molecule name
						ab[,1:3],  #coordinates
						rep(0,length(ab[,1])),
						attributesAsString(sdf@extendedAtomAttributes)
												) 
		ab <- sapply(seq(along=ab[,1]), function(x) paste(ab[x, ], collapse=" "))
	}

	## Bond block
	if(missing(bb)) {
		bb <- sdf[[3]]
		bb <- cbind(Prefix="M  V30",
						seq(along=bb[,1]), 
						bb[,c(3,1,2)],
						attributesAsString(sdf@extendedBondAttributes)
						)
		bb <- sapply(seq(along=bb[,1]), function(x) paste(bb[x, ], collapse=" "))
	}

	## Data block
	if(missing(db)) {
		db <- sdf[[4]]
		if(length(db)>0) {
			dbnames <- paste("> <", names(db), ">", sep="")
			dbvalues <- gsub(" __ ",if(.Platform$OS.type=="unix")"\n" else "\r\n", as.character(db))
			db <- as.vector(rbind(dbnames, dbvalues, ""))
		} else {
			db <- NULL
		}
	}
	
	miscNumbers = strsplit(sdf[[1]]["Counts_Line"],split="\\s+",)[[1]][6:8]
	
	counts = paste("M  V30 COUNTS",length(ab),length(bb),miscNumbers[1],miscNumbers[2],miscNumbers[3] )
	## Assemble in character vector
	sdfstrvec <- c(head, 
						"M  V30 BEGIN CTAB",
						counts,
						"M  V30 BEGIN ATOM",
						ab, 
						"M  V30 END ATOM",
						"M  V30 BEGIN BOND",
						bb, 
						"M  V30 END BOND",
						"M  V30 END CTAB",
						"M  END", 
						db, 
						"$$$$")
   return(sdfstrvec)

}

## Coerce Methods for SDFset Class 
## SDFset to list with lists of SDF sub-components
setAs(from="SDFset", to="list", 
	def=function(from) {
		SDFset2list(from)
})

## SDFset to list with many SDF objects (for summary view)
setAs(from="SDFset", to="SDF", 
	def=function(from) {
		SDFset2SDF(from)
})
setGeneric(name="view", def=function(x) standardGeneric("view"))
setMethod(f="view", signature="SDFset", definition=function(x) { as(x, "SDF") })

## SDFstr to SDFset
setAs(from="SDFstr", to="SDFset", 
	def=function(from) {
		read.SDFset(sdfstr=from) 
})

## SDF to SDFset of length one
setAs(from="SDF", to="SDFset", 
	def=function(from) {
		new("SDFset", SDF=list(from), ID="CMP") 
})

## SDF to SDFstr
setAs(from="SDF", to="SDFstr", 
	def=function(from) {
		as(as(from, "SDFset"), "SDFstr") 
})

## SDFset to character for SDFstr coercion
setAs(from="SDF", to="character", 
	def=function(from) {
       		sdf2str(sdf=from)
})

## SDFset to SDFstr
setAs(from="SDFset", to="SDFstr", 
	def=function(from) {
		from <- lapply(seq(along=from), function(x) as(from[[x]], "character"))
		new("SDFstr", a=from)		
})

## List of SDFs to SDFset
setAs(from="list", to="SDFset", 
	def=function(from) {
		new("SDFset", SDF=from, ID=names(from))
})

## User interface to SDFset() constructor
SDFset <- function(SDFlist=list(), ID=character()) {
	new("SDFset", SDF=SDFlist, ID=ID)
}

setClass("SDFset", representation(SDF="list", ID="character"))

#########################################################
## (4) Class and Method Definitions for SMI and SMIset ##
#########################################################
## Define SMI and SMIset classes
setClass("SMI", representation(smiles="character"))
setClass("SMIset", representation(smilist="list"))

## Methods to return SMI/SMIset objects as character vector or list, respectively
setMethod(f="as.character", signature="SMI", definition=function(x) {return(x@smiles)})
setMethod(f="as.character", signature="SMIset", definition=function(x) {return(unlist(x@smilist))})

## Constructor methods
## Character vector to FP with: as(myvector, "SMI")
setAs(from="character", to="SMI",  
        def=function(from) {
		new("SMI", smiles=from)
})

## List to SMIset with: as(mylist, "SMIset")
setAs(from="list", to="SMIset",  
        def=function(from) {
		new("SMIset", smilist=from)
})

## Character to SMIset with: as(mychar, "SMIset")
setAs(from="character", to="SMIset",  
        def=function(from) {
		new("SMIset", smilist=as.list(from))
})

## Accessor methods for SMIset
## Note: generic for cid() is defined under SDFset class section.
setMethod(f="cid", signature="SMIset", definition=function(x) { return(names(x@smilist)) })

## Replacement method for ID component of SMIset using accessor methods.
setReplaceMethod(f="cid", signature="SMIset", definition=function(x, value) {
	names(x@smilist) <- value 
	if(any(duplicated(names(x@smilist)))) { 
		warning("The values in the CMP ID slot are not unique anymore. To fix this, run: cid(smiset) <- makeUnique(cid(smiset))")
	}
	return(x)
})

## Replacement method for SMIset using "[" operator 
## It doesn't provide here full set of expected functionalities.
setReplaceMethod(f="[", signature="SMIset", definition=function(x, i, value) {
	x@smilist[i] <- value
	names(x@smilist) <- names(value)
	return(x)
})

## Behavior of "[" operator for SMIset 
setMethod(f="[", signature="SMIset", definition=function(x, i, ..., drop) {
	if(is.logical(i)) {
                i <- which(i)
        }
	x@smilist <- x@smilist[i]                   
	if(any(duplicated(i))) {
		warning("The values in the CMP ID slot are not unique anymore. To fix this, run: cid(smiset) <- makeUnique(cid(smiset))")
	}
	return(x)
})

## Behavior of "[[" operator for SMIset to convert single SMIset component to SMI
setMethod(f="[[", signature="SMIset", definition=function(x, i, ..., drop) {
	if(is.character(i)) { i <- which(names(x@fpma) %in% i) }
	return(new("SMI", smiles=x@smilist[[i]]))                 
})

## Length function
setMethod(f="length", signature="SMIset",
    definition=function(x) {
    	return(length(as.character(x)))
})

## Define print behavior for SMIset
setMethod(f="show", signature="SMIset", 
	definition=function(object) {    
		cat("An instance of ", "\"", class(object), "\"", " with ", length(object), " molecules", "\n", sep="")
		if(any(duplicated(names(object@smilist)))) {
			warning("The values in the CMP ID slot are not unique. To fix this, run: cid(smiset) <- makeUnique(cid(smiset))")
		}
})

## Concatenate function for SMIset
## Note: is currently limited to 2 arguments!
setMethod(f="c", signature="SMIset", definition=function(x, y) {
	smilist1 <- as.list(x)
	smilist2 <- as.list(y)
	smilist <- c(smilist1, smilist2)
	smiset <- as(smilist, "SMIset")
	if(any(duplicated(cid(smiset)))) {
		warning("The values in the CMP ID slot are not unique anymore, makeUnique() can fix this!")
	}
	return(smiset)
})

## Define print behavior for SMI
setMethod(f="show", signature="SMI",                
   definition=function(object) {
         cat("An instance of ", "\"", class(object), "\"", "\n", sep="")
         print(object@smiles)
})

## SMIset to list with many SMI objects (for summary view)
setAs(from="SMIset", to="SMI", 
        def=function(from) {
                tmp <- lapply(seq(along=from), function(x) from[[x]])
		names(tmp) <- cid(from)
		return(tmp)
})
setMethod(f="view", signature="SMIset", definition=function(x) { as(x, "SMI") })
# view(smiset)

## Import SMILES Files and Store them as SMIset Objects
read.SMIset <- function(file, removespaces=TRUE, ...) {
	smisettmp <- readLines(file, ...)
	if(removespaces==TRUE) smisettmp <- gsub(" {1,}", "", smisettmp)
	## Add compound names where they are missing
	index <- !grepl("\t.{1,}$", smisettmp)
	if(any(index)) smisettmp[index] <- paste(smisettmp[index], "\t", "CMP", which(index), sep="")
	## Construct and return SMIset object
	smiset <- gsub("\t.*$", "", smisettmp)
	names(smiset) <- gsub("^.*\t", "", smisettmp)
        smiset <- as(smiset, "SMIset")
        return(smiset)
}

## Write SMI/SMIset Objects to File 
write.SMI <- function(smi, file, cid=TRUE, ...) {
	if(class(smi)=="SMI") smima <- cbind(as.character(smi), "CMP1")
	if(class(smi)=="SMIset") smima <- cbind(as.character(smi), cid(smi), ...)
	if(cid==TRUE) write.table(smima, file=file, quote=FALSE, sep="\t", row.names=FALSE, col.names = FALSE) 
	if(cid==FALSE) write.table(smima[ , 1, drop = TRUE], file=file, quote=FALSE, sep="\t", row.names=FALSE, col.names = FALSE) 
} 

#######################################################
## (5) Class and Method Definitions for AP and APset ##
#######################################################
## Function to coerce SDF class to old non-S4 AP CMP object
SDF2apcmp <- function(SDF) { 
	atoms <- gsub("_.*", "", rownames(atomblock(SDF)))
	u <- as.numeric(bondblock(SDF)[,1])
	n_atoms <- length(atoms)
	n_bonds <- length(u)
	v <- as.numeric(bondblock(SDF)[,2])
	t <- as.numeric(bondblock(SDF)[,3])

	cmp = list(atoms=atoms, bonds=list(u=u, v=v, t=t), n_atoms=n_atoms, n_bonds=n_bonds)

	# assume we have an SDF object, not an SDFset
	sdfstr=as(as(SDF,"SDFstr"),"list")[[1]]
	defs = paste(sdfstr,collapse="\n")
	#defs = unlist(Map(function(x) paste(x,collapse="\n"), sdfstrList) )
	d <- Descriptors()
	if (Descriptors_parse_sdf(self=d, sdf=defs) == 0) {
		stop("SDF format not available or SDF not well-formatted!")
		return(list(n_atoms=0, n_bonds=0, desc_obj=NULL))
	}
	cmp$desc_obj=d

	return(cmp)
}

## Define AP/APset S4 classes for single AP vector and AP list
setClass("AP", representation(AP="numeric"))
setClass("APset", representation(AP="list", ID="character"))

## Create instance of APset form SDFset 
sdf2ap <- function(sdfset, type="AP",uniquePairs=TRUE) {
        if(!class(sdfset) %in% c("SDF", "SDFset")) stop("Functions expects input of classes SDF or SDFset.")
        if(class(sdfset)=="SDF") {
	         if(type=="AP") {
                	return(new("AP",
										AP=genAPDescriptors(sdfset,uniquePairs)))
        	   }
	         if(type=="character") {
                	return(paste(genAPDescriptors(sdfset,uniquePairs), collapse=", "))
        	   }
	     }
        if(class(sdfset)=="SDFset") {
                aplist <- as.list(seq(along=sdfset))
                exception <- FALSE
                for(i in seq(along=aplist)) {
                        tmp <- try(genAPDescriptors(sdfset[[i]],uniquePairs))
                        if(length(tmp) > 0 & class(tmp)!="try-error") {
                                aplist[[i]] <- tmp
                        } else if(length(tmp) == 0 & class(tmp)!="try-error") {
                                aplist[[i]] <- 0 # Value to use if no atom pairs are returned 
                                exception <- TRUE
                        } else if(class(tmp)=="try-error") {
                                aplist[[i]] <- 1 # Value to use if error is returned 
                                exception <- TRUE
                        }
                }
		if(exception) {
                        warning("One or more compounds failed to return APs. To identify them, run: \n\t which(sapply(as(apset, \"list\"), length)==1)")
		}
                if(type=="AP") {
                	return(new("APset", AP=aplist, ID=cid(sdfset)))
        	}
		if(type=="character") {
			names(aplist) <- cid(sdfset)
                	return(sapply(aplist, paste, collapse=", "))
        	}
        }
}

## Create AP Fingerprints
desc2fp <- function(x, descnames=1024, type="FPset") {
	if(length(descnames) == 1) {
		data(apfp)
		descnames <- as.character(apfp$AP)[1:descnames]
	}	
	if(class(x)=="APset") { 
        	apfp <- matrix(0, nrow=length(x), ncol=length(descnames), dimnames=list(cid(x), descnames))
		apsetlist <- ap(x)
                for(i in cid(x)) apfp[i, descnames %in% as.character(apsetlist[[i]])] <- 1
        } else if(class(x)=="list") {
        	apfp <- matrix(0, nrow=length(x), ncol=length(descnames), dimnames=list(names(x), descnames))
		for(i in names(x)) apfp[i, descnames %in% as.character(x[[i]])] <- 1
	} else {
		stop("x needs to be of class APset or list")
	}
        if(type=="FPset") {
                #return(as(apfp, "FPset"))
                return(new("FPset",fpma=apfp,type="apfp"))
        }
        if(type=="matrix") {
                return(apfp)
        }
        if(type=="character") {
                return(sapply(rownames(apfp), function(x) paste(apfp[x,], collapse="")))
        }
}
## Usage: 
# apfpset <- desc2fp(x=apset, descnames=1024, type="matrix")

## Accessor methods for APset class
setGeneric(name="ap", def=function(x) standardGeneric("ap"))

setMethod(f="ap", signature="AP", definition=function(x) { return(x@AP) })
setMethod(f="ap", signature="APset", definition=function(x) { tmp <- x@AP; names(tmp) <- x@ID; return(tmp) })
setMethod(f="cid", signature="APset", definition=function(x) { return(x@ID) })

## Replacement method for ID component of APset using accessor methods.
## Note: generic for cid() is defined under SDFset class section.
setReplaceMethod(f="cid", signature="APset", definition=function(x, value) {
	x@ID <- value 
	if(any(duplicated(x@ID))) { 
		warning("The values in the CMP ID slot are not unique anymore. To fix this, run: cid(apset) <- makeUnique(cid(apset))")
	}
	return(x)
})

## Replacement method for APset using "[" operator 
## It doesn't provide here full set of expected functionalities.
setReplaceMethod(f="[", signature="APset", definition=function(x, i, j, value) {
	x@AP[i] <- ap(value)
	x@ID[i] <- cid(value)
	return(x)
})

## Behavior of "[" operator for APset 
setMethod(f="[", signature="APset", definition=function(x, i, ..., drop) {
	if(is.logical(i)) {
                i <- which(i)
        }
	if(is.character(i)) { 
		ids <- seq(along=x@ID)
		names(ids) <- x@ID
		i <- ids[i]
	}
	x@AP <- x@AP[i]                   
	x@ID <- x@ID[i]                   
	if(any(duplicated(i))) {
		warning("The values in the CMP ID slot are not unique anymore. To fix this, run: cid(apset) <- makeUnique(cid(apset))")
	}
	return(x)
})

## Replacement method for APset using "[[" operator 
setReplaceMethod(f="[[", signature="APset", definition=function(x, i, value) {
	x@AP[[i]] <- value
	return(x)
})

## Behavior of "[[" operator for APset to convert single APset component to AP
setMethod(f="[[", signature="APset", definition=function(x, i, ..., drop) {
	if(is.character(i)) { i <- which(x@ID %in% i) }
	return(new("AP", AP=x@AP[[i]]))                 
})

## Length function
setMethod(f="length", signature="APset",
    definition=function(x) {
    	return(length(ap(x)))
})

## Print behavior for APset
setMethod(f="show", signature="APset",
	definition=function(object) { 
		cat("An instance of ", "\"", class(object), "\"", " with ", length(object), " molecules", "\n", sep="")
		if(any(duplicated(object@ID))) {
			warning("The values in the CMP ID slot are not unique. To fix this, run: cid(apset) <- makeUnique(cid(apset))")
		}
})

## Concatenate function for APset
## Note: is currently limited to 2 arguments!
setMethod(f="c", signature="APset", definition=function(x, y) {
	aplist1 <- as(x, "list")
	aplist2 <- as(y, "list")
	aplist <- c(aplist1, aplist2)
	apset <- as(aplist, "APset")
	if(any(duplicated(cid(apset)))) {
		warning("The values in the CMP ID slot are not unique anymore, makeUnique() can fix this!")
	}
	return(apset)
})

## Define print behavior for AP
setMethod(f="show", signature="AP",                
   definition=function(object) {
         cat("An instance of ", "\"", class(object), "\"", "\n", sep="")
         cat("<<atom pairs>>", "\n", sep="")
         if(length(object@AP)>=5) {
             cat(c(object@AP[1:5], "... length:", length(object@AP), "\n"))
         } else {
             print(object@AP)}
})

## Coerce Methods for APset Class
## APset to list with many AP objects
setAs(from="APset", to="list",
        def=function(from) {
                ap(from)
})

## List of APs to APset
setAs(from="list", to="APset", 
        def=function(from) {
                new("APset", AP=from, ID=names(from))
})

## APset to list with many AP objects (for summary view)
setAs(from="APset", to="AP", 
        def=function(from) {
                tmp <- lapply(seq(along=from), function(x) from[[x]])
		names(tmp) <- cid(from)
		return(tmp)
})
setMethod(f="view", signature="APset", definition=function(x) { as(x, "AP") })
# view(apset)

## Coerce APset to old list-style descriptor database used by search/cluster functions
apset2descdb <- function(apset) {
                list(descdb=ap(apset), cids=cid(apset), sdfsegs=NULL, source="SDFset", type="SDFset")
}

#######################################################
## (6) Class and Method Definitions for FP and FPset ##
#######################################################
## Define FP and FPset classes
setClass("FP", representation(fp="numeric",type="character",foldCount="numeric"),
			prototype=list(foldCount=0))
setMethod(f="initialize", signature="FP",definition= function(.Object, ...){
			  obj <- callNextMethod(.Object, ...)
			  if(length(obj@type)==0)
				  obj@type=paste("unknown",as.integer(runif(1)*10000),sep="-")
			  obj
			})

setClass("FPset", representation(fpma="matrix",type="character",foldCount="numeric"),
			prototype=list(foldCount=0))
setMethod(f="initialize", signature="FPset",definition= function(.Object, ...){
			  obj <- callNextMethod(.Object, ...)
			  if(length(obj@type)==0)
				  obj@type=paste("unknown",as.integer(runif(1)*10000),sep="-")
			  obj
			})

## Methods to return FPSet as vector or matrix, respectively
setMethod(f="as.vector", signature="FP", definition=function(x) {return(x@fp)})
setMethod(f="as.numeric", signature="FP", definition=function(x) {return(x@fp)})
setMethod(f="as.character", signature="FP", definition=function(x) {return(paste(x@fp, collapse=""))})
setMethod(f="as.matrix", signature="FPset", definition=function(x) {return(x@fpma)})
setMethod(f="as.character", signature="FPset", definition=function(x) {sapply(rownames(x@fpma), function(y) paste(x@fpma[y,], collapse=""))})

## Constructor methods
## Numeric vector to FP with: as(myvector, "FP")
setAs(from="numeric", to="FP",  
        def=function(from) {
		new("FP", fp=from)
})
## Matrix to FPset with: as(mymatrix, "FPset")
setAs(from="matrix", to="FPset",  
        def=function(from) {
		new("FPset", fpma=from)
})

## Character to FPset with: as(mychar, "FPset")
setAs(from="character", to="FPset",  
        def=function(from) {
		read.AP(from, type="fp")
})

## Accessor methods for FPset
## Note: generic for cid() is defined under SDFset class section.
setMethod(f="cid", signature="FPset", definition=function(x) { return(rownames(x@fpma)) })

## Replacement method for ID component of FPset using accessor methods.
setReplaceMethod(f="cid", signature="FPset", definition=function(x, value) {
	rownames(x@fpma) <- value 
	if(any(duplicated(rownames(x@fpma)))) { 
		warning("The values in the CMP ID slot are not unique anymore. To fix this, run: cid(fpset) <- makeUnique(cid(fpset))")
	}
	return(x)
})

foldVector <- function(v,count=1,bits=NULL){
	 len = length(v)
	 if(len%%2!=0)
		 stop("must have an even number of bits to fold")

	 if(!is.null(bits))
		 count=foldsNeeded(len,bits)

	 #message("count: ",count," len: ",len)
	 realCount=0
	 for(i in rep(0,count)){
		 if(len==1)
			 break
		 mid = len/2
		 #message("mid: ",mid)
		 v = mapply(function(a,b) if(a||b)1 else 0,v[1:mid],v[(mid+1):len])
		 len = length(v)
		 realCount=realCount+1
	 }
	 if(count!=realCount)
		 warning(count," folds requested but could only fold ",realCount," times")
	 list(fp=v,actualFoldCount=realCount)
}
foldsNeeded <- function(length,bits){
	count = log2(length) - log2(bits)
	if(count != as.integer(count))
		stop("not possible to achieve ",bits," with an integral number of folds")
	count
}
setGeneric(name="fold", def=function(x,count=1,bits=NULL) standardGeneric("fold"))
setMethod(f="fold",signature="FP", definition=function(x,count,bits){
			 result = foldVector(x@fp,count,bits)
			 x@fp = result$fp
			 x@foldCount = x@foldCount+result$actualFoldCount
			 x
})
setMethod(f="fold",signature="FPset", definition=function(x,count,bits) {
			 actualFolds=0
			 data = apply(x@fpma,c(1),function(y){
								 result = foldVector(y,count,bits)
								 actualFolds <<- result$actualFoldCount #just keep the last one, they should all be the same
								 result$fp	 })
			 if(!is.matrix(data)) # account for case when fp gets folded down to 1
				 dim(data) = c(nrow(x@fpma),1)
			 else
				 data = t(data)
			 x@fpma = data
			 x@foldCount = x@foldCount+actualFolds
			 x
})

setGeneric(name="fptype", def=function(x) standardGeneric("fptype"))
setMethod(f="fptype", signature="FP",definition=function(x) x@type)
setMethod(f="fptype", signature="FPset",definition=function(x) x@type)

setGeneric(name="foldCount", def=function(x) standardGeneric("foldCount"))
setMethod(f="foldCount", signature="FP",definition=function(x) x@foldCount)
setMethod(f="foldCount", signature="FPset",definition=function(x) x@foldCount)

setGeneric(name="numBits", def=function(x) standardGeneric("numBits"))
setMethod(f="numBits", signature="FP",definition=function(x) length(x@fp))
setMethod(f="numBits", signature="FPset",definition=function(x) ncol(x@fpma))

## Replacement method for FPset using "[" operator 
## It doesn't provide here full set of expected functionalities.
setReplaceMethod(f="[", signature="FPset", definition=function(x, i, value) {
	x@fpma[i,] <- value
	return(x)
})

## Behavior of "[" operator for FPset 
setMethod(f="[", signature="FPset", definition=function(x, i, ..., drop) {
	if(is.logical(i)) {
                i <- which(i)
        }
	x@fpma <- x@fpma[i, , drop=FALSE]                   
	if(any(duplicated(i))) {
		warning("The values in the CMP ID slot are not unique anymore. To fix this, run: cid(fpset) <- makeUnique(cid(fpset))")
	}
	return(x)
})

## Behavior of "[[" operator for FPset to convert single FPset component to FP
setMethod(f="[[", signature="FPset", definition=function(x, i, ..., drop) {
	if(is.character(i)) { i <- which(rownames(x@fpma) %in% i) }
	return(new("FP", fp=x@fpma[i,]))                 
})

## Length function
setMethod(f="length", signature="FPset",
    definition=function(x) {
    	return(length(as.matrix(x)[,1]))
})

## Define print behavior for FPset
setMethod(f="show", signature="FPset", 
	definition=function(object) {    
	cat("An instance of a ", length(object@fpma[1,]), " bit ", "\"", class(object), 
		 "\" of type \"",object@type,"\" with ",
		 length(object@fpma[,1]), " molecules", "\n", sep="")
})

setMethod(f="c",signature="FP",definition=function(x,...){
	args = list(x,...)

	type=NULL
	length=0
	fpma = t(sapply(args,function(obj){
		if(!inherits(obj,"FP"))
			stop("all arguments must be of type FP")

		if(is.null(type))
			type<<-obj@type
		if(length==0)
			length <<- numBits(obj)

		if(obj@type != type)
			stop("found differing types: ",obj@type," and ",type)
		if(numBits(obj) != length)
			stop("found differing number of bits: ",numBits(obj)," and ",length)

		obj@fp
	}))
	fpset=new("FPset",fpma=fpma,type=type)
	if(any(duplicated(cid(fpset)))) 
		warning("The values in the CMP ID slot are not unique anymore, makeUnique() can fix this!")
	fpset
})
## Concatenate function for FPset
setMethod(f="c", signature="FPset", definition=function(x, ...) {
	args = list(x,...)
	type=NULL
	length=0
	fpma = Reduce(rbind,Map(function(obj){
		if(!inherits(obj,"FPset"))
			stop("all arguments must be of type FPset")

		if(is.null(type))
			type<<-obj@type
		if(length==0)
			length <<- numBits(obj)

		if(obj@type != type)
			stop("found differing types: ",obj@type," and ",type)
		if(numBits(obj) != length)
			stop("found differing number of bits: ",numBits(obj)," and ",length)

		obj@fpma
	},args))
	fpset=new("FPset",fpma=fpma,type=type)
	if(any(duplicated(cid(fpset)))) 
		warning("The values in the CMP ID slot are not unique anymore, makeUnique() can fix this!")

	fpset
})

## Define print behavior for FP
setMethod(f="show", signature="FP",                
   definition=function(object) {
         cat("An instance of ", "\"", class(object), "\" of type \"",object@type, "\"\n", sep="")
         cat("<<fingerprint>>", "\n", sep="")
         if(length(object@fp)>=20) {
             cat(c(object@fp[1:20], "... length:", length(object@fp), "\n"))
         } else {
             print(object@fp)}
})

## FPset to list with many FP objects (for summary view)
setAs(from="FPset", to="FP", 
        def=function(from) {
                tmp <- lapply(seq(along=from), function(x) from[[x]])
		names(tmp) <- cid(from)
		return(tmp)
})
setMethod(f="view", signature="FPset", definition=function(x) { as(x, "FP") })
# view(fpset)

###################
## (7) Utilities ##
###################

#################################################
## (6.1) Detect Invalid SDFs in SDFset Objects ##
#################################################
validSDF <- function(x, Nabcol = 3, Nbbcol = 3, logic="&", checkNA=TRUE) {
	if(class(x)!="SDFset") 
		warning("x needs to be of class SDFset")
	ab <- atomblock(x); 
	abcol <- sapply(names(ab), function(x) length(ab[[x]][1,]))
	bb <- bondblock(x); 
	bbcol <- sapply(names(bb), function(x) length(bb[[x]][1,]))
	if(logic=="|") 
		validsdf <- abcol >= Nabcol | bbcol >= Nbbcol 
	if(logic=="&") 
		validsdf <- abcol >= Nabcol & bbcol >= Nbbcol 
	if(checkNA==TRUE) {
        	abNA <- sapply(names(ab), function(x) !any(is.na(ab[[x]])))
        	bbNA <- sapply(names(bb), function(x) !any(is.na(bb[[x]])))
		validsdf <- validsdf & abNA & bbNA
	}
	return(validsdf)
}

######################################################################
## (6.2) Create Unique CMP Names by Appending a Counter to Duplates ##
######################################################################
makeUnique <- function(x, silent=FALSE) {
	if(all(!duplicated(x))) {
		if(silent!=TRUE) print("No duplicates detected!")
		return(x)
	} else {
		count <- table(x); count <- count[x]
		dupids <- count[count>1]; dupids <- dupids[!duplicated(names(dupids))]
		for(i in seq(along=dupids)) {
			names(count)[names(count) %in% names(dupids[i])] <- paste(names(dupids)[i], seq(1, dupids[i]), sep="_")
		}
		if(silent!=TRUE) print(paste("Counter appended to", length(dupids), "duplicates!"))
		return(names(count))
	}
}

###############################
## (6.3) Molecule Properties ##
###############################
## (6.3.1) Atom count matrix
atomcountMA <- function(x, ...) {
        if(class(x)=="SDF") x <- as(x, "SDFset")
	atomcountlist <- atomcount(x, ...) 	

	columns <- unique(unlist(lapply(seq(along=atomcountlist), function(x) names(atomcountlist[[x]]))))
        myMA <- matrix(NA, length(atomcountlist), length(columns), dimnames=list(NULL, columns))
        for(i in seq(along=atomcountlist)) myMA[i, names(atomcountlist[[i]])] <- atomcountlist[[i]]
	myMA[is.na(myMA)] <- 0
	rownames(myMA) <- names(atomcountlist)
	return(myMA)
}

## (6.3.2) Molecular weight (MW data from http://iupac.org/publications/pac/78/11/2051/)
data(atomprop); atomprop=atomprop
MW <- function(x, mw=atomprop, ...) {
   if(class(x)=="SDF") x <- as(x, "SDFset")
	
	## Create MW vector with atom symbols in name slot
	AW <- mw$Atomic_weight
	names(AW) <- mw$Symbol

	## Calculate MW
	propma <- atomcountMA(x, ...)
	MW <- rowSums(t(t(propma) * AW[colnames(propma)]), na.rm = TRUE) 
	return(MW)
}

## (6.3.3) Molecular formula
MF <- function(x, ...) {
        if(class(x)=="SDF") x <- as(x, "SDFset")
	propma <- atomcountMA(x, ...)
	propma <- propma[c(1, seq(along=propma[,1])),] # Duplicates first row to support processing of single molecule with same code
	hillorder <- colnames(propma); names(hillorder) <- hillorder
	hillorder <- na.omit(unique(hillorder[c("C", "H", sort(hillorder))]))
	propma <- propma[, hillorder]
	propma[propma==1] <- ""
	MF <- paste(colnames(propma), t(propma), sep="")
	propma <- matrix(MF, nrow=length(propma[,1]), ncol=length(propma[1,]), dimnames=list(rownames(propma), colnames(propma)), byrow=TRUE)
	MF <- seq(along=propma[,1]); names(MF) <- rownames(propma)
	zeroma <- matrix(grepl("[\\*A-Za-z]0$", propma), nrow=length(propma[,1]), ncol=length(propma[1,]), dimnames=list(rownames(propma), colnames(propma)))
	propma[zeroma] <- ""
	for(i in seq(along=MF)) { MF[i] <-  paste(propma[i,], collapse="") }
	return(MF[-1]) # Minus one to remove duplicated entry in first row of propma
}

## (6.3.4) Ring Perception and Aromaticity Assignment
## Implements with some modifications the exhaustive ring perception algorithm 
## from Hanser et al (1996). URL: http://pubs.acs.org/doi/abs/10.1021/ci960322f

## (a) Iterative removal of atoms with single non hydrogen bonds.
## Returns from molecule only its rings and their inter-connections.
.cyclicCore <- function(x) {
	if(length(x) != 1) stop("x needs to be a single molecule")
	if(class(x) == "SDFset") x <- x[[1]]
	path <- conMA(x, exclude="H")
	noconnect <- rowSums(path) != 0 # Removes atoms with no connections
	path <- path[noconnect, noconnect]
	if(all(dim(path) == 0)) { return(path) } 
	term <- which(rowSums(path > 0)==1)
	while(length(term) > 0) {
		path <- path[-term,-term]
		if(any(dim(path) == 0) | is.vector(path)) { break() }
		term <- which(rowSums(path > 0)==1)
	}
	return(path)
}

## (b) Function to return the longest possible linear bond paths where:
##     - internal atoms have only two heavy atom neighbors
##     - terminal atoms are atoms with more than two heavy atom neighbors or they are ring closures
.linearCon <- function(x) {
	secatoms <- rowSums(x > 0) == 2
	secatoms <- names(which(secatoms))
	.linearCon <- function(vertex, x=x) {
		con <- as.list(names(which(x[vertex, ] > 0)))
		for(i in seq(along=con)) {
			termatom <- con[[i]][length(con[[i]])]
			termcon <- names(which(x[termatom, ] > 0))
			termcon <- termcon[!termcon %in% vertex]
			while(length(termcon) == 1 & !any(duplicated(con[[i]]))) { 
				con[[i]] <- c(con[[i]], termcon)						
				termatom <- con[[i]][length(con[[i]])]
				termcon <- names(which(x[termatom, ] > 0))
				termcon <- termcon[!termcon %in% con[[i]][length(con[[i]])-1]]
			}
		}
		if(paste(sort(unique(con[[1]])), collapse="") == paste(sort(unique(con[[2]])), collapse="")) {
			return(con[[1]])
		} else {
			return(c(rev(con[[1]]), vertex, con[[2]]))
		}
	}
	linearconlist <- lapply(secatoms, function(y) .linearCon(vertex=y, x=x))
	nodups <- !duplicated(sapply(linearconlist, function(y) paste(sort(unique(y)), collapse=""))) 
	linearconlist <- linearconlist[nodups]
	return(linearconlist)
}

## (c) Assemble intermediate results in a list
.update <- function(con, path) {
	## Remove non-terminal atoms in each path
	center_atoms <- unique(unlist(lapply(path, function(x) x[-c(1, length(x))])))
	con1 <- con[!rownames(con) %in% center_atoms, !colnames(con) %in% center_atoms]
	## Add atom pairs with three neighbors to connection list
	if(is.matrix(con1)) {
		remainbonds <- con1
		remainbonds[lower.tri(remainbonds)] <- 0
		remainbonds <- lapply(rownames(remainbonds), function(x) names(which(remainbonds[x,] > 0)))
		names(remainbonds) <- rownames(con1)
		remainbonds <- cbind(rep(names(remainbonds), sapply(remainbonds, length)), unlist(remainbonds, use.names=F))
		remainbonds <- split(remainbonds, seq(along=remainbonds[,1]))
		path <- c(path, remainbonds)
		names(path) <- seq(along=path)
	}
	## Collect complete rings and remove them from path object
	index <- unlist(lapply(path, function(y) any(duplicated(y))))
	rings <- path[index]
	path <- path[!index]
	names(path) <- seq(along=path)
	## Connection list for path component
	conpath <- t(sapply(path, function(x) x[c(1, length(x))]))
	ends <- unique(as.vector(conpath))
	conpath <- lapply(ends, function(x) as.numeric(names(which(rowSums(conpath==x) > 0))))
	names(conpath) <- ends
	conpath <- conpath[sapply(conpath, length) > 1] # removes ends that occur only once 
	## Assemble results in list
	return(list(con=con, conpath=conpath, path=path, rings=rings))
}

## (d) Return rings from cyclist object
.rings <- function(cyclist, upper=Inf) {
	## Define data containers
	pathlist <- cyclist$path
	conpath <- cyclist$conpath
	pathlistnew <- list() 
	rings <- list()
	## Loop to join linear paths/fragments stored in pathlist
	for(i in names(conpath)) {
		if(length(conpath) == 0 | !any(names(conpath) == i)) { next() }
		pos <- t(combn(conpath[[i]], m=2))
		for(j in seq(along=pos[,1])) { 
			p1 <- pathlist[[pos[j,1]]]
			p2 <- pathlist[[pos[j,2]]]
			if(sum(p1[-c(1,length(p1))] %in% p2[-c(1,length(p2))]) > 0) {
				next()
			}
			if(p1[1] == i & p2[1] == i) { # matching s1:s2 
				pathlistnew[[length(pathlistnew)+1]] <- c(rev(p2[-1]), p1)
			}
			if(p1[length(p1)] == i & p2[length(p2)] == i) { # matching e1:e2 
				pathlistnew[[length(pathlistnew)+1]] <- c(p1, rev(p2[-length(p2)]))
			}
			if(p1[1] == i & p2[length(p2)] == i) { # matching s1:e2
				pathlistnew[[length(pathlistnew)+1]] <- c(p2, p1[-1])
			}
			if(p1[length(p1)] == i & p2[1] == i) { # matching e1:s2
				pathlistnew[[length(pathlistnew)+1]] <- c(p1, p2[-1])
			}
		}
		## Various postprocessing routines for joined fragments follow
		if(length(pathlistnew) == 0) { next() }
		## Remove duplicates
		dups <- duplicated(sapply(pathlistnew, function(x) paste(sort(unique(x)), collapse="_")))
		pathlistnew <- pathlistnew[!dups]
		## Set maximum ring size; improves time performance if outer rings are not needed
		if(upper != Inf) {   
			l <- sapply(pathlistnew, length)
			pathlistnew <- pathlistnew[l <= upper]
			if(length(pathlistnew) == 0) { next() }
		} 
		## Collect complete rings and remove them from path object
		index <- unlist(lapply(pathlistnew, function(y) any(duplicated(y[c(1, length(y))]))))
		rings[[length(rings)+1]] <- pathlistnew[index]
		pathlistnew <- pathlistnew[!index]
		## Remove paths with internal duplicates 
		if(length(pathlistnew) > 0) {
			index <- unlist(lapply(pathlistnew, function(y) any(duplicated(y))))
			pathlistnew <- pathlistnew[!index]
		}
		## Update pathlist and conpath
		pathlist <- c(pathlist[-conpath[[i]]], pathlistnew)
		dups <- duplicated(sapply(pathlist, function(x) paste(sort(unique(x)), collapse="_")))
		pathlist <- pathlist[!dups]
		names(pathlist) <- seq(along=pathlist)
		conpath <- t(sapply(pathlist, function(x) x[c(1, length(x))]))
		ends <- unique(as.vector(conpath))
		conpath <- lapply(ends, function(x) as.numeric(names(which(rowSums(conpath==x) > 0))))
		names(conpath) <- ends
		conpath <- conpath[sapply(conpath, length) > 1] # removes ends that occur only once
		pathlistnew <- list()
	}
	## Generate proper output format 
	rings <- unlist(rings, recursive=FALSE)
	dups <- duplicated(sapply(rings, function(x) paste(sort(unique(x)), collapse="_")))
	rings <- c(cyclist$rings, rings[!dups])
	l <- sapply(rings, length) 
	rings <- rings[order(l)]
	if(upper != Inf) { rings <- rings[l <= upper] }
	if(length(rings) > 0) { 
		names(rings) <- paste("ring", seq(along=rings), sep="") 
	} else {
		rings <- NULL
	}
	return(rings)
}

## (e) Identify inner rings
## Expected input x is list of rings from call: 
##      x <- rings(x=sdfset[[1]], upper=Inf, type="all", arom=FALSE) 
.is.inner <- function(x) {
        rnames <- rev(names(x)); names(rnames) <- rnames
        r <- x
        names(r) <- paste(names(r), "_", sep="")
        r <- unlist(r)
        for(i in rnames) {
                tmp <- x[[i]]
                r2 <- r[!gsub("_.*", "", names(r)) %in% i] 
                if(all(tmp %in% r2)) {
                        rnames[i] <- "redundant"
                        r <- r2
                }
        }
        return(x[rev(rnames!="redundant")])
}

## (f) Aromaticity assignment for rings
## Approach
##   (i) Identify rings where all atoms are sp2 hybridized. This means each atom has a 
##       double bond or at least one lone electron pair and is attached to a sp2 hybridized atom
##   (ii) Hueckel's rule needs to be true (4n+2=integer): 2, 6, 10, 14, 18, ... pi electrons 
##        per ring.
.is.arom <- function(sdf, rings) {
	if(length(rings)==0) { return(NULL) } 
	con <- conMA(sdf)
	b2 <- bonds(sdf)
	b <- b2[,"Nbondcount"] - b2[,"charge"]
	names(b) <- paste(b2[,"atom"], "_", seq(along=b2[,1]), sep="") 
	.neighborsFct <- function(x) { sapply(rownames(x), function(y) paste(sort(paste(x[y,][x[y,]!=0], sep="_")), collapse="_")) }
	## Determine aromaticity
	.arom <- function(con, b, r=rings[[1]]) {
		## Identify sp2 hybridized atoms
		sp <- .neighborsFct(x=con)[r]
		sp2 <- grepl("1_2$", sp)
		## Identify atoms with lone electron pairs
		el <- c(Al=3, As=5, At=7, B=3, Bi=5, Br=7, C=4, Cl=7, F=7, Ga=3, Ge=4, I=7, In=3, N=5, O=6, P=5, Pb=4, Po=6, S=6, Sb=5, Se=6, Si=4, Sn=4, Te=6, Tl=3)
		bsub <- b[names(sp)]
		lp <- el[gsub("_.*", "", names(bsub))] - bsub >= 2
		lp[is.na(lp)] <- 0 # If an element is not specified under el, then its NA value in lp is set to zero
		sp2lp <- all(sp2 | lp)
		## Hueckel's rule 
		d <- rowSums(con[r, r]==2)
		double <- sum(d) 
		if(length(d[lp]) != 0) {
			lpcount <- sum(lp[d==0]) * 2
		} else {
			lpcount <- 0
		}
		n <- ((double + lpcount) - 2) / 4
		is.wholenumber <- function(x, tol = .Machine$double.eps^0.5)  abs(x - round(x)) < tol
		hueckel <- is.wholenumber(n)
		return(sp2lp & hueckel)
	}
	return(sapply(names(rings), function(x) .arom(con, b, r=rings[[x]])))
}

## Inner rings inherit aromaticity assignment from super rings if they are fully contained in them
## This is necessary since the aromaticity assignment for inner rings may miss context information required
## for Hueckel's rule. Note, for this to work the input data has to be generated with .rings(x, Inf)
.containedArom <- function(myrings, myarom) {
    if(!all(names(myrings) %in% names(myarom))) stop("Both inputs need to have the same number of rings with identical names")
    if(all(!myarom)) {
        return(myarom)
    } else {
        nonaromrings <- myrings[!myarom] # Restricts loop to non-aromatic entries
        aromrings <- myrings[myarom]
        for(i in seq_along(nonaromrings)) {
            updatearom  <- sapply(aromrings, function(x) all(nonaromrings[[i]] %in% x))
            if(any(updatearom)) myarom[names(nonaromrings[i])] <- TRUE
        }
        return(myarom)
    }
}

## (g) Ring and aromaticity perception by running the functions (1)-(5) 
rings <- function(x, upper=Inf, type="all", arom=FALSE, inner=FALSE) {
    if(!any(c("SDF", "SDFset") %in% class(x))) stop("x needs to be of class SDF or SDFset")
    if(inner==TRUE & upper!=Inf) stop("Inner ring prediction requires upper=Inf")
    if(type=="arom" & arom==FALSE) stop("type='arom' requires arom=TRUE")
    runAll <- function(x, upper) {
        con <- .cyclicCore(x)
        if(any(dim(con) == 0) | is.vector(con) | all(con == 0)) { # TRUE for linear compounds 
            if(arom==TRUE) {
                if(type=="all") return(list(RINGS=NULL, AROMATIC=NULL))
                if(type=="count") return(c(RINGS=0, AROMATIC=0))
            } else {
                if(type=="all") return(NULL)
                if(type=="count") return(0)
            }
        } else {
            path <- .linearCon(x=con)
            cyclist <- .update(con=con, path=path)
            if(arom==TRUE) {
                myrings <- .rings(cyclist, Inf) # Full ring set required to identify remaining aromatic rings with .containedArom 
                myrings <- lapply(myrings, function(x) x[-1]) # Removes duplicated atom at ring closure 
                myarom <- .is.arom(sdf=x, rings=myrings)
                myarom <- .containedArom(myrings, myarom)
                if(upper==Inf & inner==TRUE) {
                    myringnames <- names(.is.inner(x=myrings)) # Returns names of inner rings only
                    myrings <- myrings[myringnames]
                    myarom <- myarom[myringnames]
                }
                if(upper!=Inf) {
                    uppernames <- names(myrings[sapply(myrings, length) <= upper])
                    myrings <- myrings[uppernames] 
                    myarom <- myarom[uppernames]
                }
                if(type=="all") return(list(RINGS=myrings, AROMATIC=myarom))
                if(type=="arom") return(list(AROMATIC_RINGS=myrings[myarom]))
                if(type=="count") return(c(RINGS=length(myrings), AROMATIC=sum(myarom)))
            } else {
                myrings <- .rings(cyclist, upper+1) # Plus 'upper+1' is required because at this step all rings have duplicated atoms at ring closure
                myrings <- lapply(myrings, function(x) x[-1]) # Removes duplicated atom at ring closure 
                if(upper==Inf & inner==TRUE) myrings <- .is.inner(x=myrings) # Reduces myrings to inner rings only 
                if(type=="all") return(myrings)
                if(type=="count") return(length(myrings))
            }
        }
    }
    if(class(x)=="SDF") { 
        return(runAll(x, upper))
    }
    if(class(x)=="SDFset" & length(x) == 1) { 
        return(runAll(x[[1]], upper))
    }
    if(class(x)=="SDFset" &  length(x) > 1) {
        myrings <- lapply(1:length(x), function(y) runAll(x[[y]], upper))
        names(myrings) <- cid(x)
        if(type=="all" | type=="arom") return(myrings)
        if(type=="count") {
            mycol <- c("RINGS", "AROMATIC")
            return(matrix(unlist(myrings), ncol=length(myrings[[1]]), dimnames=list(names(myrings), mycol[1:length(myrings[[1]])]), byrow=T))
        }
    }
}
## Usage:
# rings(sdfset[1:4], upper=6, type="all", arom=TRUE)
# rings(sdfset[1:4], upper=6, type="arom", arom=TRUE)
# rings(sdfset[1:4], upper=6, type="count", arom=TRUE)
# plot(sdfset[1], print=F, atomnum=T, no_print_atoms="H") 
# plot(sdfset[1:4], print=F, atomnum=T, no_print_atoms="H") 

## (6.3.5) Enumerate Functional Groups
## (a) Generate neighbor information for each heavy atom in a molecule
.neighbors <- function(x, type="countMA") {
        ## Input checks        
        if(!any(c("SDF", "SDFset") %in% class(x))) stop("x needs to be of class SDF or SDFset")
        if(!any(c("all", "count", "countMA") %in% type)) stop("type can only be assigned: all, count or countMA") 
        ## Return neighbors
        .neighborsFct <- function(x, type=type) {
                colnames(x) <- paste(colnames(x), colSums(x>0), sep="_") # Adds number of bonded heavy atom neighbors (non-hydrogens)
                neighbors <- sapply(rownames(x), function(y) paste(sort(paste(gsub("_.*_", "_", colnames(x)[x[y,]!=0]), x[y,][x[y,]!=0], sep="_")), collapse="_"))
                if(type=="all") {
                        return(neighbors)
                }
                if(type=="count" | type=="countMA") {
                        return(table(paste(gsub("_.*", "", names(neighbors)), neighbors, sep=":")))
                }
        }
        ## Run on SDF object
        if(class(x)=="SDF") {
                x <- conMA(x, exclude="H")
                neighbors <- .neighborsFct(x, type)
                return(neighbors)
        }
        ## Run on SDFset objects containing one or many molecules
        if(class(x)=="SDFset") {
                cid <- cid(x)
                x <- conMA(x, exclude="H")
                neighbor_set <- lapply(seq(along=x), function(y) .neighborsFct(x[[y]], type))
                names(neighbor_set) <- cid
                if(type=="all" | type=="count") {
                        return(neighbor_set)
                }
                if(type=="countMA") {
                        columns <- unique(unlist(lapply(seq(along=neighbor_set), function(x) names(neighbor_set[[x]]))))
                        myMA <- matrix(NA, length(neighbor_set), length(columns), dimnames=list(NULL, columns))
                        for(i in seq(along=neighbor_set)) myMA[i, names(neighbor_set[[i]])] <- neighbor_set[[i]]
                        myMA[is.na(myMA)] <- 0
                        rownames(myMA) <- cid
                        return(myMA)
                }
        }
}
## Usage:
# .neighbors(sdfset[1:4], type="all")
# .neighbors(sdfset[1:4], type="countMA")

## (b) Count functional groups
groups <- function(x, groups="fctgroup", type="countMA") {
        ## Input checks        
        if(!any(c("SDF", "SDFset") %in% class(x))) stop("x needs to be of class SDF or SDFset")
        if(groups=="fctgroup" & (type=="count" | type=="all")) stop("when groups=\"fctgroup\", only type=\"countMA\" can be used")
        mylength <- length(x)
        ## Support for single molecule objects
	if(mylength==1) { x <- as(x, "SDFset"); y <- x; z <- x; cid(z) <- "dummy"; x <- c(y, z) }
        ## Generate neighbor counts
	neighbors <- .neighbors(x, type)
        ## Return neighbor counts if requested
	if(groups[1]=="neighbors") { 
		if(is.matrix(neighbors)) {
			neighbors <- neighbors[!rownames(neighbors) %in% "dummy", ]
		} else { 
			neighbors <- neighbors[!names(neighbors) %in% "dummy"]
		}
		return(neighbors) 
	
	}
        ## Count functional groups based on data stored in neighbor matrix
        if(groups[1]=="fctgroup") { 
		groups <- c(RNH2="^C:.*N_1_1$", R2NH="^N:C_._1_C_._1$", R3N="^N:C_._1_C_._1_C_._1$", 
                            ROPO3="^P:O_._._O_._._O_._._O_._.$", ROH="(?=^C:.*O_1_1)(?=^(?:(?!(N|O|P|S)_._(2|3)).)*$)", 
		            RCHO="^O:C_2_2", RCOR="^C:C_._1_C_._1.*O_1_2", RCOOH="^C:.*O_1_1_O_1_2", 
			    RCOOR="^C:.*O_1_2_O_2_1", ROR="^O:.*C_._1_C_._1", RCCH="^C:C_2_3", RCN="^N:C_2_3") 
	}
        groupMA <- sapply(names(groups), function(x) rowSums(neighbors[, rep(grep(groups[x], colnames(neighbors), perl=TRUE),2)]/2))
	## Fix counts for ambiguous functional groups
        if(c("ROR" %in% colnames(groupMA))) {
	        groupMA[, "ROR"] <- groupMA[, "ROR"] - groupMA[, "RCOOR"]
                groupMA[groupMA < 0] <- 0
        }
	if(mylength>1) {
                return(groupMA)
        } else {
                return(groupMA[1,])
        }
}
## Usage:
# groups(sdfset[1:20], groups="fctgroup", type="countMA") 
# groups(sdfset[1:4], groups="neighbors", type="countMA")
# groups(sdfset[1:4], groups="neighbors", type="count")
# groups(sdfset[1:4], groups="neighbors", type="all")

##############################################################
## (6.4) Convert SDF Tail to Numeric and Character Matrices ##
##############################################################
## (6.4.1) Store everything in one character matrix
datablock2ma <- function(datablocklist, cleanup=" \\(.*", ...) {
	if(exists("cleanup")) 
		for(i in seq(along=datablocklist)) 
			names(datablocklist[[i]]) <- gsub(cleanup, "", names(datablocklist[[i]])) # Required if name tags contain compound ids
   columns <- unique(unlist(lapply(seq(along=datablocklist), function(x) names(datablocklist[[x]]))))
	myMA <- matrix(NA, length(datablocklist), length(columns), dimnames=list(NULL, columns))
	for(i in seq(along=datablocklist)) 
		myMA[i, names(datablocklist[[i]])] <- datablocklist[[i]]
	rownames(myMA) <- names(datablocklist)
	return(myMA)
}
# Usage:
# blockmatrix <- datablock2ma(datablocklist=datablock(sdfset))

## (6.4.2) Split SDF tail matrix into character and numeric matrices
splitNumChar <- function(blockmatrix) {
	# Define function to check for valid numeric values in a character vector
	numberAble <- function(myvec, type=c("single", "vector"), extras = c(".", "NA")) {
	    type <- match.arg(type)
	    old <- options(warn = -1)
	    on.exit(options(old))
	    myvec <- gsub(" ", "", myvec)
	    myvecsub <- myvec[!myvec %in% c("", extras)]
	    isnum <- !any(is.na(as.numeric(myvecsub)))
	    if (type == "single") 
		isnum
	    else if (isnum) 
		as.numeric(myvec)
	    else myvec
	}
        colindex <- sapply(seq(along=blockmatrix[1,]), function(x) numberAble(blockmatrix[,x]))
        numMA <- blockmatrix[ , colindex]
        storage.mode(numMA) <- "numeric"
        charMA <- blockmatrix[ , !colindex]
        return(list(numMA=numMA, charMA=charMA))
}
# Usage:
# numchar <- splitNumChar(blockmatrix=blockmatrix)

#########################
## (6.5) Bond Matrices ##
#########################
## (6.5.1) Generate bond matrix from SDFset or SDF objects
conMA <- function(x, exclude="none") {
        ## Function for SDF object 
        .conMA <- function(x, exclude=exclude) {
            atoms <- rownames(atomblock(x))
            conma <- matrix(0, length(atoms), length(atoms), dimnames=list(atoms, atoms))
            bondblock <- bondblock(x)
            for(i in seq(along=bondblock[,1])) conma[bondblock[i,1], bondblock[i,2]] <- bondblock[i,3]
            for(i in seq(along=bondblock[,1])) conma[bondblock[i,2], bondblock[i,1]] <- bondblock[i,3]
            index <- !gsub("_.*", "", rownames(conma)) %in% exclude
	    conma <- conma[index, index, drop = FALSE]
            return(conma)
        }   
        ## Run on SDF objects
        if(class(x)=="SDF") {
                conma <- .conMA(x, exclude)
                return(conma)
        }
        ## Run on SDFset objects containing one or many molecules
        if(class(x)=="SDFset") {
                conma_set <- lapply(seq(along=x), function(y) .conMA(x[[y]], exclude))
                names(conma_set) <- cid(x)
                return(conma_set)
        }
}
# Usage:
# conma <- conMA(sdfset[1:2], exclude=c("H"))

## (6.5.2) Compute bond/charge count for each atom in SDFset or SDF objects
## This is used to add hydrogens with methods/functions atomcount, atomcountMA, MW and MF
bonds <- function(x, type="bonds") {
	## Input checks
        if(!any(c("SDF", "SDFset") %in% class(x))) stop("x needs to be of class SDF or SDFset")
	if(!any(c("bonds", "charge", "addNH") %in% type)) stop("type can only be assigned: bonds, charge or addNH") 
	
	## Compute bonds, charges and missing hydrogens
	.bonds <- function(x, type=type) {
		atomMA <- atomblock(x)
		atoms <- gsub("_.*", "", rownames(atomMA))
		bondMA <- bondblock(x)
		Nbonds1 <- cbind(atoms=c(bondMA[,1], bondMA[,2]), bonds=c(bondMA[,3], bondMA[,"C3"]))
		Nbonds1 <- tapply(Nbonds1[, "bonds"], Nbonds1[, "atoms"], sum)
		Nbonds <- rep(0, length(atomMA[,1])); names(Nbonds) <- seq(along=atomMA[,1]); Nbonds[names(Nbonds1)] <- Nbonds1 	
		
		## Valence related to position in periodic table (following octet rule) 
		val <- c("1"=1, "17"=1, "2"=2, "16"=2, "13"=3, "15"=3, "14"=4)
		group <- as.numeric(atomprop$Group); names(group) <- as.character(atomprop$Symbol)
		Nbondrule <- val[as.character(group[atoms])]
		Nbondrule[is.na(Nbondrule)] <- 0 # Atoms with undefined Nbondrule (NAs) are assigned zero
		Nbondrule[Nbondrule < Nbonds] <- Nbonds[Nbondrule < Nbonds] # Set Nbondrule to Nbonds values, where latter is larger 

		## Charges
		charge <- c("0"=0, "1"=3, "2"=2, "3"=1, "4"=0, "5"=-1, "6"=-2, "7"=-3) # 4 is "doublet_radical"
		charge <- charge[as.character(atomMA[,5])]
		Nbonds <- data.frame(atom=atoms, Nbondcount=Nbonds, Nbondrule=Nbondrule, charge=charge) 
		
		## Data type to return
		if(type=="bonds") { return(Nbonds) }
		if(type=="charge") {
			chargeindex <- Nbonds[, "charge"] != 0 
			if(sum(chargeindex) == 0) {
				return(NULL)
			} else {
				chargeDF <- Nbonds[chargeindex, ]
				charge <- chargeDF[, "charge"]
				names(charge) <- chargeDF[, "atom"] 
				return(charge)
			}
		}
		if(type=="addNH") { 
			Nbonds[Nbonds[,"Nbondcount"] >= Nbonds[,"Nbondrule"], "charge"] <- 0 # Ignore charge where Nbondcount greater or equal than Nbondrule
			Nbonds[Nbonds[,"Nbondcount"] == 0, c("Nbondrule", "charge")] <- 0 # Ignore atoms with zero bonds
			NH <- sum((Nbonds[, "Nbondrule"] + Nbonds[, "charge"]) - Nbonds[, "Nbondcount"])
			if(NH < 0) NH <- 0 # Count should not be negative
			return(NH) 
		}
	}
        ## Run on SDF objects
        if(class(x)=="SDF") {
                bonds <- .bonds(x, type)
                return(bonds)
        }
        ## Run on SDFset objects containing one or many molecules
        if(class(x)=="SDFset") {
                bonds_set <- lapply(seq(along=x), function(y) .bonds(x[[y]], type))
                names(bonds_set) <- cid(x)
		if(type=="bonds") {
                	return(bonds_set)
		}
		if(type=="charge") {
                	return(bonds_set)
		}
		if(type=="addNH") {
                	return(unlist(bonds_set))
		}
        }
}
# Usage:
# bondDF <- bonds(sdfset[1], type="df")) 
# bondcount <- bonds(sdfset[1], type="addNH")) 

##########################################################################
## (6.6) Subset SDF/SDFset Objects by Atom Index to Obtain Substructure ##
##########################################################################
## Function to obtain substructure from SDF/SDFset object by providing a row
## index for atom block. Both atom and bond blocks will be subsetted accordingly. 
## Two functions are combined in one: type="new" assigns new atom numbers to
## the subsetted SDF, while type="old" maintains the numbering of the source SDF.
atomsubset <- function (x, atomrows, type="new", datablock = FALSE) {
    ## Variant that assigns new numbers to atoms in subsetted SDF
    if(type=="new") { 
	if(!any(c("SDF", "SDFset") %in% class(x))) 
	    stop("x needs to be of class SDF or SDFset")
	if(class(x) == "SDFset" & class(atomrows) != "list") 
	    stop("if x is of class SDFset, atomrows argument needs to be a list")
	if(class(x) == "SDFset") {
	    if (!all(cid(x) == names(atomrows))) 
		stop("x and atomrows need to have same length and identical component (molecule) names")
	}
	.atomsubset <- function(x, atomrows) {
	    hb <- header(x)
	    ab <- atomblock(x)[atomrows, ]
	    bb <- bondblock(x)
	    index <- rowSums(cbind(bb[, 1] %in% atomrows, bb[, 2] %in% 
		atomrows)) == 2
	    bb <- bb[index, ]
	    pos <- as.numeric(gsub(".*_", "", rownames(ab)))
	    oripos <- 1:length(pos)
	    names(oripos) <- pos
	    tmp <- bb[, 1:2]
	    tmp2 <- tmp
	    for (i in oripos) tmp2[tmp == as.numeric(names(oripos[i]))] <- i
	    bb[, 1:2] <- tmp2
	    if (is.vector(bb)) {
		bb <- t(as.matrix(bb))
	    }
	    countsLine <- hb[4]
	    atomCount <- sprintf("%3d", length(atomrows))
	    bondCount <- sprintf("%3d", length(rowSums(bb)))
	    # update atom count and bond count
	    hb[4] <- paste(atomCount, bondCount, substr(countsLine, 7, 100000L), sep="")
	    # update bond block row names
	    row.names(bb) <- 1:length(rowSums(bb))
	    # update atom block row names
	    row.names(ab) <- paste(gsub("_.*", "",rownames(ab)), 1:length(atomrows), sep="_")
	    if (datablock == FALSE) {
		sdf <- new("SDF", header = hb, atomblock = ab, bondblock = bb)
		return(sdf)
	    }
	    if (datablock == TRUE) {
		sdf <- new("SDF", header = hb, atomblock = ab, bondblock = as.matrix(bb), 
		    datablock = datablock(x))
		return(sdf)
	    }
	}
	if (class(x) == "SDF") {
	    return(.atomsubset(x, atomrows))
	}
	if (class(x) == "SDFset") {
	    ids <- cid(x)
	    sdflist <- lapply(cid(x), function(y) atomsubset(sdfset[[y]], 
		atomrows[[y]]))
	    names(sdflist) <- ids
	    sdfset <- as(sdflist, "SDFset")
	    return(sdfset)
	    }
    }

    ## Variant that maintains atom numbers from source SDF in subsetted SDF
    if(type=="old") { 
        if(!any(c("SDF", "SDFset") %in% class(x))) stop("x needs to be of class SDF or SDFset")
        if(class(x)=="SDFset" & class(atomrows)!="list") stop("if x is of class SDFset, atomrows argument needs to be a list")
        if(class(x)=="SDFset") {
                if(!all(cid(x) == names(atomrows))) stop("x and atomrows need to have same length and identical component (molecule) names")
        }
        .atomsubset <- function(x, atomrows) {
	    hb <- header(x)
	    ab <- atomblock(x)[atomrows, ]
	    bb <- bondblock(x)
	    index <- rowSums(cbind(bb[,1] %in% atomrows, bb[,2] %in% atomrows)) == 2
	    bb <- bb[index,]

	    ## Update bb to positions in ab
	    pos <- as.numeric(gsub(".*_", "", rownames(ab)))
	    oripos <- 1:length(pos)
	    names(oripos) <- pos
	    tmp <- bb[,1:2]; tmp2 <- tmp 
	    for(i in oripos) tmp2[tmp==as.numeric(names(oripos[i]))] <- i
	    bb[,1:2] <- tmp2
	    
	    ## Outputs
	    if(is.vector(bb)) { bb <- t(as.matrix(bb)) }
	    if(datablock==FALSE) {
		sdf <- new("SDF", header=hb, atomblock=ab, bondblock=bb)
		return(sdf)
	    }
	    if(datablock==TRUE) {
		sdf <- new("SDF", header=hb, atomblock=ab, bondblock=as.matrix(bb), datablock=datablock(x))
		return(sdf)
	    }
        }
        if(class(x)=="SDF") {
	    return(.atomsubset(x, atomrows))
        }
        if(class(x)=="SDFset") {
	    ids <- cid(x)
	    sdflist <- lapply(cid(x), function(y) atomsubset(sdfset[[y]], atomrows[[y]]))
	    names(sdflist) <- ids
	    sdfset <- as(sdflist, "SDFset")
	    return(sdfset)
        }
    }
}

## Usage: 
# atomsubset(sdfset[[1]], atomrows=1:18, type="new")
# atomsubset(sdfset[1:2], atomrows=list(CMP1=1:18, CMP2=1:12), type="new")

###################################
## (6.7) Function write.SDFsplit ##
###################################
## Splits SD Files into any number of smaller SD Files                                                                   
write.SDFsplit <- function(x, filetag, nmol) {
        from <- seq(1, length(x), by=nmol)
        splitDF <- data.frame(from=from, to=c(from[-1], length(x)+1)-1, filename=NA)
        splitDF[,"filename"] <- paste(filetag, sprintf(paste("%0", nchar(as.character(length(x))), "d", sep=""), splitDF[,1]), "_", 
                          sprintf(paste("%0", nchar(as.character(length(x))), "d", sep=""), splitDF[,2]), ".sdf", sep="")
        for(i in seq(along=splitDF[,1])) {
                write.SDF(x[splitDF[i,"from"]:splitDF[i,"to"]], splitDF[i,"filename"])
        }                                                                                             
	return(splitDF) # Gives access to file names to simplify import of split SD Files
}                   

## Usage 
# write.SDFsplit(x=sdfstr, filetag="myfile", nmol=10)
# write.SDFsplit(x=sdfsample, filetag="myfile", nmol=10)

######################################
## (6.8) Streaming Through SD Files ##
######################################
## Streaming function to compute descriptors for large SD Files without consuming much memory.
## In addition to descriptor values, it returns a line index that defines the positions of each 
## molecule in the source SD File. This line index can be used by the read.SDFindex function to 
## retrieve specific compounds of interest from large SD Files without reading the entire file 
## into memory. 
sdfStream <- function(input, output, append=FALSE, fct, Nlines=10000, startline=1, restartNlines=10000, silent=FALSE, ...) {
	## Define loop parameters 
	stop <- FALSE 
	f <- file(input, "r")
	n <- Nlines
	offset <- 0
	## For restarting sdfStream at specific line assigned to startline argument. If assigned
        ## startline value does not match the first line of a molecule in the SD file then it 
        ## will be reset to the start position of the next molecule in the SD file.
	if(startline!=1) { 
		fmap <- file(input, "r")
		shiftback <- 2
		chunkmap <- scan(fmap, skip=startline-shiftback, nlines=restartNlines, what="a", blank.lines.skip=FALSE, quiet=TRUE, sep ="\n")
		startline <- startline + (which(grepl("^\\${4,4}", chunkmap, perl=TRUE))[1] + 1 - shiftback)
		if(is.na(startline)) stop("Invalid value assigned to startline.")
		dummy <- scan(f, skip=startline-2, nlines=1, what="a", blank.lines.skip=FALSE, quiet=TRUE, sep ="\n")
		close(fmap)
		offset <- startline - 1 # Maintains abolut line positions in index
	}
	counter <- 0
	cmpid <- 1
	partial <- NULL
	while(!stop) {
		counter <- counter + 1
		chunk <- readLines(f, n = n) # chunk n can be any number of lines
		# chunk <- scan(f, n=n, what="a", blank.lines.skip=FALSE, quiet=TRUE, sep ="\n") # scan has more flexibilities for reading specific line ranges in files.
		if(length(chunk) > 0) {
			if(length(partial) > 0) {
				chunk <- c(partial, chunk)
			}
			## Assure that lines of least 2 complete molecules are stored in chunk if available
			inner <- sum(grepl("^\\${4,4}", chunk, perl=TRUE)) < 2
			while(inner) {
				chunklength <- length(chunk)
				chunk <- c(chunk, readLines(f, n = n))
				if(chunklength == length(chunk)) { 
					inner <- FALSE 
				} else {
					inner <- sum(grepl("^\\${4,4}", chunk, perl=TRUE)) < 2
				}
			}
			y <- regexpr("^\\${4,4}", chunk, perl=TRUE) # identifies all fields that start with a '$$$$' sign
			index <- which(y!=-1)
			indexDF <- data.frame(start=c(1, index[-length(index)]+1), end=index)
			complete <- chunk[1:index[length(index)]]
			if((index[length(index)]+1) <= length(chunk)) {
				partial <- chunk[(index[length(index)]+1):length(chunk)]
			} else {
				partial <- NULL
			}
			index <- index + offset 
			indexDF <- data.frame(SDFlineStart=c(offset + 1, index[-length(index)]+1), SDFlineEnd=index)
			offset <- indexDF[length(indexDF[,2]),2]

			## Coerce file lines stored in character vector to SDFset
			sdfset <- read.SDFset(read.SDFstr(complete))
                        valid <- validSDF(sdfset)
                        sdfset <- sdfset[valid]
                        indexDForig <- indexDF
                        indexDF <- indexDF[valid,]
			## Perform desired computation on SDFset
			if(length(indexDF[,1])==1) {
				suppressWarnings(sdfset <- c(sdfset, sdfset)) # Trick to keep data in matrix format
                                resultMA <- fct(sdfset, ...)
				resultMA <- cbind(as.data.frame(indexDF), as.data.frame(resultMA[1, , drop=FALSE]), row.names=row.names(resultMA)[1])
			} else {
				resultMA <- fct(sdfset, ...)
				resultMA <- cbind(as.data.frame(indexDF), as.data.frame(resultMA), row.names=row.names(resultMA))
			}
			resultMA <- resultMA[names(valid),]
                        if(any(is.na(resultMA))) { # Maintains index for invalid compounds having NAs in descriptor fields
                                resultMA[,1:2] <- indexDForig[,1:2]
                        }
                        rownames(resultMA) <- paste("CMP", cmpid : (cmpid + length(resultMA[,1])-1), sep="")
			cmpid <- cmpid + length(resultMA[,1])
			## Print processing status to screen
                        if(silent==FALSE) {
                                print(rownames(resultMA))
                        }
			## Append results to tabular file
			if(counter==1 & append!=TRUE) {
				unlink(output)
				write.table(resultMA, output, quote=FALSE, col.names=NA, sep="\t")
			} else {	
				write.table(resultMA, output, quote=FALSE, append=TRUE, col.names=FALSE, sep="\t")
			}
		}
		if(length(chunk) == 0) {
			stop <- TRUE
			close(f)
		}
	}
}

## Usage:
# library(ChemmineR)
# data(sdfsample); sdfset <- sdfsample
# write.SDF(sdfset, "test.sdf")
## Choose descriptor set in a simple function:
# desc <- function(sdfset) {
#         cbind(SDFID=sdfid(sdfset),
#               # datablock2ma(datablocklist=datablock(sdfset)),
#               MW=MW(sdfset),
#               groups(sdfset),
#               # AP=sdf2ap(sdfset, type="character"),
#               rings(sdfset, type="count", upper=6, arom=TRUE)
#         )     
# }
# sdfStream(input="test.sdf", output="matrix.xls", fct=desc, Nlines=1000)
# indexDF <- read.delim("matrix.xls", row.names=1)[,1:2]
# sdfset <- read.SDFindex(file="test.sdf", index=indexDF, type="SDFset", outfile="sub.sdf") 


#####################################################################
## (6.9) Read Atom Pair String Representation from File into APset ##
#####################################################################
## Function to convert atom pairs (AP) or atom pair fingerprints (APFP) stored
## as character strings to APset or FPset objects (e.g. generated by sdfStream).
## Alternatively, one can provide the AP/APFP strings in a named character vector.
read.AP <- function(x, type, colid,isFile = class(x)=="character" & length(x)==1) {
        if(type=="ap") {
                if(isFile) {
                        x <- read.delim(x, sep="\t", row.names=1)
                        ids <- row.names(x); x <- x[,colid]; names(x) <- ids
                }
                desclist <- strsplit(as.character(x), ", ", fixed = TRUE)
                desclist <- lapply(desclist, as.numeric)
                names(desclist) <- names(x)
                return(as(desclist, "APset"))
        }
        if(type=="apfp" | type=="fp") {
                if(isFile) {
                        x <- read.delim(x, colClasses="character", sep="\t", row.names=1)
                        ids <- row.names(x); x <- x[,colid]; names(x) <- ids
                }
                descma <- matrix(as.numeric(unlist(strsplit(x, ""))), length(x), nchar(x[1]), byrow=TRUE, dimnames=list(names(x), 1:nchar(x[1])))
                #return(as(descma, "FPset"))
                return(new( "FPset",fpma=descma,type="apfp"))
        }
}

## Usage:
# apset <- read.AP(x="matrix.xls", type="ap", colid="AP")
# apfp <- read.AP(x="matrix.xls", type="apfp", colid="APFP")

#########################################################
## (6.10) Extract Molecules from SD File by Line Index ##
#########################################################
## Extracts specific molecules from SD File based on a line position index computed by the sdfStream function
read.SDFindex <- function(file, index, type="SDFset", outfile) {
	f <- file(file, "r") 
	if(type=="SDFset") {
		sdfset <- SDFset()
	}
	## Index transfromations
	index <- index[order(index[,1]),] # Assures positional sorting, which is expected by the following step!!
	index <- data.frame(skip=index[,1] - c(0, index[-length(index[,1]),2]) - 1 , nlines=index[,2] - index[,1] + 1) 
	## Scan through file using index to retrieve molecules one-by-one
	for(i in seq(along=index[,1])) {
		lines <- scan(f, skip=index[i,1], nlines=index[i,2], what="a", blank.lines.skip=FALSE, quiet=TRUE, sep ="\n")
		#delteme# lines <- scan(file, skip=index[i,1]-1, nlines=index[i,2]-index[i,1] + 1, what="a", blank.lines.skip=FALSE, quiet=TRUE, sep ="\n") 
		if(type=="file") {
			if(i == 1) {
				unlink(outfile)
				cat(lines, file=outfile, sep="\n")
			} else {	
				cat(lines, file=outfile, sep="\n", append=TRUE)
			}
		}
		if(type=="SDFset") {
			suppressWarnings(sdfset <- c(sdfset, read.SDFset(read.SDFstr(lines))))	
		}
	}
	close(f)
	if(type=="SDFset") {
		cid(sdfset) <- paste("CMP", 1:length(sdfset), sep="")
                return(sdfset)
	}
}
## Usage: see sdfStream()

#################################
## (6.11) String Search Method ##
#################################
## String search function for SDFset
grepSDFset <- function(pattern, x, field="datablock", mode="subset", ignore.case=TRUE, ...) {
	## Generate search vector and index for desired field in SDFset
	if(field=="header" | field==1) {
		searchfield <- header(x)
		searchstr <- as.character(unlist(searchfield))
		index <- sapply(searchfield, length)
		index <- unlist(sapply(index, function(x) seq(1, x)))
		indexnames <- rep(seq(along=searchfield), sapply(searchfield, length))
		names(index) <- indexnames
	}
	if(field=="atomblock" | field==2) { 
		searchfield <- atomblock(x)
		searchstr <- as.character(unlist(sapply(searchfield, rownames)))
		searchstr <- gsub("_.*", "", searchstr)
		index <- sapply(searchfield, function(x) length(x[,1]))
		index <- unlist(sapply(index, function(x) seq(1, x)))
		indexnames <- rep(seq(along=searchfield), sapply(searchfield, function(x) length(x[,1])))
		names(index) <- indexnames
	}
	if(field=="bondblock" | field==3) { # Not very useful for string searching.
		searchfield <- bondblock(x)
		searchstr <- as.character(unlist(sapply(searchfield, rownames)))
		searchstr <- gsub("_.*", "", searchstr)
		index <- sapply(searchfield, function(x) length(x[,1]))
		index <- unlist(sapply(index, function(x) seq(1, x)))
		indexnames <- rep(seq(along=searchfield), sapply(searchfield, function(x) length(x[,1])))
		names(index) <- indexnames
	}
	if(field=="datablock" | field==4) { 
		searchfield <- datablock(x)
		searchstr <- paste(names(unlist(searchfield)), as.character(unlist(searchfield)), sep="___")
		index <- sapply(searchfield, length)
		index <- unlist(sapply(index, function(x) seq(1, x)))
		indexnames <- rep(seq(along=searchfield), sapply(searchfield, length))
		names(index) <- indexnames
	}
	## Search with grep
	matchpos <- grep(pattern, searchstr, ignore.case=ignore.case, ...)
	if(mode=="index") {
		return(index[matchpos])

	}
	if(mode=="subset") {
		xpos <- as.numeric(unique(names(index[matchpos])))
		return(as(x[xpos], "SDF"))
	}
}

##########################
## (7) Plotting Methods ##
##########################
## Plot single CMP Structure
plotStruc <- function(sdf,
							 atomcex=1.2,
							 atomnum=FALSE,
							 no_print_atoms=c("C"),
							 noHbonds=TRUE,
							 bondspacer=0.12,
							 colbonds=NULL,
							 bondcol="red",
							 regenCoords=FALSE,
							 ...) {

	if(regenCoords && .haveOB())
		sdf = regenCoordsOB(sdf)

   toplot <- list(atomblock=cbind(atomblock(sdf)[,c(1:2)], as.matrix(bonds(sdf, type="bonds")[,-1])), bondblock=cbind(as.matrix(as.data.frame(bondblock(sdf))[,1:3]), bondcol=1))
	## Add bond color
	toplot[[2]][, "bondcol"] <- toplot[[2]][,"bondcol"] + as.numeric((toplot[[2]][,"C1"] %in% colbonds) & (toplot[[2]][,"C2"] %in% colbonds))
	## Create empty plot with proper dimensions
	plot(toplot[[1]], type="n", axes=F, xlab="", ylab="", ...)
	## Remove C-hydrogens including their bonds 
	if(noHbonds==TRUE) {
		nonbonded <- !1:length(toplot[[1]][,1]) %in% sort(unique(as.vector(toplot[[2]][,1:2])))
                nonbonded <- as.data.frame(toplot[[1]])[nonbonded,]
                CHbondindex <- sapply(seq(toplot[[2]][,1]), function(x) paste(sort(gsub("_.*", "", rownames(toplot[[1]]))[toplot[[2]][x,1:2]]), collapse="") == "CH")
		toplot[[1]] <- toplot[[1]][sort(unique(as.numeric(toplot[[2]][!CHbondindex,1:2]))), ]
		toplot[[2]] <- as.matrix(as.data.frame(toplot[[2]])[!CHbondindex,]) 
                toplot[[1]] <- as.matrix(rbind(toplot[[1]], nonbonded))
	}	
	## Plot bonds
	z <- toplot[[2]][, "bondcol"]; z[z==2] <- bondcol # Stores bond coloring data
	for(i in seq(along=toplot[[2]][,1])) {
		x <- toplot[[1]][gsub("*.*_", "", rownames(toplot[[1]])) %in% toplot[[2]][i,1:2],1]
		y <- toplot[[1]][gsub("*.*_", "", rownames(toplot[[1]])) %in% toplot[[2]][i,1:2],2]
		## Plot single bonds
		if(toplot[[2]][i,3]==1) {
			lines(x=x, y=y, lty=1, lwd=3, col=z[i]) 
		} 
		## Plot double bonds
		if(toplot[[2]][i,3]==2) {
			rslope <- (atan(diff(y)/diff(x))*180/pi)/90
			lines(x=x-rslope*bondspacer, y=y+(1-abs(rslope))*bondspacer, lty=1, lwd=3, col=z[i])
			lines(x=x+rslope*bondspacer, y=y-(1-abs(rslope))*bondspacer, lty=1, lwd=3, col=z[i])
		}
		## Plot triple bonds
		if(toplot[[2]][i,3]==3) {
			rslope <- (atan(diff(y)/diff(x))*180/pi)/90
			bondspacer <- bondspacer * 2
			lines(x=x, y=y, lty=1, lwd=3, col=z[i]) 
			lines(x=x-rslope*bondspacer, y=y+(1-abs(rslope))*bondspacer, lty=1, lwd=3, col=z[i])
			lines(x=x+rslope*bondspacer, y=y-(1-abs(rslope))*bondspacer, lty=1, lwd=3, col=z[i])
		}
		## Plot bonds with labels other than 1-3 (e.g. some ChEMBL SDFs use 4 for aromatic bonds)
		if(!toplot[[2]][i,3] %in% c(1,2,3)) {
			rslope <- (atan(diff(y)/diff(x))*180/pi)/90
			lines(x=x-rslope*bondspacer, y=y+(1-abs(rslope))*bondspacer, lty=3, lwd=3, col=z[i])
			lines(x=x+rslope*bondspacer, y=y-(1-abs(rslope))*bondspacer, lty=3, lwd=3, col=z[i])
		}
	}
	## Exclude certain atoms from being printed
	exclude <- paste("(^", no_print_atoms, "_)", sep="", collapse="|")
	labelMA <- toplot[[1]][!grepl(exclude, rownames(toplot[[1]])), , drop=FALSE] # Added July 31, 2012: 'drop=FALSE'
        ## Add charges 
	charge <- c("0"="", "3"="3+", "2"="2+", "1"="+", "-1"="-", "-2"="2-", "-3"="3-")
        charge <- charge[as.character(labelMA[,"charge"])]
        ## Add hydrogens to non-charged/non-C atoms according to valence rules (some SD files require this)
        Nhydrogens <- c("0"="", "1"="H", "2"="H2", "3"="H3", "4"="H4", "5"="H5", "6"="H6", "7"="H7", "8"="H8") 
        hydrogens <- (labelMA[, "Nbondrule"] + labelMA[, "charge"]) - labelMA[,"Nbondcount"]
        hydrogens[labelMA[,"charge"]!=0] <- 0; hydrogens[hydrogens < 0] <- 0
        hydrogens <- Nhydrogens[as.character(hydrogens)]
        ## Plot data
        if(is.vector(labelMA)) labelMA <- matrix(labelMA, 1, 2, byrow=TRUE, dimnames=list(rownames(toplot[[1]])[!grepl(exclude, rownames(toplot[[1]]))], c("C1", "C2")))
	if(is.matrix(labelMA) & length(labelMA[,1])>=1) {
		atomcol <- gsub("_.*", "", rownames(labelMA)); atomcol[!grepl("N|C|O|H", atomcol)] <- "any"; mycol <- c(C="black", H="black", N="blue", O="red", any="green"); atomcol <- mycol[atomcol]

		## Overplot nodes to display atom labels
		points(x=labelMA[,1], y=labelMA[,2], col="white", pch=16, cex=2.8)
		## Plot atom labels
		if(atomnum==TRUE) {
			text(x=labelMA[,1], y=labelMA[,2], paste(gsub("_", "", rownames(labelMA)), hydrogens, charge, sep=""), cex=atomcex, col=atomcol) 
		} else {
			text(x=labelMA[,1], y=labelMA[,2], paste(gsub("_.*", "", rownames(labelMA)), hydrogens, charge, sep=""), cex=atomcex, col=atomcol)
		}
	}
}
## Usage:
# plotStruc(sdf=sdfset[[2]], atomcex=1.2, atomnum=F, no_print_atoms=c("C"), noHbonds=TRUE, bondspacer=0.08)
# par(mfrow=c(2,3)); for(i in 1:6) plotStruc(sdf=sdfset[[i]], atomcex=1.8, atomnum=F, no_print_atoms=c("C"), noHbonds=TRUE, bondspacer=0.08)
# disabled for now as rsvg is not available on bioC
openBabelPlot=function(sdfset,
							 height=600,
							 noHbonds=TRUE,
							 regenCoords=FALSE
){
	.ensureOB()

	tempF = tempfile()
	sdf2image(sdfset,tempF,format="SVG",height=height,noHbonds,regenCoords,outputOptions=c("t"))
	img = rsvg(tempF,height,height)
	file.remove(tempF)
	plot(c(0,100),c(0,100), type="n", axes=F, xlab="", ylab="")
	rasterImage(img,0,0,100,100)
}

## Plot method for single SDF object
setMethod(f="plot", signature="SDF", definition=function(x, print=TRUE, ...) { 
		plotStruc(sdf=x, ...)
		if(print==TRUE) { return(x) } 
	}
)

## Plot method for multiple SDF objects in SDFset
setMethod(f="plot", signature="SDFset",
	definition=function(x, griddim, print_cid=cid(x), print=TRUE, ...) {
		if(missing(griddim)) {
			mydim <- ceiling(sqrt(length(x)))
			griddim <- c(mydim, mydim)
		}
		par(mfrow=griddim)
		for(i in 1:length(x)) { plotStruc(sdf=x[[i]], main=print_cid[i], ...) }
		if(print==TRUE) { return(SDFset2SDF(x)) }
})

## Object for referencing chemminetools jobs
setClass("jobToken", representation=representation(
    tool_name = "character",
    jobId = "character"
))

## Show method for checking status of a submitted chemminetools job
setMethod("show", signature=signature(
    object="jobToken"),
    function(object){
        response <- status(object)
        cat("tool name:\t", slot(object, "tool_name"), "\n")
        cat("status:\t\t", response, "\n")
    }
)

cstrsplit <- function(line) .Call(cstrsplitSym,line)
#cstrsplit <- cxxfunction(signature(l="character"),includes='
#					#include <R.h>
#					#include <boost/algorithm/string.hpp>
#								',body='
#					std::vector<std::string> strs;
#					const char *line = CHAR(STRING_ELT(l,0));
#					boost::split(strs, line, boost::is_any_of("\t "),boost::token_compress_on);
#
#					he
#					CharacterVector output2(strs.begin(),strs.end());
#					return output2;
#
#					',plugin="Rcpp")

	
SDFDataTable <- function(sdfset) {

	data = cbind( lapply(seq(along=sdfset),function(i){
				tempF = tempfile()
				sdf2image(sdfset[i],tempF,format="SVG",height=200,TRUE,TRUE,outputOptions = c('d'))
				encoding = base64encode(tempF)
				unlink(tempF)
				encoding
	} ), datablock2ma(datablock(sdfset)))
	colnames(data)[1] = "Image"

	datatable(data,
				 extensions= c('Buttons','FixedColumns','FixedHeader'),
				 options = list(
									 dom="Bfrtipl",
									 buttons = c("colvis","csv"),
									 scrollX=TRUE,
									 fixedColumns= list(leftColumns=2),
									 #fixedHeader = TRUE,
									 pageLength = 5,
									 columnDefs = list(list(
																	targets = 1,
																	data = "image",
																	render = JS(
																		"function(data,type,row,meta){",
																		"	return \"<img = height=100 width=100 src='data:image/svg+xml;base64,\"+row[1]+\"'>\";",
																		"}")
																	))))


}

testDir = system.file("unitTests",package="ChemmineR")
genRandFp = function(n,type=NULL) {
	if(is.null(type))
		new("FP",fp=sapply(runif(n),function(x) if(x>0.5) 1 else 0))
	else
		new("FP",type=type,fp=sapply(runif(n),function(x) if(x>0.5) 1 else 0))
}

test.fp <- function(){
										 

	fp1 = genRandFp(16)
	fp2 = genRandFp(24)
	fp3 = genRandFp(16)

	checkTrue(inherits(fp1,"FP"))

	x=fold(fp1)
	checkEquals(numBits(x),8)
	checkEquals(foldCount(x),1)

	x=fold(fp2,bits=6,count=34) #count should be ignored here
	checkEquals(numBits(x),6)
	checkEquals(foldCount(x),2)

	x=fold(fp3,count=2)
	checkEquals(numBits(x),4)
	checkEquals(foldCount(x),2)

	fp4 = genRandFp(16)
	x=fold(fp4,16)
	checkEquals(numBits(x),1)
	checkEquals(foldCount(x),4)

	x1=genRandFp(16,"test")
	x2=genRandFp(16,"test")
	x3=genRandFp(18,"test")
	x4=genRandFp(16,"test")

	checkException(c(x1,x3))   #different number of bits
	checkException(c(x1,fp1))  #different label
	checkException(c(x1,"hi")) #mixed types

	fpset1 = c(x1,x2,x4)
	checkEquals(length(fpset1),3)

}

test.fpset <- function(){

	message("======= testing fpset ===============================================")
	data = matrix(replicate(1280,if(runif(1)>0.5)1 else 0),10,128)
	fpset = new("FPset",fpma=data)

	checkTrue(inherits(fpset,"FPset"))

	message("======= folding... ")
	x=fold(fpset)
	checkEquals(numBits(x),64)
	checkEquals(foldCount(x),1)

	x=fold(fpset,bits=16)
	checkEquals(numBits(x),16)
	checkEquals(foldCount(x),3)
	
	x=fold(fpset,count=2)
	checkEquals(numBits(x),32)
	checkEquals(foldCount(x),2)

	x=fold(fpset,16)
	checkEquals(numBits(x),1)
	checkEquals(foldCount(x),7)

	
	fpset2 = new("FPset",fpma=data,type="randFP")
	checkEquals(fptype(fpset2),"randFP")
	checkException(c(fpset,fpset2))

	data = matrix(replicate(640,if(runif(1)>0.5)1 else 0),10,64)
	fpset3 = new("FPset",fpma=data)
	checkException(c(fpset,fpset3))

	fpset4 = new("FPset",fpma=data,type="randFP")
	catfp1=c(fpset2,fpset2,fpset2)
	checkEquals(length(catfp1),30)

}

test.import <- function(){

	#test single molecule sdf files
	singleMolFile = file.path(testDir,"singleMolecule.sdf")
	singleMols = read.SDFset(singleMolFile)
	checkEquals(length(singleMols),2)

	#test mol file import
	checkEquals(length(read.SDFset(file.path(testDir,"sample.mol"))),1)

	#test sdf file import
	checkEquals(length(read.SDFset(file.path(testDir,"sample.sdf"))),1)

}

pubchemServerURL = "https://pubchem.ncbi.nlm.nih.gov/rest/pug"

pubchemCidToSDF = function(cids){

   if(! class(cids) == "numeric")
       stop('reference compound ids must be of class \"numeric\"')
   
   if(length(cids) == 0)
       stop('no compounds to retrieve- input must contain at least one cid')

	finalSDF=NA
   
	batchByIndex(cids,function(indexBatch){
		url = paste(pubchemServerURL,"compound","cid",paste(indexBatch,collapse=","),"SDF",sep="/")
		suppressWarnings(
			if(is.na(finalSDF)){
				finalSDF<<-read.SDFset(readLines(url(url)))
			}else{
				finalSDF<<-c(finalSDF,read.SDFset(readLines(url(url))))
			})
	},100)
	cid(finalSDF) = makeUnique(cid(finalSDF),silent=TRUE)
	finalSDF

}

# PubChem only allow you to request by InChI one at a time, so this is possible 
# but should NOT be recommended by the package. Remeber sleep for some time like half 
# or one second if this is in a for loop. To be polite with API calls. 

# The only useful thing you can get through API is CID., so the return is a vector 
# of CIDs. You are not allowed to request other info by InChI, like SDF, PNG, etc. 

#' Query pubchem by InChI sttrings and return CIDs
#' @description Use PubChem API to get CIDs by InChI sttrings. This function sends 
#' one request per InChI. For courtesy, it is not recommended to parellelize this function. 
#' @param inchis character vector, InChI strings
#' @param verbose logical, show verbose information? 
#' @return a numeric vector of CIDs with names. Successful requests will have empty 
#' names, requests with invalid InChI strings will have name "invalid" and requests 
#' with valid InChI but not found in PubChem will have name "not_found"
#' @export
#' @importFrom jsonlite fromJSON
#' @importFrom stringi stri_replace_all_fixed
#' @examples 
#' # Imagine we have an InChIs as following
#' # first two are valid, thrid has no result, last is invalid 
#' if(interactive()) {
#'     inchis <- c(
#'         "InChI=1S/C15H26O/c1-9(2)11-6-5-10(3)15-8-7-14(4,16)13(15)12(11)15/h9-13,16H,5-8H2,1-4H3/t10-,11+,12-,13+,14+,15-/m1/s1", 
#'         "InChI=1S/C3H8/c1-3-2/h3H2,1-2H3", 
#'         "InChI=1S/C15H20Br2O2/c1-2-12(17)13-7-3-4-8-14-15(19-13)10-11(18-14)6-5-9-16/h3-4,6,9,11-15H,2,7-8,10H2,1H3/t5-,11-,12+,13+,14-,15-/m1/s1",
#'         "InChI=abc"
#'     )
#'     pubchemInchi2cid(inchis)
#' }
pubchemInchi2cid <- function(inchis, verbose = TRUE) {
    stopifnot(is.character(inchis) && length(inchis) > 0)
    if(length(inchis) == 1) stopifnot(nchar(inchis) > 0)
    stopifnot(is.logical(verbose) && length(verbose) == 1)
    
    # InChI strings need to be escaped, all possible special characters I am aware 
    # are listed below, add more if I missed some one. minus/dash does not need to be 
    # escaped -LZ
    inchi_escaped <- stringi::stri_replace_all_fixed(
        str = inchis,
        pattern = c("/", "[", "]", "&", ",", "(", ")", "=", "+"),
        replacement = c("%2F", "%5B", "%5D", "%26", "%2C", "%28", "%29", "%3D", "%2B"),
        vectorize_all = FALSE
    )
    
    inchi_request_base_url <- "https://pubchem.ncbi.nlm.nih.gov/rest/pug/compound/inchi/cids/JSON?inchi="
    
    cids <- c()
    inchi_total <- length(inchi_escaped)
    for(i in seq_along(inchi_escaped)) {
        Sys.sleep(0.5)
        cat("requesting for InChI", i, "/", inchi_total, "\n")
        res <- tryCatch(
            {
                req_url <- paste0(inchi_request_base_url, inchi_escaped[i])
                jsonlite::fromJSON(url(req_url))$IdentifierList$CID
            },
            error = function(e) {
                return(c("invalid" = 0))
            },
            warning = function(w) {
                if(grep("400 Bad Request", w$message) == 1) cat("Invalid InChI, skip current one, No.", i, "\n", sep = "")
                return(c("invalid" = 0))
            }
        )
        if(res == 0 && is.null(names(res))) {
            res <- c("not_found" = res)
            cat("InChI not found in PubChem, No.", i, "\n", sep = "")
        }
        cids <- c(cids, res)
    }
    cids
}

#' Query pubchem by InChIKeys sttrings and get SDF back
#' @description Use PubChem API to get CIDs by InChIKeys
#' @param inchikeys character vector, InChIKey strings
#' @return a list of 2 items. the first item "sdf_set" is a `SDFset` object. It 
#' contains all queried and successful SDF infomation. The second item "sdf_index"
#' is a named numeric vector. It records whether all input InChIKeys have successful 
#' returns in the  `SDFset` object. If so, a non-zero value is returned as the index of
#' where it exists in the `SDFset` object, if not, 0 is returned.
#' @export
#'
#' @examples
#' inchikeys <- c(
#' "ZFUYDSOHVJVQNB-FZERPYLPSA-N", 
#' "KONGRWVLXLWGDV-BYGOPZEFSA-N", 
#' "AANKDJLVHZQCFG-WLIQWNBFSA-N",
#' "SNFRINMTRPQQLE-JQWAAABSSA-N"
#' )
#' pubchemInchikey2sdf(inchikeys)
pubchemInchikey2sdf <- function(inchikeys){
    stopifnot(is.character(inchikeys) && length(inchikeys) > 0)
    if(length(inchikeys) == 1) stopifnot(nchar(inchikeys) > 0)
    if(any(duplicated(inchikeys))) stop("Make sure all InChI strings are unique.")
    
    finalSDF <- NA
    batchByIndex(inchikeys,function(indexBatch){
        url <- paste(pubchemServerURL,"compound","inchikey",paste(indexBatch,collapse=","),"SDF",sep="/")
        suppressWarnings(
            if(is.na(finalSDF)){
                finalSDF<<-read.SDFset(readLines(url(url)))
            }else{
                finalSDF<<-c(finalSDF,read.SDFset(readLines(url(url))))
            })
    },100)
    # handle missing not found inchikeys
    finalSDF_list <- SDFset2list(finalSDF)
    # get inchikey and cid from SDF as dataframe
    sdf_ma <- as.data.frame(t(data.frame(lapply(finalSDF_list, function(x) x$datablock[c("PUBCHEM_COMPOUND_CID", "PUBCHEM_IUPAC_INCHIKEY")]))))
    # match queried inchikeys to returned inchikeys and record position
    sdf_index <- unlist(lapply(inchikeys, function(x){
        index <- which(sdf_ma$PUBCHEM_IUPAC_INCHIKEY %in% x)
        if(length(index) == 0) 0 else index
    }))
    names(sdf_index) <- inchikeys
    # rename SDF by CIDs
    cid(finalSDF) <- sdf_ma$PUBCHEM_COMPOUND_CID
    
    list(
        sdf_set = finalSDF,
        sdf_index = sdf_index
    )
}
						
pubchemSmilesSearch = function(smiles){
	if(class(smiles) == "SMIset")
		smiles = as.character(smiles)
   if(! class(smiles) == "character"){
      stop('reference compound must be a smiles string of class \"character\"')
   } 
	url = paste(pubchemServerURL,"compound","fastsimilarity_2d","smiles",smiles,"SDF",sep="/")
	read.SDFset(readLines(suppressWarnings(url(url))))
}

pubchemSDFSearch = function(sdf){
   if(! class(sdf) == "SDFset"){
        stop('reference compound must be a compound of class \"SDFset\"')
   } 
   
	url = paste(pubchemServerURL,"compound","fastsimilarity_2d","sdf","SDF",sep="/")
	#message("url: ",url)

	sdfStr = paste(as(sdf[[1]],"character"),collapse="\r\n")
	read.SDFset(readLines(textConnection(rawToChar(postForm(url,sdf = sdfStr)))))
}
pubchemSDF2PNG = function(sdf,outputFile){
	if(! class(sdf) == "SDFset"){
        stop('reference compound must be a compound of class \"SDFset\"')
   } 
   
	url = paste(pubchemServerURL,"compound","fastsimilarity_2d","sdf","PNG",sep="/")
	#message("url: ",url)

	sdfStr = paste(as(sdf[[1]],"character"),collapse="\r\n")
	pngData = postForm(url,sdf=sdfStr)
	writeBin(pngData[1:length(pngData)],outputFile)
}
pubchemName2CID = function(name){
	
	url = paste(pubchemServerURL,"compound","name",name,"cids","txt",sep="/")
	#message("url: ",url)

	tryCatch(
		readLines(suppressWarnings(url(url))),
		error=function(e) NA,
		warning=function(e) NA)
}

# Purpose: R interface to ChemMine Tools
# by Tyler William H Backman

.serverURL <- "http://chemmine.ucr.edu/ChemmineR/"
#.serverURL <- "http://ec2-18-219-7-240.us-east-2.compute.amazonaws.com/ChemmineR/" ## dev machine


# check job status
status <- function(object){
    if(class(object) != "jobToken"){
        stop("input not of class jobToken")
    }
    response <- postForm(paste(.serverURL, "jobStatus", sep=""), task_id=slot(object, "jobId"))[[1]]
    if(grepl("^ERROR:", response)){
        stop(response)
    }
    return(response)
}

# browse job online (works only once, saves to user account)
browseJob <- function(object){
    if(class(object) != "jobToken"){
        stop("input not of class jobToken")
    }
    url <- paste(.serverURL, "showJob", "/", slot(object, "jobId"), sep="")
    browseURL(url)
    return(url)
}

# get result 
result <- function(object){
    if(class(object) != "jobToken"){
        stop("input not of class jobToken")
    }
    response <- "RUNNING"
    while(response == "RUNNING"){
        Sys.sleep(2)
        response <- postForm(paste(.serverURL, "jobResult", sep=""), task_id=slot(object, "jobId"))[[1]]
    }
    if(grepl("^ERROR:", response)){
        stop(response)
    }
    if(response == "FAILED"){
        stop("Job Failed")
    }
    response <- .convertOutput(response, slot(object, "tool_name"))
    return(response)
}

# Purpose: retrieve list of all tools from server
listCMTools <- function(){
    response <- postForm(paste(.serverURL, "listCMTools", sep=""), category="all")[[1]]
    if(grepl("^ERROR:", response)){
        stop(response)
    }
    read.table(text=response, sep="\t", header=T)
}

# Purpose: retrieve details on a tool 
toolDetails <- function(tool_name){
    response <- postForm(paste(.serverURL, "toolDetails", sep=""), tool_name=tool_name)[[1]]
    if(grepl("^ERROR:", response)){
        stop(response)
    }
    cat(response)
}

# Purpose: launch a ChemMine Tools job on server
launchCMTool <- function(tool_name, input = "", ...){
    toolList <- listCMTools()
    if(! tool_name %in% toolList$Name){
        stop("invalid tool name")
    }
    input <- .convertInput(input, tool_name)
    response <- postForm(paste(.serverURL, "launchCMTool", sep=""), tool_name = tool_name, input = input, ...)[[1]]
    if(grepl("^ERROR:", response)){
        stop(response)
    }
    new("jobToken",
        tool_name = tool_name,
        jobId = response
    )
}

# Purpose: convert input to correct format
.convertInput <- function(input, toolName){
    response <- postForm(paste(.serverURL, "getConverter", sep=""), converterType="input", toolName=toolName)[[1]]
    objectClass <- gsub("\n.*", "", response)
    converter <- gsub("^.*?\n", "", response)

    if(objectClass == "data.frame"){
        try(input <- as.data.frame(input), silent = TRUE)
    } else {
        try(input <- as(input, objectClass), silent = TRUE)
    }

    if(class(input) != objectClass){
        stop(paste("input not of class", objectClass))
    }

    eval(parse(text = converter))
}

# Purpose: convert output to correct format 
.convertOutput <- function(output, toolName){
    response <- postForm(paste(.serverURL, "getConverter", sep=""), converterType="output", toolName=toolName)[[1]]
    converter <- gsub("^.*?\n", "", response)

    eval(parse(text = converter))
}

##################################
# Wrappers for old web functions #
##################################

# view sdfs in ChemMine Tools
sdf.visualize <- function(sdf){
    if(! class(sdf) == "SDFset"){
        stop('input not of class \"SDFset\"')
    } 
    job <- launchCMTool("sdf.visualize", sdf)
    browseJob(job)
}

# get CIDs from PubChem through ChemMine Web Tools
getIds <- function(cids) {
#    if(! class(cids) == "numeric"){
#        stop('reference compound ids must be of class \"numeric\"')
#    }
#    if(length(cids) == 0){
#        stop('no compounds to retrieve- input must contain at least one cid')
#    }
#    jobToken <- launchCMTool("pubchemID2SDF", cids)
#    result(jobToken)
	pubchemCidToSDF(cids)
}

# search PubChem through ChemMine Web Tools with smiles query
searchString <- function(smiles) {
   # if(class(smiles) == "SMIset")
   #     smiles = as.character(smiles)
   # if(! class(smiles) == "character"){
   #     stop('reference compound must be a smiles string of class \"character\"')
   # } 	
   # sdfquery <- smiles2sdf(smiles)
   # searchSim(sdfquery)
	pubchemSmilesSearch(smiles)
}

# search PubChem through ChemMine Web Tools with sdf query
searchSim <- function(sdf) {
   # if(! class(sdf) == "SDFset"){
   #     stop('reference compound must be a compound of class \"SDFset\"')
   # } 
   # jobToken <- launchCMTool('Fingerprint Search', sdf, 'Similarity Cutoff'=0.9, 'Max Compounds Returned'=200)
   # cids <- as.numeric(result(jobToken))
   # if(length(cids) == 0) return(SDFset())
   # getIds(cids)
	pubchemSDFSearch(sdf)

}

default_node_policy = function() {
	return(c(	'N'='blue',
			'O'='red',
			'F'='gold',
			'S'='green',
			'default'='black',
			'H'='skip',
			'fmcs'='magenta',
			'C'='skip'
			))
	}

default_edge_policy = function() {
	return(c(	'default'='black',
			'H'='skip',
			'fmcs'='magenta'
			))
	
	}

concatenate_plots = function(sdf_list, filename=NULL, ...) {

	image_list = list()
	for (i in 1:length(sdf_list)) {
		image_list[[i]] = draw_sdf(sdf_list[[i]], filename=NULL,...)
		}

	image_list = do.call(arrangeGrob, image_list)
	if (!is.null(filename)) {
		#ggsave(filename, do.call(arrangeGrob, image_list))
		ggsave(filename, image_list)
		}
	#image_list = do.call(arrangeGrob, image_list)
	return(image_list)
	# todo figure out how to return concatenated images
	} # end function concatenate_plots

handle_raster = function(plot_target, raster) {
	require(png)

	# check if it's a filename
	if (typeof(raster) == 'character') {
		raster = readPNG(raster)
		} 

	g = rasterGrob(raster, interpolate=TRUE)
	plot_target = plot_target + annotation_custom(g, xmin=-Inf, xmax=Inf, ymin=-Inf, ymax=Inf)
	return(plot_target)
	}

handle_text = function(sdf, plot_target, alpha_node = 1.0, numbered = FALSE, font_size = 7, node_vertical_offset = 0, node_background_color = FALSE, node_policy = default_node_policy(), fmcs_result = NULL) {
	# handles printing of text to a plot_target
	# Args:
	#	sdf: from main draw_sdf function
	#	plot_target: must be a ggplot2 object
	#	alpha_node: defines transparency of nodes
	#	numbered: default FALSE, causes all text to be printed as
	#		without numbering. if TRUE or 1, numbers will be
	#		appended which count nth atom of type i.
	#		if TRUE but not 1, numbers will be appended which
	#		count nth atom
	#	font_size: defines absolute font size of text
	#	node_vertical_offset: permits user to shift text upward off of atom points in space
	#	node_policy: color and drawing policy for nodes. See default_node_policy()
	#	fmcs_result: if non-null, will attempt to highlight text which corresponds to 
	#		MCS in sdf. If non-null, node_policy MUST support node_policy['fmcs']	

	# handle atom name preparation
	node_names = gsub('[^[:alpha:]]', '',rownames(atomblock(sdf)) )
	toprint = node_names
	if (numbered) {
		# default behavior if numbered is evaluatable to TRUE
		unique_text = unique(node_names)
		for (i in 1:length(unique_text)) {
			atom_count = sum(node_names==unique_text[i])
			toprint[node_names==unique_text[i]] = paste(node_names[node_names==unique_text[i]], 1:atom_count, sep='')
			} # end iteration through unique text names using i
		if (numbered==2) {
			toprint = rownames(atomblock(sdf))
			}
		} # end if: numbered is not FALSE
	fmcs_labels = toprint[fmcs_result]

	# handle sieving out of skippable atoms
	node_frame = atomblock(sdf)[,1:2]
	color_list = node_policy[node_names]
	color_list[is.na(color_list)] = node_policy['default']
	# delete skippable atoms from toprint, node_names, node_frame, color_list
	toprint 	= toprint[	color_list != 'skip']
	node_names 	= node_names[	color_list != 'skip']
	node_frame	= node_frame[	color_list != 'skip', ]
	color_list	= color_list[	color_list != 'skip']

	# draw atoms as text
	node_frame[,2] = node_frame[,2] + node_vertical_offset
	node_frame = data.frame(node_frame)
	
	# add coloration editing here
	if (node_background_color != FALSE) {
		# presumably it's a color...
		plot_target = plot_target + geom_point(data = node_frame, aes(x=C1, y = C2), color = node_background_color, size = font_size + 1)
		}

	plot_target = plot_target + geom_text(alpha = alpha_node, data=node_frame, aes(x=C1, y=C2), label = toprint, color=color_list, size = font_size)

	if (!is.null(fmcs_result)) {
		fmcs_frame = atomblock(sdf)[fmcs_result,1:2]
		fmcs_frame[,2] = fmcs_frame[,2] + node_vertical_offset
		fmcs_frame = data.frame(fmcs_frame)
		plot_target = plot_target + geom_text(alpha=alpha_node, data=fmcs_frame, aes(x=C1, y=C2), label=fmcs_labels, color=node_policy['fmcs'], size = font_size)

		} # end subsection handling fmcs text drawing

	return(plot_target)
	} # end subfunction: handle_text

handle_segs = function(sdf, plot_target, alpha_edge = 0.5, edge_policy = default_edge_policy(), bond_dist_offset = 0.05, fmcs_result=NULL) {
	# handles drawing of edges on plot_target
	# Args:
	#	sdf: from main function
	#	plot_target: must be a ggplot2 object
	#	alpha_edge: defines transparency of bonds
	#	edge_policy: a policy on which segments to draw, and what color
	#	bond_dist_offset: radial distance to space double or triple bonds by
	#	fmcs_result: if non-null, maximum common substructure in SDF will
	#		be highlighted. If non-null, edge_policy MUST support edge_policy['fmcs']
	
	edge_matrix = cbind(	atomblock(sdf)[bondblock(sdf)[,1], 1:2],
				atomblock(sdf)[bondblock(sdf)[,2], 1:2],
				bondblock(sdf)[,3]
				)

	# evaluate edge pairs to determine if any should be skipped
	node_names = gsub('[^[:alpha:]]', '', rownames(atomblock(sdf)))
	tofrom_matrix = cbind(	node_names[bondblock(sdf)[,1]],
				node_names[bondblock(sdf)[,2]]
				)
	tofrom_matrix = cbind(tofrom_matrix, paste(tofrom_matrix[,1], tofrom_matrix[,2], sep='-'))

	color_vec = cbind(	match(tofrom_matrix[,1], names(edge_policy)),
				match(tofrom_matrix[,2], names(edge_policy)),
				match(tofrom_matrix[,3], names(edge_policy))
				)

	color_vec[is.na(color_vec)] = match('default', names(edge_policy))
	# condense into one vector of max values
	color_vec = apply(color_vec, 1, max)
	color_vec = edge_policy[color_vec]

	if (!is.null(fmcs_result)) {
		fmcs_search_matrix = bondblock(sdf)[,1:2]

		for (i in 1:length(color_vec)) {
			# if both origin atom and target atom are in fmcs
			is_in_fmcs= all(c(	fmcs_search_matrix[i,1],
						fmcs_search_matrix[i,2]) %in% fmcs_result)
			if(is_in_fmcs) {
				# then mark its index in color_vec with fmcs color
				color_vec[i] = edge_policy['fmcs']
				}

			} # end iteration through rows of color_vec using i
		} # end if: fmcs_result is non-null

	# cut out edges that have been marked for skipping
	tofrom_matrix = tofrom_matrix[	color_vec != 'skip',]
	edge_matrix = 	edge_matrix[	color_vec != 'skip',]
	color_vec = 	color_vec[	color_vec != 'skip']

	# evaluate edge weights, split those with str > 1 
	strong_edge_matrix = edge_matrix[edge_matrix[,5] > 1, ]
	strong_color_vec = color_vec[edge_matrix[,5] > 1]
	i = 1; offset_vec = c(1, -1, 1, -1)
	catting_matrix = matrix(data=0, nrow=1, ncol=4)
	catting_color_vec = c(0)
	while (i <= dim(strong_edge_matrix)[1]) {
		dxdy = c(strong_edge_matrix[i,1] - strong_edge_matrix[i,3], strong_edge_matrix[i,2] - strong_edge_matrix[i,4])
		scaled_dxdy = rev((dxdy/sqrt(sum(dxdy^2)))) * bond_dist_offset
		dp1 = strong_edge_matrix[i,1:4] + scaled_dxdy*  1*offset_vec
		dp2 = strong_edge_matrix[i,1:4] + scaled_dxdy* -1*offset_vec
		catting_matrix = rbind(catting_matrix, dp1, dp2)
		catting_color_vec = cbind(catting_color_vec, strong_color_vec[i], strong_color_vec[i])
		
		# if triple+ bond
		if (strong_edge_matrix[i,5] >= 3) {
			# reinsert old bond's xy values
			catting_matrix = rbind(catting_matrix, strong_edge_matrix[i,1:4])
			catting_color_vec = cbind(catting_color_vec, strong_color_vec[i])
			}
		i = i +1
		} # end iteration through rows of strong_edge_matrix using i
	catting_matrix = cbind(catting_matrix, 1)
	if (dim(catting_matrix)[1] > 1) {
		catting_color_vec = catting_color_vec[2:length(catting_color_vec)]
		catting_matrix = catting_matrix[2:dim(catting_matrix)[1],]

		color_vec = color_vec[edge_matrix[,5] <= 1]
		color_vec = c(color_vec, catting_color_vec)
		edge_matrix = edge_matrix[edge_matrix[,5] <= 1,]
		edge_matrix = rbind(edge_matrix, catting_matrix)
		}

	# finalize edge matrix
	rownames(edge_matrix) = NULL
	edge_matrix = data.frame(edge_matrix)
	plot_target = plot_target + geom_segment(alpha = alpha_edge, data=edge_matrix, aes(x=C1, y=C2, xend=C1.1, yend=C2.1), color = color_vec)
	return(plot_target)
	}

draw_sdf = function(	sdf,
			filename = 'test.jpg',
			alpha_edge = 0.5,
			alpha_node = 1.0,
			numbered=FALSE,
			font_size=5,
			node_vertical_offset = 0,
			node_background_color = FALSE,
			bgcolor = rgb(1,1,1,1),
			bgraster = NULL,
			node_policy = default_node_policy(),
			edge_policy = default_edge_policy(),
			bond_dist_offset = 0.05,
			fmcsR_sdf = NULL
			) {
	# draws an SDF
	# Args:
	# 	sdf: must support atomblock() and bondblock(). supports
	#		 length() > 1
	#	alpha_edge: value in range [0=least, 1=most], describes translucence of edge colors
	#	alpha_node: value in range [0=least, 1=most], describes translucence of node colors
	#	numbered: FALSE = node text does not include numbering, TRUE or 1 = numbering style 1,
	#		2 = numbering style 2
	#	font_size: absolute font size. Reduce this value when plotting multiple SDFs
	#	node_vertical_offset: permits text drawing of SDFs to be shifted upward
	#	bgcolor: rgb object that defines base color of background of plot
	#	bgraster: a readPNG object or a path to an object that can be read as PNG. Will
	#		be pasted as first/background layer of image
	#	node_policy: string mapping that defines what nodes to draw, and what color to draw
	#	edge_policy: string mapping that defines what edges to draw, and what color to draw
	#		policies require 'default' to be mapped to a color, ie at minumum set both equal to
	#		c('default'='black')
	#	bond_dist_offset: defines absolute space between double+ bond lines
	#	fmcsR_sdf: an SDF which supports fmcsr(sdf, fmcsR_sdf). Maximum common substructure will
	#		be highlighted in drawing of SDF. If non-null, node_policy and edge_policy MUST
	#		support node_policy['fmcs'] and edge_policy['fmcs']
	#
	#	Sample usage:
	#	> library(ChemmineR)
	#	> data(sdfsample)
	#	> source('draw_sdf.r')
	#	> draw_sdf(sdfsample[[1]], alpha_edge = 0.25, font_size=5)
	#	>
	#	> library(fmcsR)
	#	> draw_sdf(sdfsample[[2]], filename='././file_one.png', bgraster = 'demo_raster.png', fmcsR_sdf = sdfsample[[2]])
	
	if (length(sdf) > 1) {
		return(concatenate_plots(sdf, filename, alpha_edge, alpha_node, numbered, font_size, node_vertical_offset, node_background_color, bgcolor, bgraster, node_policy, edge_policy, fmcsR_sdf))
		# todo add in all args as we develop this function
		} # end if: multiple SDF

	# begin plotting
	
	plot_target = ggplot(data=data.frame(0), aes())
	if (!is.null(bgraster)) {
		plot_target = handle_raster(plot_target, bgraster)
		} # end if: raster was passed

	fmcs_result = NULL
	if (!is.null(fmcsR_sdf)) {
		require(fmcsR)
		fmcs_result = fmcs(sdf, fmcsR_sdf)
		fmcs_result = fmcs_result@mcs1$mcs1$CMP1_fmcs_1
		}
	plot_target = handle_segs(sdf, plot_target, alpha_edge, edge_policy, bond_dist_offset, fmcs_result)
	plot_target = handle_text(sdf, plot_target, alpha_node, numbered, font_size, node_vertical_offset, node_background_color, node_policy, fmcs_result)

	# fix background
	plot_target = plot_target + theme(panel.background = element_rect(fill=bgcolor, color='black'))
	plot_target = plot_target + theme(legend.position='none')
	plot_target = plot_target + theme(axis.title.x = element_blank())
	plot_target = plot_target + theme(axis.title.y = element_blank())

	if (!is.null(filename)) {
		ggsave(filename=filename, plot = plot_target)
		} # end if: filename is nonnull

	return(plot_target)

	} # end function draw_sdf

#sample fraction of all pairwise distances
genParameters = function(fpset,similarity= fpSim,sampleFraction=1,... ) {
	if( ! inherits(fpset,"FPset"))
		stop("fpset must be an instance of FPset")
	if(length(fpset) == 0)
		stop("fpset cannot be empty")

	totalBitCount = numBits(fpset[1])
	N=length(fpset)
	sampleSize=floor(N*sqrt(sampleFraction))
	#message("sample size: ",sampleSize,"^2")
	K=0.5  # used to shift the mean towards 0 to stabalize varience computation

	size=totalBitCount+2
	parameters = data.frame(count=rep(0,size),avg=rep(0,size),varience=rep(0,size),
									alpha=rep(0,size),beta=rep(0,size))

	stats = data.frame(count=rep(0,size),sums=rep(0,size),squares=rep(0,size))

	querySetIndecies = sample.int(N,sampleSize)
	targetSetIndecies = sample.int(N,sampleSize)
	targetFpSet = fpset[targetSetIndecies]

	for(i in querySetIndecies){
		distances = similarity(fpset[[i]],targetFpSet,sorted=FALSE,...)
		numBitsSet= sum(as.numeric(fpset[[i]])) + 1

		n=length(distances)
		sums=sum(distances-K)
		squares= sum((distances-K)^2)
		#print(c(i,n,sums,squares,as.numeric(numBitsSet)))

		stats$count[numBitsSet]= stats$count[numBitsSet] + n
		stats$sums[numBitsSet]= stats$sums[numBitsSet] + sums
		stats$squares[numBitsSet]= stats$squares[numBitsSet] + squares

		#for quries with bit counts with no stats

		#message(numBitsSet," ",stats$count[numBitsSet]," ",length(distances))
		stats$count[size]= stats$count[size] + n
		stats$sums[size]= stats$sums[size] + sums
		stats$squares[size]= stats$squares[size] + squares
	}
	#message("stats: ")
	#print(stats[41,])
	#print(stats[368,])

	for(i in 1:(totalBitCount+2)){
		avg =stats$sums[i] / stats$count[i] + K
		varience = (stats$squares[i] - (stats$sums[i]^2/stats$count[i]))/stats$count[i]

		parameters$count[i] = stats$count[i]
		parameters$avg[i] = avg
		parameters$varience[i]=varience
		parameters$alpha[i] = avg*((avg*(1-avg))/varience - 1)
		parameters$beta[i] = (1-avg)*((avg*(1-avg))/varience -1)
	}

	parameters
}

#scoredDistance = function(query,db,parameters,distance=fpSim,...){
#
#	distances= distance(query,db,...)
#
#	numBitsSet = sum(as.numeric(query))+1
#
#	N = parameters$count[numBitsSet]
#	if(N==0){ # no stats collected for this number of bits so use global values
#		warning("no parameters avaliable for fingerprints with ",numBitsSet-1," bits set, using global parameters")
#		numBitsSet=nrow(parameters) #global stats are last element of parameters
#		N = parameters$count[numBitsSet]
#	}
#
#	message("using stats for ",numBitsSet-1," bits")
#	print(parameters[numBitsSet,])
#	
#   avg = parameters$avg[numBitsSet]
#	varience = parameters$varience[numBitsSet]
#	alpha = parameters$alpha[numBitsSet]
#	beta = parameters$beta[numBitsSet]
#
#	Reduce(rbind,Map(function(i){
#			 zscore = (distances[i] - avg) / sqrt(varience)
#			 evalue = N*(1-pbeta(distances[i],alpha,beta))
#			 pvalue = 1-exp(-evalue)
#			 data.frame(distance=distances[i],zscore=zscore,evalue=evalue,pvalue=pvalue)
#		},seq(along=distances)))
#
#}

cstrsplitSym=NA
.onLoad <- function(libname,pkgname) {

	#message("libname: ",libname)
	#message("pkgname: ",pkgname)
	cstrsplitSym <<- getNativeSymbolInfo("cstrsplit")
}

.db.header.size <- 16
# supported elements
.elements <- list(
    R=0,
    H=1,
    He=2,
    Li=3,
    Be=4,
    B=5,
    C=6,
    N=7,
    O=8,
    F=9,
    Ne=10,
    Na=11,
    Mg=12,
    Al=13,
    Si=14,
    P=15,
    S=16,
    Cl=17,
    Ar=18,
    K=19,
    Ca=20,
    Sc=21,
    Ti=22,
    V=23,
    Cr=24,
    Mn=25,
    Fe=26,
    Co=27,
    Ni=28,
    Cu=29,
    Zn=30,
    Ga=31,
    Ge=32,
    As=33,
    Se=34,
    Br=35,
    Kr=36,
    Rb=37,
    Sr=38,
    Y=39,
    Zr=40,
    Nb=41,
    Mo=42,
    Tc=43,
    Ru=44,
    Rh=45,
    Pd=46,
    Ag=47,
    Cd=48,
    In=49,
    Sn=50,
    Sb=51,
    Te=52,
    I=53,
    Xe=54,
    Cs=55,
    Ba=56,
    La=57,
    Ce=58,
    Pr=59,
    Nd=60,
    Pm=61,
    Sm=62,
    Eu=63,
    Gd=64,
    Tb=65,
    Dy=66,
    Ho=67,
    Er=68,
    Tm=69,
    Yb=70,
    Lu=71,
    Hf=72,
    Ta=73,
    W=74,
    Re=75,
    Os=76,
    Ir=77,
    Pt=78,
    Au=79,
    Hg=80,
    Tl=81,
    Pb=82,
    Bi=83,
    Po=84,
    At=85,
    Rn=86,
    Fr=87,
    Ra=88,
    Ac=89,
    Th=90,
    Pa=91,
    U=92,
    Np=93,
    Pu=94,
    Am=95,
    Cm=96,
    Bk=97,
    Cf=98,
    Es=99,
    Fm=100,
    Md=101,
    No=102,
    Lr=103,
    Rf=104,
    Db=105,
    Sg=106,
    Bh=107,
    Hs=108,
    Mt=109,
    Ds=110,
    Rg=111)



# similarity model
# input: descriptors for two compounds. both are vectors
# output: similarity
.cmp.similarity <- function(a, b, mode=1, worst=0,
    dbcon.a=NULL, db.intsize.a=4,
    dbcon.b=NULL, db.intsize.b=4)
{
    ## ThG: added for compatability with new S4 classes APset/AP
    if(inherits(a,"APset")) { a <- ap(a)[[1]] }
    if(inherits(b,"APset")) { b <- ap(b)[[1]] }
    if(inherits(a,"AP")){ a <- ap(a) }
    if(inherits(b,"AP")){ b <- ap(b) }
    ## ThG: end of lines
    # check argument, make sure they are vectors and not lists
    if (is.character(a) && length(a) == 3 && a[[1]] == 'filedb:') 
        a <- .load.file.backed.desc(a, dbcon.a, db.intsize.a)
    if (is.character(b) && length(b) == 3 && b[[1]] == 'filedb:') 
        b <- .load.file.backed.desc(b, dbcon.b, db.intsize.b)
    if (is.null(b) || is.null(a))
        return(0)
    if (!is.numeric(b) || !is.numeric(a) ) {
        stop("Both arguments must be AP/APset objects or descriptors in the form of vectors.\n",
        "Did you use \"[]\" instead of \"[[]]\" to index the descriptor ",
        "database?")
    }

    if (mode == 1 && worst != 0) {
        # estimate upper bound
        i <- length(a)
        j <- length(b)
        u_bond <- min(i, j) / max(i, j)
        if (u_bond < worst)
            return(0)
    }
    if (mode == 0) {
        # if no mode is given, guess a mode based on compound size
        # difference 
        if (length(a) < .25 * length(b) || length(a) > 4 * length(b))
            mode <- 3
        else
            mode <- 1
    }
    if (mode == 1) 
        return (length(intersect(a, b)) / length(union(a, b)))
    else if (mode == 2)
        return (length(intersect(a, b)) / min(length(a), length(b)))
    else if (mode == 3) {
        s <- length(intersect(a, b)) / min(length(a), length(b))
        return (s^3)
    }
}
cmp.similarity <- function(a, b, mode=1, worst=0)
{
    .cmp.similarity(a, b, mode=mode, worst=worst)
}
cmp.parse1 <- function(filename) sdf2ap(read.SDFset(filename))[[1]]
cmp.parse <- function(filename) apset2descdb(sdf2ap(read.SDFset(filename)))


# search db for similar compounds. `db' gives the database returned by
# `cmp.parse' or `sdfs_to_desc'. `query' gives the descriptor of one compound,
# either returned by `cmp.parse1/sdf_to_desc' or a reference to one instance in
# db such as db$descdb[[123]] two types of cutoff: score cutoff (<=1) or count
# cutoff (>1)
cmp.search <- function(db, query, type=1, cutoff=0.5, return.score=FALSE, quiet=FALSE,
	mode=1, visualize=FALSE, visualize.browse=TRUE, visualize.query=NULL) 
{
    ## ThG: added for compatability with new S4 classes APset/AP
    ## Note: type argument was also added (has no impact on old list object). 
    dbtype <- as.character(class(db))
    if(dbtype=="APset") { db <- apset2descdb(db) }
    if(inherits(query,"APset")) query <- ap(query[[1]]) 
    if(inherits(query,"AP")) query <- ap(query) 
    ## ThG: end of lines
    if (.is.file.backed.desc(query))
        query <- .load.file.backed.desc(query)
    dbcon <- NULL
    intsize <- 4
    if (db$type == 'file-backed') {
        for (i in 1:length(db$descdb)) {
            if (.is.file.backed.desc(db$descdb[[i]])) {
                dbcon <- file(paste(db$descdb[[i]][[2]], '.cdb', sep=''), 'rb')
                seek(dbcon, 16)
                intsize <- readBin(dbcon, integer(), n=1, size=1)
                break
            }
        }
    }
    scores <- array()
    ids <- array()
    pos <- 1    # tail of entries
    size <- length(db$cids)
    perstep <- round(size / 25)
    for (i in 1:size) {
        if (!quiet && i %% perstep == 0) {
            steps <- i / perstep
            .progress_bar(paste(min(steps*4, 100), "%", collapse=""))
        }
        cmp <- db$descdb[[i]]
        if (db$type == 'file-backed' && .is.file.backed.desc(db$descdb[[i]]))
            cmp <- .load.file.backed.desc(cmp, dbcon, intsize)
        if (cutoff <= 1)
            score <- .cmp.similarity(cmp, query, mode=mode, worst=cutoff)
        else if (pos - 1 < cutoff)
            score <- .cmp.similarity(cmp, query, mode=mode, worst=0)
        else
            score <- .cmp.similarity(cmp, query, mode=mode,
                    worst=scores[[pos - 1]])
        if (cutoff <= 1) {
            if (score >= cutoff) {
                scores[[pos]] <- score
                ids[[pos]] <- i
                pos <- pos + 1
            }
        } else {
            # using naive insertion sort
            if (pos - 1 < cutoff)
                pos <- pos + 1
            else if (scores[[pos - 1]] >= score)
                next

            pos_ <- pos - 2
            while (pos_ > 0 && scores[[pos_]] < score) {
                scores[[pos_ + 1]] <- scores[[pos_]]
                ids[[pos_ + 1]] <- ids[[pos_]]
                pos_ <- pos_ - 1
            }
            pos_ <- pos_ + 1
            scores[[pos_]] <- score
            ids[[pos_]] <- i
        }
    }
    if (!is.null(dbcon)) close(dbcon)
    if (!quiet) cat("\n")
    if (cutoff <= 1) {
        order <- sort(scores, index=TRUE)[["ix"]]
        order <- order[length(order):1]
    } else
        order <- 1:length(scores)

    ## ThG: modified/added for compatability with new S4 classes APset/AP
    if (return.score & dbtype=="list") {
        return(data.frame(ids=ids[order], scores=scores[order]))
     }
    if (!return.score & dbtype=="list") {
        return(ids[order])
    }
    if (dbtype=="APset") {
	if(type==1) {
		return(ids[order])
	}
	if(type==2) {
		index <- scores[order]
		names(index) <- db$cids[ids[order]]
		return(index)
	}
	if(type==3) {
		return(data.frame(index=ids[order], cid=db$cids[ids[order]], scores=scores[order]))
	}
     }
    ## ThG: end of lines
}

# segment SDFs. given indices of selected compounds, return the concatenation
# of SDFs for them
sdf.subset <- function(db, cmps)
{
    if (!grep('://', db$source) && !file.exists(db$source)) {
        stop("cannot find the source SDF file for this database\n")
    }
    output <- ""
    for (i in cmps)
    {
        sdf <- .extract_single_sdf(db, i)
        output <- paste(output, sdf, sep="")
    }

    return(output)
}

## ThG: function is obsolete for APset class which works with standard R subsetting utilities.
db.subset <- function(db, cmps)
{
    return(list(descdb=db$descdb[cmps], cids=db$cids[cmps],
                sdfsegs=db$sdfsegs[cmps], source=db$source))
}

# helper function for subset_sdf. This function takes an index, and return the
# SDF correponding compound at that index
.extract_single_sdf <- function(db, index)
{
    if (index > length(db$sdfsegs))
        stop("Index out of range in .extract_single_sdf")

    skip <- db$sdfsegs[[index]]
    con <- file(db$source, open="r")
    if (skip > 0) 
        #scan(con, "raw", skip=skip-1, nlines=1, quiet=TRUE)
        readLines(con, skip)
    sdf <- .read.one.sdf(con, collapse=FALSE)

    # replace line 1 with compound index if no name is available
    if (length(grep("[a-zA-z0-9]", sdf[[1]])) == 0)
        sdf[[1]] <- paste("ChemmineR_Unnamed_Compound_", index, sep="")

    # close connection
    close(con)
    return(paste(sdf, sep="", collapse="\n"))
}

# explain an atom pair descriptor
db.explain <- function(desc)
{
    ## ThG: added for compatability with new S4 classes APset/AP ##
    if(inherits(desc,"APset")) desc <- ap(desc[[1]])
    if(inherits(desc,"AP")) desc <- ap(desc) 
    ## ThG: end of lines ##
    if (is.character(desc)) {
        if (.is.file.backed.desc(desc))
            desc <- .load.file.backed.desc(desc)
        else
            stop("The descriptor(s) to be explained is not valid.")
    }
    if (length(desc) == 1)
        return(.explain(desc))
    else {
        result <- c()
        for (i in 1:length(desc))
            result <- c(result, .explain(desc[[i]]))
        return(result)
    }
}

.explain <- function(desc)
{
    # numbers of appearance
    occurence <- desc %% 2^7 + 1
    desc <- desc %/% 2^7
    # extract left atom, distance, and right atom
    left <- desc %/% 2^20
    desc <- desc %% 2^20
    dist <- desc %/% 2^13
    desc <- desc %% 2^13
    right <- desc
    # atom properties
    left <- .interpret_atom(left)
    right <- .interpret_atom(right)

    # output
    return (paste(left$symbol, " [", left$neighbors, " neighbor(s),",
                left$pi_electrons, " pi electrons]<---",
                dist,
                "--->", right$symbol, " [", right$neighbors,
                " neighbor(s),", right$pi_electrons, " pi electrons]",
                collapse="", sep=""))
}

# interpret an atom descriptor
# see also: .gen_atom_desc
.interpret_atom <- function(atom_desc)
{
    # atom
    atom_symbol <- names(.elements[.elements == atom_desc %/% 2^6])
    # neighbors
    neighbors <- atom_desc %% 2^6 %/% 2^3
    # pi electron
    pi_electrons <- atom_desc %% 2^3
    return(list(symbol=atom_symbol, neighbors=neighbors,
                pi_electrons=pi_electrons))
}

# convert a factor to a vector to simplify Union and Intersection operations.
# It basically eliminate repeated names by adding suffix. For example, if `a'
# appears twice in the factor, it will be converted to `a1' and `a2'. 
# this is an internal function and is not intended to be used by users
.factor_to_vector <- function(fac)
{
    vec <- vector(mode='numeric')
    index <- 1
    freq <- table(fac)
    keys <- names(freq)
    for (i in 1:length(keys)) {
        key <- keys[[i]]
        if (freq[[key]] == 1) {
            vec[[index]] <- as.numeric(key) * 2^7
            index <- index + 1
        } else {
            for (j in 1:freq[[key]]) {
                vec[[index]] <- as.numeric(key) * 2^7 + j - 1
                index <- index + 1
            }
        }
    }

    return(vec)
}

.uniquifyAtomPairs <- function(desc) {
	.Call("uniquifyAtomPairs",desc)
}

.progress_bar_int_cnt <- 0
.progress_bar <- function(label=NULL) {
    progress <- c("|", "/", "-", "\\")
    unlockBinding(".progress_bar_int_cnt", environment(.progress_bar))
    .progress_bar_int_cnt <<- .progress_bar_int_cnt %% 4 + 1
    if (is.null(label)) {
        cat("\r", progress[[.progress_bar_int_cnt]])
    } else {
        cat("\r                                           \r")
        cat(progress[[.progress_bar_int_cnt]], label)
    }
}

.postToHost <- function(host, path, data.to.send, port=80)
{
    if(missing(path)) path <- "/"
    ua <- "User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.1)"


    boundary <- paste(
            as.integer(runif(20, min=1, max=10)), collapse=""
    )

    header <- NULL
    header <- c(header, paste("POST ", path, " HTTP/1.1", sep=""))
    header <- c(header, paste("Host: ", host, sep=""))
    header <- c(header, "Connection: close")
    header <- c(header, ua)
    header <- c(header, "Accept: */*")
    header <- c(header,
            paste("Content-type: multipart/form-data; boundary=",
                boundary, sep="")
    )
    boundary <- paste('--', boundary, sep='')

    mcontent <- NULL # keeps the content.
    size <- 0

    for (i in 1:length(data.to.send)) {
        value <- data.to.send[[i]]
        key <- names(data.to.send)[i]

        content <- paste(
            boundary, "\n",
            "Content-Disposition: form-data; name=\"",
            as.character(key), "\"", "\n",
            "\n",
            as.character(value), "\n",
            sep=""
        )
        mcontent <- c(mcontent, charToRaw(content))
    }

    size <- length(mcontent) + length(strsplit(boundary, "")[[1]]) + 4
    header <- c(header, paste("Content-length: ", size, "\n\n", sep=""))

    postdata <- c(
        charToRaw(paste(header, collapse="\n")),
        mcontent,
        charToRaw(paste(boundary,"--\n\n",sep=""))
    )

    rm(header,mcontent)

    scon <- socketConnection(host=host,port=port,open="a+b",blocking=TRUE)
    writeBin(postdata, scon, size=1)

    output <- character(0)
    repeat{
        ss <- rawToChar(readBin(scon, "raw", 2048))
        output <- paste(output,ss,sep="")
        if(regexpr("\r\n0\r\n\r\n",ss)>-1) break()
        if(ss == "") break()
    }
    close(scon)
    return(output)
}

.read.one.sdf <- function(filename, collapse=TRUE)
{
    if (length(filename) != 1)
        stop('reference sdf must be a vector of only one entry!')

    if (!("connection" %in% class(filename)) && !is.character(filename))
        stop('reference sdf must be an SDF file or one character string of sdf')

    if ("connection" %in% class(filename))
        con <- filename
    # is filename really a filename a the SDF content? check existence of \n
    else if (length(grep("\n", filename)) == 0 &&
        length(grep("\r", filename)) == 0)
        con <- file(filename, open="r")
    else
        con <- textConnection(filename)

    result <- c()
    while (TRUE) {
        line <- readLines(con=con, n=1)
        if (length(line) == 0 || "$$$$" %in% line) {
            if (length(result) == 0)
                stop("empty SDF!")
            result <- c(result, '$$$$\n')
        if (collapse)
            return (paste(result, collapse="\n"))
        else
            return (result)
        } else
            result <- c(result, line)
    }
}

.data.frame.to.str <- function(x)
{
    con <- textConnection("string", "w")
    write.table(format(x), con, row.names=F, quote=F)
    close(con)
    return(paste(string, collapse='\n'))
} 

.is.file.backed.desc <- function(desc)
{
     is.character(desc) && length(desc) == 3 && desc[[1]] == 'filedb:'
}

.load.file.backed.desc <- function(desc, dbcon=NULL, intsize=4)
{
    dbname <- desc[[2]]
    pos <- desc[[3]]
    closeme <- FALSE
    if (is.null(dbcon)) {
        db_a <- paste(dbname, '.cdb', sep='')
        if (!file.exists(db_a)) stop("cannot find database file ", db_a)
        dbcon <- file(db_a, 'rb')
        closeme <- TRUE
        seek(dbcon, .db.header.size)
        intsize <- readBin(dbcon, integer(), n=1, size=1)
    }
    seek(dbcon, as.integer(pos))
    size <- readBin(dbcon, integer(), n=1, size=intsize)
    desc <- readBin(dbcon, integer(), n=size, size=intsize)
    if (closeme) close(dbcon)
    .factor_to_vector(as.factor(desc))
}

.haveOB <- function()
{
	if(suppressWarnings(require('ChemmineOB', quietly=T))
		&& ChemmineOB:::.supportedPlatform()) {
		return(TRUE)
   }else{
		return(FALSE)
	}

}
.ensureOB <- function(mesg = paste("ChemmineOB is required to make use of this function.",
										 "This package can be installed from BioConductor with the ",
										 "command 'BiocManager::install(\"ChemmineOB\"). ",
										 "It is not currently available for windows however.",
										 "See http://bioconductor.org/packages/devel/bioc/html/ChemmineOB.html",
										 "for more information"))
{
	if(!.haveOB())
		stop(mesg)
}


##############################################
## PubChem Fingerprint Similarity Searching ##
##############################################

## Convert base 64 encoded PubChem fingerprints to binary matrix or string vector
## Definition of PubChem's substructure dictionary-based fingerprints:
## ftp://ftp.ncbi.nih.gov/pubchem/specifications/pubchem_fingerprints.txt
## For debugging use command: as.integer(rev(intToBits("19")[1:6])) 

## Load PubChem's substructure dictionary from data dir of library 
data(pubchemFPencoding); pubchemFPencoding <- pubchemFPencoding 
fp2bit <- function(x, type=3, fptag="PUBCHEM_CACTVS_SUBSKEYS") {
	## Covert base 64 strings to matrix
	if(inherits(x,"SDFset")) {
		blockmatrix <- datablock2ma(datablocklist=datablock(x))
		fp <- blockmatrix[, fptag]
	}
	if(is.matrix(x)) { 
		blockmatrix <- x
		fp <- blockmatrix[, fptag]
	}
	if(is.character(x)) { 
		fp <- x
	}
	fpma <- unlist(strsplit(fp, ""))
	fpma <- matrix(fpma, length(fp), nchar(fp[1]), byrow=TRUE)
	fpma <- fpma[, 1:154] # remove padding signs '='

	## base 64 decoding (base 64 alphabet from http://www.faqs.org/rfcs/rfc3548.html)
	base64 <- c(A=0,B=1,C=2,D=3,E=4,F=5,G=6,H=7,I=8,J=9,K=10,L=11,M=12,N=13,O=14,P=15,
                    Q=16,R=17,S=18,T=19,U=20,V=21,W=22,X=23,Y=24,Z=25,a=26,b=27,c=28,d=29,
                    e=30,f=31,g=32,h=33,i=34,j=35,k=36,l=37,m=38,n=39,o=40,p=41,q=42,r=43,
                    s=44,t=45,u=46,v=47,w=48,x=49,y=50,z=51,"0"=52,"1"=53,"2"=54,"3"=55,
                    "4"=56,"5"=57,"6"=58,"7"=59,"8"=60,"9"=61,"+"=62,"/"=63)
	fpbitma <- as.integer(intToBits(base64[as.vector(t(fpma))]))
	fpbitma <- matrix(fpbitma, length(fpma[,1])*154, 32, byrow=TRUE)[,6:1]
	fpbitma <- matrix(t(fpbitma), length(fpma[,1]), 6*154, byrow=TRUE)[,33:913]
        pubchemFP <- pubchemFPencoding[,2]
	names(pubchemFP) <- pubchemFPencoding[,1]
	colnames(fpbitma) <- pubchemFP
	rownames(fpbitma) <- names(fp)
	if(type==1) {
                return(apply(fpbitma, 1, paste, collapse=""))  
        }
	if(type==2) {
                return(fpbitma)
        }
	if(type==3) {
                #return(as(fpbitma, "FPset"))
                return(new("FPset",fpma=fpbitma,type="pubchem"))
        }
}

## Fingerprint comparison and similarity search function 
fpSimOrig <- function(x, y, sorted=TRUE, method="Tanimoto", addone=1, cutoff=0, top="all", alpha=1, beta=1, ...) {
	## Predefined similarity methods
	if(is.character(method)) {
	 	if(method=="Tanimoto" | method=="tanimoto") 
			method <- function(a,b,c,d) (c+addone)/(a+b+c+addone)
		else if(method=="Euclidean" | method=="euclidean") 
			method <- function(a,b,c,d) sqrt((c+d+addone)/(a+b+c+d+addone))
		else if(method=="Tversky" | method=="tversky") 
			method <- function(a,b,c,d) (c+addone)/(alpha*a + beta*b+c+addone)
		else if(method=="Dice" | method=="dice") 
			method <- function(a,b,c,d) (2*c+addone)/(a+c+b+c+addone)
	}
	## Check for valid inputs
	if(!any(c(is.vector(x), inherits(x,"FP"), inherits(x,"FPset") & length(x)==1))) stop("x needs to be object of class FP, FPset of length one, or vector")
   if(!any(c(is.vector(y), is.matrix(y), inherits(y,"FP"), inherits(y,"FPset") ))) stop("y needs to be object of class FP/FPset, vector or matrix")
	## Convert FP/FPset inputs into vector/matrix format
	if(inherits(x,"FP")) x <- as.numeric(x)
	if(inherits(x,"FPset")) x <- as.numeric(x[[1]])
	if(inherits(y,"FP")) y <- as.numeric(y)
	if(inherits(y,"FPset")) y <- as.matrix(y)
        ## Computate similarities
	if(is.matrix(y)) {
		c <- colSums((t(y) + x) == 2)
		d <- colSums((t(y) + x) == 0)
		b <- rowSums(y) - c
	} else {
		c <- sum(x + y == 2)
		d <- sum(x + y == 0)
		b <- sum(y) - c
	}
	a <- sum(x) - c
	if(sorted==TRUE) {
                tmp <- rev(sort(method(a,b,c,d)))
                if(top!="all") tmp <- tmp[1:top]
		if(top!=1) { 
			return(tmp[tmp>=cutoff])
		} else {
			return(tmp) # returns always a value when top=1; required for compatibility with cmp.cluster
		}
	}
	if(sorted==FALSE) {
		tmp <- method(a,b,c,d)
		if(top!=1) {
                	return(tmp[tmp>=cutoff])
		} else {
			return(tmp) # returns always a value when top=1; required for compatibility with cmp.cluster
		}
	}
}

fpSim <- function(x, y, sorted=TRUE, method="Tanimoto", 
						addone=1, cutoff=0, top="all", alpha=1, beta=1,
						parameters=NULL,scoreType="similarity") {

	if(is.character(method)) {
	 	if(method=="Tanimoto" | method=="tanimoto") 
			method <- 0
		else if(method=="Euclidean" | method=="euclidean") 
			method <- 1
		else if(method=="Tversky" | method=="tversky") 
			method <- 2
		else if(method=="Dice" | method=="dice") 
			method <- 3
		else 
			stop("invalid method found: ",method)
	}else
		return(fpSimOrig(x,y,sorted=sorted,method=method,addone=addone,cutoff=cutoff,top=top,
							  alpha=alpha, beta=beta))
		#stop("invalid method type found: ",class(method))


	if(!any(c(is.vector(x),inherits(x,"FP") , inherits(x,"FPset") & length(x)==1))) 
		stop("x needs to be object of class FP, FPset of length one, or vector")
   if(!any(c(is.vector(y), is.matrix(y),inherits(y,"FP") ,inherits(y,"FPset") )) )
		stop("y needs to be object of class FP/FPset, vector or matrix")

	## Convert FP/FPset inputs into vector/matrix format
	if(inherits(x,"FP")) 
		x <- as.numeric(x)
	else if(inherits(x,"FPset")) 
		x <- as.numeric(x[[1]])

	if(inherits(y,"FP")) {
		dbSize = 1
		y <- as.numeric(y)
	}
	else if(inherits(y,"FPset")){
		 dbSize=length(y)
		 y <- as.matrix(y)
	}
	else if(is.vector(y))
		dbSize=1
	else if(is.matrix(y))
		dbSize=nrow(y)

	if(is.vector(y)) y <- t(as.matrix(y))
   

	result=.Call("similarity",x,y,method,addone,alpha,beta)
	names(result) = rownames(y)

	if(!is.null(parameters)){
		numBitsSet = sum(x)+1

		#N = parameters$count[numBitsSet]
		#if(N==0){ # no stats collected for this number of bits so use global values
		if(parameters$count[numBitsSet]==0){ # no stats collected for this number of bits so use global values
			warning("no parameters avaliable for fingerprints with ",numBitsSet-1," bits set, using global parameters")
			numBitsSet=nrow(parameters) #global stats are last element of parameters
			#N = parameters$count[numBitsSet]
		}

		#message("using stats for ",numBitsSet-1," bits")
		#print(parameters[numBitsSet,])
		
		avg = parameters$avg[numBitsSet]
		varience = parameters$varience[numBitsSet]
		alpha = parameters$alpha[numBitsSet]
		beta = parameters$beta[numBitsSet]

		evalues = dbSize*(1-pbeta(result,alpha,beta))
		# scores <<- data.frame(similarity=result, # ThG: replaced by next line on Dec 31, 2015 since build of R Markdown vignette returned error with '<<-'.
		scores = data.frame(similarity=result,
									 zscore=(result - avg) /sqrt(varience),
									 evalue=evalues,
									 pvalue=1-exp(-evalues))
		
		titles = 1:4
		names(titles)=colnames(scores)
		if(sorted){
			if(titles[scoreType] <=2 ) #similarity or zscore, bigger is better
				scores = scores[order(-scores[,titles[scoreType]]),]
			else
				scores = scores[order(scores[,titles[scoreType]]),]
			if(top!="all")
				scores = scores[1:top,]
		}

		if(!missing(cutoff)){
			if(titles[scoreType] <=2 ) #similarity or zscore, bigger is better
				cutScores = scores[scores[,titles[scoreType]]>= cutoff,]
			else   # e or p values, lower is better
				cutScores = scores[scores[,titles[scoreType]]<= cutoff,]

			# make sure we don't lose all results do to cutoff
			if( nrow(cutScores) >= 1)
				scores = cutScores
		}
		scores
	}
	else{

		if(sorted) {
			result = sort(result, decreasing=TRUE)
			if(top!="all")
				result = result[1:top]
		}
		cutResult = result[result >= cutoff]
		if( length(cutResult) >= 1)
			cutResult
		else # make sure we don't lose all results do to cutoff
			result
	}
	

}


sdf2image <- function(sdf,filename,format="SVG",
							 height=300,
							 noHbonds=TRUE,
							 regenCoords=FALSE,
							 outputOptions=c()){
	 .ensureOB()

    if(! inherits(sdf,"SDFset") ){
        stop('reference compound must be a compound of class \"SDFset\"')
    } 

	 genOps = data.frame(names=character(0),args=character(0))
	 outOps = data.frame(names=character(0),args=character(0))

	 if(height != 300){ #differs from default
		 #optName = if(format == "SVG") "P" else "p"
		 optName = "p"
		 outOps = rbind(outOps,data.frame(names=optName,args=as.character(height)))
	 }
	 if(noHbonds)
		 genOps = rbind(genOps,data.frame(names="d",args=""))
	 if(regenCoords)
		 genOps = rbind(genOps,data.frame(names="gen2D",args=""))

	 outOps= rbind(outOps,data.frame(names=outputOptions,args=rep("",length(outputOptions))))


	 defs = sdfSet2definition(sdf)
	 convertToImage("SDF",format,defs,filename,
						 options = genOps, out_options = outOps)

}

######################################
## Query ChemMine Web Tools Service ##
######################################
#.serverURL <- "http://chemmine.ucr.edu/ChemmineR/"

# perform sdf to smiles conversion
sdf2smilesOB <- function(sdf) {
    if(! inherits(sdf,"SDFset")){
        stop('reference compound must be a compound of class \"SDFset\"')
    } 

	 .ensureOB()
	 #sdfstrList=as(as(sdf,"SDFstr"),"list")
	 #defs = paste(Map(function(x) paste(x,collapse="\n"), sdfstrList),collapse="\n" )
	 defs = sdfSet2definition(sdf)
	 t=Reduce(rbind,strsplit(unlist(strsplit(convertFormat("SDF","SMI",defs),
														  "\n",fixed=TRUE)),
				 "\t",fixed=TRUE))
	 if(!is.matrix(t)){ # R rearranged our matrix because there was only one result
		 smiles=t[1]
		 names(smiles)=t[2]
	 }else{
		 smiles = t[,1]
		 names(smiles)= t[,2]
	 }
	 as(smiles, "SMIset")
}
sdf2smiles <- sdf2smilesOB



smiles2sdfOB <- function(smiles) {
    if(!any(class(smiles) %in% c("character", "SMIset"))){
        stop('input must be SMILES strings stored as \"SMIset\" or \"character\" object')
    }
	 if(inherits(smiles,"SMIset")) smiles <- as.character(smiles)
	 .ensureOB()
	 sdf = definition2SDFset(convertFormat("SMI","SDF",paste(paste(smiles,names(smiles),sep="\t"), collapse="\n")))
	 cid(sdf)=sdfid(sdf)
	 sdf
}
smiles2sdf <- smiles2sdfOB

regenCoordsOB <- function(sdf){
	applyOptions(sdf,data.frame(names="gen2D",args=""))
}
regenerateCoords <- regenCoordsOB

generate3DCoordsOB <- function(sdf){
	applyOptions(sdf,data.frame(names="gen3D",args=""))
}
generate3DCoords <- generate3DCoordsOB

canonicalizeOB <- function(sdf){
	applyOptions(sdf,data.frame(names="canonical",args=""))
}
canonicalize <- canonicalizeOB

canonicalNumberingOB <- function(sdf){
	.ensureOB()
	results=canonicalNumbering_OB(obmol(sdf))
	names(results) = cid(sdf)
	results
}
canonicalNumbering <- canonicalNumberingOB

applyOptions <- function(sdf,options){
	.ensureOB()

	if(inherits(sdf,"SDFset") || inherits(sdf,"SDF")){
		defs = sdfSet2definition(sdf)
		sdfNew = definition2SDFset(convertFormat("SDF","SDF",defs,options))
		cid(sdfNew)=sdfid(sdf)
		if(inherits(sdf,"SDF"))
			sdfNew[[1]]
		else
			sdfNew
	}else
		stop("input to applyOptions must be a SDFset or SDF object. Found ",class(sdf))
}

times = new.env()
times$descT = 0
times$uniqueT = 0
genAPDescriptors <- function(sdf,uniquePairs=TRUE){

	# t=Sys.time()
	d=.Call("genAPDescriptor",sdf)
	# times$descT <- times$descT + (Sys.time() - t)

	if(uniquePairs){
		# t=Sys.time()
		d= .uniquifyAtomPairs(d)
		# itimes$uniqueT <- times$uniqueT + (Sys.time() - t)
	}

	d
}

propOB <- function(sdfSet){
	.ensureOB()
	results = prop_OB(obmol(sdfSet))
	rownames(results) = cid(sdfSet)
	results
}

fingerprintOB <- function(sdfSet,fingerprintName){
	.ensureOB()
   x = fingerprint_OB(obmol(sdfSet),fingerprintName)
	if(is.vector(x)) x= t(as.matrix(x))

	fpset = new("FPset",fpma=x,
					type=fingerprintName)
	cid(fpset) = cid(sdfSet)
	fpset
}
smartsSearchOB <- function(sdfset,smartsPattern,uniqueMatches=TRUE){
	.ensureOB()
	smartsSearch_OB(obmol(sdfset),smartsPattern,uniqueMatches)
}
exactMassOB <- function(sdfset){
	.ensureOB()
	exactMass_OB(obmol(sdfset))
}


#compounds should be items that can be passed into similarity
maximallyDissimilar <- function(compounds,n,similarity = cmp.similarity) {
	dist = function(a,b) 1-similarity(a,b)
	if(length(compounds) <= 2)
		stop("maximallyDissimilar: compounds must have more than 2 elements")

	#pick first selection at random
	selected = sample(1:length(compounds),1)

	#compute dist between compounds[-selected] and compounds[selected]
	minDistsToSelected = sapply(1:length(compounds),
										 function(i) dist(compounds[[i]],compounds[[selected]]))

	for(k in 2:n){
		#find candidate farthest from those selected
		newPoint = which.max(minDistsToSelected)
		selected = c(selected,newPoint)
		minDistsToSelected[newPoint] = 0

		#update min distances
		minDistsToSelected = sapply(1:length(compounds),
											 function(i) 
												 if(minDistsToSelected[i]==0) 0 
												 else min(minDistsToSelected[i],dist(compounds[i],compounds[newPoint])))
	}
	
	compounds[selected]
}

sdf2OBMol<- function(sdfSet){
	.ensureOB()
	defs = paste(Map(function(x) paste(x,collapse="\n"),
						  as(as(sdfSet,"SDFstr"),"list")),"\n",
					 sep="",collapse="" )

	forEachMol("SDF",defs,identity,c)
}

largestComponent <- function(sdfSet){
	smiles = as.character(sdf2smiles(sdfSet))
	splits = strsplit(smiles,'.',fixed=TRUE)
	largestComps = sapply(splits,
			 function(comps){  
				 comps[sort.int(vapply(comps,function(x){nchar(x)},0),
									 decreasing=TRUE,
									 index.return=TRUE)$ix][1] 
			 })
	#print(largestComps)
	compsSdf = smiles2sdf(largestComps)
	cid(compsSdf) = cid(sdfSet)
	compsSdf
}

test.formatConversions <- function() {
	if(! ChemmineR:::.haveOB()) 
		DEACTIVATED("this test requires ChemmineOB, but not available")
	message("test.formatConversions")

	data(sdfsample)

	smiles = sdf2smiles(sdfsample[1])
	sdfs = smiles2sdf(smiles)
	smiles2 = sdf2smiles(sdfs)
	smiles =gsub("[\r\n]", "", smiles) #remove newlines and convert to simple string
  smiles2 =gsub("[\r\n]", "", smiles2)

	checkEquals(smiles,smiles2)

}

test.genAPDescriptors <- function(){

	DEACTIVATED("removed old version of function")

	data(sdfsample)
	
	for(i in 1:100){
		sdf = sdfsample[[i]]
		desc = genAPDescriptors(sdf) 
		#print(head(desc));

		oldDesc=ChemmineR:::.gen_atom_pair(ChemmineR:::SDF2apcmp(sdf))
                 
		#print(oldDesc);
		compResult = desc==oldDesc
		if(!all(compResult)){
			message("descriptor mismatch")
			print(oldDesc[!compResult])
			print(desc[!compResult])
			message("----------")
			firstFalse = match(FALSE,compResult)
			print(oldDesc[(firstFalse-5):(firstFalse+5)])
			print(desc[(firstFalse-5):(firstFalse+5)])

		}
		checkTrue(all(compResult))
		#checkEqualsNumeric(desc,oldDesc)
	}
}
test.propOB <- function() {
	DEACTIVATED("fails on ubuntu 16.04")
	data(sdfsample)
	p = propOB(sdfsample[1:5])
	#print(p)
	#checkEquals(ncol(p),15)
	checkEquals(nrow(p),5)
   checkEquals(p$MW[2],MW(sdfsample[2])[[1]])

}
test.fingerprintOB <- function(){

	if(! ChemmineR:::.haveOB()) 
		DEACTIVATED("this test requires ChemmineOB, but not available")

	data(sdfsample)
	fp = fingerprintOB(sdfsample[1:5],"FP2")
	checkEquals(fptype(fp),"FP2")
	fpSingle = fingerprintOB(sdfsample[1],"FP2")
	checkEquals(as.character(class(fpSingle)),"FPset")
	checkEqualsNumeric(as.matrix(fpSingle[1]), as.matrix(fp[1]))
}
test.obmolRefs <- function() {
	if(! ChemmineR:::.haveOB()) 
		DEACTIVATED("this test requires ChemmineOB, but not available")

	data(sdfsample)
	obmolRef = obmol(sdfsample[[1]])

	checkEquals(class(obmolRef)[[1]],"_p_OpenBabel__OBMol")

	obmolRefs = obmol(sdfsample)
	checkEquals(class(obmolRefs),"list")
	checkEquals(class(obmolRefs[[2]])[[1]],"_p_OpenBabel__OBMol")
	checkEquals(length(sdfsample),length(obmolRefs))
}
test.smartsSearchOB <- function(){
	if(! ChemmineR:::.haveOB()) 
		DEACTIVATED("this test requires ChemmineOB, but not available")
	data(sdfsample)
	rotableBonds = smartsSearchOB(sdfsample[1:5],"[!$(*#*)&!D1]-!@[!$(*#*)&!D1]",uniqueMatches=FALSE)
	print("rotable bonds: ")
	print(rotableBonds)
	print(sdfid(sdfsample[1:5]))
	checkEquals(as.vector(rotableBonds[1:5]),c(24,20,14,30,10))

}
test.fpSim <- function(){
	data(apset)
	fpset = desc2fp(apset)
	dists = fpSim(fpset[[1]],fpset,top=6)
	checkEqualsNumeric(dists, 
							 c(1.0000000,0.4719101,0.4288499,0.4275229,0.4247423,0.4187380),
							 tolerance = 0.0001)

	for(m in c("tanimoto","euclidean","tversky","dice")){
		sim = ChemmineR:::fpSimOrig(fpset[[1]],fpset,
					method=m,cutoff=0.4,top=6)
		simFast= fpSim(fpset[[1]],fpset,
					method=m,cutoff=0.4,top=6)
		#message("method: ",m)
		#print(sim)
		#print(simFast)
		checkEqualsNumeric(sim,simFast,tolerance=0.00001)
	}

	
}
test.fpSimParameters<- function(){
	data(apset)
	fpset = desc2fp(apset)

	params = genParameters(fpset)

	similarities = fpSim(fpset[[1]],fpset,top=6,parameters=params)
	#print(similarities)

	checkEqualsNumeric(similarities$similarity, 
							 c(1,0.471910112359551,0.428849902534113,0.427522935779817,0.424742268041237,0.418738049713193),
							 tolerance = 0.0001)
	checkEqualsNumeric(similarities$zscore, 
							 c(6.41202501933441,1.6379277432492,1.24865001753133,1.23665382424036,1.21151572069559,1.15723571451518),
							 tolerance = 0.0001)
	checkEqualsNumeric(similarities$evalue, 
							 c(0.00000,6.36243,11.64270,11.84515,12.27769,13.25050),
							 tolerance = 0.0001)
	checkEqualsNumeric(similarities$pvalue, 
							 c(0,0.998274830604939,0.999991217102066,0.999992826756578,0.999995345559029,0.999998240535916),
							 tolerance = 0.0001)

}
test.exactMassOB <- function(){
	if(! ChemmineR:::.haveOB()) 
		DEACTIVATED("this test requires ChemmineOB, but not available")
	data(sdfsample)
	mass = exactMassOB(sdfsample[1:5])
	checkEqualsNumeric(mass,c(456.2009,357.1801,
									  370.1100,461.1733,
									  318.1943),tolerance=0.00001)
}
test.3dCoords <-function(){
	DEACTIVATED("causing timeout on bioc, disabling for now")
	data(sdfsample)
	sdf3d = generate3DCoords(sdfsample[1])

	checkTrue(!any(atomblock(sdf3d)[[1]][,3]==0))
	
}
test.canonicalize <- function(){
	if(! ChemmineR:::.haveOB()) 
		DEACTIVATED("this test requires ChemmineOB, but not available")
	data(sdfsample)
	cansdf = canonicalize(sdfsample[1])

	bb=bondblock(cansdf)[[1]]

	checkEqualsNumeric(bb[1,1:3],c(2,3,1))
	checkEqualsNumeric(bb[2,1:3],c(2,4,1))

}
test.parseV3000 <- function() {

	DEACTIVATED("requires local files")
	sdfset2 = read.SDFset("~/runs/v3000/DrugLike-0_2-3K3K_1.v2k.sdf")
	sdfset3 = read.SDFset("~/runs/v3000/DrugLike-0_2-3K3K_1.sdf")  

	compareSdfVersions = function(v2k,v3k){
		checkEquals(sdfid(v2k),sdfid(v3k))

		#message("v2k: ",nrow(atomblock(v2k)),"x",ncol(atomblock(v2k)))
		#message("v3k: ",nrow(atomblock(v3k)),"x",ncol(atomblock(v3k)))
		#print(head(atomblock(v2k)))
		#print(head(atomblock(v3k)))
		toCompare = c(1:5,7:10) #exclude colum 6
		checkTrue( all(atomblock(v2k)[,toCompare] ==
							atomblock(v3k)[,toCompare]))

#		cmp = bondblock(v2k)[,1:3] == bondblock(v3k)
#		if(! all(cmp)){
#			mismatched = which(cmp==FALSE)
#			print(cmp)
#			print("mismatched: ")
#			print(mismatched)
#			print("data:")
#			print(bondblock(v2k)[mismatched,1:3])
#			print(bondblock(v3k)[mismatched,])
#		}
#		checkTrue( all(bondblock(v2k)[,1:3] == bondblock(v3k)))

		checkTrue( all(datablock(v2k) == datablock(v3k)))
	}
	for(i in seq(along=sdfset2)){
		#if(!(i  %in% c(38,39,89))){ # this differ in acceptable ways
		#	message("testing ",i, " id: ",sdfid(sdfset2[i]))
			compareSdfVersions(sdfset2[[i]],sdfset3[[i]])
		#}
	}


}


test.pubchemPUG <- function(){

	DEACTIVATED("Causes SSL protocol version error on BioC")
	sdf = ChemmineR:::pubchemCidToSDF(c(434,435))
	message("cid to sdf, length: ",length(sdf))	
	checkEquals(length(sdf),2)


	sdf = ChemmineR:::pubchemSmilesSearch("C1CCCCCC1")
	message("smiles search, length: ",length(sdf))
	checkTrue(length(sdf) >= 1)

	data(sdfsample)
	sdf = ChemmineR:::pubchemSDFSearch(sdfsample[1])
	message("sdf search, length: ",length(sdf))
	checkTrue(length(sdf) >= 1)

	# just check that no exception is thrown
	ChemmineR:::pubchemSDF2PNG(sdfsample[1],"test-sample.png")


}

test.largestComponent <- function(){
	DEACTIVATED("just for manual testing")
	print("----------------")
	testSdf = smiles2sdf(c(
								  "O=C(NC1CCCC1)CN(c1cc2OCCOc2cc1)C(=O)CCC(=O)Nc1noc(c1)C	TEST1",
								  "CC.CC(=O)C1=CC2=C(C=C1)SC3=CC=CC=C3N2CCCN(C)C.C(=CC(=O)O)C(=O)O	TEST2",
								  "Cl.CCC1C2CC3C4C5(CC(C2C5O)N3C1O)C6=CC=CC=C6N4C	TEST3"))
	answer =  (c( "O=C(NC1CCCC1)CN(c1cc2OCCOc2cc1)C(=O)CCC(=O)Nc1noc(c1)C",
					 "CC(=O)C1=CC2=C(C=C1)SC3=CC=CC=C3N2CCCN(C)C",
					 "CCC1C2CC3C4C5(CC(C2C5O)N3C1O)C6=CC=CC=C6N4C"))
	names(answer) = c("TEST1","TEST2","TEST3")

	largestComps = largestComponent(testSdf)

	message("result: ")
	print(as.character(sdf2smiles(largestComps)))
	print(answer)

	print(largestComps==answer)

	checkTrue(all(largestComps==answer))
	print("----------------")
}

debug = FALSE
#debug = TRUE

dbOp<-function(dbExpr){
	#print(as.character(substitute(dbExpr)))
	#print(system.time(dbExpr))
	#print(dbExpr)
	dbExpr
}




initDb <- function(handle){

	if(is.character(handle)){ #assume sqlite filename
		require(RSQLite)
		driver = dbDriver("SQLite")
		conn = dbConnect(driver,dbname=handle,cache_size=100000)
	}else if(inherits(handle,"DBIConnection")){ #the user passed in a connection object
		conn=handle
	}else{
		stop("handle must be a SQLite database name or a DBIConnection")
	}
	
	enableForeignKeys(conn)

	tableList=dbListTables(conn)

	if( ! all(c("compounds","descriptor_types","descriptors", "compound_descriptors") %in% tableList)) {
		print("createing db")

		sqlFile = file.path("schema",if(inherits(conn,"SQLiteConnection")) "compounds.SQLite" 
								  else if(inherits(conn,"PostgreSQLConnection")) "compounds.RPostgreSQL")
																	
		statements = unlist(strsplit(paste(
							  readLines(system.file(sqlFile,package="ChemmineR",mustWork=TRUE)),
							  collapse=""),";",fixed=TRUE))
		#print(statements)

		Map(function(sql) dbOp(dbExecute(conn,sql)),statements)
	}
	conn
}
enableForeignKeys <- function(conn){
	#SQLite needs this to enable foreign key constrains, which are off by default
	if(inherits(conn,"SQLiteConnection"))
		dbExecute(conn,"PRAGMA foreign_keys = ON")
}

dbTransaction <- function(conn,expr){
	tryCatch({

		# be paranoid about setting this as bad things will happen if its not set
		enableForeignKeys(conn)

		dbExecute(conn,"BEGIN TRANSACTION")
		ret=expr
		dbCommit(conn)
		ret
	},error=function(e){
		dbRollback(conn)
#		print(sys.calls())
		stop(paste("db error inside transaction: ",e$message))
	})
}
dbGetQueryChecked <- function(conn,statement,execute=FALSE,...){
	if(execute)
		ret=dbExecute(conn,statement)
	else
		ret=dbGetQuery(conn,statement)
	err=dbGetException(conn)
	if(err$errorMsg[1] != "OK")
		stop("error in dbGetQuery: ",err$errorMsg,"  ",traceback())
	ret
}
loadDb <- function(conn,data,featureGenerator){

	names(data)=tolower(names(data))
	if(debug) print(paste("loading ",paste(dim(data),collapse=" "),"compounds"))

	if( ! ("definition_checksum" %in% colnames(data) ))
		data=cbind(data,definition_checksum=definitionChecksums(data[,"definition"]) )

	numCompounds = dim(data)[1]
	dups=0

	addNeededFeatures(conn,data,featureGenerator)

	if(all(c("name","definition","format") %in% colnames(data))){
		insertNamedDef(conn,data)
	}else if(all(c("definition","format") %in% colnames(data))){
		insertDef(conn,data)
	}else {
		stop("given data must have columns either (definition,format), or (name,definiton,format)")
	}

	insertUserFeatures(conn,data)
	as.matrix(data["definition_checksum"],rownames.force=FALSE)
}
definitionChecksums <- function(defs) {
	sapply(as.vector(defs),function(def) digest(def,serialize=FALSE),USE.NAMES=FALSE)
}
loadDescriptors <- function(conn,data){
	#expects a data frame with  req_columns

	req_columns=c("definition_checksum","descriptor","descriptor_type")
	if(!all(req_columns %in% colnames(data)))
		stop(paste("descriptor function is missing some fields, found",paste(colnames(data),collapse=","),
					  "need",paste(req_columns,collapse=",")))

	#ensure the needed descriptor types are available for the insertDescriptor function to use
	unique_types = unique(data[["descriptor_type"]])
	all_descriptor_types=dbGetQuery(conn,"SELECT distinct descriptor_type FROM descriptor_types")

	newTypes = if(nrow(all_descriptor_types)==0) unique_types 
				  else setdiff(unique_types,all_descriptor_types$descriptor_type)

	if(debug)
		print(paste("existing desc types:",paste(all_descriptor_types,collapse=","),"needed right now: ",
				paste(unique_types,collapse=",")," to be added: ",paste(newTypes,collapse=",")))
	if(length(newTypes) > 0)
		dbTransaction(conn,insertDescriptorType(conn,data.frame(descriptor_type=newTypes)))

	insertDescriptor(conn,data)
}

addDescriptorType <- function(conn,descriptorType){
	present = dbGetQuery(conn,
			paste("SELECT 1 FROM
					descriptor_types WHERE descriptor_type = '",
					descriptorType,"'",sep=""))
	print(nrow(present))
	if(nrow(present) == 0)
		insertDescriptorType(conn,data.frame(descriptor_type=descriptorType))
}

addNeededFeatures <- function(conn,data, featureGenerator){
	if(dim(data)[1] == 0){ # no data given
		warning("no data given to addNeededFeatures, doing nothing")
		return()
	}

	features = featureDiff(conn,data)

	if(length(features$missing) != 0)
		stop(paste("missing features:",paste(features$missing,collapse=",")))


	#will need to query all existing compounds and add these features
	if(length(features$new) != 0){
		message("adding new features to existing compounds. This could take a while")
		lapply(features$new,function(name) createFeature(conn,name,is.numeric(data[,name])))
		indexExistingCompounds(conn,features$new,featureGenerator)
	}
}
featureDiff <- function(conn,data) {

	if( nrow(data) == 0){ # no data given
		list(new=c(),missing=c())
	}else{

		compoundFields = dbListFields(conn,"compounds")
		userFieldNames = setdiff(colnames(data),compoundFields)

		existingFeatures = listFeatures(conn)

		missingFeatures = setdiff(existingFeatures,userFieldNames)
		newFeatures = setdiff(userFieldNames,existingFeatures)

		list(new=newFeatures, missing=missingFeatures)
	}
}
insertUserFeatures<- function(conn,data){
	if(debug) print("inserting user features")

	if(dim(data)[1] == 0){ # no data given
		warning("no data given to insertUserFeatures, doing nothing")
		return()
	}


	compoundFields = dbListFields(conn,"compounds")
	userFieldNames = setdiff(colnames(data),compoundFields)
	if(length(userFieldNames)==0) return()

	tableList=dbListTables(conn)
	existingFeatures = sub("^feature_","",tableList[grep("^feature_.*",tableList)])
	if(length(existingFeatures)==0) return()


		
	#index all new compounds for all features

	#fetch newly inserted compounds
	
	df = dbGetQuery(conn,paste("SELECT compound_id,definition_checksum FROM compounds LEFT JOIN feature_",
								 tolower(userFieldNames[1])," as f USING(compound_id)  WHERE f.compound_id IS
								 NULL",sep=""))
	data= merge(data,df)
	sapply(userFieldNames,function(name) insertFeature(conn,name,data))

}


########### Large query/file utilities ################
bufferLines <- function(fh,batchSize,lineProcessor){
	while(TRUE){
		lines = readLines(fh,n=batchSize)
		if(length(lines) > 0)
			lineProcessor(lines)
		else
			break;
	}
}
#db connections cannot be nested, so make sure rsProcessor does not
#try to use the db.
bufferResultSet <- function(rs,rsProcessor,batchSize=1000,closeRS=FALSE){
	while(TRUE){
		chunk = fetch(rs,n=batchSize)
		if(dim(chunk)[1]==0) # 0 rows in data frame
			break;
		rsProcessor(chunk)
	}
	if(closeRS) dbClearResult(rs)
}
batchByIndex <- function(allIndices,indexProcessor, batchSize=100000){

	numIndices=length(allIndices)

	if(numIndices==0)
		return()

	for(start in seq(1,numIndices,by=batchSize)){
		end = min(start+batchSize-1,numIndices)
		if(debug) print(paste(start,end))
		indexSet = allIndices[start:end]
		indexProcessor(indexSet)

	}
}
parBatchByIndex <- function(allIndices,indexProcessor,reduce,cl,batchSize=100000){

	numIndices=length(allIndices)

	if(numIndices==0)
		return()

	starts = seq(1,numIndices,by=batchSize)
	f = function(jobId){
		tryCatch({
				start = starts[jobId]
				end = min(start+batchSize-1,numIndices)
				ids=allIndices[start:end]
				indexProcessor(ids,jobId)
			},
			error=function(e){
				#write the error to a file to ensure it doesn't get lost
				cat(as.character(e),"\n",file=paste("error-",jobId,".out",sep=""))
				stop(e)
			}
		)
	}

	require(snow)
	#copy this to all nodes once so it is not copied for each iteration
	#of clusterApply
	clusterExport(cl,"allIndices",envir=environment())

	#we explicitly create an environment for f with just what it needs
	# so that serialization does not pull in un-nessacary things
	fEnv = new.env(parent=globalenv())
	fEnv$numIndices = numIndices
	fEnv$starts = starts
	fEnv$indexProcessor = indexProcessor
	fEnv$batchSize = batchSize

	environment(f) <- fEnv

	reduce(clusterApplyLB(cl,1:length(starts),f ))
}
#this does not guarentee a consistant ordering of the result
selectInBatches <- function(conn, allIndices,genQuery,batchSize=100000){
	#print(paste("all indexes: ",paste(allIndices,collapse=", ")))

	indices = unique(allIndices)
	#TODO: possibly pre-allocate result here, if performance is a problem
	result=NULL
	batchByIndex(indices, function(indexBatch){
			#print(paste("query:",genQuery(indexBatch)))
			df = dbGetQuery(conn,genQuery(indexBatch))
			#print(paste("got",paste(dim(df),collapse=" "),"results"))
			result <<- if(is.null(result)) df else  rbind(result,df)
			#print(paste("total results so far: ",length(result)))
	},batchSize)
	#print(paste("final count: ",length(result)))
	result

}
###############################################################


definition2SDFset <- function(defs){
	read.SDFset(unlist(strsplit(defs,"\n",fixed=TRUE)))
}
sdfSet2definition <- function(sdfset){
		 paste(Map(function(x) paste(x,collapse="\n"), 
					  as(as(sdfset,"SDFstr"),"list")),
				 collapse="\n" )
}

loadSmiles <- function(conn, smileFile,...){
	loadSdf(conn,smile2sdfFile(smileFile),...)
}
loadSdf <- function(conn,sdfFile,fct=function(x) data.frame(),
						  descriptors=function(x) data.frame(descriptor=c(),descriptor_type=c()), 
						  Nlines=50000, startline=1, restartNlines=100000,updateByName=FALSE){

	if(inherits(sdfFile,"SDFset")){
		if(debug) print("loading SDFset")
		sdfset=sdfFile


		sdfstrList=as(as(sdfset,"SDFstr"),"list")
		names = unlist(Map(function(x) x[1],sdfstrList))
		defs = unlist(Map(function(x) paste(x,collapse="\n"), sdfstrList) )
		processAndLoad(conn,names,defs,sdfset,fct,descriptors,updateByName)
	}else{
		compoundIds=c()
		## Define loop parameters 
		stop <- FALSE 
		f <- file(sdfFile, "r")
		n <- Nlines
		offset <- 0
		## For restarting sdfStream at specific line assigned to startline argument. If assigned
			  ## startline value does not match the first line of a molecule in the SD file then it 
			  ## will be reset to the start position of the next molecule in the SD file.
		if(startline!=1) { 
			fmap <- file(sdfFile, "r")
			shiftback <- 2
			chunkmap <- scan(fmap, skip=startline-shiftback, nlines=restartNlines, what="a", blank.lines.skip=FALSE, quiet=TRUE, sep ="\n")
			startline <- startline + (which(grepl("^\\${4,4}", chunkmap, perl=TRUE))[1] + 1 - shiftback)
			if(is.na(startline)) stop("Invalid value assigned to startline.")
			dummy <- scan(f, skip=startline-2, nlines=1, what="a", blank.lines.skip=FALSE, quiet=TRUE, sep ="\n")
			close(fmap)
			offset <- startline - 1 # Maintains abolut line positions in index
		}
		counter <- 0
		cmpid <- 1
		partial <- NULL

		while(!stop) {
			counter <- counter + 1
			chunk <- scan(f, n=n, what="a", blank.lines.skip=FALSE, quiet=TRUE, sep ="\n") # scan has more flexibilities for reading specific line ranges in files.
			if(length(chunk) > 0) {
				if(length(partial) > 0) {
					chunk <- c(partial, chunk)
				}
				## Assure that lines of least 2 complete molecules are stored in chunk if available
				inner <- sum(grepl("^\\${4,4}", chunk, perl=TRUE)) < 2
				while(inner) {
					chunklength <- length(chunk)
					chunk <- c(chunk, readLines(f, n = n))
					if(chunklength == length(chunk)) { 
						inner <- FALSE 
					} else {
						#inner <- sum(grepl("^\\${4,4}", chunk, perl=TRUE)) < 2
						inner <- sum(grepl("$$$$", chunk, fixed=TRUE)) < 2
					}
				}
				y <- regexpr("^\\${4,4}", chunk, perl=TRUE) # identifies all fields that start with a '$$$$' sign
				index <- which(y!=-1)
				indexDF <- data.frame(start=c(1, index[-length(index)]+1), end=index)
				complete <- chunk[1:index[length(index)]]
				if((index[length(index)]+1) <= length(chunk)) {
					partial <- chunk[(index[length(index)]+1):length(chunk)]
				} else {
					partial <- NULL
				}

				sdfset <- read.SDFset(read.SDFstr(complete))
				valid = validSDF(sdfset)
				sdfset=sdfset[valid]

				defs=apply(indexDF,1,function(row) paste(complete[row[1]:row[2]],collapse="\n"))[valid]
				names = complete[indexDF[,1]][valid]
				cmdIds = processAndLoad(conn,names,defs,sdfset,fct,descriptors,updateByName,inTransaction=TRUE)

				compoundIds = c(compoundIds,cmdIds)
				
			}
			if(length(chunk) == 0) {
				stop <- TRUE
				close(f)
			}
		}

		compoundIds
		
	}
}

processAndLoad <- function(conn,names,defs,sdfset,featureFn,descriptors,updateByName,inTransaction=FALSE ) {
	# - compute checksums on defs
	# - if(updateByName)
	#		query checksums for each name
	#		exclude those that match our checksum
	#		updates <- those with different checksum
	#		new compounds <- everything else
	#	else
	#		exclude existing checksums
	#		insert the rest	
	# - include checksums in systemFields
	#		- have loadDb check for the existance of checksums and don't re-compute
	# - compute and insert/update descriptors for new/updated compounds

	checksums = definitionChecksums(defs)
	index=1:length(names)
	deleteCompIds=c()


	if(updateByName){
		#we assume compounds are unique by name and so changes in checksum
		# indicate updates to the same compounds

		if(debug) message("given names: ",paste(names,collapse=","))
		names(index)=names
		index=rev(index) # so last matches win


		existingByName = findCompoundsByX(conn,"name",names,allowMissing=TRUE,
														 extraFields = c("definition_checksum","name"))
		if(debug) {message("existing names: "); print(existingByName); }

#		idsToLoad = Filter(function(i) {
#			#either the name is completely new, or it exists, but the checksum is different, so this is 
#			# an update
#			(! names[i] %in% existingByName$name) || (! checksums[i] %in% existingByName$definition_checksum)
#
#		},index)


		namesToLoad = unique(Filter(function(name) {
			#either the name is completely new, or it exists, but the checksum is different, so this is 
			# an update
			(! name %in% existingByName$name) || (! checksums[index[name]] %in% existingByName$definition_checksum)
		},names))
		if(debug) message("names to load: ",paste(namesToLoad,collapse=","))

		namesToDelete = unique(Filter(function(name) {
			#delete those needing an update, so name exists and checksum is different
			( name %in% existingByName$name) && (! checksums[index[name]] %in% existingByName$definition_checksum)
		},names))
		if(debug) message("names to delete: ",paste(namesToDelete,collapse=","))

		#delete modified and missing compounds, will cascade to all descriptors

		deleteCompIds = c()
		for(name in namesToDelete){
			i = Position(function(x) x==name,existingByName$name,right=TRUE)
			deleteCompIds[checksums[index[name]]] = existingByName$compound_id[i]
		}


		#existingNameToCompId = existingByName$compound_id
		#names(existingNameToCompId) = existingByName$name
		#existingNameToCompId = rev(existingNameToCompId)
		#deleteCompIds = existingNameToCompId[namesToDelete]
		#rownames(existingByName)=existingByName$compound_id

		#rownames(existingByName)=existingByName$name
		#deleteCompIds = existingByName[namesToDelete,]$compound_id

		#if(length(namesToDelete) != 0)
			#names(deleteCompIds) = checksums[index[namesToDelete]]
		ids = index[namesToLoad]
		message("loading ",length(ids)," new compounds, updating ",length(deleteCompIds)," compounds")
	}else{
		#we do not assume names are unique, therefore if a checksum does not
		#exist, then it is added as if it where a new compound
		names(index)=checksums
		if(debug){ message("checking for existing compounds: ")}
		existingByChecksum = findCompoundsByX(conn,"definition_checksum",checksums,allowMissing=TRUE,
														 extraFields = c("definition_checksum","name"))

		if(debug){ message("existing checksums: "); print(existingByChecksum); }
		#select only those whose checksum does not already exist
		#setdiff also makes its result unique
		checksumsToLoad = setdiff(checksums,existingByChecksum$definition_checksum)
		if(debug) message("checksumsToLoad: ",paste(checksumsToLoad,collapse=","))

		ids = index[checksumsToLoad]
		if(debug) message("loading ",length(ids)," new compounds")
	}
	if(debug) message("updating ids: ",paste(ids,collapse=","))

	tx = if(inTransaction) function(a,x) x  else dbTransaction
	if(length(ids)==0){
		tx(conn,deleteCompounds(conn,deleteCompIds))
		c() # no compound ids to return
	}else{

		names = names[ids]
		defs = defs[ids]
		checksums = checksums[ids]
		sdfset = sdfset[ids]
		userFeatures = featureFn(sdfset)

		if(debug) message("Features: ",colnames(userFeatures))
		if(debug) message("names: ",length(names)," defs: ",length(defs),", cksm: ",length(checksums),", features: ",length(userFeatures))

		systemFields=data.frame(name=names,definition=defs,format=rep("sdf",length(names)),definition_checksum=checksums)

		allFields = if(length(userFeatures)!=0) cbind(systemFields,userFeatures) else systemFields

		tx(conn, deleteCompounds(conn,deleteCompIds) )
		loadedChecksums = tx(conn, loadDb(conn,allFields,featureFn) )

		#We assume descriptors are in the same order as compounds
		descriptor_data = descriptors(sdfset)
		if(length(descriptor_data) != 0)
			loadDescriptors(conn,cbind(loadedChecksums,descriptor_data))


		#print("original deleted comp ids")
		#print(deleteCompIds)
		#cmdIds=findCompoundsByChecksum(conn,loadedChecksums)
		#print("new comp ids: ")
		#print(cmdIds)

		# to keep stable compound id numbers, we reset the compound id of those
		# compounds that were merely modified.
		for(i in seq(along=deleteCompIds)){
			cksum=names(deleteCompIds)[i]
			id = deleteCompIds[i]
			dbExecute(conn,paste("UPDATE compounds SET compound_id = ",id,
										  " WHERE definition_checksum = '",cksum,"'",sep=""))
		}


		cmdIds=findCompoundsByChecksum(conn,loadedChecksums)
		if(nrow(loadedChecksums) != length(cmdIds)){
			stop("failed to insert all compounds. recieved ",nrow(loadedChecksums), 
				  " but only inserted ",length(cmdIds))
		}
		#print("updated comp ids:")
		#print(cmdIds)
	
		#those in deleteCompIds were not really added, just modified. so remove them here.
		#return newly added compound ids.
		setdiff(cmdIds,deleteCompIds)
		
	}
}
setPriorities <- function(conn,priorityFn,descriptorIds=c(),cl=NULL,connSource=NULL){

	if(length(descriptorIds) == 0)
		compoundGroups = dbGetQuery(conn,"SELECT * FROM compounds_grouped_by_descriptors")
	else{
		compoundGroups = selectInBatches(conn,descriptorIds, function(ids)
						paste("SELECT * FROM compounds_grouped_by_descriptors ",
											 " WHERE descriptor_id IN
											 (",paste(ids,collapse=","),")") )
	}
	message("setting priorities for ",nrow(compoundGroups)," groups.")
	#message("compound groups: ")
	#print(compoundGroups)

	processIds = function(indexes,conn){
		for(i in indexes){
			dbTransaction(conn,	{
				compIds = unlist(strsplit(compoundGroups$compound_ids[i],",",fixed="TRUE"))
				priorities = priorityFn(conn,compIds)
				priorities$descriptor_id = rep(compoundGroups$descriptor_id[i],nrow(priorities))
				updatePriorities(conn,priorities)} )
			}

	}
	if(is.null(cl)){
			processIds(seq(along=compoundGroups$compound_ids),conn)
			#for(i in seq(along=rows$compound_ids)){
				#compIds = unlist(strsplit(rows$compound_ids[i],",",fixed="TRUE"))
				#priorities = priorityFn(conn,compIds)
				#priorities$descriptor_id = rep(rows$descriptor_id[i],nrow(priorities))
				#updatePriorities(conn,priorities)
			#}
	}else{
		if(is.null(connSource)) stop("A connSource function must be given to use a cluster")

		clusterExport(cl,"compoundGroups",envir=environment())

		parBatchByIndex(seq(along=compoundGroups$compound_ids),function(ids,jobId){
					conn=connSource()
					processIds(ids,conn)
					dbDisconnect(conn)
			},identity,cl)	
	}



}
randomPriorities <- function(conn,compIds){
	data.frame(compound_id = compIds,priority=1:length(compIds))
}
forestSizePriorities <- function(conn,compIds){
	#convert sdf to smiles and count dots to see how many trees are in the forest
	sdf = getCompounds(conn,compIds)
	smiles = sdf2smiles(sdf)
	matches = gregexpr(".",as.character(smiles),fixed=TRUE)
	numTrees = sapply(seq(along=matches),function(i){
							 l=length(matches[[i]])
							 if(l==1 && matches[[i]][1]==-1)
								 1
							 else 
								 l+1
	})

	data.frame(compound_id = compIds, priority = numTrees)

}

smile2sdfFile <- function(smileFile,sdfFile=tempfile()){
	.ensureOB("smile format only suppported with ChemmineOB package")
	convertFormatFile("SMI","SDF",smileFile,sdfFile)
	sdfFile
}


deleteCompounds <- function(conn,compoundIds) {
	if(length(compoundIds)!=0)
		dbExecute(conn,paste("DELETE FROM compounds WHERE compound_id IN (",
							paste(compoundIds,collapse=","),")"))
}

getAllCompoundIds <- function(conn){
	dbGetQueryChecked(conn,"SELECT compound_id FROM compounds WHERE format!='junk' ")[[1]]
}
findCompounds <- function(conn,featureNames,tests){

	# SELECT compound_id FROM compounds join f1 using(compound_id) join f2 using(compound_id)
	# ... where test1 AND test2 AND ...
	featureNames = tolower(featureNames)

	featureTables = paste("feature_",featureNames,sep="")
	tryCatch({
		sql = paste("SELECT compound_id FROM compounds JOIN ",paste(featureTables,collapse=" USING(compound_id) JOIN "),
					" USING(compound_id) WHERE ",paste("(",paste(tests,collapse=") AND ("),")") ) 
	
		if(debug) print(paste("query sql:",sql))
		result = dbGetQueryChecked(conn,sql)
		result[1][[1]]
	},error=function(e){
		if(length(grep("no such column",e$message))!=0){
			stop("featureNames must contain every feature used in a test")
		}else{
			stop(paste("error in findCompounds:",e$message))
		}
	})

}

#undefined ordering by default
findCompoundsByChecksum <- function(conn,checksums,keepOrder=FALSE,allowMissing=FALSE)
	findCompoundsByX(conn,"definition_checksum",checksums,keepOrder,allowMissing)
findCompoundsByName<- function(conn,names,keepOrder=FALSE,allowMissing=FALSE)
	findCompoundsByX(conn,"name",names,keepOrder,allowMissing)

findCompoundsByX<- function(conn,fieldName,data,keepOrder=FALSE,allowMissing=FALSE,extraFields=c()){


	xf = if(length(extraFields)!=0) paste(",",paste(extraFields,collapse=",")) else ""
	result = selectInBatches(conn,data,function(batch) 
			paste("SELECT compound_id,",fieldName," ",xf,
					" FROM compounds WHERE ",fieldName," IN
					('",paste(batch,collapse="','"),"')",sep=""),1000)

	#no column names preserved for empty dataframes, so we can't just
	# handle it the same way, we need a special case :(
	if(length(result)==0){
		if(!allowMissing && length(data) != 0)
			stop(paste("found 0 out of",length(data),
					  "queries given"))
		else
			return(result)
	}


	ids = result$compound_id
	#message("allowMissing? ",allowMissing," num ids: ",length(ids),", num data: ",length(data))

	if(!allowMissing && length(ids)!=length(data))
		stop(paste("found only",length(ids),"out of",length(data),
					  "queries given"))
	if(keepOrder){
		if(length(extraFields)!=0){
			rownames(result)=result[[fieldName]]
			result[as.character(data),c("compound_id",extraFields)]
		}
		else{
			names(ids)=result[[fieldName]]
			ids[as.character(data)]
		}
	}else{
		if(length(extraFields)!=0)
			result[,c("compound_id",extraFields)]
		else
			ids
	}
}
getCompounds <- function(conn,compoundIds,filename=NA,keepOrder=FALSE,allowMissing=FALSE){
	
	processedCount=0
	if(!is.na(filename)){
		f=file(filename,"w")

		resultProcessor = function(rows){
			lapply(rows[2][[1]],function(def) cat(def,"\n",sep="",file=f))
			processedCount <<- processedCount + dim(rows)[1]
		}
	}else{
		sdfset = rep(NA,length(compoundIds))
		count=1
		resultProcessor = function(rows){
					l=length(rows[2][[1]])
					sdfset[count:(count+l-1)]<<-as(definition2SDFset(rows[2][[1]]),"SDF")
					names(sdfset)[count:(count+l-1)]<<-as.character(rows[1][[1]])
					count<<-count+l
					processedCount <<- processedCount + dim(rows)[1]
			}
	}

	batchByIndex(compoundIds,function(compoundIdSet){
		rs = dbSendQuery(conn,
							  paste("SELECT compound_id,definition FROM compounds where compound_id in (",
									  paste(compoundIdSet,collapse=","),")"))
		f=if(keepOrder)
			function(rows){
				rownames(rows) = rows$compound_id
				orderedIds = intersect(compoundIdSet,rows$compound_id)
				resultProcessor(rows[as.character(orderedIds),])
			}
		else
			resultProcessor

		bufferResultSet(rs,f,1000)
		dbClearResult(rs)
	})

	if(!allowMissing && length(compoundIds) != processedCount) {
		if(debug) print(str(sdfset))
		stop(paste("not all compounds found,",length(compoundIds),"given but",processedCount,"found"))
	}

	if(!is.na(filename)){
		close(f)
	}else{
		return(as(sdfset,"SDFset"))
	}
}
getCompoundFeatures <- function(conn,compoundIds, featureNames, filename=NA,
										  keepOrder=FALSE, allowMissing=FALSE,batchSize=100000){

	finalResult=data.frame()
	processedCount=0

	if(!is.na(filename))
		f=file(filename,"w")

	featureNames = tolower(featureNames)

	featureTables = paste("feature_",featureNames,sep="")
	batchByIndex(compoundIds,function(compoundIdSet){
		tryCatch({
			sql = paste("SELECT ",paste(c("compound_id",featureNames),collapse=","),
						" FROM compounds JOIN ",paste(featureTables,collapse=" USING(compound_id) JOIN "),
						" USING(compound_id) WHERE compound_id in (",
										  paste(compoundIdSet,collapse=","),")")

			if(debug) print(paste("query sql:",sql))


			result = dbGetQueryChecked(conn,sql)

			if(keepOrder){
				rownames(result) = result$compound_id
				orderedIds = intersect(compoundIdSet,result$compound_id)
				result = result[as.character(orderedIds),]
			}
			
			if(!is.na(filename))
				if(processedCount==0) #first time
					write.table(result,file=f,row.names=FALSE,sep=",",quote=FALSE)
				else
					write.table(result,file=f,append=TRUE,col.names=FALSE,row.names=FALSE,sep=",",quote=FALSE)
			else
				finalResult <<- rbind(finalResult,result)

			processedCount <<- processedCount + nrow(result)
		},error=function(e){
			stop(paste("error in findCompounds:",e$message))
		})
   },batchSize=batchSize)

	if(!allowMissing && length(compoundIds) != processedCount) {
		stop(paste("not all compounds found,",length(compoundIds),"given but",processedCount,"found"))
	}

	if(!is.na(filename))
		close(f)
	else
		finalResult
}
getCompoundNames <- function(conn, compoundIds,keepOrder=FALSE,allowMissing=FALSE){

	result = selectInBatches(conn,compoundIds,function(ids)
					  paste("SELECT compound_id, name FROM compounds where compound_id in (",
									  paste(ids,collapse=","),")"))

	if(!allowMissing)
		if(nrow(result) != length(compoundIds))
			stop(paste("found only",nrow(result),"out of",length(compoundIds), "ids given"))

	n=result$name
	if(keepOrder){
		names(n)=result$compound_id
		n[as.character(compoundIds)]
	}else
		n
}
indexExistingCompounds <- function(conn,newFeatures,featureGenerator){

	# we have to batch by index because we need to execute an insert statment along
	# the way and R DBI does not allow you to do two things at once.
	ids = dbGetQuery(conn,"SELECT compound_id FROM compounds WHERE format!='junk' ")
	if(length(ids) > 0)
		batchByIndex(ids[1][[1]],function(compoundIdSet){
			tryCatch({
					rows=dbGetQuery(conn,paste("SELECT compound_id,definition FROM compounds WHERE compound_id in (",
									  paste(compoundIdSet,collapse=","),")"))

					sdfset = definition2SDFset(rows[2][[1]])
					userFeatures  = featureGenerator(sdfset)
					names(userFeatures)=tolower(names(userFeatures))
					lapply(newFeatures, function(name){
							 insertFeature(conn,name,cbind(compound_id=rows[1][[1]],userFeatures[name]))
					})
				},error=function(e) stop(paste("error in indexExistingCompounds:",e$message))
			)

		},1000)
}
addNewFeatures <- function(conn,featureGenerator){

	firstBatch = TRUE
	newFeatures = c()
	ids = dbGetQuery(conn,"SELECT compound_id FROM compounds WHERE format!='junk' ")
	if(length(ids) > 0)
		batchByIndex(ids[1][[1]],function(compoundIdSet){
			tryCatch({
					rows=dbGetQuery(conn,paste("SELECT compound_id,definition FROM compounds WHERE compound_id in (",
									  paste(compoundIdSet,collapse=","),")"))

					sdfset = definition2SDFset(rows[2][[1]])

					data = featureGenerator(sdfset)
					names(data)=tolower(names(data))

					if(firstBatch){
						firstBatch<<-FALSE
						features = featureDiff(conn,data)
						newFeatures <<- features$new
						for(name in features$new)
							createFeature(conn,name,is.numeric(data[[name]]))
					}
					if(debug) print(paste("new features ",paste(newFeatures,collapse=",")))
					lapply(newFeatures, function(name){
							 insertFeature(conn,name,cbind(compound_id=rows[1][[1]],data[name]))
					})
				},error=function(e) stop(paste("error in addNewFeature:",e$message))
			)

		},1000)


}

listFeatures <- function(conn){
	
	 tableList=dbListTables(conn)
	 sub("^feature_","",tableList[grep("^feature_.*",tableList)])
}

createFeature <- function(conn,name, isNumeric){

	sqlType = if(isNumeric) "NUMERIC" else "TEXT"
	if(debug) print(paste("adding",name,", sql type: ",sqlType))

	dbGetQueryChecked(conn,
		paste("CREATE TABLE feature_",name," (
			compound_id INTEGER PRIMARY KEY REFERENCES compounds(compound_id) ON DELETE CASCADE ON UPDATE CASCADE, ",
			"",name," ",sqlType," )",sep=""),execute=TRUE)

	#print("made table")
	dbExecute(conn,paste("CREATE INDEX feature_",name,"_index ON
								 feature_",name,"(\"",name,"\")",sep=""))
	#print("made index")

}

rmDups <- function(data,columns) data[!duplicated(data[,columns]),]
insertDef <- function(conn,data)  {
	data = rmDups(data,"definition_checksum")
	fields = c("definition","definition_checksum","format")
	if(inherits(conn,"SQLiteConnection")){
		getPreparedQuery(conn,paste("INSERT INTO compounds(definition,definition_checksum,format) ",
								 "VALUES(:definition,:definition_checksum,:format)",sep=""), bind.data=data[fields])
	}else if(inherits(conn,"PostgreSQLConnection")){
		if(debug) print(data[,"definition_checksum"])
		apply(data[,fields],1,function(row) dbOp(dbExecute(conn, 
						 "INSERT INTO compounds(definition,definition_checksum,format) VALUES($1,$2,$3)",
						 row)))
	}else{
		stop("database ",class(conn)," unsupported")
	}
}

insertNamedDef <- function(conn,data) {
	data = rmDups(data,"definition_checksum")
	fields = c("name","definition","definition_checksum","format")
	if(inherits(conn,"SQLiteConnection")){
		getPreparedQuery(conn,paste("INSERT INTO compounds(name,definition,definition_checksum,format) ",
								 "VALUES(:name,:definition,:definition_checksum,:format)",sep=""), bind.data=data[fields])
	}else if(inherits(conn,"PostgreSQLConnection")){
		postgresqlWriteTable(conn,"compounds",data[,fields],append=TRUE,row.names=FALSE)


	}else{
		stop("database ",class(conn)," unsupported")
	}
}

insertFeature <- function(conn,name,values){
	if(debug) print(paste("name:",name))
	fields = c("compound_id",name)
	if(inherits(conn,"SQLiteConnection")){
		getPreparedQuery(conn, paste("INSERT INTO feature_",name,"(compound_id,",name,") ",
												 "VALUES(:compound_id,:",name,")",sep=""), bind.data=values[fields])
	}else if(inherits(conn,"PostgreSQLConnection")){

		postgresqlWriteTable(conn,paste("feature_",name,sep=""),values[,fields],append=TRUE,row.names=FALSE)


	}else{
		stop("database ",class(conn)," unsupported")
	}
}
descriptorTypes <- function(conn){
	data = dbGetQuery(conn,"SELECT descriptor_type_id, descriptor_type FROM descriptor_types")
	dt = data$descriptor_type_id
	names(dt) = data$descriptor_type
	dt	
}
insertDescriptor <- function(conn,data){
	data = rmDups(data,c("definition_checksum","descriptor_type"))
	data$descriptor_checksum = sapply(as.character(data$descriptor),function(x) digest(x,serialize=FALSE))
	uniqueDescriptors = rmDups(data,c("descriptor_type","descriptor_checksum"))

	descTypes = descriptorTypes(conn)
	fields1 = c("descriptor_type","descriptor","descriptor_checksum")
	fields2 = c("definition_checksum","descriptor_type","descriptor_checksum")


	if(inherits(conn,"SQLiteConnection")){
		getPreparedQuery(conn, paste("INSERT OR IGNORE INTO descriptors(descriptor_type_id,descriptor,descriptor_checksum) ",
				"VALUES( (SELECT descriptor_type_id FROM descriptor_types WHERE descriptor_type = :descriptor_type), 
							:descriptor,:descriptor_checksum )") ,bind.data=uniqueDescriptors[fields1])
		getPreparedQuery(conn, paste("INSERT INTO compound_descriptors(compound_id,
												 descriptor_id) ",
				"VALUES( (SELECT compound_id FROM compounds WHERE definition_checksum = :definition_checksum),
							(SELECT descriptor_id FROM descriptors JOIN descriptor_types USING(descriptor_type_id) 
							 WHERE descriptor_type = :descriptor_type 
								AND descriptor_checksum = :descriptor_checksum))"),
						bind.data=data[fields2])
	}else if(inherits(conn,"PostgreSQLConnection")){
		apply(uniqueDescriptors[,fields1],1,function(row) {
				row[1] = descTypes[row[1]] #translate descriptor_type to descriptor_type_id
				dbTransaction(conn,
					dbClearResult(dbSendQuery(conn, paste("INSERT INTO descriptors(descriptor_type_id,descriptor,descriptor_checksum) ",
										" SELECT $1, $2, $3 ",
										" WHERE NOT EXISTS (SELECT 1 FROM descriptors WHERE descriptor_type_id = $1 AND descriptor_checksum=$3)" 
									) ,row))
				)
			})
		apply(data[,fields2],1,function(row) {
			row[2] = descTypes[row[2]] #translate descriptor_type to descriptor_type_id
			dbTransaction(conn,dbExecute(conn, paste("INSERT INTO compound_descriptors(compound_id,
										  descriptor_id) ",
					"VALUES( (SELECT compound_id FROM compounds WHERE definition_checksum = $1),
								(SELECT descriptor_id FROM descriptors  
								 WHERE descriptor_type_id = $2 AND descriptor_checksum = $3))"),row))
			})
	}else{
		stop("database ",class(conn)," unsupported")
	}
}
insertDescriptorType <- function(conn,data){
	if(inherits(conn,"SQLiteConnection")){
		getPreparedQuery(conn,"INSERT INTO descriptor_types(descriptor_type) VALUES(:descriptor_type)",
								 bind.data=data)
	}else if(inherits(conn,"PostgreSQLConnection")){
		apply(data,1,function(row) 
				dbExecute(conn,paste("INSERT INTO descriptor_types(descriptor_type) VALUES($1)"),row))
	}else{
		stop("database ",class(conn)," unsupported")
	}
}
updatePriorities <- function(conn,data){
	#message("updatePriorities (1-10): ")
	#print(data[1:10,])
	if(inherits(conn,"SQLiteConnection")){
		getPreparedQuery(conn,"UPDATE compound_descriptors SET priority = :priority WHERE compound_id=:compound_id AND
								 descriptor_id=:descriptor_id", bind.data=data)
	}else if(inherits(conn,"PostgreSQLConnection")){
		apply(data[,c("compound_id","descriptor_id","priority")],1,function(row) 
				dbExecute(conn,paste("UPDATE compound_descriptors SET priority = $3 WHERE compound_id=$1 AND
								 descriptor_id=$2"),row))
	}else{
		stop("database ",class(conn)," unsupported")
	}

}

getPreparedQuery <- function(conn,statement,bind.data){
	#message("SQL statement: ")
	#print(statement)
	#message("data:")
	#print(colnames(bind.data))

	#dbSendPreparedQuery(conn,statement,bind.data)
	
	#print("sending query")
	res <- dbSendStatement(conn,statement)
	#print("after sendQuery")
	on.exit(dbClearResult(res)) #clear result set when this function exits
	#print("after exit callback registered")

	#suppress warnings here otherwise it complains about 
	#converting factors to strings occasionally
	suppressWarnings( dbBind(res,bind.data))
	#print("after dbBind")
}



DUD <- function(destinationDir="."){
	#getDbConn("dud.db")
	URL ="http://biocluster.ucr.edu/~khoran/datasets/dud.tar.gz"
	destFile = file.path(destinationDir,"dud.tar.gz")
	if(!file.exists(file.path(destinationDir,"dud.db"))){
		message("dud.db not found in '",destinationDir,"', downloading. This could take several minutes.")
		download.file(URL,destFile,mode="wb")
		message("unpacking...")
		#gunzip(destFile)
		untar(destFile)
		unlink(destFile,force=TRUE)
		message("done")
	}

	initDb(file.path(destinationDir,"dud.db"))
}
DrugBank <- function(){
	getDbConn("drugbank.db")
}
getDbConn <- function(dbName) {
	if(require("ChemmineDrugs"))
		initDb(system.file(file.path("extdata",dbName),package="ChemmineDrugs",mustWork=TRUE))
	else
		error("The package 'ChemmineDrugs' must be installed to use this function")
}

testDir = system.file("unitTests",package="ChemmineR")
test_aaa.clean <- function(){

	unlink(c("test.db","test2.db","test1.db","test.sdf","test_desc.db",
				"part1.db","part2.db","dup_test.db"))
	
}

test_aa.initDb<-function(){
	#DEACTIVATED("temp")
	conn = initDb("test.db")
	checkTrue(file.exists("test.db"))
	checkException(initDb(c(1,2)))
	checkTrue(all(c("compounds","descriptor_types","descriptors") %in% dbListTables(conn)))
	checkTrue(inherits(conn,"DBIConnection"))
	dbDisconnect(conn)
}

test_ba.loadSdf<-function(){
	#DEACTIVATED("temp")
	data(sdfsample)


	conn = initDb("test1.db")
#	print("loading first half, no features, with exception")
#	checkException(loadSdf(conn,sdfsample[c(1,2,1,3)]))
	compIds=loadSdf(conn,sdfsample[c(1,2,3)])
	checkEquals(length(compIds),3)
	dbDisconnect(conn)


	conn = initDb("test1.db") # use new conn to make sure changes are durable
	print("loading first half, no features")
	compoundCount = dbGetQuery(conn,"SELECT count(*) FROM
										compounds WHERE format!='junk'")[1][[1]]
	checkEquals(compoundCount, 3)


	firstHalf=tempfile()
	write.SDF(sdfsample[1:50],firstHalf)
	secondHalf=tempfile()
	write.SDF(sdfsample[51:100],secondHalf)

	conn = initDb("test2.db")

	print("loading first half,with features")
	loadSdf(conn,firstHalf,function(sdfset)
			  data.frame( 
					  MW=MW(sdfset),
					  rings(sdfset, type="count", upper=6, arom=TRUE)) )

	print("loading incomplete features")
	checkException(loadSdf(conn,secondHalf,function(sdfset)
			  data.frame( CID=cid(sdfset),
					  rings(sdfset, type="count", upper=6, arom=TRUE)) ))

	print("loading second half")
	loadSdf(conn,secondHalf,function(sdfset)
			  data.frame( CID=cid(sdfset),
					  MW=MW(sdfset),
					  rings(sdfset, type="count", upper=6, arom=TRUE)) )
	print("done loading")


	compoundCount = dbGetQuery(conn,"SELECT count(*) FROM
										compounds WHERE format!='junk'")[1][[1]]
	checkEquals(compoundCount ,length(cid(sdfsample)))
	featureCount= dbGetQuery(conn,"SELECT count(*) FROM feature_mw")[1][[1]]
	checkEquals(featureCount ,length(cid(sdfsample)))
	dbDisconnect(conn)

	#test loading descriptors
	conn=initDb("test_desc.db")
	loadSdf(conn,firstHalf,function(sdfset) data.frame(MW=MW(sdfset)),
			  descriptors=function(sdfset) 
				data.frame(descriptor_type="ap",descriptor=unlist(lapply(ap(sdf2ap(sdfset)),
														function(ap) paste(ap,collapse=", ")))))
	descriptorCount= dbGetQuery(conn,"SELECT count(*) FROM descriptors")[1][[1]]
	checkEquals(descriptorCount,50)
	typeCount= dbGetQuery(conn,"SELECT count(*) FROM descriptor_types WHERE descriptor_type = 'ap' ")[1][[1]]
	checkEquals(typeCount,1)
}
test_bn.addNewFeatures<-function(){

	conn = initDb("test2.db")
	addNewFeatures(conn,function(sdfset) data.frame(new=cid(sdfset),new2=cid(sdfset)))
	features = listFeatures(conn)
	checkTrue("new" %in% features)
	checkTrue("new2" %in% features)

	#tables = dbListTables(conn)
	#checkTrue("feature_new" %in% tables)
	#checkTrue("feature_new2" %in% tables)
}

test_ca.findCompounds<-function(){
	#DEACTIVATED("temp")
	conn = initDb("test2.db")

	indexes = findCompounds(conn,"MW",c("MW < 400"))
	print(paste("found",length(indexes)," compounds"))
	checkEquals(length(indexes),70)

	checkException(findCompounds(conn,"MW",c("mw < 400","rings > 3")))

	indexes=findCompounds(conn,c("MW","RINGS"),c("mw < 400","rings > 3"))
	print(paste("found",length(indexes)," compounds"))
	checkEquals(length(indexes),20)

	dbDisconnect(conn)
}

test_da.getCompounds<-function(){
	#DEACTIVATED("temp")
	conn = initDb("test2.db")

	indexes = findCompounds(conn,"MW","mw < 400")

	sdfset = getCompounds(conn,indexes,keepOrder=TRUE)
	checkEquals(length(cid(sdfset)),70)
	ids2=findCompoundsByName(conn,sdfid(sdfset),keepOrder=TRUE)
	names(ids2)=c()
	checkEquals(indexes,ids2)
	
	getCompounds(conn,indexes,file="test.sdf")
	checkTrue(file.exists("test.sdf"))
	sdfFromFile = read.SDFset("test.sdf")
	checkEquals(length(cid(sdfFromFile)),70)
	dbDisconnect(conn)
}



test_ea.comparison <- function() {
	DEACTIVATED("local test")
	#filename = "~/runs/kinase/kinase.sdf"
	filename = "~/runs/protein/proteins.sdf"
	#filename = "~/runs/protein/proteins-1000.sdf"
#	options(warn=2)
	options(error=traceback)
	streamTest <- function(){
		#sink("/dev/null")
		print(system.time(sdfStream(input=filename,output="index.stream", silent=TRUE, fct=function(sdfset)
					 cbind(MW=MW(sdfset)  ))))
		print(system.time(index <- read.delim("index.stream",row.names=1)))
		#index[index$sdfid %in% c("3540","5329468","32014"),]
		print(system.time(queryIds <- index[ !is.na(index$MW) & index$MW < 400,]))
		#print(system.time(read.SDFindex(file=filename,index=queryIds,type="file",outfile="stream_result.sdf")))
		#print(system.time(sdfset<<-read.SDFindex(file=filename,index=queryIds)))
		#print(length(sdfset))

		#sink()
		#print(t1) #loadSdf
		#print(t2) #
		#print(t3) #findCompounds
		#print(t4) #write compounds
	}
	dbTest <- function(){
		print(system.time(conn<-initDb("tempdb")))
		print(system.time(loadSdf(conn,filename,function(sdfset)cbind(MW=MW(sdfset)),
										  function(x) {
											  #print(paste("apset time",length(x)))
											  #print(system.time(aps<<-sdf2ap(x)))
											  #data.frame(descriptor_type="ap",
															 #descriptor = unlist(lapply(ap(aps), 
																					#function(x) paste(x,collapse=", "))))
											  data.frame(descriptor_type=c(),descriptor=c())
										  }
										)))
		print(system.time(indexes <<- findCompounds(conn,"MW","mw < 400")))
		print(system.time(getCompounds(conn, indexes,file="dbtest_result.sdf")))
		print(system.time(sdfset<<-getCompounds(conn, indexes)))
		print(length(sdfset))
		dbDisconnect(conn)
	}

	unlink("tempdb")

	print("stream:")
	#Rprof()
	print(system.time(streamTest()))
	#Rprof(NULL)
	#summaryRprof("Rprof.out")
	
	print("db:")
#	Rprof()
	print(system.time(dbTest()))
}

test_fa.parBatchByIndex <- function(){
	message("starting parBatchByIndex")
	require(snow)
	cl = makeSOCKcluster(3)
	conn = initDb("test2.db")
	ids = dbGetQuery(conn,"SELECT compound_id FROM compounds WHERE format!='junk'")$compound_id
	print(str(ids))
	outfile="parBatch.out"

	unlink(outfile)
	unlink("parBench-*")
	parBatchByIndex(ids,batchSize = 10,cl=cl,
			   indexProcessor = function(indexSet,jobId){
					filename = paste("parBench-sub",jobId,sep="-")
					cat(indexSet,"\n", sep=" ",file=filename)
					filename
				},
				reduce =function(results) {

					print(paste("results: ",paste(results,collapse=",")))
					for(filename in results)
						cat(scan(filename,quiet=TRUE),sep="\n",file=outfile,append=TRUE)
				})
	resultIds = scan(outfile,quiet=TRUE)
	checkEquals(ids,resultIds)
}

test_ga.addDups <- function() {

	data(sdfsample)
	conn = initDb("test1.db")
	print("loading duplications")

	descFn = function(sdfset) data.frame(descriptor = paste("descriptor for ",sdfid(sdfset)),
													 descriptor_type = "testing")


	#add 3 dups by checksum
	count1= getCompoundCount(conn)
	loadSdf(conn,sdfsample[c(1,2,3)],descriptors=descFn)
	count2= getCompoundCount(conn)
	checkEquals(count1,count2)

	compIds = findCompoundsByName(conn,sdfid(sdfsample[1:3]),keepOrder=TRUE,allowMissing=TRUE)
	checkEquals(length(compIds),3)


	# add two dups and one update by checksum
	atomblock(sdfsample)[[1]][,]=8
	loadSdf(conn,sdfsample[c(1,2,3)],descriptors=descFn)
	count2= getCompoundCount(conn)
	checkEquals(count1+1,count2)
	compIds = findCompoundsByName(conn,sdfid(sdfsample[1]),allowMissing=TRUE)
	checkEquals(length(compIds),2)

	# add one dup and update by name
	atomblock(sdfsample)[[2]][,]=8
	loadSdf(conn,sdfsample[c(2,3)],descriptors=descFn, updateByName=TRUE)
	count2= getCompoundCount(conn)
	checkEquals(count1+1,count2)
}
getCompoundCount  <- function(conn){

	dbGetQuery(conn,"SELECT count(*) FROM compounds WHERE format!='junk'")[1][[1]]
}

test_ea.dupDescriptors <- function() {

	DEACTIVATED("local test only")
	#   descriptor_id          compound_id
	# 13881056,13881075      13884414,13884433
	# 41764092,41764082      41780498,41780494
   print("loading  duplicated descriptors")
	conn = initDb("dup_test.db")
	sdfs = read.SDFset(file.path(testDir,"descriptor_dups.sdf"))
	loadSdf(conn,sdfs,function(sdfset) data.frame(MW=MW(sdfset)),
			  descriptors=function(sdfset) 
				data.frame(descriptor_type="ap",descriptor=unlist(lapply(ap(sdf2ap(sdfset)),
														function(ap) paste(ap,collapse=", ")))))
	print("done loading")
	descriptorCount= dbGetQuery(conn,"SELECT count(*) FROM descriptors")[1][[1]]
	checkEquals(descriptorCount,1)
	typeCount= dbGetQuery(conn,"SELECT count(*) FROM descriptor_types WHERE descriptor_type = 'ap' ")[1][[1]]
	checkEquals(typeCount,1)
	linkCount= dbGetQuery(conn,"SELECT count(*) FROM compound_descriptors")[1][[1]]
	checkEquals(linkCount,7)
   dbDisconnect(conn)
	
}
test_fa.getALlCompoundIds  <- function() {

	conn = initDb("test2.db")
	ids = getAllCompoundIds(conn)
	message("found ",length(ids)," ids")
	print(ids)
	checkEqualsNumeric(length(ids),100)
}
test_ga.getCompoundFeatures <- function(){
	conn = initDb("test2.db")
	ids = getAllCompoundIds(conn)
	message("fetching features: ")
	features = getCompoundFeatures(conn,ids,c("mw","rings"))
	checkEquals(nrow(features),100)
	checkEquals(ncol(features),3)

	features = getCompoundFeatures(conn,rev(ids),c("mw","rings"),keepOrder=TRUE)
	checkEqualsNumeric(rev(ids),features$compound_id)

	#should not find 444, which should raise an error
	checkException(getCompoundFeatures(conn,c(ids,444),c("mw","rings")))

	checkException(getCompoundFeatures(conn,ids[1:10],c("mw","non_existant_feature")))

	#should not raise an error
	getCompoundFeatures(conn,c(ids,444),c("mw","rings"),allowMissing=TRUE)

}

debug=0

test_dj.jarvisPatrick <- function() {

	numNbrs=10 #5
	minNbrs=2 # 3
	data(sdfsample)
	aps=sdf2ap(sdfsample)
	fp=desc2fp(aps)

#	clustering = jarvisPatrick(aps,j=numNbrs,k=minNbrs,cutoff=0.5,mode="a1a2b",linkage="average")
#	print(clustering)
#	print(table(clustering))
#	sizes=table(clustering)
#	print(sizes[sizes!=1])
#	return()



	for(data in list(aps,fp))
		for(cutoff in list(NULL,0.5))
		{
			nnm = nearestNeighbors(data,numNbrs=numNbrs,cutoff=cutoff)
			for(mode in c("a1a2b","a1b","b"))
				for(linkage in c("single","average","complete")){
					if(debug) print(paste("cutoff:",cutoff,"mode:",mode,"linkage:",linkage))
					clustering = jarvisPatrick(nnm,k=minNbrs,mode=mode,linkage=linkage)
					if(debug) print(byCluster(clustering))
				}
		}
			
	#clustering = jarvisPatrick(fp,j=numNbrs,k=minNbrs)
	#print(clustering)
}

---
title: "_ChemmineR_: Cheminformatics Toolkit for R"
author: "Authors: Kevin Horan, Yiqun Cao, Tyler Backman, [Thomas Girke](mailto:thomas.girke@ucr.edu)"
date: "Last update: `r format(Sys.time(), '%d %B, %Y')`" 
package: "`r library(BiocStyle); pkg_ver('ChemmineR')`"
output:
  html_document:
    toc: true
    toc_float: true
    toc_depth: 3
    fig_caption: yes

fontsize: 14pt
bibliography: references.bib
---
<!--
%% \VignetteEngine{knitr::rmarkdown}
%% \VignetteEncoding{UTF-8}
%\VignetteIndexEntry{ChemmineR}
%% \VignetteDepends{fmcsR, ChemmineDrugs}
%% \VignetteKeywords{cheminformatics, structural searching, clustering}
%% \VignettePackage{ChemmineR}
-->

<!---
- Compile from command-line
echo "rmarkdown::render('ChemmineR.Rmd')" | R -slave; R CMD Stangle ChemmineR.Rmd

- Commit to github
git commit -am "some edits"; git push -u origin master

- To customize font size and other style features, add this line to output section in preamble:  
    css: style.css
-->

```{r style, echo = FALSE, results = 'asis'}
BiocStyle::markdown()
options(width=100, max.print=1000)
knitr::opts_chunk$set(
    eval=as.logical(Sys.getenv("KNITR_EVAL", "TRUE")),
    cache=as.logical(Sys.getenv("KNITR_CACHE", "TRUE")))
```

```{r setup, echo=FALSE, messages=FALSE, warnings=FALSE}
suppressPackageStartupMessages({
    library(ChemmineR)
    library(fmcsR)
    library(ggplot2)
	 #library(ChemmineOB)
	
})
```

Note: the most recent version of this tutorial can be found <a href="https://htmlpreview.github.io/?https://github.com/girke-lab/ChemmineR/blob/master/vignettes/ChemmineR.html">here</a> and a short overview slide show [here](http://faculty.ucr.edu/~tgirke/HTML_Presentations/Manuals/Workshop_Dec_5_8_2014/Rcheminfo/Cheminfo.pdf).


Introduction
============

`ChemmineR` is a cheminformatics package for analyzing
drug-like small molecule data in R. Its latest version contains
functions for efficient processing of large numbers of small molecules,
physicochemical/structural property predictions, structural similarity
searching, classification and clustering of compound libraries with a
wide spectrum of algorithms.

![Figure: `ChemmineR` environment with its add-on packages and
selected functionalities](overview.png )

In addition, `ChemmineR` offers visualization functions
for compound clustering results and chemical structures. The integration
of chemoinformatic tools with the R programming environment has many
advantages, such as easy access to a wide spectrum of statistical
methods, machine learning algorithms and graphic utilities. The first
version of this package was published in Cao et al. [-@Cao_2008]. Since then many additional
utilities and add-on packages have been added to the environment (Figure 2) and
many more are under development for future releases [@Backman_2011; @Wang_2013].

</br>

__Recently Added Features__

-   Improved SMILES support via new `SMIset` object class
    and SMILES import/export functions

-   Integration of a subset of OpenBabel functionalities via new
    `ChemmineOB` add-on package [@Cao_2008]

-   Streaming functionality for processing millions of molecules on a
    laptop

-   Mismatch tolerant maximum common substructure (MCS) search algorithm

-   Fast and memory efficient fingerprint search support using atom pair
    or PubChem fingerprints

<div align="right">[Back to Table of Contents]()</div>

Getting Started
===============

Installation
------------

The R software for running ChemmineR can be downloaded from CRAN
(<http://cran.at.r-project.org/>). The ChemmineR package can be
installed from R with:

```{r eval=FALSE}
 if (!requireNamespace("BiocManager", quietly=TRUE))
     install.packages("BiocManager")
 BiocManager::install("ChemmineR")
```

<div align="right">[Back to Table of Contents]()</div>

Loading the Package and Documentation
-------------------------------------


```{r eval=TRUE, tidy=FALSE}
 library("ChemmineR") # Loads the package
```

```{r eval=FALSE, tidy=FALSE}
 library(help="ChemmineR") # Lists all functions and classes 
 vignette("ChemmineR") # Opens this PDF manual from R 
```

<div align="right">[Back to Table of Contents]()</div>

Five Minute Tutorial
--------------------

The following code gives an overview of the most important
functionalities provided by `ChemmineR`. Copy and paste
of the commands into the R console will demonstrate their utilities.  

Create Instances of `SDFset` class: 
```{r eval=TRUE, tidy=FALSE}
 data(sdfsample) 
 sdfset <- sdfsample
 sdfset # Returns summary of SDFset 
 sdfset[1:4] # Subsetting of object

 sdfset[[1]] # Returns summarized content of one SDF

 
```{r eval=FALSE, tidy=FALSE}
 view(sdfset[1:4]) # Returns summarized content of many SDFs, not printed here 
 as(sdfset[1:4], "list") # Returns complete content of many SDFs, not printed here 
 
```


An `SDFset` is created during the import of an SD file:

```{r eval=FALSE, tidy=FALSE}
 sdfset <- read.SDFset("http://faculty.ucr.edu/~tgirke/Documents/R_BioCond/Samples/sdfsample.sdf") 
```


Miscellaneous accessor methods for `SDFset` container:

```{r eval=FALSE, tidy=FALSE}
 header(sdfset[1:4]) # Not printed here
```
 
```{r eval=TRUE, tidy=FALSE}
 header(sdfset[[1]])
```

```{r eval=FALSE, tidy=FALSE}
 atomblock(sdfset[1:4]) # Not printed here 
```
 
```{r eval=TRUE, tidy=FALSE}
atomblock(sdfset[[1]])[1:4,] 
```

```{r eval=FALSE, tidy=FALSE}
bondblock(sdfset[1:4]) # Not printed here 
```
 
```{r eval=TRUE, tidy=FALSE}
 bondblock(sdfset[[1]])[1:4,] 
```
```{r eval=FALSE, tidy=FALSE}
 datablock(sdfset[1:4]) # Not printed here 
```

```{r eval=TRUE, tidy=FALSE}
 datablock(sdfset[[1]])[1:4] 
```


Assigning compound IDs and keeping them unique: 
```{r eval=TRUE, tidy=FALSE}
 cid(sdfset)[1:4] # Returns IDs from SDFset object
 sdfid(sdfset)[1:4] # Returns IDs from SD file header block
 unique_ids <- makeUnique(sdfid(sdfset))
 cid(sdfset) <- unique_ids 
```


Converting the data blocks in an `SDFset` to a matrix:

```{r eval=TRUE, tidy=FALSE}
 blockmatrix <- datablock2ma(datablocklist=datablock(sdfset)) # Converts data block to matrix 
 numchar <- splitNumChar(blockmatrix=blockmatrix) # Splits to numeric and character matrix 
 numchar[[1]][1:2,1:2] # Slice of numeric matrix 
 numchar[[2]][1:2,10:11] # Slice of character matrix 
```


Compute atom frequency matrix, molecular weight and formula:

```{r eval=TRUE, tidy=FALSE}
 propma <- data.frame(MF=MF(sdfset), MW=MW(sdfset), atomcountMA(sdfset))
 propma[1:4, ] 
```


Assign matrix data to data block: 
```{r eval=TRUE, tidy=FALSE}
 datablock(sdfset) <- propma 
 datablock(sdfset[1]) 
```


String searching in `SDFset`: 
```{r eval=FALSE, tidy=FALSE}
 grepSDFset("650001", sdfset, field="datablock", mode="subset") # Returns summary view of matches. Not printed here.
```

```{r eval=TRUE, tidy=FALSE}
 grepSDFset("650001", sdfset, field="datablock", mode="index") 
```


Export SDFset to SD file: 
```{r eval=FALSE, tidy=FALSE}
 write.SDF(sdfset[1:4], file="sub.sdf", sig=TRUE) 
```


Plot molecule structure of one or many SDFs: 
```{r plotstruct, eval=TRUE, tidy=FALSE}
 plot(sdfset[1:4], print=FALSE) # Plots structures to R graphics device 
```



```{r eval=FALSE, tidy=FALSE}
 sdf.visualize(sdfset[1:4]) # Compound viewing in web browser 
```

![Figure: Visualization webpage created by calling
`sdf.visualize`.](visualizescreenshot-small.png )

Structure similarity searching and clustering: 
```{r eval=FALSE, tidy=FALSE}
 apset <- sdf2ap(sdfset) # Generate atom pair descriptor database for searching 
```

```{r eval=TRUE, tidy=FALSE}
 data(apset) # Load sample apset data provided by library. 
 cmp.search(apset, apset[1], type=3, cutoff = 0.3, quiet=TRUE) # Search apset database with single compound. 

 cmp.cluster(db=apset, cutoff = c(0.65, 0.5), quiet=TRUE)[1:4,] # Binning clustering using variable similarity cutoffs. 
```

<div align="right">[Back to Table of Contents]()</div>

OpenBabel Functions
===================

`ChemmineR` integrates now a subset of cheminformatics
functionalities implemented in the OpenBabel C++ library [@greycite13432; @Cao_2008]. These
utilities can be accessed by installing the `ChemmineOB`
package and the OpenBabel software itself. `ChemmineR`
will automatically detect the availability of
`ChemmineOB` and make use of the additional utilities.
The following lists the functions and methods that make use of
OpenBabel. References are included to locate the sections in the manual
where the utility and usage of these functions is described.  

*Structure format interconversions* (see Section [Format Inter-Conversions](#format-interconversions))

-   `smiles2sdf`: converts from SMILES to SDF object

-   `sdf2smiles`: converts from SDF to SMILES object

-   `convertFormat`: converts strings between two formats

-   `convertFormatFile`: converts files between two formats. This function can be used to enable ChemmineR to read in any
format supported by Open Babel. For example, if you had an SML file you could do:
```{r eval=FALSE, tidy=FALSE}
convertFormatFile("SML","SDF","mycompound.sml","mycompound.sdf")
sdfset=read.SDFset("mycompound.sdf")
```


`propOB`: generates several compound properties. See the man page for a current list of properties computed.
```{r eval=FALSE, tidy=FALSE}
propOB(sdfset[1])
```

`fingerprintOB`: generates fingerprints for compounds. The fingerprint name can be anything supported by OpenBabel. See the man page
for a current list.
```{r eval=FALSE, tidy=FALSE}
fingerprintOB(sdfset,"FP2")
```

`smartsSearchOB`: find matches of SMARTS patterns in compounds
```{r eval=FALSE, tidy=FALSE}
#count rotable bonds
smartsSearchOB(sdfset[1:5],"[!$(*#*)&!D1]-!@[!$(*#*)&!D1]",uniqueMatches=FALSE)
```

`exactMassOB`: Compute the monoisotopic (exact) mass of a set of compounds
```{r eval=FALSE, tidy=FALSE}
exactMassOB(sdfset[1:5])
```

`regenerateCoords`: Re-compute the 2D coordinates of a compound using Open Babel. This can sometimes
improve the quality of the compounds plot. See also the `regenCoords` option of the plot function.
```{r eval=FALSE, tidy=FALSE,fig.height=5,fig.width=5}
sdfset2 = regenerateCoords(sdfset[1:5])

plot(sdfset[1], regenCoords=TRUE,print=FALSE)
```

OpenBabel can also be used to plot compounds directly:
```{r eval=FALSE, tidy=FALSE, dev='svg',fig.height=5,fig.width=5}
openBabelPlot(sdfset[4],regenCoords=TRUE)
```



`generate3DCoords`: Generate 3D coordinates for compounds with only 2D coordinates.
```{r eval=FALSE, tidy=FALSE}
sdf3D = generate3DCoords(sdfset[1])
```

`canonicalize`: Compute a canonicalized atom numbering. This allows compounds with the same molecular
structure but different atom numberings to be compared properly.
```{r eval=FALSE, tidy=FALSE}
canonicalSdf= canonicalize(sdfset[1])
```

`canonicalNumbering`: Return a mapping from the original atom numbering to the 
canonical atom number.
```{r eval=FALSE, tidy=FALSE}
mapping = canonicalNumbering(sdfset[1])
```

<div align="right">[Back to Table of Contents]()</div>


Overview of Classes and Functions
=================================

The following list gives an overview of the most important S4 classes,
methods and functions available in the ChemmineR package. The help
documents of the package provide much more detailed information on each
utility. The standard R help documents for these utilities can be
accessed with this syntax: `?function\_name` (*e.g.*
`?cid`) and `?class\_name-class` (*e.g*.
`?"SDFset-class"`).

<div align="right">[Back to Table of Contents]()</div>

Molecular Structure Data
------------------------

Classes

-   `SDFstr`: intermediate string class to facilitate SD
    file import; not important for end user

-   `SDF`: container for single molecule imported from an
    SD file

-   `SDFset`: container for many SDF objects; most
    important structure container for end user

-   `SMI`: container for a single SMILES string

-   `SMIset`: container for many SMILES strings

Functions/Methods (mainly for `SDFset` container,
`SMIset` should be coerced with
`smiles2sd` to `SDFset`)

-   Accessor methods for `SDF/SDFset`

    -   Object slots: `cid`, `header`, `atomblock`, `bondblock`,
        `datablock` (`sdfid`, `datablocktag`)

    -   Summary of `SDFset`: `view`

    -   Matrix conversion of data block: `datablock2ma`,
        `splitNumChar`

    -   String search in SDFset: `grepSDFset`

-   Coerce one class to another

    -   Standard syntax `as(..., "...")` works in most
        cases. For details see R help with
       `?"SDFset-class"`.

-   Utilities

    -   Atom frequencies: `atomcountMA`, `atomcount`

    -   Molecular weight: `MW`

    -   Molecular formula: `MF`

    -   ...

-   Compound structure depictions

    -   R graphics device: `plot`, `plotStruc`

    -   Online: `cmp.visualize`

<div align="right">[Back to Table of Contents]()</div>

Structure Descriptor Data
-------------------------

Classes

-   `AP`: container for atom pair descriptors of a single
    molecule

-   `APset`: container for many AP objects; most
    important structure descriptor container for end user

-   `FP`: container for fingerprint of a single molecule

-   `FPset`: container for fingerprints of many
    molecules, most important structure descriptor container for end
    user

Functions/Methods

-   Create `AP/APset` instances

    -   From `SDFset`: `sdf2ap`

    -   From SD file: `cmp.parse`

    -   Summary of `AP/APset`: `view`,
        `db.explain`

-   Accessor methods for AP/APset

    -   Object slots: `ap`, `cid`

-   Coerce one class to another

    -   Standard syntax `as(..., "...")` works in most
        cases. For details see R help with
        `?"APset-class"`.

-   Structure Similarity comparisons and Searching

    -   Compute pairwise similarities : `cmp.similarity`,
        `fpSim`

    -   Search APset database: `cmp.search`, `fpSim`

-   AP-based Structure Similarity Clustering

    -   Single-linkage binning clustering: `cmp.cluster`

    -   Visualize clustering result with MDS:
        `cluster.visualize`

    -   Size distribution of clusters: `cluster.sizestat`
-   Folding
    - Fold a descriptor with `fold`
	 - Query the number of times a descriptor has been folded:
		`foldCount`
	 - Query the number of bits in a descriptor: `numBits`
	 
<div align="right">[Back to Table of Contents]()</div>

Import of Compounds
===================

SDF Import
----------

The following gives an overview of the most important import/export
functionalities for small molecules provided by
`ChemmineR`. The given example creates an instance of the
`SDFset` class using as sample data set the first 100
compounds from this PubChem SD file (SDF):
Compound\_00650001\_00675000.sdf.gz
(<ftp://ftp.ncbi.nih.gov/pubchem/Compound/CURRENT-Full/SDF/>).  

SDFs can be imported with the `read.SDFset` function:

```{r eval=FALSE, tidy=FALSE}
 sdfset <- read.SDFset("http://faculty.ucr.edu/~tgirke/Documents/R_BioCond/Samples/sdfsample.sdf") 
```

```{r eval=TRUE, tidy=FALSE}
 data(sdfsample) # Loads the same SDFset provided by the library 
 sdfset <- sdfsample
 valid <- validSDF(sdfset) # Identifies invalid SDFs in SDFset objects 
 sdfset <- sdfset[valid] # Removes invalid SDFs, if there are any 
```


Import SD file into `SDFstr` container: 
```{r eval=FALSE, tidy=FALSE}
 sdfstr <- read.SDFstr("http://faculty.ucr.edu/~tgirke/Documents/R_BioCond/Samples/sdfsample.sdf") 
```
Create
`SDFset` from `SDFstr` class:

```{r eval=TRUE, tidy=FALSE}
 sdfstr <- as(sdfset, "SDFstr") 
 sdfstr
 as(sdfstr, "SDFset") 
```

SDFs in V3000 format can also be imported, this format will be detected automacially. If you want
to also be able to access the extended attributes of this format, you should set `extendedAttributes=TRUE`
on `read.SDFset`. 
```{r eval=TRUE, tidy=FALSE}
 v3 <- read.SDFset("https://cluster.hpcc.ucr.edu/~tgirke/Documents/R_BioCond/Samples/v3000.sdf",extendedAttributes=TRUE) 
```
This will have the side effect of producing an `SDFset` composed of `ExtSDF` objects, which
are sub-classes of `SDF` objects. Not all SDF methods will work on this sub-type currently. 
```{r eval=TRUE, tidy=FALSE}
getAtomAttr(v3[[1]],17,"CHG")
getBondAttr(v3[[1]],10,"CFG")
```
This example will fetch the value of the atom attribute "CHG" on atom 16, and the value of the bond attribute "CFG" on bond 10. 

<div align="right">[Back to Table of Contents]()</div>

SMILES Import
-------------

The `read.SMIset` function imports one or many molecules
from a SMILES file and stores them in a `SMIset`
container. The input file is expected to contain one SMILES string per
row with tab-separated compound identifiers at the end of each line. The
compound identifiers are optional.  

Create sample SMILES file and then import it: 
```{r eval=FALSE, tidy=FALSE}
 data(smisample); smiset <- smisample
 write.SMI(smiset[1:4], file="sub.smi") 
 smiset <- read.SMIset("sub.smi")
```


Inspect content of `SMIset`: 
```{r eval=TRUE, tidy=FALSE}
 data(smisample) # Loads the same SMIset provided by the library 
 smiset <- smisample
 smiset 
 view(smiset[1:2]) 
```


Accessor functions: 
```{r eval=TRUE, tidy=FALSE}
 cid(smiset[1:4]) 
 smi <- as.character(smiset[1:2])
```


Create `SMIset` from named character vector:

```{r eval=TRUE, tidy=FALSE}
 as(smi, "SMIset") 
```

<div align="right">[Back to Table of Contents]()</div>

Export of Compounds
===================

SDF Export
----------

Write objects of classes `SDFset/SDFstr/SDF` to SD file:

```{r eval=FALSE, tidy=FALSE}
 write.SDF(sdfset[1:4], file="sub.sdf") 
```


Writing customized `SDFset` to file containing
`ChemmineR` signature, IDs from `SDFset`
and no data block: 
```{r eval=FALSE, tidy=FALSE}
 write.SDF(sdfset[1:4], file="sub.sdf", sig=TRUE, cid=TRUE, db=NULL) 
```


Example for injecting a custom matrix/data frame into the data block of
an `SDFset` and then writing it to an SD file:

```{r eval=FALSE, tidy=FALSE}
 props <- data.frame(MF=MF(sdfset), MW=MW(sdfset), atomcountMA(sdfset)) 
 datablock(sdfset) <- props
 write.SDF(sdfset[1:4], file="sub.sdf", sig=TRUE, cid=TRUE) 
```


Indirect export via `SDFstr` object: 
```{r eval=FALSE, tidy=FALSE}
 sdf2str(sdf=sdfset[[1]], sig=TRUE, cid=TRUE) # Uses default components 
 sdf2str(sdf=sdfset[[1]], head=letters[1:4], db=NULL) # Uses custom components for header and data block 
```


Write `SDF`, `SDFset` or
`SDFstr` classes to file: 
```{r eval=FALSE, tidy=FALSE}
 write.SDF(sdfset[1:4], file="sub.sdf", sig=TRUE, cid=TRUE, db=NULL)
 write.SDF(sdfstr[1:4], file="sub.sdf") 
 cat(unlist(as(sdfstr[1:4], "list")), file="sub.sdf", sep="") 
```

<div align="right">[Back to Table of Contents]()</div>

SMILES Export
-------------

Write objects of class `SMIset` to SMILES file with and
without compound identifiers: 
```{r eval=FALSE, tidy=FALSE}
 data(smisample); smiset <- smisample # Sample data set 

 write.SMI(smiset[1:4], file="sub.smi", cid=TRUE) write.SMI(smiset[1:4], file="sub.smi", cid=FALSE) 
```

<div align="right">[Back to Table of Contents]()</div>

Format Interconversions
=======================

The `sdf2smiles` and `smiles2sdf`
functions provide format interconversion between SMILES strings
(Simplified Molecular Input Line Entry Specification) and
`SDFset` containers.  

Convert an `SDFset` container to a SMILES
`character` string:


```{r sdf2smiles, eval=FALSE, tidy=FALSE}
 data(sdfsample);
 sdfset <- sdfsample[1] 
 smiles <- sdf2smiles(sdfset) 
 smiles 
```


Convert a SMILES `character` string to an
`SDFset` container:


```{r smiles2sdf, eval=FALSE, tidy=FALSE}
 sdf <- smiles2sdf("CC(=O)OC1=CC=CC=C1C(=O)O")
 view(sdf) 
```


When the `ChemineOB` package is installed these
conversions are performed with the OpenBabel Open Source Chemistry
Toolbox. Otherwise the functions will fall back to using the ChemMine
Tools web service for this operation. The latter will require internet
connectivity and is limited to only the first compound given.
`ChemmineOB` provides access to the compound format
conversion functions of OpenBabel. Currently, over 160 formats are
supported by OpenBabel. The functions `convertFormat` and
`convertFormatFile` can be used to convert files or
strings between any two formats supported by OpenBabel. For example, to
convert a SMILES string to an SDF string, one can use the
`convertFormat` function.


```{r eval=FALSE, tidy=FALSE}
 sdfStr <- convertFormat("SMI","SDF","CC(=O)OC1=CC=CC=C1C(=O)O_name") 
```


This will return the given compound as an SDF formatted string. 2D
coordinates are also computed and included in the resulting SDF string.

To convert a file with compounds encoded in one format to another
format, the `convertFormatFile` function can be used
instead. 
```{r eval=FALSE, tidy=FALSE}
 convertFormatFile("SMI","SDF","test.smiles","test.sdf") 
```


To see the whole list of file formats supported by OpenBabel, one can
run from the command-line "obabel -L formats".

<div align="right">[Back to Table of Contents]()</div>

Splitting SD Files
==================

The following `write.SDFsplit` function allows to split
SD Files into any number of smaller SD Files. This can become important
when working with very big SD Files. Users should note that this
function can output many files, thus one should run it in a dedicated
directory!  

Create sample SD File with 100 molecules: 
```{r eval=FALSE, tidy=FALSE}
 write.SDF(sdfset, "test.sdf") 
```


Read in sample SD File. Note: reading file into SDFstr is much faster
than into SDFset: 
```{r eval=FALSE, tidy=FALSE}
 sdfstr <- read.SDFstr("test.sdf") 
```


Run export on `SDFstr` object: 
```{r eval=FALSE, tidy=FALSE}
 write.SDFsplit(x=sdfstr, filetag="myfile", nmol=10) # 'nmol' defines the number of molecules to write to each file 
```


Run export on `SDFset` object: 
```{r eval=FALSE, tidy=FALSE}
 write.SDFsplit(x=sdfset, filetag="myfile", nmol=10) 
```

<div align="right">[Back to Table of Contents]()</div>

Streaming Through Large SD Files
================================

The `sdfStream` function allows to stream through SD
Files with millions of molecules without consuming much memory. During
this process any set of descriptors, supported by
`ChemmineR`, can be computed (*e.g.* atom pairs,
molecular properties, etc.), as long as they can be returned in tabular
format. In addition to descriptor values, the function returns a line
index that gives the start and end positions of each molecule in the
source SD File. This line index can be used by the downstream
`read.SDFindex` function to retrieve specific molecules
of interest from the source SD File without reading the entire file into
R. The following outlines the typical workflow of this streaming
functionality in `ChemmineR`.  

Create sample SD File with 100 molecules: 
```{r eval=FALSE, tidy=FALSE}
 write.SDF(sdfset, "test.sdf") 
```


Define descriptor set in a simple function: 
```{r eval=FALSE, tidy=FALSE}
 desc <- function(sdfset) 
 cbind(SDFID=sdfid(sdfset), 
	# datablock2ma(datablocklist=datablock(sdfset)), 
	 MW=MW(sdfset),
	groups(sdfset), APFP=desc2fp(x=sdf2ap(sdfset), descnames=1024,
	type="character"), AP=sdf2ap(sdfset, type="character"), rings(sdfset,
	type="count", upper=6, arom=TRUE) )  
```


Run `sdfStream` with `desc` function and
write results to a file called `matrix.xls`:

```{r eval=FALSE, tidy=FALSE}
 sdfStream(input="test.sdf", output="matrix.xls", fct=desc, Nlines=1000) # 'Nlines': number of lines to read from input SD File at a time 
```


One can also start reading from a specific line number in the SD file.
The following example starts at line number 950. This is useful for
restarting and debugging the process. With `append=TRUE`
the result can be appended to an existing file. 
```{r eval=FALSE, tidy=FALSE}
 sdfStream(input="test.sdf", output="matrix2.xls", append=FALSE, fct=desc, Nlines=1000, startline=950) 
```


Select molecules meeting certain property criteria from SD File using
line index generated by previous `sdfStream` step:

```{r eval=FALSE, tidy=FALSE}
 indexDF <- read.delim("matrix.xls", row.names=1)[,1:4] 
 indexDFsub <- indexDF[indexDF$MW < 400, ] # Selects molecules with MW < 400 
 sdfset <- read.SDFindex(file="test.sdf", index=indexDFsub, type="SDFset") # Collects results in 'SDFset' container 
```


Write results directly to SD file without storing larger numbers of
molecules in memory: 
```{r eval=FALSE, tidy=FALSE}
 read.SDFindex(file="test.sdf", index=indexDFsub, type="file",
 outfile="sub.sdf") 
```


Read AP/APFP strings from file into `APset` or
`FP` object: 
```{r eval=FALSE, tidy=FALSE}
 apset <- read.AP(x="matrix.xls", type="ap", colid="AP") 
 apfp <- read.AP(x="matrix.xls", type="fp", colid="APFP") 
```


Alternatively, one can provide the AP/APFP strings in a named character
vector: 
```{r eval=FALSE, tidy=FALSE}
 apset <- read.AP(x=sdf2ap(sdfset[1:20], type="character"), type="ap") 
 fpchar <- desc2fp(sdf2ap(sdfset[1:20]), descnames=1024, type="character")
 fpset <- as(fpchar, "FPset") 
```

<div align="right">[Back to Table of Contents]()</div>

Storing Compounds in an SQL Database
====================================

As an alternative to sdfStream, there is now also an option to store
data in an SQL database, which then allows for fast queries and compound
retrieval. The default database
is SQLite, but any other SQL database should work with some minor
modifications to the table definitions, which are stored in
schema/compounds.SQLite under the ChemmineR package directory. Compounds
are stored in their entirety in the databases so there is no need to
keep any original data files.

Users can define their own set of compound features to compute and store
when loading new compounds. Each of these features will be stored in its
own, indexed table. Searches can then be performed using these features
to quickly find specific compounds. Compounds can always be retrieved
quickly because of the database index, no need to scan a large compound
file. In addition to user defined features, descriptors can also be
computed and stored for each compound.

A new database can be created with the `initDb` function.
This takes either an existing database connection, or a filename. If a
filename is given then an SQLite database connection is created. It then
ensures that the required tables exist and creates them if not. The
connection object is then returned. This function can be called safely
on the same connection or database many times and will not delete any
data.

<div align="right">[Back to Table of Contents]()</div>

Loading Data
------------

The functions `loadSdf` and `loadSmiles` can be used to load
compound data from either a file (both) or an `SDFset` (`loadSdf`
only).  The `fct` parameter should be a function to
extract features from the data. It will be handed an
`SDFset` generated from the data being loaded. This may
be done in batches, so there is no guarantee that the given SDFSset will
contain the whole dataset. This function should return a data frame with
a column for each feature and a row for each compound given. The order
of the final data frame should be the same as that of the
`SDFset`. The column names will become the feature names.
Each of these features will become a new, indexed, table in the database
which can be used later to search for compounds.

The `descriptors` parameter can be a function which
computes descriptors. This function will also be given an
`SDFset` object, which may be done in batches. It should
return a data frame with the following two columns: "descriptor" and
"descriptor\_type". The "descriptor" column should contain a string
representation of the descriptor, and "descriptor\_type" is the type of
the descriptor. Our convention for atom pair is "ap" and "fp" for finger
print. The order should also be maintained.

When the data has been loaded, `loadSdf` will return the
compound id numbers of each compound loaded. These compound id numbers
are computed by the database and are not extracted from the compound
data itself. They can be used to quickly retrieve compounds later.

New features can also be added using this function. However, all
compounds must have all features so if new features are added to a new
set of compounds, all existing features must be computable by the
`fct` function given. If new features are detected, all
existing compounds will be run through `fct` in order to
compute the new features for them as well.

For example, if dataset X is loaded with features F1 and F2, and then at
a later time we load dataset Y with new feature F3, the
`fct` function used to load dataset Y must compute and
return features F1, F2, and F3. `loadSdf` will call
`fct` with both datasets X and Y so that all features are
available for all compounds. If any features are missing an error will
be raised. If just new features are being added, but no new compounds,
use the `addNewFeatures` function.

In this example, we create a new database called "test.db" and load it
with data from an `SDFset`. We also define
`fct` to compute the molecular weight, "MW", and the
number of rings and aromatic rings. The rings function actually returns
a data frame with columns "RINGS" and "AROMATIC", which will be merged
into the data frame being created which will also contain the "MW"
column. These will be the names used for these features and must be used
when searching with them. Finally, the new compound ids are returned and
stored in the "ids" variable.


```{r eval=TRUE, tidy=FALSE}
 data(sdfsample)

 #create and initialize a new SQLite database 
 conn <- initDb("test.db")

 # load data and compute 3 features: molecular weight, with the MW function, 
 # and counts for RINGS and AROMATIC, as computed by rings, which 
 # returns a data frame itself. 
 ids<-loadSdf(conn,sdfsample, function(sdfset) 
					 data.frame(rings(sdfset,type="count",upper=6, arom=TRUE)) ) 

 #list features in the database:
 print(listFeatures(conn))
```

<div align="right">[Back to Table of Contents]()</div>

Updates
-------
By default the `loadSdf` / `loadSmiles` functions will detect duplicate
compound entries and only insert one of them. This means it is safe
to run these functions on the same data set several times and you
won't end up with duplicates. This allows the functions to be re-run
in the event that a previous run on a dataset does not complete.
Duplicate compounds are detected by compouting the MD5 checksum on
the textual representation of it. 

It can also update existing compounds with new versions of the same
compound. To enable this, set `updateByName` to true. It will then
consider two compounds with the same name to be the same, even if the
definition is different. Then, if the name of a compound exists in
the database and it is trying to insert another compound with the
same name, it will overwrite the existing compound. It will also drop
and re-compute all associated descriptors and features for the new
compound (assuming the required functions for descriptor and feature
computation are available at the time the update is performed).

<div align="right">[Back to Table of Contents]()</div>

Duplicate Descriptors
---------------------
It is often the case when loading a large set of compounds that
several compounds will produce the same descriptor. `ChemmineR` 
detects this case and only stores one copy of the descriptor for
every compound it is for. This feature saves some space and some
time for processes that need to be applied to every descriptor.
It also highlights a new problem. If you have a descriptor in hand
and you want to find a single compound to represent it, which
compound should be used if the descriptor was produced from multiple
compounds? To address this problem, `ChemmineR` allows you to set
priority values for each compound-descriptor mapping. Then, in
contexts where a single compound is required, the highest priority
compound will be chosen. Highest priority corresponds to the lowest
numerical value. So mapping with priority 0 would be used first.

To set these priorities there is the function `setPriorities`.
It takes a function, `priorityFn`, for computing these priority values.
The `setPriorities` function should be run after loading a complete set of data.
It will find each group of compounds which share the same
descriptor and call the given function, `priorityFn`, 
with the compound_id numbers of the group. This function should
then assign priorities to each compound-descriptor pair, however
it wishes. 

One built in priority function is `forestSizePriorities`. This simply
prefers compounds with fewer disconnected components over compounds with
more dissconnected components.

```{r eval=FALSE, tidy=FALSE}
setPriorities(conn,forestSizePriorities)
```

<div align="right">[Back to Table of Contents]()</div>


Searching
---------

Compounds can be searched for using the `findCompounds`
function. This function takes a connection object, a vector of feature
names used in the tests, and finally, a vector of tests that must all
pass for a compound to be included in the result set. Each test should
be a boolean expression. For example: `c("MW <= 400","RINGS \> 3")`
would return all compounds with a molecular weight of 400 or less and
more than 3 rings, assuming these features exist in the database. The
syntax for each test is `'\<feature name\> \<SQL operator\> \<value\>'`.
If you know SQL you can go beyond this basic syntax. These tests will
simply be concatenated together with "AND" in-between them and tacked on
the end of a WHERE clause of an SQL statement. So any SQL that will work
in that context is fine. The function will return a list of compound
ids, the actual compounds can be fetched with
`getCompounds`. If just the names are needed, the
`getCompoundNames` function can be used. Compounds can
also be fetched by name using the `findCompoundsByName`
function.

In this example we search for compounds with 0 or 1 rings:


```{r }
results = findCompounds(conn,"rings",c("rings <= 1"))
message("found ",length(results))
```

If more than one test is given, only compounds which satisfy all tests are found. So if we wanted
to further restrict our search to compounds with 2 or more aromatic rings we could do:
```{r }
results = findCompounds(conn,c("rings","aromatic"),c("rings<=2","aromatic >= 2"))
message("found ",length(results))
```

Remember that any feature used in some test must be listed in the second argument.

String patterns can also be used. So if we wanted to match a substring of the molecular formula, say
to find compounds with 21 carbon atoms, we could do:
```{r eval=FALSE}
results = findCompounds(conn,"formula",c("formula like '%C21%'"))
message("found ",length(results))
```

The "like" operator does a pattern match. There are two wildcard 
operators that can be used with this operator. The "%" will match any stretch of characters while the "?"
will match any single character. So the above expression would match a formula like "C21H28N4O6".

Valid comparison operators are: 

 - <,    <=,   > ,   >=
 - =,    ==,   !=,   <>,   IS,   IS NOT,   IN,   LIKE 

The boolean operators "AND" and "OR" can also be used to create more complex expressions within a single test.

If you just want to fetch every compound in the database you can use the `getAllCompoundIds` function:
```{r }
allIds = getAllCompoundIds(conn)
message("found ",length(allIds))
```

<div align="right">[Back to Table of Contents]()</div>

Using Search Results
-----------------------
Once you have a list of compound ids from the `findCompounds` function, you can either
fetch the compound names, or the whole set of compounds as an SDFset. 

```{r }

#get the names of the compounds:
names = getCompoundNames(conn,results)

#if the name order is important set keepOrder=TRUE 
#It will take a little longer though
names = getCompoundNames(conn,results,keepOrder=TRUE) 


# get the whole set of compounds
compounds = getCompounds(conn,results)
#in order:
compounds = getCompounds(conn,results,keepOrder=TRUE)
#write results directly to a file:
compounds = getCompounds(conn,results,filename=file.path(tempdir(),"results.sdf"))
```

Using the `getCompoundFeatures` function, you can get a set of feature values 
as a data frame:
```{r}
getCompoundFeatures(conn,results[1:5],c("rings","aromatic"))

#write results directly to a CSV file (reduces memory usage):
getCompoundFeatures(conn,results[1:5],c("rings","aromatic"),filename="features.csv")

#maintain input order in output:
print(results[1:5])
getCompoundFeatures(conn,results[1:5],c("rings","aromatic"),keepOrder=TRUE)
```

<div align="right">[Back to Table of Contents]()</div>

Pre-Built Databases
--------------------
We have pre-built SQLite databases for the Drug Bank and DUD datasets. They can be found in 
the ChemmineDrugs annotation package. Connections to these databases can be fetched from the
functions `DrugBank` and `DUD` to get the corresponding database. Any of the above functions can
then be used to query the database.

The DUD dataset was downloaded from [here](http://dude.docking.org/db/subsets/all/all.tar.gz). A description
can be found [here](http://dude.docking.org/). 

The Drug Bank data set is version 4.1. It can be downloaded [here](http://www.drugbank.ca/system/downloads/current/structures/all.sdf.zip)

The following features are included:

 - **aromatic**: Number of aromatic rings
 - **cansmi**: Canonical SMILES sting
 - **cansmins**:
 - **formula**: Molecular formula
 - **hba1**:
 - **hba2**:
 - **hbd**:
 - **inchi**: INCHI string
 - **logp**:
 - **mr**:
 - **mw**: Molecular weight
 - **ncharges**:
 - **nf**:
 - **r2nh**:
 - **r3n**:
 - **rcch**:
 - **rcho**:
 - **rcn**:
 - **rcooh**:
 - **rcoor**:
 - **rcor**:
 - **rings**:
 - **rnh2**:
 - **roh**:
 - **ropo3**:
 - **ror**:
 - **title**:
 - **tpsa**:

The DUD database additionally includes:

 - **target_name**: Name of the target
 - **type**: either "active" or "decoy"

<div align="right">[Back to Table of Contents]()</div>

Working with SDF/SDFset Classes
===============================

Several methods are available to return the different data components of
`SDF/SDFset` containers in batches. The following
examples list the most important ones. To save space their content is
not printed in the manual. 
```{r eval=FALSE, tidy=FALSE}

 view(sdfset[1:4]) # Summary view of several molecules 

 length(sdfset) # Returns number of molecules 
 sdfset[[1]] # Returns single molecule from SDFset as SDF object 

 sdfset[[1]][[2]] # Returns atom block from first compound as matrix

 sdfset[[1]][[2]][1:4,] 
 c(sdfset[1:4], sdfset[5:8]) # Concatenation of several SDFsets 
 
```


The `grepSDFset` function allows string
matching/searching on the different data components in
`SDFset`. By default the function returns a SDF summary
of the matching entries. Alternatively, an index of the matches can be
returned with the setting `mode="index"`. 
```{r eval=FALSE, tidy=FALSE}
 grepSDFset("650001", sdfset, field="datablock", mode="subset") # To return index, set mode="index") 
```


Utilities to maintain unique compound IDs: 
```{r eval=FALSE, tidy=FALSE}
 sdfid(sdfset[1:4]) # Retrieves CMP IDs from Molecule Name field in header block. 
 cid(sdfset[1:4]) # Retrieves CMP IDs from ID slot in SDFset. 
 unique_ids <- makeUnique(sdfid(sdfset)) # Creates unique IDs by appending a counter to duplicates. 
 cid(sdfset) <- unique_ids # Assigns uniquified IDs to ID slot 
```


Subsetting by character, index and logical vectors: 
```{r eval=FALSE, tidy=FALSE}
 view(sdfset[c("650001", "650012")])
 view(sdfset[4:1])
 mylog <- cid(sdfset)
 view(sdfset[mylog]) 
```


Accessing `SDF/SDFset` components: header, atom, bond and
data blocks: 
```{r eval=FALSE, tidy=FALSE}
 atomblock(sdf); sdf[[2]];
 sdf[["atomblock"]] # All three methods return the same component

 header(sdfset[1:4]) 
 atomblock(sdfset[1:4])
 bondblock(sdfset[1:4]) 
 datablock(sdfset[1:4])  
 header(sdfset[[1]])
 atomblock(sdfset[[1]]) 
 bondblock(sdfset[[1]]) 
 datablock(sdfset[[1]]) 
```


Replacement Methods: 
```{r eval=FALSE, tidy=FALSE}
 sdfset[[1]][[2]][1,1] <- 999 
 atomblock(sdfset)[1] <- atomblock(sdfset)[2] 
 datablock(sdfset)[1] <- datablock(sdfset)[2] 
```


Assign matrix data to data block: 
```{r eval=FALSE, tidy=FALSE}
 datablock(sdfset) <- as.matrix(iris[1:100,])
 view(sdfset[1:4]) 
```


Class coercions from `SDFstr` to `list`,
`SDF` and `SDFset`: 
```{r eval=FALSE, tidy=FALSE}
 as(sdfstr[1:2], "list") as(sdfstr[[1]], "SDF")
 as(sdfstr[1:2], "SDFset") 
```


Class coercions from `SDF` to `SDFstr`,
`SDFset`, list with SDF sub-components: 
```{r eval=FALSE, tidy=FALSE}
 sdfcomplist <- as(sdf, "list") sdfcomplist <-
 as(sdfset[1:4], "list"); as(sdfcomplist[[1]], "SDF") sdflist <-
 as(sdfset[1:4], "SDF"); as(sdflist, "SDFset") as(sdfset[[1]], "SDFstr")
 as(sdfset[[1]], "SDFset") 
```


Class coercions from `SDFset` to lists with components
consisting of SDF or sub-components: 
```{r eval=FALSE, tidy=FALSE}
 as(sdfset[1:4], "SDF") as(sdfset[1:4], "list") as(sdfset[1:4], "SDFstr")
```

<div align="right">[Back to Table of Contents]()</div>

Molecular Property Functions (Physicochemical Descriptors)
==========================================================

Several methods and functions are available to compute basic compound
descriptors, such as molecular formula (MF), molecular weight (MW), and
frequencies of atoms and functional groups. In many of these functions,
it is important to set `addH=TRUE` in order to
include/add hydrogens that are often not specified in an SD file.


```{r boxplot, eval=TRUE, tidy=FALSE}
 propma <- atomcountMA(sdfset, addH=FALSE) 
 boxplot(propma, col="blue", main="Atom Frequency") 
```



```{r eval=FALSE, tidy=FALSE}
 boxplot(rowSums(propma), main="All Atom Frequency") 
```


Data frame provided by library containing atom names, atom symbols,
standard atomic weights, group and period numbers: 
```{r eval=TRUE, tidy=FALSE}
 data(atomprop)
 atomprop[1:4,] 
```


Compute MW and formula: 
```{r eval=TRUE, tidy=FALSE}
 MW(sdfset[1:4], addH=FALSE)
 MF(sdfset[1:4], addH=FALSE) 
```


Enumerate functional groups: 
```{r eval=TRUE, tidy=FALSE}
 groups(sdfset[1:4], groups="fctgroup", type="countMA") 
```


Combine MW, MF, charges, atom counts, functional group counts and ring
counts in one data frame: 
```{r eval=TRUE, tidy=FALSE}
 propma <- data.frame(MF=MF(sdfset, addH=FALSE), MW=MW(sdfset, addH=FALSE),
							 Ncharges=sapply(bonds(sdfset, type="charge"), length),
							 atomcountMA(sdfset, addH=FALSE), 
							 groups(sdfset, type="countMA"), 
							 rings(sdfset, upper=6, type="count", arom=TRUE))
 propma[1:4,] 
```


The following shows an example for assigning the values stored in a
matrix (*e.g.* property descriptors) to the data block components in an
`SDFset`. Each matrix row will be assigned to the
corresponding slot position in the `SDFset`.

```{r eval=FALSE, tidy=FALSE}
 datablock(sdfset) <- propma # Works with all SDF components 
 datablock(sdfset)[1:4] 
 test <- apply(propma[1:4,], 1, function(x) 
 data.frame(col=colnames(propma), value=x)) 
```


The data blocks in SDFs contain often important annotation information
about compounds. The `datablock2ma` function returns this
information as matrix for all compounds stored in an
`SDFset` container. The `splitNumChar`
function can then be used to organize all numeric columns in a
`numeric matrix` and the character columns in a
`character matrix` as components of a
`list` object. 
```{r eval=FALSE, tidy=FALSE}
 datablocktag(sdfset, tag="PUBCHEM_NIST_INCHI")
 datablocktag(sdfset,
 tag="PUBCHEM_OPENEYE_CAN_SMILES") 
```


Convert entire data block to matrix: 
```{r eval=FALSE, tidy=FALSE}
 blockmatrix <- datablock2ma(datablocklist=datablock(sdfset)) # Converts data block to matrix 
 numchar <- splitNumChar(blockmatrix=blockmatrix) # Splits matrix to numeric matrix and character matrix 
 numchar[[1]][1:4,]; numchar[[2]][1:4,]
 # Splits matrix to numeric matrix and character matrix 
```

<div align="right">[Back to Table of Contents]()</div>

Bond Matrices
=============

Bond matrices provide an efficient data structure for many basic
computations on small molecules. The function `conMA`
creates this data structure from `SDF` and
`SDFset` objects. The resulting bond matrix contains the
atom labels in the row/column titles and the bond types in the data
part. The labels are defined as follows: 0 is no connection, 1 is a
single bond, 2 is a double bond and 3 is a triple bond. 
```{r contable, eval=FALSE, fig.keep='none', tidy=FALSE}
 conMA(sdfset[1:2],
 exclude=c("H")) # Create bond matrix for first two molecules in sdfset

 conMA(sdfset[[1]], exclude=c("H")) # Return bond matrix for first molecule 
 plot(sdfset[1], atomnum = TRUE, noHbonds=FALSE , no_print_atoms = "", atomcex=0.8) # Plot its structure with atom numbering 
 rowSums(conMA(sdfset[[1]], exclude=c("H"))) # Return number of non-H bonds for each atom
```

<div align="right">[Back to Table of Contents]()</div>

Charges and Missing Hydrogens
=============================

The function `bonds` returns information about the number
of bonds, charges and missing hydrogens in `SDF` and
`SDFset` objects. It is used by many other functions
(*e.g.* `MW`, `MF`,
`atomcount`, `atomcuntMA` and
`plot`) to correct for missing hydrogens that are often
not specified in SD files. 
```{r eval=TRUE, tidy=FALSE}
 bonds(sdfset[[1]], type="bonds")[1:4,]
 bonds(sdfset[1:2], type="charge")
 bonds(sdfset[1:2], type="addNH") 
```

<div align="right">[Back to Table of Contents]()</div>

Ring Perception and Aromaticity Assignment
==========================================

The function `rings` identifies all possible rings in one
or many molecules (here `sdfset[1]`) using the exhaustive
ring perception algorithm from Hanser et al. [-@Hanser_1996]. In addition, the function can 
return all smallest possible rings as well as aromaticity information.

The following example returns all possible rings in a
`list`. The argument `upper` allows to
specify an upper length limit for rings. Choosing smaller length limits
will reduce the search space resulting in shortened compute times. Note:
each ring is represented by a character vector of atom symbols that are
numbered by their position in the atom block of the corresponding
`SDF/SDFset` object. 
```{r eval=TRUE, tidy=FALSE}
 ringatoms <- rings(sdfset[1], upper=Inf, type="all", arom=FALSE, inner=FALSE)
```


For visual inspection, the corresponding compound structure can be
plotted with the ring bonds highlighted in color: 
```{r eval=TRUE, tidy=FALSE}
 atomindex <- as.numeric(gsub(".*_", "", unique(unlist(ringatoms))))
 plot(sdfset[1], print=FALSE, colbonds=atomindex) 
```


Alternatively, one can include the atom numbers in the plot:

```{r eval=TRUE, tidy=FALSE}
 plot(sdfset[1], print=FALSE, atomnum=TRUE, no_print_atoms="H") 
```


Aromaticity information of the rings can be returned in a logical vector
by setting `arom=TRUE`: 
```{r eval=TRUE, tidy=FALSE}
 rings(sdfset[1], upper=Inf, type="all", arom=TRUE, inner=FALSE) 
```


Return rings with no more than 6 atoms that are also aromatic:

```{r eval=TRUE, tidy=FALSE}
 rings(sdfset[1], upper=6, type="arom", arom=TRUE, inner=FALSE) 
```


Count shortest possible rings and their aromaticity assignments by
setting `type=count` and `inner=TRUE`. The
inner (smallest possible) rings are identified by first computing all
possible rings and then selecting only the inner rings. For more
details, consult the help documentation with `?rings`.

```{r eval=TRUE, tidy=FALSE}
 rings(sdfset[1:4], upper=Inf, type="count", arom=TRUE, inner=TRUE) 
```

<div align="right">[Back to Table of Contents]()</div>

Rendering Chemical Structure Images
===================================

R Graphics Device
-----------------

A new plotting function for compound structures has been added to the
package recently. This function uses the native R graphics device for
generating compound depictions. At this point this function is still in
an experimental developmental stage but should become stable soon.  

If you have `ChemmineOB` available you can use the `regenCoords`
option to have OpenBabel regenerate the coordinates for the compound.
This can sometimes produce better looking plots.

Plot compound Structures with R's graphics device: 
```{r plotstruct2, eval=TRUE, tidy=FALSE}
 data(sdfsample)
 sdfset <- sdfsample
 plot(sdfset[1:4], regenCoords=TRUE,print=FALSE) # 'print=TRUE' returns SDF summaries
```


Customized plots: 
```{r eval=FALSE, tidy=FALSE}
 plot(sdfset[1:4], griddim=c(2,2), print_cid=letters[1:4], print=FALSE, 
		noHbonds=FALSE) 
```


In the following plot, the atom block position numbers in the SDF are
printed next to the atom symbols (`atomnum = TRUE`). For
more details, consult help documentation with
`?plotStruc` or `?plot`. 
```{r plotstruct3, eval=TRUE, tidy=FALSE}
 plot(sdfset["CMP1"], atomnum = TRUE, noHbonds=F , no_print_atoms = "",
	  	atomcex=0.8, sub=paste("MW:", MW(sdfsample["CMP1"])), print=FALSE) 
```


Substructure highlighting by atom numbers: 
```{r plotstruct4, eval=TRUE, tidy=FALSE}
 plot(sdfset[1], print=FALSE, colbonds=c(22,26,25,3,28,27,2,23,21,18,8,19,20,24)) 
```

<div align="right">[Back to Table of Contents]()</div>


Data Tables
------------
Compound images and data can also be viewed in a web browser. 
This allows you to page through the table, as well as filter
the results using the search box. Results can be sorted on
any column by clicking on the column title. Compound images are
rendered as SVGs, so you can zoom in on them to see more details.

```{r datatable, eval=FALSE, tidy=FALSE}
data(sdfsample)
SDFDataTable(sdfsample[1:5])

```

Online with ChemMine Tools
--------------------------

Alternatively, one can visualize compound structures with a standard web
browser using the online ChemMine Tools service.

Plot structures using web service ChemMine Tools: 
```{r eval=FALSE, tidy=FALSE}
 sdf.visualize(sdfset[1:4]) 
```

![Figure: Visualization webpage created by calling
`sdf.visualize`.](visualizescreenshot-small.png )

<div align="right">[Back to Table of Contents]()</div>

Similarity Comparisons and Searching
====================================

Maximum Common Substructure (MCS) Searching
-------------------------------------------

The `ChemmineR` add-on package
[`fmcsR`](http://www.bioconductor.org/packages/devel/bioc/html/fmcsR.html)
provides support for identifying maximum common substructures (MCSs) and
flexible MCSs among compounds. The algorithm can be used for pairwise
compound comparisons, structure similarity searching and clustering. The
manual describing this functionality is available
[here](http://www.bioconductor.org/packages/devel/bioc/vignettes/fmcsR/inst/doc/fmcsR.html)
and the associated publication is Wang et al. [-@Wang_2013]. The following gives a
short preview of some functionalities provided by the
`fmcsR` package.  

```{r plotmcs, eval=TRUE, tidy=FALSE}
 library(fmcsR)
 data(fmcstest) # Loads test sdfset object 
 test <- fmcs(fmcstest[1], fmcstest[2], au=2, bu=1) # Searches for MCS with mismatches 
 plotMCS(test) # Plots both query compounds with MCS in color 
```

<div align="right">[Back to Table of Contents]()</div>

AP/APset Classes for Storing Atom Pair Descriptors
--------------------------------------------------

The function `sdf2ap` computes atom pair descriptors for
one or many compounds [@Carhart_1985; @Chen_2002]. It returns a searchable atom pair database
stored in a container of class `APset`, which can be used
for structural similarity searching and clustering. As similarity
measure, the Tanimoto coefficient or related coefficients can be used.
An `APset` object consists of one or many
`AP` entries each storing the atom pairs of a single
compound. Note: the deprecated `cmp.parse` function is
still available which also generates atom pair descriptor databases, but
directly from an SD file. Since the latter function is less flexible it
may be discontinued in the future.  

Generate atom pair descriptor database for searching: 
```{r eval=TRUE, tidy=FALSE}
 ap <- sdf2ap(sdfset[[1]]) # For single compound
 ap 
```

```{r eval=FALSE, tidy=FALSE}
 apset <- sdf2ap(sdfset)
 # For many compounds. 
```
 
```{r eval=TRUE, tidy=FALSE}
view(apset[1:4]) 
```


Return main components of APset objects: 
```{r eval=FALSE, tidy=FALSE}
 cid(apset[1:4]) # Compound IDs 
 ap(apset[1:4]) # Atom pair
 descriptors 
 db.explain(apset[1]) # Return atom pairs in human readable format 
```


Coerce APset to other objects: 
```{r eval=FALSE, tidy=FALSE}
 apset2descdb(apset) # Returns old list-style AP database 
 tmp <- as(apset, "list") # Returns list 
 as(tmp, "APset") # Converts list back to APset 
```

<div align="right">[Back to Table of Contents]()</div>

Large SDF and Atom Pair Databases
---------------------------------

When working with large data sets it is often desirable to save the
`SDFset` and `APset` containers as binary
R objects to files for later use. This way they can be loaded very
quickly into a new R session without recreating them every time from
scratch.  

Save and load of `SDFset` and `APset`
containers: 
```{r eval=FALSE, tidy=FALSE}
 save(sdfset, file = "sdfset.rda", compress = TRUE) 
 load("sdfset.rda") save(apset, file = "apset.rda", compress = TRUE)
 load("apset.rda") 
```

<div align="right">[Back to Table of Contents]()</div>

Pairwise Compound Comparisons with Atom Pairs
---------------------------------------------

The `cmp.similarity` function computes the atom pair
similarity between two compounds using the Tanimoto coefficient as
similarity measure. The coefficient is defined as *c/(a+b+c)*, which
is the proportion of the atom pairs shared among two compounds divided
by their union. The variable *c* is the number of atom pairs common in
both compounds, while *a* and *b* are the numbers of their unique
atom pairs. 
```{r eval=TRUE, tidy=FALSE}
 cmp.similarity(apset[1],
 apset[2])
 cmp.similarity(apset[1], apset[1]) 
```

<div align="right">[Back to Table of Contents]()</div>

Similarity Searching with Atom Pairs
------------------------------------

The `cmp.search` function searches an atom pair database
for compounds that are similar to a query compound. The following
example returns a data frame where the rows are sorted by the Tanimoto
similarity score (best to worst). The first column contains the indices
of the matching compounds in the database. The argument cutoff can be a
similarity cutoff, meaning only compounds with a similarity value larger
than this cutoff will be returned; or it can be an integer value
restricting how many compounds will be returned. When supplying a cutoff
of 0, the function will return the similarity values for every compound
in the database. 
```{r eval=TRUE, tidy=FALSE}
 cmp.search(apset,
 apset["650065"], type=3, cutoff = 0.3, quiet=TRUE) 
```
Alternatively, the
function can return the matches in form of an index or a named vector if
the `type` argument is set to `1` or
`2`, respectively. 
```{r eval=TRUE, tidy=FALSE}
 cmp.search(apset, apset["650065"], type=1, cutoff = 0.3, quiet=TRUE)
 cmp.search(apset, apset["650065"], type=2, cutoff = 0.3, quiet=TRUE) 
```

<div align="right">[Back to Table of Contents]()</div>

FP/FPset Classes for Storing Fingerprints
-----------------------------------------

The `FPset` class stores fingerprints of small molecules
in a matrix-like representation where every molecule is encoded as a
fingerprint of the same type and length. The `FPset`
container acts as a searchable database that contains the fingerprints
of many molecules. The `FP` container holds only one
fingerprint. Several constructor and coerce methods are provided to
populate `FP/FPset` containers with fingerprints, while
supporting any type and length of fingerprints. For instance, the
function `desc2fp` generates fingerprints from an atom
pair database stored in an `APset`, and
`as(matrix, "FPset")` and `as(character, "FPset")` construct an `FPset` database from
objects where the fingerprints are represented as
`matrix` or `character` objects,
respectively.  

Show slots of `FPset` class: 
```{r eval=TRUE, tidy=FALSE}
 showClass("FPset") 
```


Instance of `FPset` class: 
```{r eval=TRUE, tidy=FALSE}
 data(apset) 
 fpset <- desc2fp(apset)
 view(fpset[1:2]) 
```


`FPset` class usage: 
```{r eval=TRUE, tidy=FALSE}
 fpset[1:4] # behaves like a list 
 fpset[[1]] # returns FP object 
 length(fpset) # number of compounds ENDCOMMENT
 cid(fpset) # returns compound ids 
 fpset[10] <- 0 # replacement of 10th fingerprint to all zeros 
 cid(fpset) <- 1:length(fpset) # replaces compound ids 
 c(fpset[1:4], fpset[11:14]) # concatenation of several FPset objects 
 
```


Construct `FPset` class form `matrix`:

```{r eval=TRUE, tidy=FALSE}
 fpma <- as.matrix(fpset) # coerces FPset to matrix 
 as(fpma, "FPset") 
```


Construct `FPset` class form `character vector`: 
```{r eval=TRUE, tidy=FALSE}
 fpchar <- as.character(fpset) # coerces FPset to character strings 
 as(fpchar, "FPset") # construction of FPset class from character vector
```


Compound similarity searching with `FPset`:

```{r eval=TRUE, tidy=FALSE}
 fpSim(fpset[1], fpset, method="Tanimoto", cutoff=0.4, top=4) 
```

Folding fingerprints:

```{r eval=TRUE,tidy=FALSE}
 fold(fpset) # fold each FP once
 fold(fpset, count=2) #fold each FP twice
 fold(fpset, bits=128) #fold each FP down to 128 bits
 fold(fpset[[1]])  # fold an individual FP

 fptype(fpset) # get type of FPs
 numBits(fpset) # get the number of bits of each FP
 foldCount(fold(fpset)) # the number of times an FP or FPset has been folded
```

<div align="right">[Back to Table of Contents]()</div>

Atom Pair Fingerprints
----------------------

Atom pairs can be converted into binary atom pair fingerprints of fixed
length. Computations on this compact data structure are more time and
memory efficient than on their relatively complex atom pair
counterparts. The function `desc2fp` generates
fingerprints from descriptor vectors of variable length such as atom
pairs stored in `APset` or `list`
containers. The obtained fingerprints can be used for structure
similarity comparisons, searching and clustering.  

Create atom pair sample data set: 
```{r eval=FALSE, tidy=FALSE}
 data(sdfsample)
 sdfset <- sdfsample[1:10] 
 apset <- sdf2ap(sdfset) 
```


Compute atom pair fingerprint database using internal atom pair
selection containing the 4096 most common atom pairs identified in
DrugBank's compound collection. For details see `?apfp`.
The following example uses from this set the 1024 most frequent atom
pairs: 
```{r eval=FALSE, tidy=FALSE}
 fpset <- desc2fp(apset, descnames=1024, type="FPset") 
```


Alternatively, one can provide any custom atom pair selection. Here, the
1024 most common ones in `apset`: 
```{r eval=FALSE, tidy=FALSE}
 fpset1024 <- names(rev(sort(table(unlist(as(apset, "list")))))[1:1024]) 
 fpset <- desc2fp(apset, descnames=fpset1024, type="FPset") 
```


A more compact way of storing fingerprints is as character values:

```{r eval=FALSE, tidy=FALSE}
 fpchar <- desc2fp(x=apset,
 descnames=1024, type="character") fpchar <- as.character(fpset) 
```


Converting a fingerprint database to a matrix and vice versa:

```{r eval=FALSE, tidy=FALSE}
 fpma <- as.matrix(fpset)
 fpset <- as(fpma, "FPset") 
```


Similarity searching and returning Tanimoto similarity coefficients:

```{r eval=FALSE, tidy=FALSE}
 fpSim(fpset[1], fpset, method="Tanimoto") 
```


Under `method` one can choose from several predefined
similarity measures including *Tanimoto* (default),
*Euclidean*, *Tversky* or
*Dice*. Alternatively, one can pass on custom similarity
functions. 
```{r eval=FALSE, tidy=FALSE}
 fpSim(fpset[1], fpset, method="Tversky", cutoff=0.4, top=4, alpha=0.5, beta=1) 
```


Example for using a custom similarity function: 
```{r eval=FALSE, tidy=FALSE}
 myfct <- function(a, b, c, d) c/(a+b+c+d)
 fpSim(fpset[1], fpset, method=myfct) 
```


Clustering example: 
```{r eval=FALSE, tidy=FALSE}
 simMAap <- sapply(cid(apfpset), function(x) fpSim(x=apfpset[x], apfpset, sorted=FALSE)) 
 hc <- hclust(as.dist(1-simMAap), method="single")
 plot(as.dendrogram(hc), edgePar=list(col=4, lwd=2), horiz=TRUE) 
```

<div align="right">[Back to Table of Contents]()</div>

Fingerprint E-values
---------------------
The `fpSim` function can also return Z-scores, E-values, and p-values
if given a set of score distribution parameters. These parameters can
be computed over an `fpSet` with the `genParameters` function.


```{r eval=TRUE, tidy=FALSE}
    params <- genParameters(fpset)
```
This function will compute all pairwise distances between the given
fingerprints and then fit a Beta distribution to the resulting
Tanimoto scores, conditioned on the number of set bits in each
fingerprint. For large data sets where you would not want to compute
all pairwise distances, you can set what fraction to sample with the
`sampleFraction` argument. This step only needs to be done once for
each database of `fpSet` objects. Alternatively, if you have a large
database of fingerprints, or you believe that the parameters computed
on a single database are more generally applicable, you can use the
resulting parameters for other databases as well. 

Once you have a set of parameters, you can pass them to `fpSim` with
the `parameters` argument. 

```{r eval=TRUE, tidy=FALSE}
	fpSim(fpset[[1]], fpset, top=10, parameters=params)	
```

This will then return a data frame with the similarity, Z-score,
E-value, and p-value. You can change which value will be used as a
cutoff and to sort by by setting the argument `scoreType` to one of
these scores. In this way you could set an E-value cutoff of 0.04 for
example.

```{r eval=TRUE, tidy=FALSE}
	fpSim(fpset[[1]], fpset, cutoff=0.04, scoreType="evalue", parameters=params)	
```

<div align="right">[Back to Table of Contents]()</div>

Pairwise Compound Comparisons with PubChem Fingerprints
-------------------------------------------------------

The `fpSim` function computes the similarity coefficients
(*e.g.* Tanimoto) for pairwise comparisons of binary fingerprints. For
this data type, *c* is the number of "on-bits" common in both
compounds, and *a* and *b* are the numbers of their unique
"on-bits". Currently, the PubChem fingerprints need to be provided (here
PubChem's SD files) and cannot be computed from scratch in
`ChemmineR`. The PubChem fingerprint specifications can
be loaded with `data(pubchemFPencoding)`.  

Convert base 64 encoded PubChem fingerprints to
`character` vector, `matrix` or
`FPset` object: 
```{r eval=TRUE, tidy=FALSE}
 cid(sdfset) <- sdfid(sdfset)
 fpset <- fp2bit(sdfset, type=1) 
 fpset <- fp2bit(sdfset, type=2) 
 fpset <- fp2bit(sdfset, type=3) 
 fpset 
```


Pairwise compound structure comparisons: 
```{r eval=TRUE, tidy=FALSE}
 fpSim(fpset[1], fpset[2]) 
```

<div align="right">[Back to Table of Contents]()</div>

Similarity Searching with PubChem Fingerprints
----------------------------------------------

Similarly, the `fpSim` function provides search
functionality for PubChem fingerprints: 
```{r eval=TRUE, tidy=FALSE}
 fpSim(fpset["650065"], fpset, method="Tanimoto", cutoff=0.6, top=6) 
```

<div align="right">[Back to Table of Contents]()</div>

Visualize Similarity Search Results
-----------------------------------

The `cmp.search` function allows to visualize the
chemical structures for the search results. Similar but more flexible
chemical structure rendering functions are `plot` and
`sdf.visualize` described above. By setting the visualize
argument in `cmp.search` to `TRUE`, the
matching compounds and their scores can be visualized with a standard
web browser. Depending on the `visualize.browse`
argument, an URL will be printed or a webpage will be opened showing the
structures of the matching compounds.

View similarity search results in R's graphics device:

```{r search_result, eval=TRUE, tidy=FALSE}
 cid(sdfset) <-
 cid(apset) # Assure compound name consistency among objects. 

 plot(sdfset[names(cmp.search(apset, apset["650065"], type=2, cutoff=4, quiet=TRUE))], print=FALSE) 
```


View results online with Chemmine Tools: 
```{r eval=FALSE, tidy=FALSE}
 similarities <- cmp.search(apset, apset[1], type=3, cutoff = 10)
 sdf.visualize(sdfset[similarities[,1]]) 
```

<div align="right">[Back to Table of Contents]()</div>

Clustering
==========

Clustering Identical or Very Similar Compounds
----------------------------------------------

Often it is of interest to identify very similar or identical compounds
in a compound set. The `cmp.duplicated` function can be
used to quickly identify very similar compounds in atom pair sets, which
will be frequently, but not necessarily, identical compounds.  

Identify compounds with identical AP sets: 
```{r eval=TRUE, tidy=FALSE}
 cmp.duplicated(apset, type=1)[1:4] # Returns AP duplicates as logical vector 
 cmp.duplicated(apset, type=2)[1:4,] # Returns AP duplicates as data frame 
```


Plot the structure of two pairs of duplicates: 
```{r duplicates, eval=TRUE, tidy=FALSE}
 plot(sdfset[c("650059","650060", "650065", "650066")], print=FALSE) 
```


Remove AP duplicates from SDFset and APset objects: 
```{r eval=TRUE, tidy=FALSE}
 apdups <- cmp.duplicated(apset, type=1)
 sdfset[which(!apdups)]; apset[which(!apdups)] 
```


Alternatively, one can identify duplicates via other descriptor types if
they are provided in the data block of an imported SD file. For
instance, one can use here fingerprints, InChI, SMILES or other
molecular representations. The following examples show how to enumerate
by identical InChI strings, SMILES strings and molecular formula,
respectively.


```{r eval=TRUE, tidy=FALSE}
 count <- table(datablocktag(sdfset,
 tag="PUBCHEM_NIST_INCHI"))
 count <- table(datablocktag(sdfset, tag="PUBCHEM_OPENEYE_CAN_SMILES")) 
 count <- table(datablocktag(sdfset, tag="PUBCHEM_MOLECULAR_FORMULA")) 
 count[1:4] 
```

<div align="right">[Back to Table of Contents]()</div>

Binning Clustering
------------------

Compound libraries can be clustered into discrete similarity groups with
the binning clustering function `cmp.cluster`. The
function accepts as input an atom pair (`APset`) or a
fingerprint (`FPset`) descriptor database as well as a
similarity threshold. The binning clustering result is returned in form
of a data frame. Single linkage is used for cluster joining. The
function calculates the required compound-to-compound distance
information on the fly, while a memory-intensive distance matrix is only
created upon user request via the `save.distances`
argument (see below).

Because an optimum similarity threshold is often not known, the
`cmp.cluster` function can calculate cluster results for
multiple cutoffs in one step with almost the same speed as for a single
cutoff. This can be achieved by providing several cutoffs under the
cutoff argument. The clustering results for the different cutoffs will
be stored in one data frame.

One may force the `cmp.cluster` function to calculate and
store the distance matrix by supplying a file name to the
`save.distances` argument. The generated distance matrix
can be loaded and passed on to many other clustering methods available
in R, such as the hierarchical clustering function
`hclust` (see below).

If a distance matrix is available, it may also be supplied to
`cmp.cluster` via the `use.distances`
argument. This is useful when one has a pre-computed distance matrix
either from a previous call to `cmp.cluster` or from
other distance calculation subroutines.  

Single-linkage binning clustering with one or multiple cutoffs:

```{r eval=TRUE, tidy=FALSE}
 clusters <- cmp.cluster(db=apset, cutoff = c(0.7, 0.8, 0.9), quiet = TRUE)
 clusters[1:12,] 
```


Clustering of `FPset` objects with multiple cutoffs. This
method allows to call various similarity methods provided by the
`fpSim` function. For details consult
`?fpSim`. 
```{r eval=TRUE, tidy=FALSE}
 fpset <- desc2fp(apset)
 clusters2 <- cmp.cluster(fpset, cutoff=c(0.5, 0.7, 0.9), method="Tanimoto", quiet=TRUE)
 clusters2[1:12,] 
```


Sames as above, but using Tversky similarity measure: 
```{r eval=TRUE, tidy=FALSE}
 clusters3 <- cmp.cluster(fpset, cutoff=c(0.5, 0.7, 0.9), 
								  method="Tversky", alpha=0.3, beta=0.7, quiet=TRUE) 
```


Return cluster size distributions for each cutoff: 
```{r eval=TRUE, tidy=FALSE}
 cluster.sizestat(clusters, cluster.result=1)
 cluster.sizestat(clusters, cluster.result=2)
 cluster.sizestat(clusters, cluster.result=3) 
```


Enforce calculation of distance matrix: 
```{r eval=FALSE, tidy=FALSE}
 clusters <- cmp.cluster(db=apset, cutoff = c(0.65, 0.5, 0.3),
 save.distances="distmat.rda") # Saves distance matrix to file "distmat.rda" in current working directory. 
 load("distmat.rda") # Loads distance matrix. 
 
```

<div align="right">[Back to Table of Contents]()</div>

Jarvis-Patrick Clustering
-------------------------

The Jarvis-Patrick clustering algorithm is widely used in
cheminformatics [@greycite13371]. It requires a nearest neighbor table, which consists
of *j* nearest neighbors for each item (*e.g.* compound).
The nearest neighbor table is then used to join items into clusters when
they meet the following requirements: (a) they are contained in each
other's neighbor list and (b) they share at least *k*
nearest neighbors. The values for *j* and
*k* are user-defined parameters. The
`jarvisPatrick` function implemented in
`ChemmineR` takes a nearest neighbor table generated by
`nearestNeighbors`, which works for
`APset` and `FPset` objects. This function
takes either the standard Jarvis-Patrick *j* parameter
(as the `numNbrs` parameter), or else a
`cutoff` value, which is an extension to the basic
algorithm that we have added. Given a cutoff value, the nearest neighbor
table returned contains every neighbor with a similarity greater than
the cutoff value, for each item. This allows one to generate tighter
clusters and to minimize certain limitations of this method, such as
false joins of completely unrelated items when operating on small data
sets. The `trimNeighbors` function can also be used to
take an existing nearest neighbor table and remove all neighbors whose
similarity value is below a given cutoff value. This allows one to
compute a very relaxed nearest neighbor table initially, and then
quickly try different refinements later.

In case an existing nearest neighbor matrix needs to be used, the
`fromNNMatrix` function can be used to transform it into
the list structure that `jarvisPatrick` requires. The
input matrix must have a row for each compound, and each row should be
the index values of the neighbors of compound represented by that row.
The names of each compound can also be given through the
`names` argument. If not given, it will attempt to use
the `rownames` of the given matrix.

The `jarvisPatrick` function also allows one to relax
some of the requirements of the algorithm through the
`mode` parameter. When set to "a1a2b", then all
requirements are used. If set to "a1b", then (a) is relaxed to a
unidirectional requirement. Lastly, if `mode` is set to
"b", then only requirement (b) is used, which means that all pairs of
items will be checked to see if (b) is satisfied between them. The size
of the clusters generated by the different methods increases in this
order: "a1a2b" < "a1b" < "b". The run time of method "a1a2b" follows a
close to linear relationship, while it is nearly quadratic for the much
more exhaustive method "b". Only methods "a1a2b" and "a1b" are suitable
for clustering very large data sets (e.g. \>50,000 items) in a
reasonable amount of time.

An additional extension to the algorithm is the ability to set the
linkage mode. The `linkage` parameter can be one of
"single", "average", or "complete", for single linkage, average linkage
and complete linkage merge requirements, respectively. In the context of
Jarvis-Patrick, average linkage means that at least half of the pairs
between the clusters under consideration must meet requirement (b).
Similarly, for complete linkage, all pairs must requirement (b). Single
linkage is the normal case for Jarvis-Patrick and just means that at
least one pair must meet requirement (b).

The output is a cluster `vector` with the item labels in
the name slot and the cluster IDs in the data slot. There is a utility
function called `byCluster`, which takes out cluster
vector output by `jarvisPatrick` and transforms it into a
list of vectors. Each slot of the list is named with a cluster id and
the vector contains the cluster members. By default the function
excludes singletons from the output, but they can be included by setting
`excludeSingletons`=FALSE`.

Load/create sample `APset` and `FPset`:

```{r eval=TRUE, tidy=FALSE}
 data(apset) 
 fpset <- desc2fp(apset) 
```


Standard Jarvis-Patrick clustering on `APset` and
`FPset` objects: 
```{r eval=TRUE, tidy=FALSE}
 jarvisPatrick(nearestNeighbors(apset,numNbrs=6), k=5, mode="a1a2b")
 #Using "APset" 

 jarvisPatrick(nearestNeighbors(fpset,numNbrs=6), k=5, mode="a1a2b")
 #Using "FPset" 
```


The following example runs Jarvis-Patrick clustering with a minimum
similarity `cutoff` value (here Tanimoto coefficient). In
addition, it uses the much more exhaustive `"b"` method
that generates larger cluster sizes, but significantly increased the run
time. For more details, consult the corresponding help file with
`?jarvisPatrick`. 
```{r eval=TRUE, tidy=FALSE}
 cl<-jarvisPatrick(nearestNeighbors(fpset,cutoff=0.6,
 method="Tanimoto"), k=2 ,mode="b")
 byCluster(cl) 
```


Output nearest neighbor table (`matrix`): 
```{r eval=TRUE, tidy=FALSE}
 nnm <- nearestNeighbors(fpset,numNbrs=6)
 nnm$names[1:4] 
 nnm$ids[1:4,] 
 nnm$similarities[1:4,] 
```


Trim nearest neighbor table: 
```{r eval=TRUE, tidy=FALSE}
 nnm <- trimNeighbors(nnm,cutoff=0.4) 
 nnm$similarities[1:4,]
```


Perform clustering on precomputed nearest neighbor table: 
```{r eval=TRUE, tidy=FALSE}
 jarvisPatrick(nnm, k=5,mode="b") 
```


Using a user defined nearest neighbor matrix: 
```{r eval=TRUE, tidy=FALSE}
 nn <- matrix(c(1,2,2,1),2,2,dimnames=list(c('one','two'))) 
 nn
 byCluster(jarvisPatrick(fromNNMatrix(nn),k=1)) 
```

<div align="right">[Back to Table of Contents]()</div>

Multi-Dimensional Scaling (MDS)
-------------------------------

To visualize and compare clustering results, the
`cluster.visualize` function can be used. The function
performs Multi-Dimensional Scaling (MDS) and visualizes the results in
form of a scatter plot. It requires as input an `APset`,
a clustering result from `cmp.cluster`, and a cutoff for
the minimum cluster size to consider in the plot. To help determining a
proper cutoff size, the `cluster.sizestat` function is
provided to generate cluster size statistics.

MDS clustering and scatter plot: 
```{r eval=FALSE, tidy=FALSE}
 cluster.visualize(apset, clusters, size.cutoff=2, quiet = TRUE) # Color codes clusters with at least two members. 
 cluster.visualize(apset, clusters, quiet = TRUE) # Plots all items.
```


Create a 3D scatter plot of MDS result: 
```{r mds_scatter, eval=TRUE, tidy=FALSE}
 library(scatterplot3d) 
 coord <- cluster.visualize(apset, clusters, size.cutoff=1, dimensions=3, quiet=TRUE) 
 scatterplot3d(coord) 
```


Interactive 3D scatter plot with Open GL (graphics not evaluated here):

```{r eval=FALSE, tidy=FALSE}
 library(rgl) rgl.open(); offset <- 50;
 par3d(windowRect=c(offset, offset, 640+offset, 640+offset)) 
 rm(offset)
 rgl.clear() 
 rgl.viewpoint(theta=45, phi=30, fov=60, zoom=1)
 spheres3d(coord[,1], coord[,2], coord[,3], radius=0.03, color=coord[,4], alpha=1, shininess=20) 
 aspect3d(1, 1, 1) 
 axes3d(col='black')
 title3d("", "", "", "", "", col='black')
 bg3d("white") # To save a snapshot of the graph, one can use the command rgl.snapshot("test.png").
```

<div align="right">[Back to Table of Contents]()</div>

Clustering with Other Algorithms
--------------------------------

`ChemmineR` allows the user to take advantage of the wide
spectrum of clustering utilities available in R. An example on how to
perform hierarchical clustering with the hclust function is given
below.  

Create atom pair distance matrix:

```{r ap_dist_matrix, eval=TRUE, tidy=FALSE}
 dummy <- cmp.cluster(db=apset, cutoff=0, save.distances="distmat.rda", quiet=TRUE) 
 load("distmat.rda") 
```


Hierarchical clustering with `hclust`: 
```{r hclust, eval=TRUE, tidy=FALSE}
 hc <- hclust(as.dist(distmat), method="single") 
 hc[["labels"]] <- cid(apset) # Assign correct item labels 
 plot(as.dendrogram(hc), edgePar=list(col=4, lwd=2), horiz=T) 
```


Instead of atom pairs one can use PubChem's fingerprints for clustering:

```{r fp_hclust, eval=FALSE, tidy=FALSE}
 simMA <- sapply(cid(fpset), function(x) fpSim(fpset[x], fpset, sorted=FALSE))
 hc <- hclust(as.dist(1-simMA), method="single") 
 plot(as.dendrogram(hc), edgePar=list(col=4, lwd=2), horiz=TRUE) 
```


Plot dendrogram with heatmap (here similarity matrix): 
```{r heatmap, eval=TRUE, tidy=FALSE}
 library(gplots) 
 heatmap.2(1-distmat, Rowv=as.dendrogram(hc), Colv=as.dendrogram(hc), 
			  col=colorpanel(40, "darkblue", "yellow", "white"), 
			  density.info="none", trace="none") 
```

<div align="right">[Back to Table of Contents]()</div>

Searching PubChem
=================

Get Compound SDF from PubChem by Id
--------------------------------

The function `pubchemCidToSDF` (alias `getIds`) accepts one or more numeric PubChem
compound ids and downloads the corresponding compounds from PubChem
Power User Gateway (PUG) returning results in an `SDFset`
container.  

Fetch 2 compounds from PubChem:


```{r pubchemCidToSDF, eval=FALSE, tidy=FALSE}
 compounds <- pubchemCidToSDF(c(111,123))
 compounds 
```

<div align="right">[Back to Table of Contents]()</div>


Get Compound SDF from PubChem by InChIkey
--------------------------------
The function `pubchemInchikey2sdf` accepts one or more character PubChem
compound InChIkey(s) and downloads the corresponding compounds from PubChem's
Power User Gateway (PUG). This returns the results in a list of two items. The first item is 
the `SDFset` container of all successful queries. The second item is a named numeric 
vector. This vector records whether an InChIkey has a successful return. If the InChIkey query 
is successful, a non-zero number is returned as the index of
where it exists in the `SDFset` object for this InChIkey. If failed, `0` is returned.

```{r pubchemInchikey2sdf, eval=FALSE, tidy=FALSE}
inchikeys <- c(
"ZFUYDSOHVJVQNB-FZERPYLPSA-N",
"KONGRWVLXLWGDV-BYGOPZEFSA-N",
"AANKDJLVHZQCFG-WLIQWNBFSA-N",
"SNFRINMTRPQQLE-JQWAAABSSA-N"
)
# You should only have 2 SDF returned, 2 other not found
inchikey_query <- pubchemInchikey2sdf(inchikeys)
inchikey_query$sdf_set

# successful queries
inchikey_query_index <- inchikey_query$sdf_index[inchikey_query$sdf_index != 0]

# get CID of these queries
inchikey_query_cid <- cid(inchikey_query$sdf_set[inchikey_query_index])
names(inchikey_query_cid) <- names(inchikey_query_index)
inchikey_query_cid
```

<div align="right">[Back to Table of Contents]()</div>

Get Compound CID from PubChem by InChI
--------------------------------
The function `pubchemInchi2cid` accepts one or more character PubChem
compound InChI string(s) and downloads the corresponding compound CID from PubChem
Power User Gateway (PUG) returning results in a named numeric vector. Successful 
requests will have empty names, requests with invalid InChI strings will have 
name "invalid" and requests with valid InChI but not found in PubChem will have 
name "not_found". Both "invalid" and "not_found" queries will have CID `0` as return.

PubChem API allows users to only query one InChI a time, so this 
function sends one PubChem API request per InChI. For courtesy reasons, the rate 
is limited to 1 query per second. It is not recommended to parallelize this function. 

```{r pubchemInchi2cid, eval=FALSE, tidy=FALSE}
# first two are valid, third has no result, last is invalid 
inchis <- c(
 "InChI=1S/C15H26O/c1-9(2)11-6-5-10(3)15-8-7-14(4,16)13(15)12(11)15/h9-13,16H,5-8H2,1-4H3/t10-,11+,12-,13+,14+,15-/m1/s1", 
 "InChI=1S/C3H8/c1-3-2/h3H2,1-2H3", 
 "InChI=1S/C15H20Br2O2/c1-2-12(17)13-7-3-4-8-14-15(19-13)10-11(18-14)6-5-9-16/h3-4,6,9,11-15H,2,7-8,10H2,1H3/t5-,11-,12+,13+,14-,15-/m1/s1",
 "InChI=abc"
)
pubchemInchi2cid(inchis)
```

<div align="right">[Back to Table of Contents]()</div>

Search a SMILES Query in PubChem
--------------------------------

The function `searchString` accepts one SMILES string
(Simplified Molecular Input Line Entry Specification) and performs a
\>0.95 similarity PubChem fingerprint search, returning the hits in an
`SDFset` container. The ChemMine Tools web service is
used as an intermediate, to translate queries from plain HTTP POST to a
PubChem Power User Gateway (PUG) query.  

Search a SMILES string on PubChem:


```{r searchString, eval=FALSE, tidy=FALSE}
compounds <- searchString("CC(=O)OC1=CC=CC=C1C(=O)O") 
compounds 
```

<div align="right">[Back to Table of Contents]()</div>

Search an SDF Query in PubChem
------------------------------

The function `searchSim` performs a PubChem similarity
search just like `searchString`, but accepts a query in
an `SDFset` container. If the query contains more than
one compound, only the first is searched.  

Search an `SDFset` container on PubChem:


```{r searchSim, eval=FALSE, tidy=FALSE}
 data(sdfsample); 
 sdfset <- sdfsample[1] 
 compounds <- searchSim(sdfset) 
 compounds 
```

<div align="right">[Back to Table of Contents]()</div>

ChemMine Tools R Interface
==========================

ChemMine Web Tools is an online service for analyzing and clustering small molecules. It provides numerous cheminformatics tools which can be used directly on the website, or called remotely from within R. When called within R jobs are sent remotely to a queue on a compute cluster at UC Riverside, which is a free service offered to `ChemmineR` users.
The website is free and open to all users and is available at <http://chemmine.ucr.edu>. When new tools are added to the service, they automatically become availiable within `ChemmineR` without updating your local R package.

List all available tools:

```{r listCMTools, eval=FALSE, tidy=FALSE}
listCMTools()
```

```{r eval=TRUE, echo=FALSE}
# cache results from previous code chunk
# NOTE: this must match the code in the previous code chunk but will be
#   hidden. Delete cacheFileName to rebuild the cache from web data.
cacheFileName <- "listCMTools.RData"
if(! file.exists(cacheFileName)){
    toolList <- listCMTools()
    save(list=c("toolList"), file=cacheFileName)
}
load(cacheFileName)
toolList
```

Show options and description for a tool. This also provides an example function call which can be copied
verbatim, and changed as necessary:

```{r toolDetailsCMT, eval=FALSE, tidy=FALSE}
toolDetails("Fingerprint Search")
```

```{r eval=TRUE, echo=FALSE}
# cache results from previous code chunk
# NOTE: this must match the code in the previous code chunk but will be
#   hidden. Delete cacheFileName to rebuild the cache from web data.
cacheFileName <- "toolDetails.RData"
if(! file.exists(cacheFileName)){
    .serverURL <- "http://chemmine.ucr.edu/ChemmineR/"
    library(RCurl)
    response <- postForm(paste(.serverURL, "toolDetails", sep = ""), tool_name = "Fingerprint Search")[[1]]
    save(list=c("response"), file=cacheFileName)
}
load(cacheFileName)
cat(response)
```

<div align="right">[Back to Table of Contents]()</div>

Launch a Job
------------------------------

When a job is launched it returns a job token which refers to the running job on the UC Riverside cluster. You can check the status of a job or obtain the results as follows. If `result` is called on a job that is still running, it will loop internally until the job is completed, and then return the result.

Launch the tool `pubchemID2SDF` to obtain the structure for PubChem cid 2244:

```{r launchCMTool, eval=FALSE, tidy=FALSE}
job1 <- launchCMTool("pubchemID2SDF", 2244)
status(job1)
result1 <- result(job1)
```

Use the previous result to search PubChem for similar compounds:

```{r fingerprintSearchCMT, eval=FALSE, tidy=FALSE}
job2 <- launchCMTool('Fingerprint Search', result1, 'Similarity Cutoff'=0.95, 'Max Compounds Returned'=200)
result2 <- result(job2)
job3 <- launchCMTool("pubchemID2SDF", result2)
result3 <- result(job3)
```

Compute OpenBabel descriptors for these search results:

```{r obDescriptorsCMT, eval=FALSE, tidy=FALSE}
job4 <- launchCMTool("OpenBabel Descriptors", result3)
result4 <- result(job4)
result4[1:10,] # show first 10 lines of result
```

```{r eval=TRUE, echo=FALSE}
# cache results from previous code chunk
# NOTE: this must match the code in the previous code chunk but will be
#   hidden. Delete cacheFileName to rebuild the cache from web data.
cacheFileName <- "launchCMTool.RData"
if(! file.exists(cacheFileName)){
    job1 <- launchCMTool("pubchemID2SDF", 2244)
    status(job1)
    result1 <- result(job1)
    job2 <- launchCMTool('Fingerprint Search', result1, 'Similarity Cutoff'=0.95, 'Max Compounds Returned'=200)
    result2 <- result(job2)
    job3 <- launchCMTool("pubchemID2SDF", result2)
    result3 <- result(job3)
    job4 <- launchCMTool("OpenBabel Descriptors", result3)
    result4 <- result(job4)
    save(list=c("result4"), file=cacheFileName)
}
load(cacheFileName)
result4[1:10,]
```

<div align="right">[Back to Table of Contents]()</div>

View Job Result in Browser
------------------------------

The function `browseJob` launches a web browser to view the results of a job online, just as if they
had been run from the ChemMine Tools website itself. If you also want the result data within R, you must first call
the `result` object from within R before calling `browseJob`. Once `browseJob` has been called on a job token,
the results are no longer accessible within R. 

If you have an account on ChemMine Tools and would like to save the web results from your job, you must first login to your account within the default web browser on your system before you launch `browseJob`. The job will then be assigned automatically to the currently logged in account.

View OpenBabel descriptors online:

```{r obDescriptorsWWW, eval=FALSE, tidy=FALSE}
browseJob(job4)
```

Perform binning clustering and visualize result online:

```{r binningClusterWWW, eval=FALSE, tidy=FALSE}
job5 <- launchCMTool("Binning Clustering", result3, 'Similarity Cutoff'=0.9)
browseJob(job5)
```

<div align="right">[Back to Table of Contents]()</div>


Version Information
===================


```{r sessionInfo, results='asis'}
 sessionInfo()
```

<div align="right">[Back to Table of Contents]()</div>

Funding
=======

This software was developed with funding from the National Science
Foundation: [ABI-0957099](http://www.nsf.gov/awardsearch/showAward.do?AwardNumber=0957099),
2010-0520325 and IGERT-0504249.

References
===========

\name{apset2descdb}
\alias{apset2descdb}
\title{
\code{APset} to list-style AP database
}
\description{
Coerces APset to old list-style descriptor database used by search/cluster functions.
}
\usage{
apset2descdb(apset)
}
\arguments{
  \item{apset}{
Object of class \code{apset}
}
}
\details{
...
}
\value{
\item{list}{ with following components }
\item{descdb}{ list of atom pair sets }
\item{cids}{ compound IDs }
\item{sdfsegs}{ start/end coordinates for each molecule in SD file; only populated when \code{cmp.parse} is used for import }
\item{source}{ path/name of SD file }
\item{type}{ import method }
}
\references{
Chen X and Reynolds CH (2002). "Performance of similarity measures
in 2D fragment-based similarity searching: comparison of structural descriptors
and similarity coefficients", J Chem Inf Comput Sci.
}
\author{
Thomas Girke
}
\seealso{
Functions: \code{SDF2apcmp}, \code{sdf2ap}, \code{cmp.search}, \code{cmp.similarity}
}
\examples{
## Instance of SDFset class
data(sdfsample)
sdfset <- sdfsample[1:50]
sdf <- sdfsample[[1]]

## Compute atom pair library
ap <- sdf2ap(sdf)
(apset <- sdf2ap(sdfset))
view(apset[1:4])

## Return main components of APset object
cid(apset[1:4]) # compound IDs
ap(apset[1:4]) # atom pair descriptors

## Return atom pairs in human readable format
db.explain(apset[1]) 

## Coerce APset to other objects 
apset2descdb(apset) # returns old list-style AP database
tmp <- as(apset, "list") # returns list
as(tmp, "APset") # converst list back to APset

## Compound similarity searching with APset
cmp.search(apset, apset[1], type=3, cutoff=0.2) 
plot(sdfset[names(cmp.search(apset, apset[6], type=2, cutoff=0.4))])

## Identify compounds with identical AP sets 
cmp.duplicated(apset, type=2)

## Structure similarity clustering 
cmp.cluster(db=apset, cutoff = c(0.65, 0.5))[1:20,]
}
\keyword{ utilities }

\name{numBits}
\alias{numBits}
\title{
	numBits
}
\description{
	Returns the number of bits in a fingerprint.
}
\usage{
numBits(x)
}
\arguments{
  \item{x}{
		Either an \code{FP} or an \code{FPset} object.
	}

}
\value{
	The number of bits in this fingerprint object.
}
\author{
	Kevin Horan
}
\examples{
	fp = new("FP",fp=c(1,0,1,1, 0,0,1,0))
	n = numBits(fp) # == 8
}

\name{fingerprintOB}
\alias{fingerprintOB}
\title{
	Fingerprints from OpenBabel
}
\description{
	Generates fingerprints from SDFsets using OpenBabel. The name of the fingerprint can
	also be set and can be anything available through OpenBabel. You can see what this list is by
	executing "obabel -L fingerprints".  Results are returned as an FPset.
}
\usage{
fingerprintOB(sdfSet, fingerprintName)
}
\arguments{
  \item{sdfSet}{
	  Input compounds to generate fingerprints for.
	}
  \item{fingerprintName}{
	  The name of the fingerprint in Open Babel. A list of available names can be found
	  by executing "obabel -L fingerprints".  Currently that list is: "FP2", "FP3", "FP4", and "MACCS". 
	}
}
\value{
	An FPset with an element for each given compound.
}
\author{
	Kevin Horan
}
\examples{
	\dontrun{
		data(sdfsample)
		fpset = fingerprintOB(sdfsample)
	}
}

\name{batchByIndex}
\alias{batchByIndex}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
	Batch by Index
}
\description{
	When doing a select were the condition is a large number of ids it is not always possible
	to include them in a single SQL statement. This function will break the list of ids into chunks 
	and allow the indexProcessor to deal with just a small number of ids.
}
\usage{
batchByIndex(allIndices, indexProcessor, batchSize = 1e+05)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{allIndices}{
		A vector of values that will be broken into batches and passed as an argument to the
		\code{indexProcessor} function.
	}
  \item{indexProcessor}{
  		A function that takes one batch if indices. It is called once for each batch.
		The return value from this function is ignored. To accumulate results you can	
		write to a global variable using the "<<-" operator. 
	}
  \item{batchSize}{
		The size of each batch. The last batch may be smaller than this value.
	}
}
\value{
	No value is returned.
}
\author{
	Kevin Horan
}

\seealso{
\code{\link{parBatchByIndex}}
}
\examples{
	
	\dontrun{
		result=NA
		indices = 1:10000
		
		#run a query on each batch of indexes, appending each result to
		# "result" as we go.
		batchByIndex(indices, function(indexBatch){
				df = dbGetQuery(dbConnection, generateQuery(indexBatch))
				result <<- if(is.na(result)) df else  rbind(result,df)
		},1000)
	}


}

\name{pubchemSmilesSearch}
\alias{pubchemSmilesSearch}
\title{
PubChem Similarity (Fingerprint) SMILES Search 
}
\description{
Accepts one SMILE string or \code{SMIset} container
and performs a  PubChem fingerprint search, returning 
hits in an \code{SDFset} container.  If the input object
contains multiple items, only the first is used as a query.
}
\usage{
pubchemSmilesSearch(smiles)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{smiles}{
  	  A \code{SMIset} object which contains one compound, or a SMILES string
}
}
\value{
\item{SDFset}{ for details see ?"SDFset-class"}
}
\references{
PubChem PUG REST: https://pubchem.ncbi.nlm.nih.gov/pug_rest/PUG_REST_Tutorial.html


SMILES Format: http://en.wikipedia.org/wiki/Chemical_file_format#SMILES
}
\author{
	Kevin Horan
}

\examples{
\dontrun{
## get a sample compound
data(sdfsample); sdfset <- sdfsample[2]
## search a compound on PubChem
compounds <- pubchemSmilesSearch(sdfset)}
}

\keyword{ utilities }

\name{SDFset-class}
\Rdversion{1.1}
\docType{class}
\alias{SDFset-class}
\alias{[,SDFset-method}
\alias{[[,SDFset-method}
\alias{[[<-,SDFset-method}
\alias{[<-,SDFset-method}
\alias{atomblock,SDFset-method}
\alias{atomcount,SDFset-method}
\alias{bondblock,SDFset-method}
\alias{obmol,SDFset-method}
\alias{c,SDFset-method}
\alias{cid,SDFset-method}
\alias{cid<-,SDFset-method}
\alias{header<-,SDFset-method}
\alias{atomblock<-,SDFset-method}
\alias{bondblock<-,SDFset-method}
\alias{datablock<-,SDFset-method}
\alias{coerce,list,SDFset-method}
\alias{coerce,SDFset,list-method}
\alias{coerce,SDFset,SDF-method}
\alias{coerce,SDFset,SDFstr-method}
\alias{datablock,SDFset-method}
\alias{datablocktag,SDFset-method}
\alias{header,SDFset-method}
\alias{length,SDFset-method}
\alias{plot,SDFset-method}
\alias{sdfid,SDFset-method}
\alias{SDFset2list,SDFset-method}
\alias{SDFset2SDF,SDFset-method}
\alias{SDFset2SDF<-,SDFset-method}
\alias{show,SDFset-method}
\alias{view,SDFset-method}
\alias{SDFset}

\title{Class "SDFset"}
\description{
List-like container for storing one or many objects of class \code{SDF} each containing the structure definition information of molecules provided by an SD/MOL file. The \code{SDFset} is the most important class in the ChemmmineR package for accessing and manipulating information stored in SD files.
}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("SDFset", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{SDF}:}{Object of class \code{"list"} storing \code{SDF} components }
    \item{\code{ID}:}{Object of class \code{"character"} storing compound identifiers }
  }
}
\section{Methods}{
  \describe{
    \item{[}{\code{signature(x = "SDFset")}: subsetting of class with bracket operator }
    \item{[[}{\code{signature(x = "SDFset")}: returns single component as \code{SDF} object }
    \item{[[<-}{\code{signature(x = "SDFset")}: replacement method for single \code{SDF} component }
    \item{[<-}{\code{signature(x = "SDFset")}: replacement method for several \code{SDF} components }
    \item{atomblock}{\code{signature(x = "SDFset")}: returns all atom blocks as list }
    \item{atomcount}{\code{signature(x = "SDFset")}: returns all atom frequencies as list }
    \item{bondblock}{\code{signature(x = "SDFset")}: returns all bond blocks as list }
    \item{obmol}{\code{signature(x = "SDFset")}: returns pointers to OBMol objects as a vector }
    \item{c}{\code{signature(x = "SDFset")}: concatenates two \code{SDFset} containers }
    \item{cid}{\code{signature(x = "SDFset")}: returns all compound identifiers from ID slot }
    \item{header<-}{\code{signature(x = "SDFset")}: replacement method for header block }
    \item{atomblock<-}{\code{signature(x = "SDFset")}: replacement method for atom block }
    \item{bondblock<-}{\code{signature(x = "SDFset")}: replacement method for bond block }
    \item{datablock<-}{\code{signature(x = "SDFset")}: replacement method for data block }
    \item{coerce}{\code{signature(from = "list", to = "SDFset")}: \code{as(list, "SDFset")} }
    \item{coerce}{\code{signature(from = "SDF", to = "SDFset")}: \code{as(sdf, "SDFset")} }
    \item{coerce}{\code{signature(from = "SDFset", to = "list")}: \code{as(sdfset, "list")} }
    \item{coerce}{\code{signature(from = "SDFset", to = "SDF")}: \code{as(sdfset, "SDF")} }
    \item{coerce}{\code{signature(from = "SDFset", to = "SDFstr")}: \code{as(sdfset, "SDFstr")} }
    \item{coerce}{\code{signature(from = "SDFstr", to = "SDFset")}: \code{as(sdfstr, "SDFset")} }
    \item{datablock}{\code{signature(x = "SDFset")}: returns all data blocks as list }
    \item{datablocktag}{\code{signature(x = "SDFset")}: returns all data blocks as named as list with subsetting support }
    \item{header}{\code{signature(x = "SDFset")}: returns all header blocks as list }
    \item{length}{\code{signature(x = "SDFset")}: returns number of entries stored in object }
    \item{plot}{\code{signature(x = "SDFset")}: plots one or many molecule structures from \code{SDFset} object }
    \item{sdfid}{\code{signature(x = "SDFset")}: returns molecule ID field from header block }
    \item{SDFset2list}{\code{signature(x = "SDFset")}: returns \code{SDFset} object as \code{list} }
    \item{SDFset2SDF}{\code{signature(x = "SDFset")}: returns \code{SDFset} object as \code{list} with \code{SDF} components}
    \item{SDFset2SDF<-}{\code{signature(x = "SDFset")}: replacement method for \code{SDFset} component in \code{SDFset} using accessor method }
    \item{show}{\code{signature(object = "SDFset")}: prints summary of \code{SDFset} }
    \item{view}{\code{signature(x = "SDFset")}: prints extended summary of \code{SDFset} }
    \item{SDFset}{\code{SDFset(SDF, ID)}: interface to \code{SDFset} constructor}
	 }
}
\references{
SDF format definition: http://www.symyx.com/downloads/public/ctfile/ctfile.jsp
}
\author{
Thomas Girke
}

\seealso{
Related classes: SDF, SDFstr, AP, APset

Import function: read.SDFset("some_SDF_file") 

Export function: write.SDF(sdfset, "some_file.sdf")
}
\examples{
showClass("SDFset")

## Instances of SDFset class
data(sdfsample); sdfset <- sdfsample
sdfset; view(sdfset[1:4])
sdfset[[1]]

## Import and store SD File in SDFset container
# sdfset <- read.SDFset("some_SDF_file")

## Miscellaneous accessor methods
header(sdfset[1:4])
atomblock(sdfset[1:4])
atomcount(sdfset[1:4])
bondblock(sdfset[1:4])
datablock(sdfset[1:4])

## Assigning compound IDs and keeping them unique
cid(sdfset); sdfid(sdfset)
unique_ids <- makeUnique(sdfid(sdfset))
cid(sdfset) <- unique_ids

## Convert data block to matrix
blockmatrix <- datablock2ma(datablocklist=datablock(sdfset)) # Converts data block to matrix  
numchar <- splitNumChar(blockmatrix=blockmatrix) # Splits to numeric and character matrix
numchar[[1]][1:4,]; numchar[[2]][1:4,]

## Compute atom frequency matrix, molecular weight and formula
propma <- data.frame(MF=MF(sdfset), MW=MW(sdfset), atomcountMA(sdfset))
propma[1:4, ]

## Assign matrix data to data block
datablock(sdfset) <- propma 
view(sdfset[1:4])

## String Searching in SDFset
grepSDFset("650001", sdfset, field="datablock", mode="subset") # To return index, set mode="index")

## Export SDFset to SD file
# write.SDF(sdfset[1:4], file="sub.sdf", sig=TRUE)

## Plot molecule structure of SDF 
plot(sdfset[1:4]) # plots to R graphics device
# sdf.visualize(sdfset[1:4]) # viewing in browser

}
\keyword{classes}

\name{read.SDFset}
\alias{read.SDFset}
\title{
SD file to \code{SDFset} 
}
\description{
Imports one or many molecules from an SD/MOL file and stores it in an \code{SDFset} container. 
Supports both the V2000 and V3000 formats.
}
\usage{
read.SDFset(sdfstr = sdfstr,skipErrors=FALSE, ...)
}
\arguments{
  \item{sdfstr}{
		path/name to an SD file; alternatively an \code{SDFstr} object can be provided
  }
  \item{skipErrors}{
	  If true, molecules which fail to parse will be removed from the output. Otherwise
	  and error will be thrown and processing of the input will stop. 
  }
  \item{\dots}{
		option to pass on additional arguments. Possible arguments are: 

		datablock: true or false, whether to include the data fields or not.
		Defaults to TRUE.

		tail2vec: true or false, whether to return data feilds as a vector or not. 
		Defaults to TRUE.

		extendedAttributes: true or false, whether to parse the extended attributes available on the
		V3000 format. Defaults to FALSE. When set to TRUE, the resulting objects will be of type
		ExtSDF, which is a sub-class of SDF. However, some functions, such as plot, may not work with
		this type right now. 

	}
}
\details{
...
}
\value{
\item{SDFset}{ for details see ?"SDFset-class"}
}
\references{
SDF format defintion: http://www.symyx.com/downloads/public/ctfile/ctfile.jsp
}
\author{
Thomas Girke
}

\seealso{
Functions: \code{read.SDFstr}
}
\examples{
## Write instance of SDFset class to SD file
data(sdfsample); sdfset <- sdfsample
# write.SDF(sdfset[1:4], file="sub.sdf")

## Import SD file 
# read.SDFset("sub.sdf")

## Pass on SDFstr object
sdfstr <- as(sdfset, "SDFstr")
read.SDFset(sdfstr) 
}
\keyword{ utilities }

\name{read.SDFstr}
\alias{read.SDFstr}
\title{
SD file to \code{SDFstr} 
}
\description{
Imports one or many molecules from an SD/MOL file and stores it in an \code{SDFstr} container. 
}
\usage{
read.SDFstr(sdfstr)
}
\arguments{
  \item{sdfstr}{
path/name to an SD file; alternatively one can pass on a \code{character} vector containing lines of an SD file
}
}
\details{
...
}
\value{
\item{SDFstr}{ for details see ?"SDFstr-class"}
}
\references{
SDF format defintion: http://www.symyx.com/downloads/public/ctfile/ctfile.jsp
}
\author{
Thomas Girke
}

\seealso{
Functions: \code{read.SDFset}
}
\examples{
## Write instance of SDFstr class to SD file
data(sdfsample); sdfset <- sdfsample
sdfstr <- as(sdfset, "SDFstr")
# write.SDF(sdfset[1:4], file="sub.sdf")

## Import SD file 
# read.SDFstr("sub.sdf")

## Pass on SDFstr object
sdfstr <- as(sdfset, "SDFstr")
read.SDFset(sdfstr) 
}

\keyword{ utilities }

\name{cmp.parse}
\alias{cmp.parse}
\title{Parse an SDF file and compute descriptors for all compounds}
\description{
'cmp.parse' will take a SDF file, parse all the compounds
encoded, compute their atom-pair descriptors, and return the descriptors as a
list. The list contains two names, 'descdb' and 'cids'. 'descdb' is a vector of
descriptors, and 'cids' is a list of names of compounds found in the SDF file.
The returned list is usually used to a database, against which similarity
search can be performed using the 'search' function. These two functions will
parse all compounds in the SDF file. To parse a single compound, use
'cmp.parse1' instead.
}
\usage{
%cmp.parse(filename, quiet=FALSE, type="normal", dbname="")
cmp.parse(filename)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{filename}{The file name of the SDF file}
  %\item{quiet}{Whether to silent the output of progress information}
  %\item{type}{Database type. Use the default value, or set to 'file-backed'
  %when the library is large. See below.}
  %\item{dbname}{Datbase name. Only used when the type is set to 'file-backed'.}
}
\details{
	The 'filename' can be a local file or an URL. It is interactive, and
	will display the parsing progress. Since the parsing will also compute
	of atom-pair descriptors, it is time consuming. You will be reminded to
	save the parsing result for future use at the end of parsing.

	'type' is either set to the default value 'normal' or 'file-backed'.
	When set to 'file-backed', the parsing work will be delegated to a
	separate package called 'ChemmineRpp', and the database will be stored
	in a file instead of in the primary memory. Therefore, 'file-backed'
	mode can handle larger compound libraries. In 'file-backed' mode,
	'dbname' will be used to name the database file. A suffix '.cdb' will
	be appended to the given name.

	The type of the database is transparent to other part of the package.
	For example, calling 'cmp.search' against a database in 'file-backed'
	mode will cause the package to load the descriptors from the database
	file progressively.
}
\value{
	Return a list that can be used as the database against which similarity
	search can be performed. The 'search' and 'cmp.cluster' functions both
	expect a database returned by 'cmp.parse'.
  \item{descdb}{A vector containing the descriptors for all the compounds.}
  \item{cids}{Compound ID information found in the SDF file. It is the first
	  line of SDF of a compound.}
}
\references{Chen X and Reynolds CH (2002). "Performance of similarity measures
in 2D fragment-based similarity searching: comparison of structural descriptors
and similarity coefficients", in \emph{J Chem Inf Comput Sci}.}
\author{Y. Eddie Cao, Li-Chang Cheng}

\seealso{\code{\link{cmp.parse1}}, \code{\link{cmp.search}},
	\code{\link{cmp.cluster}},
\code{\link{cmp.similarity}}}
\examples{
## Load sample SD file
# data(sdfsample); sdfset <- sdfsample

## Generate atom pair descriptor database for searching
# apset <- sdf2ap(sdfset) 

## Loads same atom pair sample data set provided by library
data(apset) 
db <- apset
# (optinally) save the db for future use
save(db, file="db.rda", compress=TRUE)
# ...
# later, in a separate session, you can load it back:
load("db.rda")
}
\keyword{utilities}

\name{atomsubset}
\alias{atomsubset}
\title{
Subset SDF/SDFset Objects by Atom Index to Obtain Substructure
}
\description{
Function to obtain a substructure from SDF/SDFset objects by providing a row index for the atom block in an SDF referencing the atoms of interest. The function subsets both the atom and bond block(s) accordingly.
}
\usage{
atomsubset(x, atomrows, type="new", datablock = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{
object of class \code{SDFset} or \code{SDF}
}
  \item{atomrows}{
The argument \code{atomrows} can be assigned a numeric index referencing the atoms in the atom block of \code{x}. If \code{x} is of class \code{SDF}, the index needs to be provided as \code{vector}. If \code{x} is of class \code{SDFset}, the same number of index vectors as molecules stored in \code{x} need to be passed on in a list with component names identical to the component (molecule) names stored in \code{x}.  
}
  \item{type}{
The argument \code{type="new"} assigns new atom numbers to a subsetted SDF, while \code{type="old"} maintains the numbering of the source SDF. 
}
  \item{datablock}{
By default the data block(s) in \code{SDF/SDFset} objects are removed after atom subsetting. The setting \code{datablock=TRUE} will maintain the data block information in the subsetted result.
}
}
\details{
...
}
\value{
object of class \code{SDF} or \code{SDFset}
}
\references{
...
}
\author{
Thomas Girke
}
\seealso{
...
}
\examples{
## Instance of SDFset class
data(sdfsample)
sdfset <- sdfsample

## Subset one or more molecules with atom index(es) to obtain substructure(s)
atomsubset(sdfset[[1]], atomrows=1:18) 
indexlist <- list(1:18, 1:12)
names(indexlist) <- cid(sdfset[1:2])
atomsubset(sdfset[1:2], atomrows=indexlist)
}
\keyword{ utilities }

\name{bufferLines}
\alias{bufferLines}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
	Buffer File Input
}
\description{
	Buffer the input of files to increase efficiency
}
\usage{
bufferLines(fh, batchSize, lineProcessor)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{fh}{
	  file handle
	}
  \item{batchSize}{
		How many lines to read in each batch
	}
  \item{lineProcessor}{
		Each batch of lines will be passed to this function for processing
	}
}
\value{
	No return value
}
\author{
	Kevin Horan
}

\examples{

	\dontrun{
		fh = file("filename")
		bufferLines(fh,100,function(lines) {
			message("found ",length(lines)," lines")
		})
	}
}

\name{header}
\alias{header}
\alias{header<-}
\alias{header-methods}
\title{
Return header block
}
\description{
Returns header block(s) from an object of class SDF or SDFset.
}
\usage{
header(x)
}
\arguments{
  \item{x}{
object of class \code{SDF} or \code{SDFset}
}
}
\details{
...
}
\value{
named \code{character} vector if \code{SDF} is provided or \code{list} of named \code{character} vectors if \code{SDFset} is provided
}
\references{
...
}
\author{
Thomas Girke
}
\seealso{
\code{atomblock}, \code{atomcount}, \code{bondblock}, \code{datablock}, \code{cid}, \code{sdfid} 
}
\examples{
## SDF/SDFset instances
data(sdfsample)
sdfset <- sdfsample
sdf <- sdfset[[1]]

## Extract header block
header(sdf)
header(sdfset[1:4])

## Replacement methods
sdfset[[1]][[1]][1] <- "test"
sdfset[[1]]
header(sdfset)[1] <- header(sdfset[2])  
view(sdfset[1:2])
}

\keyword{ utilities }

\name{getCompoundNames}
\alias{getCompoundNames}
\title{
	Get Compound Names
}
\description{
	Fetch the names of the given compound ids, if they exist
}
\usage{
getCompoundNames(conn, compoundIds, keepOrder = FALSE, allowMissing = FALSE)
}
\arguments{
  \item{conn}{
	  A database connection object, such as is returned by \code{\link{initDb}}.
   }
  \item{compoundIds}{
     A vector of compound ids.
   }
  \item{keepOrder}{
     If true, the order of the output compound ids will be the same as the 
     input names. This imposes a performance hit that can be significant for
     large datasets, thus it should be left FALSE unless needed.
   }
	\item{allowMissing}{
		When this is false an error will be raised when compound ids queried were not found in the database. 
		If true, just those that are found will be returned with no error or warning.
	}

}
\value{
   Returns a vector of compound names.The rownames will be the compound ids. Compound ids
   not found, or for which a name is not defined, will be represented as NA.
}
\author{
   Kevin Horan
}
\examples{
   #create and initialize a new SQLite database
   conn = initDb("test2.db")

	data(sdfsample)

	#just load the data with no features or descriptors
	ids=loadSdf(conn,sdfsample)

   getCompoundNames(conn,ids[1:3])
	unlink("test3.db")

}

\name{propOB}
\alias{propOB}
\title{
	Properties from OpenBabel
}
\description{
	 Generates the following descriptors: 
	 "cansmi", "cansmiNS", "formula", "HBA1", "HBA2", "HBD", "InChI", 
	 "InChIKey", "logP", "MR", "MW", "nF","title", "TPSA".
}
\usage{
propOB(sdfSet)
}
\arguments{
  \item{sdfSet}{
	  An SDFset object.
	}
}
\value{
	A data frame with a row for each compound in the given data frame and a named
	column for each property.
}
\author{
	Kevin Horan
}

\examples{
	\dontrun{
		library(ChemmineR)
		data(sdfsample)
		propOB(sdfsample)
	}
}

\name{groups}
\alias{groups}
\title{
Enumeration of Functional Groups and Atom Neighbors
}
\description{
Returns frequency information of functional groups in molecules provided as \code{SDF} or \code{SDFset} objects. Alternatively, the function can return for each atom its atom/bond neighbor information.
}
\usage{
groups(x, groups = "fctgroup", type = "countMA")
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{
\code{SDF} or \code{SDFset} containers
}
  \item{groups}{
if \code{groups="fctgroup"}, frequencies of functional groups are returned; if \code{groups="neighbors"}, atom/bond neighbor information is returned. 
}
  \item{type}{
if \code{type="all"}, then the complete neighbor information is generated for each atom in a molecule; if \code{type="count"}, the neighbors are enumerated in a list and if \code{type="countMA"}, then the counts of atom neighbors or functional groups are returned in a frequency matrix. 
}
}
\details{
At this point this function is in an experimental stage.
}
\value{
...
}
\references{
...
}
\author{
Thomas Girke
}
\seealso{
...
}
\examples{
## Instances of SDFset class
data(sdfsample)
sdfset <- sdfsample

## Enumerate functional groups
groups(sdfset[1:20], groups="fctgroup", type="countMA") 

## Report atom/bond neighbors
groups(sdfset[1:4], groups="neighbors", type="countMA")
groups(sdfset[1:4], groups="neighbors", type="count")
groups(sdfset[1:4], groups="neighbors", type="all")
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ utilities }

\name{grepSDFset}
\alias{grepSDFset}
\title{
String search in \code{SDFset}
}
\description{
Convenience grep function for string searching in \code{SDFset} containers.
}
\usage{
grepSDFset(pattern, x, field = "datablock", mode = "subset", ignore.case = TRUE, ...)
}
\arguments{
  \item{pattern}{
search pattern
}
  \item{x}{
\code{SDFset}
}
  \item{field}{ delimits search to specific section in SDF; can be
   \code{header}, \code{atomblock}, \code{bondblock} or \code{datablock} 
}
  \item{mode}{
if \code{mode = "index"}, then the match positions are returned as vector; if \code{mode = "subset"}, a 
\code{list} with \code{SDF} components is returned where every entry has at least one query match
}
  \item{ignore.case}{
\code{TRUE} turns off case sensitivity 
}
  \item{\dots}{
option to pass on additional arguments
}
}
\details{
...
}
\value{
\item{numeric}{ index vector where the name field contains the component positions in the \code{SDFset} and the values the row positions in each sub-component. }
\item{list}{ if \code{mode = "subset"}}
}
\references{
...
}
\author{
Thomas Girke
}

\seealso{
Class: \code{SDFset}
}
\examples{

## Instances of SDFset class
data(sdfsample)
sdfset <- sdfsample

## String Searching in SDFset
q <- grepSDFset("65000", sdfset, field="datablock", mode="subset") 
as(q, "SDFset")
grepSDFset("65000", sdfset, field="datablock", mode="index") 

}

\keyword{ utilities }

\name{fromNNMatrix}
\alias{fromNNMatrix}
\title{
	From Nearest Neighbor Matrix
}
\description{
	Converts a nearest neighbor matrix into a list that can be used with the jarvisPatrick function.
}
\usage{
fromNNMatrix(data, names = rownames(data))
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{data}{
		A matrix containing integer valued indexes which represent items to be clustered. The index values contained in
		the matrix must be smaller than the number of rows in the matrix.
		Each row in the matrix represents one item and the columns are the nearest neighbors of that item.
	}
  \item{names}{
	  The names for each row. The rownames of data will be used if not given.
	}
}
\value{
	A list containing the slots "indexes" and "names".
}
\author{
	Kevin Horan
}

\seealso{
	\code{\link{jarvisPatrick}}
}
\examples{


	data(apset)

	nn = nearestNeighbors(apset,cutoff=0.6)
	nnMatrix = nn$indexes

	cl = jarvisPatrick(fromNNMatrix(nnMatrix),k=2)
}

\name{generate3DCoords}
\alias{generate3DCoords}
\title{
	Generate 3D Coords
}
\description{
	Uses Open Babel to compute 3D coordinates given an SDFset with
	only 2D coordinates.
}
\usage{
generate3DCoords(sdf)
}
\arguments{
  \item{sdf}{
	  Any sdfset object.
	}
}
\value{
	A new SDFset in which all compounds have 3D coordinates.
}
\author{
	Kevin Horan
}

\examples{
	\dontrun{
		data(sdfsample)
		sdf3D = generate3DCoords(sdfsample[1])
	}
}

\name{plotStruc}
\alias{plotStruc}
\alias{plot}
\title{
Plot compound structures
}
\description{
Plots compound structure(s) for molecules stored in SDF and SDFset containers.
}
\usage{
## Convenience plot method
# plot(x, griddim, print_cid=cid(x), print=TRUE, ...)

## Less important for user 
plotStruc(sdf, atomcex = 1.2, atomnum = FALSE, no_print_atoms = c("C"),
          noHbonds = TRUE, bondspacer = 0.12, colbonds=NULL, bondcol="red",
			 regenCoords=FALSE, ...)
}

\arguments{
  \item{sdf}{
Object of class \code{SDF} 
}
  \item{atomcex}{
Font size for atom labels
}
  \item{atomnum}{
If \code{TRUE}, then the atom numbers are included in the plot. They are the position numbers of each atom in the atom block of an SDF.
}
  \item{no_print_atoms}{
Excludes specified atoms from being plotted.
}
  \item{noHbonds}{
If \code{TRUE}, then the C-hydrogens and their bonds - explicitly defined in an SDF - are excluded from the plot.
}
  \item{bondspacer}{
Numeric value specifying the plotting distance for double/triple bonds.
}
  \item{colbonds}{
Highlighting of subgraphs in main structure by providing a numeric vector of atom numbers, here position index in atom block. 
The bonds of connected atoms will be plotted in the color provided under \code{bondcol}.
}
  \item{bondcol}{
A character or numeric vector of length one to specify the color to use for substructure highlighting under \code{colbonds}.

}
	\item{regenCoords}{
		If ChemmineOB is installed and this option is TRUE, then Open
		Babel will be used to re-generate the 2D coords for each
		compound before plotting it. This often results in a nicer
		layout. If you want to save the results of the coord
		re-generation, call the \code{\link{regenerateCoords}} function
		first yourself and save the result.
	}
\item{\dots}{
Arguments to be passed to/from other methods.
}
}
\details{
The function \code{plotStruc} depicts a single 2D compound structure based
on the XY-coordinates specified in the atom block of an SDF. The generic method
\code{plot} can be used as a convenient shorthand to plot one or many
structures at once. Both functions depend on the availability of the
XY-coordinates in the source SD file and only 2D (not 3D) representations are plotted
correctly. 

Additional arguments that can only be passed on to the \code{plot} function when supplied with
an SDFset object:

   \code{griddim}: numeric vector of length two to define the dimensions for arranging several structures in one plot. 
   
   \code{print_cid}: character vector for printing custom compound labels. Default is \code{print_cid=cid(sdfset)}.

   \code{print}: if \code{print=TRUE}, then a summary of the SDF content for each supplied compound is printed to the screen.
          This behavior is turned off with \code{print=TRUE}.
} 
\value{
Prints summary of SDF/SDFset to screen and plots their structures to graphics device.
}
\references{
...
}
\author{
Thomas Girke
}
\note{
The compound depictions created by this function are not as pretty as the structure representations generated with the \code{sdf.visualize} function. This will be improved in the future. 
}

\seealso{
\code{sdf.visualize}
}
\examples{
## Import SDFset sample set
data(sdfsample)
(sdfset <- sdfsample)

## Plot single compound structure
plotStruc(sdfset[[1]])

## Plot several compounds structures
plot(sdfset[1:4])

## Highlighting substructures (here all rings)
myrings <- as.numeric(gsub(".*_", "", unique(unlist(rings(sdfset[1])))))
plot(sdfset[1], colbonds=myrings) 

## Customize plot 
plot(sdfset[1:4], griddim=c(2,2), print_cid=letters[1:4], print=FALSE, noHbonds=FALSE)
}

\keyword{ aplot  }
\keyword{ utilities }

\name{launchCMTool}
\alias{launchCMTool}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Launch a Tool on ChemMine Tools
}
\description{
Accepts a tool name (string), input options, and input data to launch a remote
web tool on the ChemMine Tools website.
}
\usage{
launchCMTool(tool_name, input = "", ...)
}
\arguments{
  \item{tool_name}{
A tool name matching verbatim an existing tool name as listed by \code{listCMTools}.
}
  \item{input}{
Input data in the format required for this tool as listed by \code{listCMTools}.
}
  \item{\dots}{
Additional options as mentioned by running \code{toolDetails} on the tool specified.
}
}
\details{
By running the function \code{toolDetails} on a tool of choice, you can see
a pre-generated example function call for this tool.
}
\value{
\item{jobToken}{ for details see ?"jobToken-class"}
}
\references{
See ChemMine Tools at \url{http://chemmine.ucr.edu}.
}
\author{
Tyler William H Backman
}

\seealso{
Functions: \code{toolDetails}, \code{listCMTools}, \code{result}, \code{browseJob}, \code{status}
}
\examples{
\dontrun{
## list available tools
listCMTools()

## get detailed instructions on using a tool
toolDetails("Fingerprint Search")

## download compound 2244 from PubChem
job1 <- launchCMTool("pubchemID2SDF", 2244)

## check job status and download result
status(job1)
result1 <- result(job1)
}
}
\keyword{ utilities }

\name{jobToken-class}
\Rdversion{1.1}
\docType{class}
\alias{jobToken-class}
\alias{show,jobToken-method}

\title{Class \code{"jobToken"}}
\description{
Container for storing a reference to a remote job ran on the ChemMine Tools web server.
}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("jobToken", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{tool_name}:}{Object of class \code{"character"} }
    \item{\code{jobId}:}{Object of class \code{"character"} }
  }
}
\section{Methods}{
  \describe{
    \item{show}{\code{signature(object = "jobToken")}: check the status of a launched job }
	 }
}
\references{
See ChemMine Tools at \url{http://chemmine.ucr.edu}.
}
\author{
Tyler William H Backman
}

\seealso{
Functions: \code{launchCMTool}, \code{toolDetails}, \code{listCMTools}, \code{result}, \code{browseJob}, \code{status}
}
\examples{
showClass("jobToken")
\dontrun{
## launch a job on the server and obtain jobToken back
job1 <- launchCMTool("pubchemID2SDF", 2244)

## check status of the job
status(job1)

## obtain results
result1 <- result(job1)
result1
}
}
\keyword{classes}

\name{genParameters}
\alias{genParameters}
\title{
	Generate Parameters
}
\description{
	Generate statistics from a fingerprint database for use in caluclating z-scores, E-values, 
	and p-values later.
}
\usage{
	genParameters(fpset, similarity = fpSim, sampleFraction = 1, ...)
}
\arguments{
  \item{fpset}{
	  The database of fingerprints. Needs to be in the format expected by the similarity function.
	  For the default similarity function, this would be an \code{FPset}.
	}
  \item{similarity}{
	  A function to compute the similarity between two fingerprints. The first argument should be 
	  a single query and the second argument should be a set of fingerprints.
	}
  \item{sampleFraction}{
		The fraction of all pairs to use for estimating parameters. See Details section.
	}
  \item{\dots}{
		Extra parameters will be passed on to the similarity function.
	}
}
\details{
	A beta function will be fit to the distribution of similarity scores
	produced by the given similarity function. By default, all pairwise similarities will be
	computed. Since this can be expensive for large databases, one can also sample pairs to use.
	This can be done by setting \code{sampleFraction} to the fraction of all pairwise similarities to
	use. For example, for a database of 100 fingerprints, there are 10,000 pairs. Setting
	\code{sampleFraction} to 0.5 will result in only 5,000 pairs being used to estimate the
	parameters.

	Parameters are conditioned on the number of set bits. This function therefore groups
	fingerprints by the number of set bits they have and then estimates parameters for each group.
	A set of global parameters is also estimated and returned for use in cases where there was not
	enough data to estimate the parameters for a particular number of set bits.

}
\value{
	A data frame with  the following columns:
	\item{count}{ The number of similarities used to estimate these parameters}
	\item{avg}{ the mean}
	\item{variance}{ the variance}
	\item{alpha}{ The alpha paramber of the Beta function}
	\item{beta}{ The beta parameter of the Beta function}

	There will be a row for each possible count of 1 bits. So for a database of 1024 bit
	fingerprints, there will be 1025 rows for the possible values of 0-1024 bits. There will also be one
	additional row at the end with the global parameters. This can be used for cases where there
	are no parameters estimated for the current query 1-bit count.
}
\references{
	Pierre Baldi and Ramzi Nasr, "When is Chemical Similarity Significant? The Statistical
		Distribution of Chemical Similarity Scores and Its Extreme Values"
		Journal of Chemical Information and Modeling 2010 50 (7), 1205-1222
}
\author{
	Kevin Horan
}
\seealso{
	\code{\link{fpSim}}
}
\examples{

	library(ChemmineR)
	data(apset)
	fpset=desc2fp(apset) #get a fingerprint database

	params = genParameters(fpset)
	scores = fpSim(fpset[[1]],fpset,parameters=params,top=10)
}
\keyword{evalue}
\keyword{pvalue}
\keyword{fingerprint}
\keyword{similarity}

\name{regenerateCoords}
\alias{regenerateCoords}
\title{
	Re-generate 2D Coordinates
}
\description{
	This uses Open Babel (requires ChemmineOB package) to re-generate
	the 2D coordinates of compounds. This often results in a 
	nicer layout of the compound when plotting.
}
\usage{
regenerateCoords(sdf)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sdf}{
	  A SDF or SDFset object whose coordinates will be re-generated.
}
}
\value{
	Either an SDF object if given an SDF, or else and SDFset.
}
\author{
	Kevin Horan
}

\seealso{
	\code{\link{plotStruc}}
}
\examples{
	\dontrun{
		data(sdfsample)
		prettySdfset = regenerateCoords(sdfsample[1:4])
	}

}

\name{SDFDataTable}
\alias{SDFDataTable}
\title{
	SDF Data Table
}
\description{
	Creates and HTML DataTable showing the compound image along with the fields 
	in the compound data block. Using a browser, this table can be filtered and paged,
	among other things.

	This uses the DT library to create the DataTable.
}
\usage{
	SDFDataTable(sdfset)
}
\arguments{
	\item{sdfset}{ An \code{SDFSet} object }
}
\value{
	Returns the result of the \code{datatable} function from the \code{DT} library.
	An HTML file can be created from this value by calling the \code{saveWidget} function
	on it.
}
\references{
	DT library: https://rstudio.github.io/DT/
	DataTables javascript library: https://datatables.net/
}
\author{
	Kevin Horan
}
\examples{
	\dontrun{ #depends on ChemmineOB
		library(ChemmineR)
		library(DT)
		data(sdfsample)

		# this will open a browser to display the result
		x=SDFDataTable(sdfsample[1:3]) 

		# if no GUI is available or you want to save the HTML result:
		saveWidget(x,"output.html")
	}

	
}
\keyword{datatable,sdfset,compounds,display}

\name{byCluster}
\alias{byCluster}
\title{
	By Cluster
}
\description{
	Re-organize a vector valued clustering into an list which groups cluster members together
}
\usage{
byCluster(clustering, excludeSingletons = TRUE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{clustering}{
		A named vector in which the names are cluster members and the values are cluster labels. This
		is format output by jarvisPatrick.
	}
  \item{excludeSingletons}{
	  If true only clusters with more than 1 member will be in the output, otherwise all clusters will be used.
	}
}
\value{
	A list with a slot for each cluster. Each slot of the list is a vector containing the cluster members.
}
\author{
	Kevin Horan
}


\seealso{
	\code{\link{jarvisPatrick}}
}
\examples{
	data(apset)
	cl = jarvisPatrick(nearestNeighbors(apset,cutoff=0.6),k=2)
	print(byCluster(cl))
}

\name{AP-class}
\Rdversion{1.1}
\docType{class}
\alias{AP-class}
\alias{ap,AP-method}
\alias{show,AP-method}

\title{Class "AP"}
\description{
Container for storing the atom pair descriptors of a single compound as numeric vector. The atom pairs are used as structural similarity measures and for compound similarity searching.
}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("AP", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{AP}:}{Object of class \code{"numeric"} }
  }
}
\section{Methods}{
  \describe{
    \item{ap}{\code{signature(x = "AP")}: returns atom pairs as numeric vector }
    \item{coerce}{\code{signature(from = "APset", to = "AP")}: \code{as(apset, "AP")} }
    \item{show}{\code{signature(object = "AP")}: prints summary of \code{AP} }
	 }
}
\references{
Chen X and Reynolds CH (2002). "Performance of similarity measures
in 2D fragment-based similarity searching: comparison of structural descriptors
and similarity coefficients", J Chem Inf Comput Sci.
}

\author{
Thomas Girke
}
\seealso{
Related classes: SDF, SDFset, SDFstr, APset. 

Functions: \code{SDF2apcmp}, \code{apset2descdb}, \code{cmp.search}, \code{cmp.similarity}
}
\examples{
showClass("AP")

## Instance of SDFset class
data(sdfsample)
sdfset <- sdfsample[1:50]
sdf <- sdfsample[[1]]

## Compute atom pair library
ap <- sdf2ap(sdf)
(apset <- sdf2ap(sdfset))
view(apset[1:4])

## Return main components of APset object
cid(apset[1:4]) # compound IDs
ap(apset[1:4]) # atom pair descriptors

## Return atom pairs in human readable format
db.explain(apset[1]) 

## Coerce APset to other objects 
apset2descdb(apset) # returns old list-style AP database
tmp <- as(apset, "list") # returns list
as(tmp, "APset") # converst list back to APset

## Compound similarity searching with APset
cmp.search(apset, apset[1], type=3, cutoff=0.2) 
plot(sdfset[names(cmp.search(apset, apset[6], type=2, cutoff=0.4))])

## Identify compounds with identical AP sets 
cmp.duplicated(apset, type=2)

## Structure similarity clustering 
cmp.cluster(db=apset, cutoff = c(0.65, 0.5))[1:20,]

}

\keyword{classes}

\name{toolDetails}
\alias{toolDetails}
\title{
Detailed instructions for each ChemMine Tools web tool
}
\description{
Connects to the ChemMine Tools web service, and provides detailed instructions and example
function calls for any tool.
}
\usage{
toolDetails(tool_name)
}
\arguments{
  \item{tool_name}{
A tool name matching verbatim an existing tool name as listed by \code{listCMTools}.
}
}
\details{
Prints instructions to console.
}
\references{
See ChemMine Tools at \url{http://chemmine.ucr.edu}.
}
\author{
Tyler William H Backman
}

\seealso{
Functions: \code{launchCMTool}, \code{listCMTools}, \code{result}, \code{browseJob}, \code{status}
}
\examples{
\dontrun{
## list available tools
listCMTools()

## get detailed instructions on using a tool
toolDetails("Fingerprint Search")

## download compound 2244 from PubChem
job1 <- launchCMTool("pubchemID2SDF", 2244)

## check job status and download result
status(job1)
result1 <- result(job1)
}
}
\keyword{ utilities }

\name{FP-class}
\Rdversion{1.1}
\docType{class}
\alias{FP-class}
\alias{as.character,FP-method}
\alias{as.numeric,FP-method}
\alias{as.vector,FP-method}
%\alias{coerce,FPset,FP-method}
\alias{coerce,numeric,FP-method}
\alias{show,FP-method}
\alias{c,FP-method}
\alias{fold,FP-method}
\alias{foldCount,FP-method}
\alias{fptype,FP-method}
\alias{numBits,FP-method}

\title{Class \code{"FP"}}
\description{
Container for storing the fingerprint of a single compound. The \code{FPset} class is used for storing the fingerprints of many compounds.
}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("FP", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{fp}:}{Object of class \code{"numeric"} }
    \item{\code{foldCount}:}{Object of class \code{"numeric"} }
    \item{\code{type}:}{Object of class \code{"character"} }
  }
}
\section{Methods}{
  \describe{
    \item{as.character}{\code{signature(x = "FP")}: returns fingerprint as character string  }
    \item{as.numeric}{\code{signature(x = "FP")}: returns fingerprint as numeric vector }
    \item{as.vector}{\code{signature(x = "FP")}: returns fingerprint as numeric vector }
    \item{coerce}{\code{signature(from = "FPset", to = "FP")}: coerce \code{FPset} component to list with many \code{FP} objects }
    \item{coerce}{\code{signature(from = "numeric", to = "FP")}: construct \code{FP} object from numeric vector }
    \item{show}{\code{signature(object = "FP")}: prints summary of \code{FP} }
    \item{c}{\code{signature(x = "FP")}: concatenates any number of \code{FP} objects}
    \item{fold}{\code{signature(x = "FP")}: fold fingerprint in half }
    \item{foldCount}{\code{signature(x = "FP")}: number of times this object has been folded}
    \item{fptype}{\code{signature(x = "FP")}: the type of this fingerprint }
    \item{numBits}{\code{signature(x = "FP")}: the number of bits in this fingerprint}
	 }
}
\references{
Chen X and Reynolds CH (2002). "Performance of similarity measures
in 2D fragment-based similarity searching: comparison of structural descriptors
and similarity coefficients", in J Chem Inf Comput Sci.
}
\author{
Thomas Girke
}
\seealso{
Related classes: SDF, SDFset, SDFstr, AP, APset, FPset. 
}
\examples{
showClass("FP")

## Instance of FP class
data(apset)
fpset <- desc2fp(apset)
(fp <- fpset[[1]])

## Class usage
fpc <- as.character(fp)
fpn <- as.numeric(fp)
as(fpn, "FP")
as(fpset[1:4], "FP") 

}
\keyword{classes}

\name{apset}
\alias{apset}
\docType{data}
\title{
Atom pairs stored in \code{APset} object
}
\description{
Atom pairs for 100 molecules stored in \code{sdfsample}.
}
\usage{data(apset)}
\format{
  Object of class \code{apset}
}
\details{
Object stores atom pairs of 100 molecules.
}
\source{
\code{apset <- sdf2ap(sdfsample)}
}
\references{
Chen X and Reynolds CH (2002). "Performance of similarity measures
in 2D fragment-based similarity searching: comparison of structural descriptors
and similarity coefficients", J Chem Inf Comput Sci.
}
\examples{
data(apset)
apset[1:4]
view(apset[1:4])
}
\keyword{datasets}

\name{fp2bit}
\alias{fp2bit}
\title{
Convert base 64 fingerprints to binary
}
\description{
The function converts the base 64 encoded PubChem fingerprints to a binary \code{matrix} or a \code{character} vector. If applied to a \code{SDFset} object, then its data block needs to contain the PubChem fingerprint information.
}
\usage{
fp2bit(x, type = 3, fptag = "PUBCHEM_CACTVS_SUBSKEYS")
}
\arguments{
  \item{x}{
Object of class \code{SDFset}, \code{matrix} or \code{character}
}
  \item{type}{
If set to \code{1}, the results are returned as binary \code{matrix}. If set to \code{2}, the results are returned as \code{character} strings in a named \emph{vector}. If set to \code{3} (default), the results are returned as \code{FPset} object. 
}
  \item{fptag}{
Name tag in SDF data block where the PubChem fingerprints are stored. Default is set to "PUBCHEM_CACTVS_SUBSKEYS".
}
}
\details{
...
}
\value{
\code{matrix}, \code{character} or \code{FPset}
}
\references{
See PubChem fingerprint specification at: ftp://ftp.ncbi.nih.gov/pubchem/specifications/pubchem_fingerprints.txt
}
\author{
Thomas Girke
}
\seealso{
Functions: \code{fpSim}
}
\examples{
## Load PubChem SDFset sample
data(sdfsample); sdfset <- sdfsample
cid(sdfset) <- sdfid(sdfset)

## Convert base 64 encoded fingerprints to FPset object
fpset <- fp2bit(sdfset)

## Pairwise compound structure comparisons
fpSim(fpset[1], fpset[2]) 

## Structure similarity searching: x is query and y is fingerprint database
fpSim(x=fpset[1], y=fpset, method="Tanimoto", cutoff=0, top="all") 

## Compute fingerprint based Tanimoto similarity matrix 
simMA <- sapply(cid(fpset), function(x) fpSim(x=fpset[x], fpset, sorted=FALSE)) 

## Hierarchical clustering with simMA as input
hc <- hclust(as.dist(1-simMA), method="single")

## Plot hierarchical clustering tree
plot(as.dendrogram(hc), edgePar=list(col=4, lwd=2), horiz=TRUE)
}
\keyword{utilities}

\name{sdf.subset}
\alias{sdf.subset}
\title{Subset a SDF and return SDF segements for selected compounds}
\description{
'sdf.subset' will take a descriptor database generated by 'cmp.parse' and an
array of indices, and return an SDF string consisting of SDFs for compounds
corresponding to that list of indices. The returned value is a character
string.
}
\usage{
sdf.subset(db, cmps)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{db}{The database generated by 'cmp.parse'}
  \item{cmps}{An array of indecies that correspond to a set of selected
	  compounds from the database}
}
\details{
	'sdf.subset' depends on information embedded in the descriptor database
	returned by 'cmp.parse'. It also relies on the availability of the
	original SDF where the database has been generated from.  Basically,
	when 'cmp.parse' parses the original SDF file, it will store the path
	of that SDF file as well as offset information for SDF segment in that
	file. Therefore, if the SDF file has been changed or deleted,
	'sdf.subset' cannot function properly.

	The result SDF will also have names added to compounds if they are not
	present in the original SDF.
}
\value{
	Return a character string whose content is the concatenation of SDFs
	for the selected compounds.
}

\seealso{\code{\link{cmp.parse}}, \code{\link{sdf.visualize}}}
\examples{
## Note: this functionality has become obsolete since the introduction of the 
## 'SDFset' and 'apset' S4 classes.

# load sample database from web
# db <- cmp.parse("http://bioweb.ucr.edu/ChemMineV2/static/example_db.sdf")
# select SDF for 1st and 2nd compound in that SDF
# sdf_segments <- sdf.subset(db, c(1, 2))
# now sdf_segments containt the 2 SDFs for those 2 compounds
}
\keyword{utilities}

\name{SMI-class}
\Rdversion{1.1}
\docType{class}
\alias{SMI-class}
\alias{as.character,SMI-method}
\alias{coerce,character,SMI-method}
\alias{show,SMI-method}

\title{Class \code{"SMI"}}
\description{
Container for storing the SMILES string of a single molecule.
}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("SMI", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{smiles}:}{Object of class \code{"character"} of length one}
  }
}
\section{Methods}{
  \describe{
    \item{as.character}{\code{signature(x = "SMI")}: returns content as character vector}
    \item{coerce}{\code{signature(from = "character", to = "SMI")}: \code{as(smi, "SMI")}}
    \item{coerce}{\code{signature(from = "SMIset", to = "SMI")}: \code{as(smiset, "SMI")}}
    \item{show}{\code{signature(object = "SMI")}: prints summary of \code{SMI} }
	 }
}
\references{
SMILES (Simplified molecular-input line-entry system) format definition:
http://en.wikipedia.org/wiki/Simplified_molecular-input_line-entry_system
}
\author{
Thomas Girke
}
\seealso{
Related classes: SMIset, SDF, SDFset
}
\examples{
showClass("SMI")

## Instances of SMI class
data(smisample); smiset <- smisample
(smi <- smiset[[1]]) # returns first molecule in smiset as SMI object
}
\keyword{classes}

\name{obmol}
\alias{obmol}
\alias{obmol-methods}
\title{
	obmol
}
\description{
Return reference to an OBMol from OpenBabel, if available. Operates
on SDF or SDFset objects.
}
\usage{
obmol(x)
}
\arguments{
  \item{x}{
object of class \code{SDF} or \code{SDFset}
}
}
\value{
	A pointer to an OBMol object, or a vector of pointers for an
	\code{SDFset}.
}
\author{
	Kevin Horan
}

\seealso{
\code{header}, \code{atomcount}, \code{bondblock}, \code{datablock}, \code{cid}, \code{sdfid} 
}
\examples{
## SDF/SDFset instances
if(ChemmineR:::.haveOB()){
	data(sdfsample)
	sdfset <- sdfsample
	sdf <- sdfset[[1]]

	obmolRef = obmol(sdf)
}
}

\keyword{ utilities }

\name{FPset-class}
\Rdversion{1.1}
\docType{class}
\alias{FPset-class}
\alias{[,FPset-method}
\alias{[[,FPset-method}
\alias{[<-,FPset-method}
\alias{as.character,FPset-method}
\alias{as.matrix,FPset-method}
\alias{c,FPset-method}
\alias{cid,FPset-method}
\alias{cid<-,FPset-method}
\alias{coerce,FPset,FP-method}
\alias{coerce,matrix,FPset-method}
\alias{coerce,character,FPset-method}
\alias{length,FPset-method}
\alias{show,FPset-method}
\alias{view,FPset-method}
\alias{fold,FPset-method}
\alias{foldCount,FPset-method}
\alias{fptype,FPset-method}
\alias{numBits,FPset-method}

\title{Class \code{"FPset"}}
\description{
Container for storing fingerprints of many compounds. This container is used for structure similarity searching of compounds.
}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("FPset", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{fpma}:}{Object of class \code{"matrix"} with compound identifiers stored in row names}
    \item{\code{foldCount}:}{Object of class \code{"numeric"} }
    \item{\code{type}:}{Object of class \code{"character"} }
  }
}
\section{Methods}{
  \describe{
    \item{[}{\code{signature(x = "FPset")}: subsetting of class with bracket operator }
    \item{[[}{\code{signature(x = "FPset")}: returns single component as \code{FP} object }
    \item{[<-}{\code{signature(x = "FPset")}: replacement method for several components }
    \item{as.character}{\code{signature(x = "FPset")}: returns content as named character vector }
    \item{as.matrix}{\code{signature(x = "FPset")}: returns content as numeric matrix }
    \item{c}{\code{signature(x = "FPset")}: concatenates any number of \code{FPset} containers }
    \item{cid}{\code{signature(x = "FPset")}: returns all compound identifiers from row names }
    \item{cid<-}{\code{signature(x = "FPset")}: replacement method for compound identifiers  }
    \item{coerce}{\code{signature(from = "FPset", to = "FP")}: \code{as(fpset, "FP")} }
    \item{coerce}{\code{signature(from = "matrix", to = "FPset")}: \code{as(fpma, "FPset")} }
    \item{coerce}{\code{signature(from = "character", to = "FPset")}: \code{as(fpchar, "FPset")} }
    \item{length}{\code{signature(x = "FPset")}: returns number of entries stored in object }
    \item{show}{\code{signature(object = "FPset")}: prints summary of \code{FPset} }
    \item{view}{\code{signature(x = "FPset")}: prints extended summary of \code{FPset} }
    \item{fold}{\code{signature(x = "FPset")}: fold fingerprint in half }
    \item{foldCount}{\code{signature(x = "FPset")}: number of times this object has been folded}
    \item{fptype}{\code{signature(x = "FPset")}: the type of these fingerprints }
    \item{numBits}{\code{signature(x = "FPset")}: the number of bits in these fingerprints}
	 }
}
\references{
Chen X and Reynolds CH (2002). "Performance of similarity measures
in 2D fragment-based similarity searching: comparison of structural descriptors
and similarity coefficients", in J Chem Inf Comput Sci.
}
\author{
Thomas Girke
}

\seealso{
Related classes: SDF, SDFset, SDFstr, AP, APset, FP. 
}
\examples{
showClass("FPset")

## Instance of FPset class
data(apset)
(fpset <- desc2fp(apset))
view(fpset)

## Class usage 
fpset[1:4] # behaves like a list
fpset[[1]] # returns FP object
length(fpset) # number of compounds
cid(fpset) # returns compound ids
fpset[1] <- 0 # replacement
cid(fpset) <- 1:length(fpset) # replaces compound ids
c(fpset[1:4], fpset[11:14]) # concatenation

## Coerce FPset from/to other objects
fpma <- as.matrix(fpset) # coerces to matrix
fpchar <- as.character(fpset) # coerces to character strings
as(fpma, "FPset")
as(fpchar, "FPset")

## Compound similarity searching with FPset 
fpSim(x=fpset[1], y=fpset, method="Tanimoto", cutoff=0.4, top=4) 
}
\keyword{classes}

\name{pubchemFPencoding}
\alias{pubchemFPencoding}
\docType{data}
\title{
Enncoding of PubChem Fingerprints
}
\description{
Data frame with bit positions and substructure specifications.
}
\usage{data(pubchemFPencoding)}
\format{
  The format is a data frame with 881 rows and 2 columns.
}
\source{
From: ftp://ftp.ncbi.nih.gov/pubchem/specifications/pubchem_fingerprints.txt
}
\references{
See: ftp://ftp.ncbi.nih.gov/pubchem/specifications/pubchem_fingerprints.txt
}
\examples{
data(pubchemFPencoding)
pubchemFPencoding[1:4,]
}
\keyword{datasets}

\name{listFeatures}
\alias{listFeatures}
\title{
	List Features
}
\description{
	List the available features in the given database. These features can
	be used in the \code{\link{findCompounds}} function.
}
\usage{
	listFeatures(conn)
}
\arguments{
  \item{conn}{
	  Database connection
	}
}
\value{
	A vector of character feature names.
}
\author{
	Kevin Horan
}


\seealso{
	\code{\link{findCompounds}} 
}
\examples{
   #create and initialize a new SQLite database
   conn = initDb("test7.db")

	data(sdfsample)

	#just load the data with no features or descriptors
	ids=loadSdf(conn,sdfsample,fct=function(sdfset) cbind(mw=MW(sdfset)))
	listFeatures(conn) # produces c("mw")
	unlink("test7.db")
}

\name{canonicalNumbering}
\alias{canonicalNumbering}
\title{
	Canonical Numbering
}
\description{
 Computes a re-arrangement required to transform the atom numbering
      of the given compound into the canonical atom numbering. This
      function uses the OBGraphSym and CanonicalLabels classes of Open
      Babel to compute the re-arrangement.

}
\usage{
canonicalNumbering(sdf)
}
\arguments{
  \item{sdf}{
	  Any sdfset object.
	}
}
\value{
   A list of vectors of index values. Each item in the list corresponds to one of the given
    compounds. The values of a list item are the re-arrangement of the atoms.
    For example, if the value in item 1, column 1 is  25, that means that
    atom number 1 in the original compound should become atom number 25
    in the canonical version of that compound.
}
\references{
	http://openbabel.org/api/2.3/canonical_code_algorithm.shtml
}
\author{
	Kevin Horan
}

\seealso{
\code{\link{canonicalize}}
}
\examples{
	\dontrun{
	data(sdfsample)
	labels = canonicalNumbering(sdfsample[1])
	}
}
\keyword{canonical}
\keyword{morgan}

\name{read.SDFindex}
\alias{read.SDFindex}
\title{
Extract Molecules from SD File by Line Index
}
\description{
Extracts specific molecules from SD File based on a line position index computed by the \code{sdfStream} function.
}
\usage{
read.SDFindex(file, index, type = "SDFset", outfile)
}
\arguments{
  \item{file}{
file name of source SD file used to generate \code{index}
}
  \item{index}{
data frame containing in the first two columns the start and end positions (index) of molecules in an SD File, respectively. Typically, this index would be imported with \code{read.table/read.delim} from a tabular descriptor file generated by the \code{sdfStream} function. 
}
  \item{type}{
if \code{type="file"}, the SDF output will be written to a file named as specified under \code{outfile}; if \code{type="SDFset"}, the SDF data is collected will be a \code{SDFset} container.
}
  \item{outfile}{
name of output file when \code{type="file"}
}
}
\details{
...
}
\value{
Writes molecules in SDF format to file or collects them in \code{SDFset} container.
}
\references{
SDF format definition: http://www.symyx.com/downloads/public/ctfile/ctfile.jsp
}
\author{
Thomas Girke
}
\seealso{
Import/export functions: \code{read.SDFset}, \code{read.SDFstr}, \code{read.SDFstr}, \code{read.SDFset}, \code{write.SDFsplit}
}
\examples{
## Load sample data
library(ChemmineR)
data(sdfsample); sdfset <- sdfsample
\dontrun{write.SDF(sdfset, "test.sdf")

## Define descriptor set in a simple function
desc <- function(sdfset) {
        cbind(SDFID=sdfid(sdfset), 
              # datablock2ma(datablocklist=datablock(sdfset)), 
              MW=MW(sdfset), 
              groups(sdfset), 
              # AP=sdf2ap(sdfset, type="character"),
              rings(sdfset, type="count", upper=6, arom=TRUE)
        )
}

## Run sdfStream with desc function and write results to a file called 'matrix.xls'
sdfStream(input="test.sdf", output="matrix.xls", fct=desc, Nlines=1000)

## Select molecules from SD File using line index from sdfStream
indexDF <- read.delim("matrix.xls", row.names=1)[,1:4]
indexDFsub <- indexDF[indexDF$MW < 400, ] # Selects molecules with MW < 400
sdfset <- read.SDFindex(file="test.sdf", index=indexDFsub, type="SDFset")

## Write result directly to SD file without storing larger numbers of molecules in memory
read.SDFindex(file="test.sdf", index=indexDFsub, type="file", outfile="sub.sdf")
}
}
\keyword{ utilities }

\name{sdf.visualize}
\alias{sdf.visualize}
\title{Visualize an SDFset online using ChemMine Tools}
\description{
'sdf.visualize' will take an \code{SDFset} object and send the compounds to the ChemMine Tools
website, for visualization and futher analysis. The results are launched in the users web browser.
}
\usage{
sdf.visualize(sdf)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
	\item{sdf}{
	  A \code{SDFset} object which containing the given compounds
	}
}
\references{
ChemMine Tools web service: http://chemmine.ucr.edu
}
\author{
Tyler Backman
}
\value{
	Returns the URL of the webpage containing all the SDFs and 2D images
	corresponding to the selected compounds.
}

\seealso{\code{\link{cmp.parse}}, \code{\link{sdf.subset}}, \code{\link{plotStruc}}}
\examples{
## Load sample SD file
data(sdfsample)
sdfset <- sdfsample

\dontrun{
## Plot structures using web service ChemMine Tools
sdf.visualize(sdfset[1:4])
}
}
\keyword{utilities}

\name{loadSdf}
\alias{loadSdf}
\alias{loadSmiles}
\title{
	Load SDF and SMILES Data
}
\description{
	Load an SDF or SMILES formatted file or SDFSet objects into the database. This will also load arbitrary features 
	from the data as well as descriptor data. The \code{fct} parameter can be used to specify a function
	which will compute features which will then be indexed and stored in the database. These features can later
	be used to quickly search for compounds. Descriptors can also be computed and stored in another table. 
}
\usage{
	loadSdf(conn, sdfFile, fct = function(x) data.frame(), descriptors=function(x) data.frame(descriptor=c(),descriptor_type=c()),
				Nlines = 50000, startline = 1, restartNlines = 1e+05,updateByName=FALSE)
	loadSmiles(conn, smileFile, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{conn}{
	  A database connection object, such as is returned by \code{\link{initDb}}.
	}
  \item{sdfFile}{
	  Either the filename of an SDF formated file, or and SDFSet object.
	}
  \item{smileFile}{
	  The filename of an SMILES formated file.
	}
	\item{...}{
		When calling loadSmiles, any of the arguments for loadSdf can be used and will be passed to loadSdf internally.
	}
  \item{fct}{
	  A function to extract features from the data. It will be handed an SDFSet generated from the data being loaded.
	  This may be done in batches, so there is no guarantee that the given SDFSset will contain the whole dataset. This
	  function should return a data frame with a column for each feature and a row for each compound given, and in the
	  same order. Each of these features will become a new, indexed, table in the database which can be used later to
	  search for compounds. The column name will become the feature name.
		If not given, no features are computed.
	}
	\item{descriptors}{
		This function will also be given an SDFSet object, which may be done in batches. It should return a data frame
		with the following two columns: "descriptor" and "descriptor_type".  The "descriptor"  column should contain
		a string representation of the descriptor, and "descriptor_type" is the type of the descriptor. Our convention
		for atom pair is "ap" and "fp" for finger print. The order should be maintained.
			If not given no descriptors are computed.
	}
  \item{Nlines}{
	  When reading data from a file, the number of lines to read at a time. See also \code{\link{sdfStream}}.
	}
  \item{startline}{
	  When reading data from a file, the line number to start reading from.See also \code{\link{sdfStream}}
  }
  \item{restartNlines}{
	  When reading data from a file and startline > 1, the number of lines to look forward to find the start of the
	  next compound. See also \code{\link{sdfStream}}
  }
 \item{updateByName}{
	 If true we make the assumption that all compounds, both in the existing database and the
	 given dataset, have unique names. This function will then avoid re-adding existing,
	 identical compounds, and will update existing compounds with a new definition if a new
	 compound definition with an existing name is given. 

	 If false, we allow duplicate compound names to exist in the database, though not
	 duplicate definitions. So identical compounds will not be re-added, but if a new version of
	 an existing compound is added it will not update the existing one, it will add the modified one 
	 as a completely new compound with a new compound id. 
  }

}
\details{
	Arguments to loadSmiles are the same as those to loadSdf. LoadSmiles will convert its input into an SDFSet 
	and then call loadSdf. 

	New features can also be added using this function. However, all compounds must have all features so if new
	features are added to a new set of compounds, all existing features must be computable by the \code{fct} function 
	given. If new features are detected, all existing compounds will be run through \code{fct} in order to compute
	the new features for them as well.

	For example, if dataset X is loaded with features F1 and F2, and then at a later time we load dataset Y with
	new feature F3, the \code{fct} function used to load dataset Y must compute and return features F1, F2, and F3. 
	\code{loadSdf} will call \code{fct} with both datasets X and Y so that all features are available for all
	compounds. If any features are missing an error will be raised.

	If just new features are being added, but no new compounds, use the \code{\link{addNewFeatures}} function.
}
\value{
	Returns the compound id numbers of each compound loaded. These can be used to retrieve compounds later.
	These are id numbers computed by the database and are not extracted from the compound data itself.
}
\author{
	Kevin Horan
}


\seealso{
	\code{\link{sdfStream}}
}
\examples{
	  
   #create and initialize a new SQLite database
   conn = initDb("test6.db")

	data(sdfsample)

	#just load the data with no features or descriptors
	ids=loadSdf(conn,sdfsample)
	unlink("test6.db")

   conn = initDb("test5.db")
	#load data and compute 3 features: molecular weight, with the MW function, 
	# and counts for RINGS and AROMATIC, as computed by rings, which returns a data frame itself.
	ids=loadSdf(conn,sdfsample,
			  function(sdfset) 
					data.frame(MW = MW(sdfset),  rings(sdfset,type="count",upper=6, arom=TRUE))
			 )
	unlink("test5.db")
}

\name{sdf2list}
\alias{sdf2list}
\title{
\code{SDF} to \code{list}
}
\description{
Returns objects of class \code{SDF} as \code{list}.
}
\usage{
sdf2list(x)
}
\arguments{
  \item{x}{
object of class \code{SDF}
}
}
\details{
...
}
\value{
\item{list}{with following components:}
\item{character}{SDF header block}
\item{matrix}{SDF bond block}
\item{matrix}{SDF atom block}
\item{character}{SDF data block}
}
\references{
SDF format definition: http://www.symyx.com/downloads/public/ctfile/ctfile.jsp
}
\author{
Thomas Girke
}

\seealso{
Functions: \code{sdfstr2list}, \code{sdf2str}, \code{SDFset2list}, \code{SDFset2SDF}
}
\examples{
## Instance of SDF class
data(sdfsample); sdfset <- sdfsample
sdf <- sdfset[[1]]

## Return as list
sdf2list(sdf)
as(sdf, "list") # similar result
}
\keyword{ utilities }

\name{exactMassOB}
\alias{exactMassOB}
\title{
	Exact Mass (Monoisotopic Mass)
}
\description{
	Computes the exact mass of each compound given.
}
\usage{
exactMassOB(sdfset)
}
\arguments{
  \item{sdfset}{
		Any SDFset object.
	}
}
\value{
	A vector of mass values.
}
\author{
	Kevin Horan
}
\examples{
	\dontrun{
	library(ChemmineR)
	data(sdfsample)
	mass = exactMassOB(sdfsample)
	}
}
\keyword{exact}
\keyword{mass}
\keyword{monoisotopic}

\name{getCompounds}
\alias{getCompounds}
\title{
	Get Compounds From Database
}
\description{
	Create SDF objects from the given set of compound ids. Id numbers can be found using the findCompounds function.
}
\usage{
   getCompounds(conn,compoundIds,filename=NA, keepOrder = FALSE, allowMissing = FALSE)
}
\arguments{
  \item{conn}{
	  A database connection object, such as is returned by \code{\link{initDb}}.
   }
  \item{compoundIds}{
     A vector of compound ids, as returned by \code{\link{loadSdf}} or \code{\link{findCompounds}}.
   }
   \item{filename}{
      If given, writes the compounds directly to the file named.
   }
  \item{keepOrder}{
     If true, the order of the output compound ids will be the same as the 
     input names. This imposes a performance hit that can be significant for
     large datasets, thus it should be left FALSE unless needed.
   }
	\item{allowMissing}{
		When this is false an error will be raised when compound ids queried were not found in the database. 
		If true, just those that are found will be returned with no error or warning.
	}

}
\value{
   An SDFset with the requested compounds or nothing if \code{filename} was specified. 
   A warning will be raised if not all compounds could be found.
}
\author{
   Kevin Horan
}
\seealso{
   \code{\link{loadSdf}} 
   \code{\link{findCompounds}}.
}
\examples{
   #create and initialize a new SQLite database
   conn = initDb("test3.db")

	data(sdfsample)

	#just load the data with no features or descriptors
	ids=loadSdf(conn,sdfsample)

   #returns a SDFset with 3 compounds
   getCompounds(conn, ids[1:3])

	unlink("test3.db")

}

\name{genAPDescriptors}
\alias{genAPDescriptors}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
	Generate AP Descriptors
}
\description{
	Generates Atom Pair descriptors using a fast C function.
}
\usage{
genAPDescriptors(sdf,uniquePairs=TRUE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sdf}{
		A single SDF object.
	}
	\item{uniquePairs}{
		When the same atom pair occurs more than once in a single compound, should the 
		names be unique or not? Setting this to true will take slightly longer to compute.
	}
}
\value{
	A vector of descriptors for the compound given.  An AP object
	can be generated as shown in the example below.
}
\author{
	Kevin Horan
}
\examples{
	library(ChemmineR)
	data(sdfsample)
	sdf = sdfsample[[2]]
	ap = new("AP", AP=genAPDescriptors(sdf))
}

\name{fptype}
\alias{fptype}
\title{
	fptype
}
\description{
	Returns the type label of this fingerprint
}
\usage{
fptype(x)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{Either an \code{FP} or an \code{FPset} object.
	}
}
\value{
	The type label of this fingerprint.
}
\author{
	Kevin Horan
}
\examples{

	fp = new("FP",fp=c(1,0,1,1, 0,0,1,0),type="testFP")
	type = fptype(fp) # == "testFP"
}

\name{maximallyDissimilar}
\alias{maximallyDissimilar}
\title{
	Maximally Dissimilar
}
\description{
	Find a set of compounds that are far away from each other.
}
\usage{
maximallyDissimilar(compounds, n, similarity = cmp.similarity)
}
\arguments{
  \item{compounds}{
	  The set of items from which to pick \code{n} dissimlar items. This can be a list of
	  anything that the similarity function will accept. By default this will be
	  an APset.
	}
  \item{n}{
	  The number of dissimilar items to return.
	}
  \item{similarity}{
	  The similarity function to use. By default Tanimoto will be used on APset objects.
	  Internally, this will be converted to a distance function using \code{1-similarity(a,b)}, so
	  whatever similarity function you use should return a value between 0 and 1.
	}
}
\details{
	This will run in O(length(compounds)n) time. Based on the algorithm described in (Higgs,1997).
}
\value{
	A vector of indexes of the dissimilar items.
}
\references{
	Higgs, R.E., Bemis, K.G., Watson, I.A., and Wikel, J.H. 1997. Experimental designs for
	selecting molecules from large
	chemical databases. J. Chem. Inf. Comput. Sci. 37, 861-870

}
\author{
	Kevin Horan
}

\examples{
	data(apset)
	maximallyDissimilar(apset,10)
}
\keyword{dissimilar}

\name{foldCount}
\alias{foldCount}
\title{
	foldCount
}
\description{
	Returns the number of times this fingerprint has been folded.
}
\usage{
foldCount(x)
}
\arguments{
  \item{x}{
		Either an \code{FP} or an \code{FPset} object.
	}
}
\value{
	Returns the number of times this fingerprint has been folded.
}
\author{
	Kevin Horan
}
\examples{
	fp = new("FP",fp=c(1,0,1,1, 0,0,1,0))
	foldedFp=fold(fp)
	fc = foldCount(foldedFp) # == 1
}

\name{cmp.similarity}
\alias{cmp.similarity}
\title{Compute similarity between two compounds using their descriptors}
\description{
	Given descriptors for two compounds, 'cmp.similarity' returns the
	similarity measure between the two compounds.
}
\usage{
cmp.similarity(a, b, mode = 1, worst = 0)
}
\arguments{
  \item{a}{Descriptor of the first compound.}
  \item{b}{Descriptor of the second compound.}
  \item{mode}{Mode used when computing the distance. See details below.}
  \item{worst}{The worst value you are expecting. If 'cmp.similarity' finds the
  upper bound of similarity is worse than it, it will return a 0 and
  potentially save some computation.}
}
\details{
	'cmp.similarity' uses descriptor information generated by 'cmp.parse'
	and 'cmp.parse1'. Basically, a descriptor is a vector of numbers. The
	vector actually reprsents the set of descriptors of structural
	fragment.  Similarity measurement uses Tanimoto coefficient.

	'cmp.similarity' supports 3 different modes. In mode 1, normal Tanimoto
	coefficient is used. In mode 2, it uses the size of descriptor
	intersection over the size of the smaller descriptor, mainly to deal
	with compounds that vary a lot in size. In mode 3, it is similar to
	mode 2, except that it raises the similarity to the power 3 to penalize
	small values. When mode is 0, 'cmp.similarity' will select mode 1 or
	mode 3, based on the size differences between the two descriptors.

	When 'cmp.similarity' is used in searching compounds with a threshold
	similarity value, or in clustering with a cutoff distance, the
	threshold similarity and cutoff distance can be used to decide a
	'worse' value. 'cmp.similarity' can compute an upper bound of
	similarity easier, and by comparing this upper bound to the 'worst'
	value, it can potentially skip the real computation if it finds the
	similarity will be below the 'worst' value and will be useless to the
	caller.
}
\value{
	Return a numeric value between 0 and 1 which gives the similarity
	between the two compounds.  }
\references{Chen X and Reynolds CH (2002). "Performance of similarity measures
in 2D fragment-based similarity searching: comparison of structural descriptors
and similarity coefficients", in \emph{J Chem Inf Comput Sci}.
	
	Peter Willett (1998). "Chemical Similarity Searching", in \emph{J. Chem.
	Inf. Comput. Sci}.}
\author{Y. Eddie Cao, Li-Chang Cheng}
\seealso{\code{\link{cmp.parse1}}, \code{\link{cmp.parse}},
	\code{\link{cmp.search}}, \code{\link{cmp.cluster}}}
\examples{
## Load sample SD file
# data(sdfsample); sdfset <- sdfsample

## Generate atom pair descriptor database for searching
# apset <- sdf2ap(sdfset) 

## Loads same atom pair sample data set provided by library
data(apset) 

## Compute similarities among two compounds
cmp.similarity(apset[1], apset[2])

## Search apset database with a query compound
cmp.search(apset, apset[1], type=3, cutoff = 0.3)
}
\keyword{utilities}

\name{cmp.parse1}
\alias{cmp.parse1}
\title{Parsing an SDF file and calculate the descriptor for one compound}
\description{
	Read SDF information from an SDF file or connection, parse the first
	compound, and calculate the descriptor for that compound. The returned
	descriptor can be added to database returned by 'cmp.parse' or be used
	as the query structure when calling 'search'. This function will only
	parse one compound and return only the descriptor. To parse all
	compounds in an SDF file, use 'cmp.parse'.
}
\usage{
cmp.parse1(filename)
}
\arguments{
  \item{filename}{The file name of the SDF file or a URL or a connection.}
}
\details{
	'cmp.parse1' can take a file name or a URL or a
	connection. When a connection is used, the current line must be the
	first line of SDF of the compound to be parsed. 'cmp.parse1'  will skip
	the header and parse from the 4th line.
	Therefore, the compound ID information will be skipped. After the
	parsing is done, if 'filename' is a connection, it will then point to
	the line after the connection table of SDF. You can use some other
	procedure to parse the annotation block.
}
\value{
	Return the descriptor, which is encoded as a vector.
}
\references{Chen X and Reynolds CH (2002). "Performance of similarity measures
in 2D fragment-based similarity searching: comparison of structural descriptors
and similarity coefficients", in \emph{J Chem Inf Comput Sci}.}
\author{Y. Eddie Cao, Li-Chang Cheng}
\seealso{\code{\link{cmp.parse}}, \code{\link{cmp.search}}, \code{\link{cmp.cluster}},
    \code{\link{cmp.similarity}}}
\examples{
# load an SDF file from web and parse it
\dontrun{structure <- cmp.parse1("http://bioweb.ucr.edu/ChemMineV2/compound/Aurora/b32:NNQS2MBRHAZTI===/sdf")}
}
\keyword{utilities}

\name{ExtSDF-class}
\Rdversion{1.1}
\docType{class}
\alias{ExtSDF-class}
\alias{getAtomAttr,ExtSDF-method}
\alias{getBondAttr,ExtSDF-method}
\alias{show,ExtSDF-method}

\title{Class "ExtSDF"}
\description{
	This is a subclass of \code{SDF} and thus inherits all the
	slots and methods from that class. It adds a list of extended attributes
	for atoms and bonds. These attributes can curretnly only be populated
	from a V3000 formatted SDF file.

}

\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("ExtSDF", ...)}. The
function \code{\link{read.SDFset}} will also return objects of this class if
the argument \code{extendedAttributes} is set to "TRUE".
}
\section{Slots}{
  \describe{
    \item{\code{extendedAtomAttributes}:}{Object of class \code{"list"} }
    \item{\code{extendedBondAttributes}:}{Object of class \code{"list"} }
  }
}
\section{Methods}{
  \describe{
    \item{getAtomAttr}{\code{signature(x = "ExtSDF")}: returns atom attributes as a named list of values}
    \item{getBondAttr}{\code{signature(x = "ExtSDF")}: returns bond attributes as a named list of values}
    \item{show}{\code{signature(object = "ExtSDF")}: prints summary of \code{SDF} as well as any defined extended
							 attributes for the atoms or bonds}
	 }
}
\references{
SDF V3000 format definition: http://www.symyx.com/downloads/public/ctfile/ctfile.jsp
}
\author{
	Kevin Horan
}

\seealso{
Related classes: SDF, SDFset, SDFstr, AP, APset
}
\examples{
	showClass("ExtSDF")
}
\keyword{classes}

\name{sdf2str}
\alias{sdf2str}
\alias{sdf2str-methods}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
\code{SDF} to \code{SDFstr}
}
\description{
Converts \code{SDF} to \code{SDFstr}. Its main use is to facilitate the export to SD files. It contains optional arguments to generate custom SDF output.
}
\usage{
sdf2str(sdf, head, ab, bb, db, cid = NULL, sig = FALSE, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sdf}{
object of class \code{SDF}
}
  \item{head}{
optional \code{character} vector to supply custom header block
}
  \item{ab}{
optional \code{matrix} to supply custom atom block 
}
  \item{bb}{
optional \code{matrix} to supply custom bond block 
}
  \item{db}{
optional \code{character} vector to supply custom data block 
}
  \item{cid}{
\code{character} can be provided to inject custom compound ID into header block
}
  \item{sig}{
\code{if = TRUE} then the ChemmineR signature will be injected into the header block for tracking purposes
}
  \item{\dots}{
option to pass on additional arguments
}
}
\details{
If the export function \code{write.SDF} is supplied with an \code{SDFset} object, then \code{sdf2str} is used internally to customize the export of many molecules to a single SD file using the same optional arguments.
}
\value{
\item{sdfstr}{SDF data of one molecule collapsed to character vector}
}
\references{
SDF format definition: http://www.symyx.com/downloads/public/ctfile/ctfile.jsp 
}
\author{
Thomas Girke
}

\seealso{
Coerce functions: \code{sdfstr2list}, \code{sdf2str}, \code{SDFset2list}, \code{SDFset2SDF}

Export function: \code{write.SDF}
}
\examples{
## Instance of SDF class
data(sdfsample); sdfset <- sdfsample
sdf <- sdfset[[1]]

## Customize SDF blocks for export to SD file
sdf2str(sdf=sdf, sig=TRUE, cid=TRUE) # uses default SDF components
sdf2str(sdf=sdf, head=letters[1:4], db=NULL) # uses custom components for header and datablock

## The same arguments can be supplied to the write.SDF function for
## batch export of custom SDFs
# write.SDF(sdfset[1:4], file="sub.sdf", sig=TRUE, cid=TRUE, db=NULL)
}

\keyword{ utilities }

\name{initDb}
\alias{initDb}
\title{
	Iinitialize SQL Database
}
\description{
	This will ensure that the database connection given is ready for use. If it does not find the tables it needs, it
	will try to create them.
}
\usage{
initDb(handle)
}
\arguments{
  \item{handle}{
	  This can be either a filename, in which case we assume it is the name of an SQLite database and use RSQLite to
	  connect to it, or else any DBI Connection.
}
}
\value{
   Returns a connection object that can be used with other database oriented functions.
}
\author{
   Kevin Horan
}

\seealso{
   RSQLite
}
\examples{
   #create and initialize a new SQLite database
   conn = initDb("test.db")
}

\name{setPriorities}
\alias{setPriorities}
\alias{forestSizePriorities}
\alias{randomPriorities}
\title{
	Set Priorities
}
\description{
	This function should be run after loading a complete set of data.
	It will find each group of compounds which share the same
	descriptor and call the given function, \code{priorityFn}, 
	with the compound_id numbers of the group. This function should
	then assign priorities to each compound-descriptor pair, however
	it wishes. Priorities are integer values with lower values being
	used in preference of higher values.

	It is important that this function be called after all data is
	loaded. It may be that a compound loaded at the beginning of a data
	set shares a descriptor with a compound loaded near the end of the
	data set. If the priorities were set at some point in between these
	then it would not see all the compounds for that one descriptor.

	If a SNOW cluster and connection source function are given, it will
	run in parallel.

	Some pre-defined functions that can be use for \code{priorityFn}
	are:

	\code{randomPriorities}: Set the priorities of compounds within a descriptor group
	randomly.

	\code{forestSizePriorities}: Set the priority based on the number
	of disconnected components (trees) within the compound. Compounds
	with fewer trees will have a higher priority (lower numerical
	value) than compounds with more trees.
}

\usage{
setPriorities(conn,priorityFn,descriptorIds=c(),cl=NULL,connSource=NULL)
forestSizePriorities(conn,compIds)
randomPriorities(conn,compIds)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{conn}{
	  A database connection object.
	}
  \item{priorityFn}{
	  This function will be called with the compound_id numbers 
	  associated with the same descriptor. It should use the id
	  numbers to lookup whatever data it wants to assign a priority to
	  each compound. These priority values will be used to pick a
	  compound to represent the group in cases where only one compound
	  is needed for each descriptor. 

	  The function should return a data.frame with the fields
	  "compound_id" and "priority". The order of the rows is not
	  important.
	}
	\item{descriptorIds}{
			If given then only re-compute priorities for groups
			involving descriptors in this list. This is useful
			for updating priorities after adding new compounds
			to an existing database.
	}
	\item{cl}{
		A SNOW cluster on which to run jobs on.
	}
	\item{connSource}{
		A function to create a new database connection with. This will be run once for each new job
		created. It must return a newly created connection, not a reference to an existing connection.
	}
	\item{compIds}{
	  The compound_id values for each group.
	}

}
\value{
	For \code{setPriorities}, no value is returned.
	\code{randomPriorities} and \code{forestSizePriorities} return
	a data.frame with columns "compound_id" and "priority".
}
\author{
	Kevin Horan
}
\examples{
	\dontrun{
		data(sdfsample)
		conn = initDb("sample.db")
		sdfLoad(conn,sdfsample)
		setPriorities(conn,forestSizePriorities)
	}
}

\name{write.SDFsplit}
\alias{write.SDFsplit}
\title{
SDF split function
}
\description{
Splits SD Files into any number of smaller SD Files
}
\usage{
write.SDFsplit(x, filetag, nmol)
}
\arguments{
  \item{x}{
object of class \code{SDFset}, \code{SDFstr}
}
  \item{filetag}{
string to prepend to file names
}
  \item{nmol}{
integer specifying number of molecules in split SD files
}
}
\details{
To split an SD File into smaller ones, one can read the source file into R with \code{read.SDFstr}
and write out smaller ones with \code{write.SDFsplit}. Note: when importing big SD Files, \code{read.SDFstr} 
will be much faster than \code{read.SDFset}, and there is no need to go through an SDFset object instance
in this case.
}
\references{
SDF format definition: http://www.symyx.com/downloads/public/ctfile/ctfile.jsp
}
\author{
Thomas Girke
}
\seealso{
Import/export functions: \code{read.SDFset}, \code{read.SDFstr}, \code{read.SDFstr}, \code{read.SDFset}
}
\examples{
## Load sample data
library(ChemmineR)
data(sdfsample)

\dontrun{## Create sample SD File with 100 molecules
write.SDF(sdfsample, "test.sdf")

## Read in sample SD File 
sdfstr <- read.SDFstr("test.sdf")

## Run export on SDFstr object
write.SDFsplit(x=sdfstr, filetag="myfile", nmol=10)

## Run export on SDFset object
write.SDFsplit(x=sdfsample, filetag="myfile", nmol=10)

}
}
\keyword{ utilities }

\name{trimNeighbors}
\alias{trimNeighbors}
\title{
   Trim Neighbors
}
\description{
   Further reduce the cutoff value of a nearest neighbor (NN) table, as produced by
   \code{\link{nearestNeighbors}}. This allows one to compute a very relaxed NN table
   initially, and then quickly restrict it later without having to re-compute all the
   similarities.
}
\usage{
   trimNeighbors(nnm, cutoff)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{nnm}{
      A nearest neighbor table, as produced by \code{\link{nearestNeighbors}}.
   }
  \item{cutoff}{
      The new similarities cutoff value. All pairs with a similarity less than this value
      will be removed from the table.
   }
}
\value{
   The return value has the same structure as \code{nnm}, with some neighbors
   removed from the \code{indexes} and \code{similarties} entries.
}
\author{
   Kevin Horan
}

\seealso{
   \code{\link{jarvisPatrick}}
   \code{\link{nearestNeighbors}}
}
\examples{

   data(sdfsample)
   ap = sdf2ap(sdfsample)
   nnm = nearestNeighbors(ap,numNbrs=20)
   nnm = trimNeighbors(nnm,cutoff=0.5)
   clustering = jarvisPatrick(nnm,k=2,mode="a1b")
}

\name{SDFset2SDF}
\alias{SDFset2SDF}
\alias{SDFset2SDF<-}
\alias{SDFset2SDF-methods}
\title{
\code{SDFset} to list with many \code{SDF}
}
\description{
Returns object of class \code{SDFset} as \code{list} were each component consists of an \code{SDF} object.
}
\usage{
SDFset2SDF(x)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{
object of class \code{SDFset}
}
}
\details{
...
}
\value{
\item{list}{containing one or many \code{SDF} objects}
}
\references{
SDF format definition: http://www.symyx.com/downloads/public/ctfile/ctfile.jsp 
}
\author{
Thomas Girke
}

\seealso{
Functions: \code{sdfstr2list}, \code{sdf2str}, \code{sdf2list}, \code{SDFset2list}
}
\examples{
## Instance of SDFset class
data(sdfsample); sdfset <- sdfsample
sdfset 

## Returns sdfset as list
SDFset2SDF(sdfset[1:4])
as(sdfset, "SDF")[1:4] # similar result
view(sdfset[1:4]) # same result

}

\keyword{ utilities }

\name{sdf2smiles}
\alias{sdf2smiles}
\alias{sdf2smilesOB}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
\code{SDFset} to \code{character}
Convert \code{SDFset} to SMILES (\code{character})
}
\description{
Accepts compounds in an \code{SDFset} container and returns the corresponding
SMILES (Simplified Molecular Input Line Entry Specification) strings as \code{SMIset} object. 
If ChemineOB is available then OpenBabel for the format conversion. 
Otherwise the compound is submitted to the ChemMine Tools web service for conversion
with the Open Babel Open Source Chemistry Toolbox. If the input object
contains multiple items, only the first is converted.
}
\usage{
	sdf2smiles(sdf)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sdf}{
  	  A \code{SDFset} object which containing the given compounds
}
}
\value{
	\item{character}{ for details see ?"character"}
}
\references{
Chemmine web service: http://chemmine.ucr.edu

Open Babel: http://openbabel.org

SMILES Format: http://en.wikipedia.org/wiki/Chemical_file_format#SMILES
}
\author{
Tyler Backman, Kevin Horan
}

\examples{
\dontrun{
## get a sample compound
data(sdfsample); sdfset <- sdfsample[1]
## convert to smiles
(smiles <- sdf2smiles(sdfset))
as.character(smiles)
}
}
\keyword{ utilities }

\name{findCompounds}
\alias{findCompounds}
\title{
	Find Compounds in Database
}
\description{
   Searches the SQL database using features computed at load time. Each feature
   used should be specified in the \code{featureNames} parameter. Then a set of filters
   can be given to search for specific compounds.
}
\usage{
findCompounds(conn, featureNames, tests)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{conn}{
	  A database connection object, such as is returned by \code{\link{initDb}}.
   }
  \item{featureNames}{
     A list of all feature names used in any test.
  }
  \item{tests}{
     A vector of filters that must all be true for a compound to be returned. For example:
     c("MW <= 400","RINGS > 3") would return all compounds with a molecular weight of 400 or
     less and a more than 3 rings, assuming these features exist in the database. 
     The syntax for each test is "<feature name> <SQL operator> <value>".
     These tests will simply be concatenated together with " AND " in-between them and tacked on the
     end of a WHERE clause of an SQL statement. So any SQL that will work in that context is fine.
   }
}
\value{
   Returns a list of compound ids. The actual compounds can be fetched with \code{\link{getCompounds}}.
}
\author{
   Kevin Horan
}
\seealso{
\code{\link{getCompounds}}
}
\examples{
   #create and initialize a new SQLite database
   conn = initDb("test1.db")

	data(sdfsample)

	#load data and compute 3 features: molecular weight, with the MW function, 
	# and counts for RINGS and AROMATIC, as computed by rings, which returns a data frame itself.
	ids=loadSdf(conn,sdfsample,
			  function(sdfset) 
					data.frame(MW = MW(sdfset),  rings(sdfset,type="count",upper=6, arom=TRUE))
			 )
   #search for compounds with molecular weight less than 200
   lightIds = findCompounds(conn,"MW",c("MW < 200"))
   MW(getCompounds(conn,lightIds)) # should find one compound with weight 140
	unlink("test1.db")

}

\name{desc2fp}
\alias{desc2fp}
\title{
Fingerprints from descriptor vectors
}
\description{
Generates fingerprints from descriptor vectors such as atom pairs stored in \code{APset} or \code{list} containers. The obtained fingerprints can be used for structure similarity comparisons, searching and clustering. Due to their compact size, computations on fingerprints are often more time and memory efficient than on their much more complex atom pair counterparts.
}
\usage{
desc2fp(x, descnames=1024, type = "FPset")
}
\arguments{
  \item{x}{
Object of classe \code{APset} or \code{list} of vectors
}
  \item{descnames}{
Descriptor set to consider for fingerprint encoding. If a single value from 1-4096 is provided then the function uses the corresponding number of the most frequent atom pairs stored in the \code{apfp} data set provided by the package. Alternatively, one can provide here any custom atom pair selection in form of a \code{character} vector.
}
  \item{type}{
return fingerprint set as \code{FPset}, \code{matrix} or \code{character} vector 
}
}
\details{
...
}
\value{
\code{matrix} or \code{character} vectors
}
\references{
Chen X and Reynolds CH (2002). "Performance of similarity measures
in 2D fragment-based similarity searching: comparison of structural descriptors
and similarity coefficients", J Chem Inf Comput Sci.
}
\author{
Thomas Girke
}

\seealso{
Functions: \code{sdf2ap}, \code{SDF2apcmp}, \code{apset2descdb}, \code{cmp.search}, \code{cmp.similarity}

Related classes: SDF, SDFset, SDFstr, APset. 
}
\examples{
## Instance of SDFset class
data(sdfsample)
sdfset <- sdfsample[1:10]

## Compute atom pair library
apset <- sdf2ap(sdfset)

## Compute atom pair fingerprint matrix using internal atom pair
## selection containing 4096 most common atom pairs in DrugBank.
## For details see ?apfp. The following example uses from this 
## set the 1024 most frequent atom pairs: 
fpset <- desc2fp(x=apset, descnames=1024, type="FPset")

## Alternatively, one can provide any custom atom pair selection. Here
## 1024 most common ones in apset object.
fpset1024 <- names(rev(sort(table(unlist(as(apset, "list")))))[1:1024])
fpset2 <- desc2fp(x=apset, descnames=fpset1024, type="FPset")

## A more compact way of storing fingerprints is as character values
fpchar <- desc2fp(x=apset, descnames=1024, type="character")

## Convert character fingerprints back to FPset or matrix
fpset <- as(fpchar, "FPset")
fpma <- as.matrix(fpset)

## Similarity searching returning Tanimoto similarity coefficients
fpSim(x=fpset[1], y=fpset)

## Clustering example
simMAap <- sapply(cid(fpset), function(x) fpSim(x=fpset[x], fpset, sorted=FALSE)) 
hc <- hclust(as.dist(1-simMAap), method="single")
plot(as.dendrogram(hc), edgePar=list(col=4, lwd=2), horiz=TRUE)
}
\keyword{ utilities }

\name{listCMTools}
\alias{listCMTools}
\title{
List all available ChemMine Tools
}
\description{
Connects to the ChemMine Tools web service and obtains a list of all available tools, and their
input and output formats.
}
\usage{
listCMTools()
}
\value{
\item{data.frame}{ A four column data.frame which describes a tool on each row}
}
\references{
See ChemMine Tools at \url{http://chemmine.ucr.edu}.
}
\author{
Tyler William H Backman
}

\seealso{
Functions: \code{toolDetails}, \code{launchCMTool}, \code{result}, \code{browseJob}, \code{status}
}
\examples{
\dontrun{
## list available tools
listCMTools()

## get detailed instructions on using a tool
toolDetails("Fingerprint Search")

## download compound 2244 from PubChem
job1 <- launchCMTool("pubchemID2SDF", 2244)

## check job status and download result
status(job1)
result1 <- result(job1)
}
}
\keyword{ utilities }

\name{bonds}
\alias{bonds}
\title{
Bonds, charges and missing hydrogens 
}
\description{
Returns information about bonds, charges and missing hydrogens in \code{SDF} and \code{SDFset} objects. 
}
\usage{
bonds(x, type = "bonds")
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{
\code{SDF} or \code{SDFset} containers
}
  \item{type}{
If \code{type="bonds"} (default), a \code{data.frame} is returned with columns: \code{atom} (atom labels), \code{Nbondcount} (observed bond count), \code{Nbondrule} (bond count according to position in periodic table) and \code{charge} (charge of each atom). 

If \code{type="charge"}, all charged atoms are returned and if \code{type="addNH"}, the number of missing hydrogens are returned for each molecule. 
}
}
\details{
It is used by many other functions (e.g. \code{MW}, \code{MF}, \code{atomcount}, \code{atomcuntMA} and \code{plot}) to correct for missing hydrogens that are often not specified in SD files. 
}
\value{
If \code{x} is of class \code{SDF}, then a single \code{data.frame} or \code{vector} is returned. If \code{x} is of class \code{SDFset}, then a \code{list} of \code{data.frames} or \code{vecotors} is returned that has the same length and order as \code{x}. 
}
\references{
...
}
\author{
Thomas Girke
}
\seealso{
Functions: \code{conMA} 

Class: \code{SDF} and \code{SDFset}
}
\examples{
## Instances of SDFset class
data(sdfsample)
sdfset <- sdfsample

## Returns data frames with bonds and charges 
bonds(sdfset[1:2], type="bonds")

## Returns charged atoms in each molecule
bonds(sdfset[1:2], type="charge")

## Returns the number of missing hydrogens in each molecule
bonds(sdfset[1:2], type="addNH")

}
\keyword{ utilities }

\name{read.SMIset}
\alias{read.SMIset}
\title{
SMILES file to \code{SMIset}
}
\description{
Imports one or many molecules from a SMILES file and stores content in a \code{SMIset} container. The input file is expected to
contain one SMILES string per row with tab-separated compound identifiers at the end of each line. The compound identifiers
are optional. 
}
\usage{
read.SMIset(file, removespaces = TRUE, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{file}{
path/name to a SMILES file
}
  \item{removespaces}{
if set to \code{TRUE} spaces will be removed
}
  \item{\dots}{
option to pass on additional arguments
}
}
\details{
...
}
\value{
\item{SMIset}{ for details see ?"SMIset-class"}
}
\references{
SMILES (Simplified molecular-input line-entry system) format definition:
http://en.wikipedia.org/wiki/Simplified_molecular-input_line-entry_system
}
\author{
Thomas Girke
}

\seealso{
Functions: \code{read.SDFset}
}
\examples{
## Write instance of SMIset class to SMILES file
data(smisample); smiset <- smisample
# write.SMI(smiset[1:4], file="sub.smi")

## Import SMILES file 
# read.SMIset("sub.smi")

}
\keyword{ utilities }

\name{SDF-class}
\Rdversion{1.1}
\docType{class}
\alias{SDF-class}
\alias{[,SDF-method}
\alias{[[,SDF-method}
\alias{[[<-,SDF-method}
\alias{[<-,SDF-method}
\alias{atomblock,SDF-method}
\alias{atomcount,SDF-method}
\alias{bondblock,SDF-method}
\alias{obmol,SDF-method}
\alias{coerce,character,SDF-method}
\alias{coerce,list,SDF-method}
\alias{coerce,SDF,character-method}
\alias{coerce,SDF,list-method}
\alias{coerce,SDF,SDFset-method}
\alias{coerce,SDF,SDFstr-method}
\alias{datablock,SDF-method}
\alias{datablocktag,SDF-method}
\alias{header,SDF-method}
\alias{plot,SDF-method}
\alias{sdf2list,SDF-method}
\alias{sdf2str,SDF-method}
\alias{sdfid,SDF-method}
\alias{show,SDF-method}

\title{Class "SDF"}
\description{
Container for storing every element of a single molecule defined in an SD/MOL
file without information loss in a list-like container. The import occurs via
the \code{SDFstr} container class. The header block is stored as named
character vector, the atom/bond blocks as matrices and the data block as named
character vector.  }

\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("SDF", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{header}:}{Object of class \code{"character"} }
    \item{\code{atomblock}:}{Object of class \code{"matrix"} }
    \item{\code{bondblock}:}{Object of class \code{"matrix"} }
    \item{\code{datablock}:}{Object of class \code{"character"} }
    \item{\code{obmolRef}:}{Object of class \code{"ExternalReferenceOrNULL"} }
    \item{\code{version}:}{Object of class \code{"character"} }
  }
}
\section{Methods}{
  \describe{
    \item{[}{\code{signature(x = "SDF")}:  subsetting of class with bracket operator }
    \item{[[}{\code{signature(x = "SDF")}: returns one of the four object components }
    \item{[[<-}{\code{signature(x = "SDF")}: replacement method for the four sub-components }
    \item{[<-}{\code{signature(x = "SDF")}: replacement method for the four sub-components }
    \item{atomblock}{\code{signature(x = "SDF")}: returns atom block as matrix}
    \item{atomcount}{\code{signature(x = "SDF")}: returns atom frequency }
    \item{bondblock}{\code{signature(x = "SDF")}: returns bond block as matrix }
    \item{obmol}{\code{signature(x = "SDF")}: returns an OBMol pointer }
    \item{coerce}{\code{signature(from = "character", to = "SDF")}: \code{as(character, "SDF")} }
    \item{coerce}{\code{signature(from = "list", to = "SDF")}: \code{as(list, "SDF")} }
    \item{coerce}{\code{signature(from = "SDF", to = "character")}: \code{as(sdf, "character")} }
    \item{coerce}{\code{signature(from = "SDF", to = "list")}: \code{as(sdf, "list")} }
    \item{coerce}{\code{signature(from = "SDF", to = "SDFset")}: \code{as(sdf, "SDFset")} }
    \item{coerce}{\code{signature(from = "SDF", to = "SDFstr")}: \code{as(SDF, "SDFstr")} }
    \item{coerce}{\code{signature(from = "SDFset", to = "SDF")}: \code{as(sdfset, "SDF")} }
    \item{datablock}{\code{signature(x = "SDF")}: returns data block as named character vector }
    \item{datablocktag}{\code{signature(x = "SDF")}: returns data block as named character vector with subsetting support }
    \item{header}{\code{signature(x = "SDF")}: returns header block as named character vector }
    \item{plot}{\code{signature(x = "SDF")}: plots molecule structure for \code{SDF} object}
    \item{sdf2list}{\code{signature(x = "SDF")}: returns \code{SDF} object as \code{list}}
    \item{sdf2str}{\code{signature(sdf = "SDF")}: returns \code{SDF} object as \code{character} vector}
    \item{sdfid}{\code{signature(x = "SDF")}: returns molecule ID field from header block }
    \item{show}{\code{signature(object = "SDF")}: prints summary of \code{SDF} }
	 }
}
\references{
SDF format definition: http://www.symyx.com/downloads/public/ctfile/ctfile.jsp
}
\author{
Thomas Girke
}

\seealso{
Related classes: SDFset, SDFstr, AP, APset
}
\examples{
showClass("SDF")

## Instances of SDF class
data(sdfsample); sdfset <- sdfsample
(sdf <- sdfset[[1]]) # returns first molecule in sdfset as SDF object

## Accessing SDF components
header(sdf); atomblock(sdf); bondblock(sdf); datablock(sdf)
sdfid(sdf)

## Plot molecule structure of SDF 
plot(sdf) # plots to R graphics device
# sdf.visualize(sdf) # viewing in browser
}
\keyword{classes}

\name{getCompoundFeatures}
\alias{getCompoundFeatures}
\title{
	Get Compound Features
}
\description{
	Get feature values for specific compounds.
}
\usage{
getCompoundFeatures(conn, compoundIds, featureNames, filename = NA, keepOrder = FALSE, allowMissing = FALSE, batchSize = 1e+05)
}
\arguments{
  \item{conn}{
	  A database connection object, such as is returned by \code{\link{initDb}}.
	}
  \item{compoundIds}{
	  A vector of compound_id numbers from this database. These are not compound names. Features will be fetched for
	  each compound given here.
	}
  \item{featureNames}{
	  A vector of features to fetch the value for, for each given compound.
	}
  \item{filename}{
	  If given, dump the results into a comma seperated values (CSV) file instead of returning a data frame. This can
	  avoid some potential memory limits when fetching large sets of data.
	}
  \item{keepOrder}{
	  Ensure that the output order of values matches the order in which the compound ids where given. This will make things a
	  little slower, so should only be used where required.
	}
  \item{allowMissing}{
	  If false, raise an exception if a compound cannot be found, otherwise just silently ignore it and return data for
	  whatever compound were found.
	}
  \item{batchSize}{
	  The number of compounds to fetch in a single query. If you find your running out of memory you can try reducing this
	  values, as well as try writing the result to a file using the \code{filename} parameter.
	}
}
\value{
	If \code{filename} is not given, returns a data frame with the compound_id and any given feature names. Each row represents
	one compound. If \code{filename} is given a filename then no value is returned, but the given file is created.
}
\author{
	Kevin Horan
}
\examples{
	#create and initialize a new SQLite database
   conn = initDb("test1.db")

	data(sdfsample)

	#load data 
	ids=loadSdf(conn,sdfsample,
			  function(sdfset) 
					data.frame(MW = MW(sdfset),  rings(sdfset,type="count",upper=6, arom=TRUE))
			 )

	f = getCompoundFeatures(conn,ids,c("mw","rings"))

	unlink("test1.db")


}

\name{SDF2apcmp}
\alias{SDF2apcmp}
\title{
\code{SDF} to \code{list} for AP generation
}
\description{
Returns \code{SDF} class as \code{list} containing the components for generating atom pair descriptors.
}

\usage{
SDF2apcmp(SDF)
}

\arguments{
  \item{SDF}{\code{SDF}}
}

\details{
...
}

\value{
\item{list}{ with atom and bond components}
}

\references{
Chen X and Reynolds CH (2002). "Performance of similarity measures
in 2D fragment-based similarity searching: comparison of structural descriptors
and similarity coefficients", J Chem Inf Comput Sci.
}

\author{
Thomas Girke
}

\seealso{
Functions: \code{sdf2ap}, \code{apset2descdb}, \code{cmp.search}, \code{cmp.similarity}
}

\examples{

## Instances of SDFset class
data(sdfsample)
sdf <- sdfsample[[1]]

## Return list 
cmp <- SDF2apcmp(sdf)

}

\keyword{ utilities }

\name{makeUnique}
\alias{makeUnique}
\title{
Uniquify CMP names 
}
\description{
Creates unique CMP names by appending a counter to each duplicatation set. The function can be used for any character vector.
}
\usage{
makeUnique(x, silent = FALSE)
}
\arguments{
  \item{x}{
\code{character} vector
}
  \item{silent}{
\code{silent = TRUE} suppresses message about duplicate count
}
}
\details{
The function is important to maintain unique compound names in the ID slot of \code{SDFset} containers.
}
\value{
\item{character}{ of same length as x but without duplications}
}
\references{
...
}
\author{
Thomas Girke
}

\seealso{
Functions: \code{cid}, \code{sdfid}
}
\examples{
## SDFset instance
data(sdfsample)
sdfset <- sdfsample

## Create unique compound IDs 
unique_ids <- makeUnique(sdfid(sdfset))
cid(sdfset) <- unique_ids 
cid(sdfset[1:4])

}

\keyword{ utilities }

\name{pubchemInchikey2sdf}
\alias{pubchemInchikey2sdf}
\title{
Query pubchem by InChIKeys sttrings and get SDF back
}
\description{
Use PubChem API to get CIDs by InChIKeys
}
\usage{
pubchemInchikey2sdf(inchikeys)
}

\arguments{
  \item{inchikeys}{
		Character vector, InChIKey strings.
}
}
\value{
a list of 2 items. the first item "sdf_set" is a `SDFset` object. It 
contains all queried and successful SDF infomation. The second item "sdf_index"
is a named numeric vector. It records whether all input InChIKeys have successful 
returns in the  `SDFset` object. If so, a non-zero value is returned as the index of
where it exists in the `SDFset` object, if not, 0 is returned.
}
\references{
PubChem PUG REST: https://pubchem.ncbi.nlm.nih.gov/pug_rest/PUG_REST_Tutorial.html

}
\author{
	Le Zhang
}

\examples{
	\dontrun{
	 ## fetch 2 compounds from PubChem
	 inchikeys <- c(
	 "ZFUYDSOHVJVQNB-FZERPYLPSA-N", 
	 "KONGRWVLXLWGDV-BYGOPZEFSA-N", 
	 "AANKDJLVHZQCFG-WLIQWNBFSA-N",
	 "SNFRINMTRPQQLE-JQWAAABSSA-N"
	 )
	 pubchemInchikey2sdf(inchikeys)

	}
}

\keyword{ utilities }

\name{conMA}
\alias{conMA}
\title{
Bond Matrices
}
\description{
Creates a bond matrix from \code{SDF} and \code{SDFset} objects. The matrix contains the atom labels in the row and column titles and the bond types are given in the data part as follows: 0 is no connection, 1 is a single bond, 2 is a double bond and 3 is a triple bond.
}
\usage{
conMA(x, exclude = "none")
}
\arguments{
  \item{x}{
\code{SDF} or \code{SDFset} containers
}
  \item{exclude}{
if \code{exclude="none"}, then all atoms will be considered in the resulting connection table; if \code{exclude=c("H")}, then the H atoms will be excluded. Any number of atom labels to be excluded can be passed on to this argument in form of a \code{character} vector.
}
}
\details{
...
}
\value{
If \code{x} is of class \code{SDF}, then a single bond \code{matrix} is returned. If \code{x} is of class \code{SDFset}, then a \code{list} of matrices is returned that has the same length as \code{x}.
}
\references{
...
}
\author{
Thomas Girke
}
\seealso{
Functions: \code{bonds}

Class: \code{SDF} and \code{SDFset}
}
\examples{
## Instances of SDFset class
data(sdfsample)
sdfset <- sdfsample

## Create bond matrix for first two molecules in sdfset
conMA(sdfset[1:2], exclude=c("H"))

## Return bond matrix for first molecule and plot its structure with atom numbering
conMA(sdfset[[1]], exclude=c("H"))
plot(sdfset[1], atomnum = TRUE, noHbonds=FALSE , no_print_atoms = "", atomcex=0.8)

## Return number of non-H bonds for each atom 
rowSums(conMA(sdfset[[1]], exclude=c("H")))
}
\keyword{ utilities }

\name{view}
\alias{view}
\alias{view-methods}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Viewing of complex objects
}
\description{
Convenience function for viewing the content of complex objects like SDFset and APset containers. The function
is a shorthand wrapper for \code{as(sdfset, "SDF")} and \code{as(apset, "AP")}.
}
\usage{
view(x)
}
\arguments{
  \item{x}{ object of class \code{SDFset} or \code{APset}
}
}
\details{
...
}
\value{
List populated with \code{SDF} and \code{AP} components.
}
\references{
...
}
\author{
Thomas Girke
}

\seealso{
Classes: SDF, SDFset, AP, APset
}
\examples{
## Viewing content of SDFset 
data(sdfsample); sdfset <- sdfsample
view(sdfset[1:4])

## Viewing content of APset 
apset <- sdf2ap(sdfset[1:10])
view(apset)
}
\keyword{ utilities }

\name{selectInBatches}
\alias{selectInBatches}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
	Select in Batches
}
\description{
	When doing a select were the condition is a large number of ids it is not always possible
	to include them in a single SQL statement. This function will break the list of ids into chunks 
	and  send the query for each batch. The resutls are appended and returned as one data frame.
}
\usage{
selectInBatches(conn, allIndices, genQuery, batchSize = 1e+05)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{conn}{
		Database connection object
	}
  \item{allIndices}{
	  A vector of indices to pass to the genQuery function in batches.
	}
  \item{genQuery}{
	  A function which takes a vector of indices and constructs an SQL SELECT statement
	  returning records for the given indicies.
	}
  \item{batchSize}{
	  How many indicies to put in each batch.
	}
}
\value{
	A data frame with the results of the query as if all inidices had been included
	in a single SELEcT statement.
}
\author{
	Kevin Horan
}
\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

## The function is currently defined as
function (conn, allIndices, genQuery, batchSize = 1e+05) 
{
    batchByIndex(allIndices, function(indexBatch) {
        df = dbGetQuery(conn, genQuery(indexBatch))
        result = rbind(result, df)
    }, batchSize)
    result
  }
}

\name{SMIset-class}
\Rdversion{1.1}
\docType{class}
\alias{SMIset-class}
\alias{[,SMIset-method}
\alias{[[,SMIset-method}
\alias{[<-,SMIset-method}
\alias{as.character,SMIset-method}
\alias{c,SMIset-method}
\alias{cid,SMIset-method}
\alias{cid<-,SMIset-method}
\alias{coerce,character,SMIset-method}
\alias{coerce,list,SMIset-method}
\alias{coerce,SMIset,SMI-method}
\alias{length,SMIset-method}
\alias{show,SMIset-method}
\alias{view,SMIset-method}

\title{Class \code{"SMIset"}}
\description{
List-like container for storing SMILES strings of many compounds. 
}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("SMIset", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{smilist}:}{Object of class \code{"list"} with compound identifiers stored in name slots}
  }
}
\section{Methods}{
  \describe{
    \item{[}{\code{signature(x = "SMIset")}: subsetting of class with bracket operator }
    \item{[[}{\code{signature(x = "SMIset")}: returns single component as \code{SMI} object }
    \item{[<-}{\code{signature(x = "SMIset")}: replacement method for one or many entries }
    \item{as.character}{\code{signature(x = "SMIset")}: returns content as named character vector }
    \item{c}{\code{signature(x = "SMIset")}: concatenates two \code{SMIset} containers }
    \item{cid}{\code{signature(x = "SMIset")}: returns compound identifiers }
    \item{cid<-}{\code{signature(x = "SMIset")}: replacement method for compound identifiers }
    \item{coerce}{\code{signature(from = "character", to = "SMIset")}: \code{as(character, "SMIset")} }
    \item{coerce}{\code{signature(from = "list", to = "SMIset")}: \code{as(list, "SMIset")} }
    \item{coerce}{\code{signature(from = "SMIset", to = "SMI")}: \code{as(smiset, "SMI")} }
    \item{length}{\code{signature(x = "SMIset")}: returns number of entries stored in object }
    \item{show}{\code{signature(object = "SMIset")}: prints summary of \code{SMIset} }
    \item{view}{\code{signature(x = "SMIset")}: prints extended summary of \code{SMIset} }
	 }
}
\references{
SMILES (Simplified molecular-input line-entry system) format definition:
http://en.wikipedia.org/wiki/Simplified_molecular-input_line-entry_system
}
\author{
Thomas Girke
}

\seealso{
Related classes: SMI, SDF, SDFset

Import function: read.SMIset("some_SMILES_file") 

Export function: write.SMI(smiset, "some_file.smi")
}
\examples{
showClass("SMIset")

## Instances of SMIset class
data(smisample); smiset <- smisample
smiset; view(smiset[1:4])
smiset[[1]]

## Import and store SMILES file in SMIset container
# smiset <- read.SMIset("some_SMILES_file")

## Miscellaneous accessor methods
cid(smiset[1:4])
(smivec <- as.character(smiset[1:4]))

## Construct SMIset from named vector 
as(smivec, "SMIset")

## Assigning compound IDs and keeping them unique
unique_ids <- makeUnique(cid(smiset))
cid(smiset) <- unique_ids

## Export SMIset to SMILES file
# write.SMI(smiset[1:4], file="sub.smi", cid=TRUE)

}
\keyword{classes}

\name{searchSim-deprecated}
\alias{searchSim}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
PubChem Similarity (Fingerprint) Search 
}
\description{
Accepts one \code{SDFset} container
and performs a >0.9 similarity PubChem fingerprint search, returning up to 200 
hits in an \code{SDFset} container. The ChemMine Tools web service
is used as an intermediate, to translate queries from plain HTTP POST to
a PubChem Power User Gateway (PUG) query. If the input object
contains multiple items, only the first is used as a query.
}
\usage{
searchSim(sdf)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sdf}{
  	  A \code{SDFset} object which contains one compound
}
}
\value{
\item{SDFset}{ for details see ?"SDFset-class"}
}
\references{
PubChem PUG SOAP: http://pubchem.ncbi.nlm.nih.gov/pug_soap/pug_soap_help.html

Chemmine web service: http://chemmine.ucr.edu

PubChem help: http://pubchem.ncbi.nlm.nih.gov/search/help_search.html

SMILES Format: http://en.wikipedia.org/wiki/Chemical_file_format#SMILES
}
\author{
Tyler Backman
}

\examples{
\dontrun{
## get a sample compound
data(sdfsample); sdfset <- sdfsample[2]
## search a compound on PubChem
compounds <- searchSim(sdfset)}
}

\keyword{ utilities }

\name{SDFset2list}
\alias{SDFset2list}
\alias{SDFset2list-methods}
\title{
\code{SDFset} to \code{list}
}
\description{
Returns object of class \code{SDFset} as \code{list} where each component conists of a \code{list} of the four SDF sub-components: header block, atom block, bond block and data block.
}
\usage{
SDFset2list(x)
}
\arguments{
  \item{x}{
object of class \code{SDFset}
}
}
\details{
...
}
\value{
\item{list}{containing one or many lists each with following components:}
\item{character}{SDF header block}
\item{matrix}{SDF bond block}
\item{matrix}{SDF atom block}
\item{character}{SDF data block}
}
\references{
SDF format definition: http://www.symyx.com/downloads/public/ctfile/ctfile.jsp 
}
\author{
Thomas Girke
}

\seealso{
Functions: \code{sdfstr2list}, \code{sdf2str}, \code{sdf2list}, \code{SDFset2SDF}
}
\examples{
## Instance of SDFset class
data(sdfsample); sdfset <- sdfsample
sdfset 

## Returns sdfset as list
SDFset2list(sdfset[1:4])
as(sdfset, "list")[1:4] # similar result
}

\keyword{ utilities }

\name{write.SMI}
\alias{write.SMI}
\title{
SMI export function
}
\description{
Writes one or many molecules stored in a \code{SMIset} object to a SMILES file.
}
\usage{
write.SMI(smi, file, cid = TRUE, ...)
}
\arguments{
  \item{smi}{
object of class \code{SMIset}
}
  \item{file}{
name of SMILES file to write to
}
  \item{cid}{
if \code{cid = TRUE} the compound identifiers will be exported by appending them in tab-separated format to each SMILES string
}
  \item{\dots}{
option to pass on additional arguments
}
}
\details{
...
}
\references{
SMILES (Simplified molecular-input line-entry system) format definition:
http://en.wikipedia.org/wiki/Simplified_molecular-input_line-entry_system
}
\author{
Thomas Girke
}

\seealso{
Functions: \code{write.SDF}
}
\examples{
## Instance of SMIset class
data(smisample); smiset <- smisample

## Write objects of classes SMIset to file with and 
## without compound identifiers
# write.SMI(smiset[1:4], file="sub.smi", cid=TRUE)
# write.SMI(smiset[1:4], file="sub.smi", cid=FALSE)

}
\keyword{ utilities }

\name{getAllCompoundIds}
\alias{getAllCompoundIds}
\title{
	Get ALl Compound Ids
}
\description{
	Return a vector of every compound id in the given database. 
}
\usage{
getAllCompoundIds(conn)
}
\arguments{
  \item{conn}{
	  A database connection object, such as is returned by \code{\link{initDb}}.
	}
}
\value{
	A vector of compound_id numbers
}
\author{
	Kevin Horan
}
\examples{
   #create and initialize a new SQLite database
   conn = initDb("test1.db")

	data(sdfsample)

	#load data
	ids=loadSdf(conn,sdfsample)
	ids2=getAllCompoundIds(conn)
	#ids == ids2

	unlink("test1.db")
}

\name{addDescriptorType}
\alias{addDescriptorType}
\title{
	Add Descriptor Type
}
\description{
	Add a new descriptor type to the database. Normally descriptor types are added as needed, but
	if you are doing a parrallel data load you must pre-load the descriptor type to prevent
	duplicate defintion errors.
}
\usage{
addDescriptorType(conn, descriptorType)
}
\arguments{
  \item{conn}{
		Any database connection object.
	}
  \item{descriptorType}{
	  The name of the descriptor.
	}
}
\value{
	No return value.
}
\author{
	Kevin Horan
}
\examples{
	\dontrun{
		conn =  initDb(...)
		addDescriptor(conn,"fp")
	}
}

\name{sdfid}
\alias{sdfid}
\title{
Return SDF compound IDs
}
\description{
Returns the compound identifiers from the header block of \code{SDF} or \code{SDFset} objects. 
}
\usage{
sdfid(x, tag = 1)
}
\arguments{
\item{x}{
object of class \code{SDFset} or \code{SDF}
}
\item{tag}{
values from 1-4 to extract different header block fields; SDF ID is in first one (default)
}
}
\details{
...
}
\value{
\code{character} vector}

\references{
...
}
\author{
Thomas Girke
}
\seealso{
\code{atomblock}, \code{atomcount}, \code{bondblock}, \code{datablock}, \code{header}, \code{cid} 
}
\examples{
## SDF/SDFset instances
data(sdfsample)
sdfset <- sdfsample
sdf <- sdfset[[1]]

## Extract IDs from header block
sdfid(sdf, tag=1)
sdfid(sdfset[1:4])

## Extract compound IDs from ID slot in SDFset container
cid(sdfset[1:4])

## Assigning compound IDs and keeping them unique
unique_ids <- makeUnique(sdfid(sdfset))
cid(sdfset) <- unique_ids 
cid(sdfset[1:4])

}

\keyword{ utilities }

\name{cluster.sizestat}
\alias{cluster.sizestat}
\title{generate statistics on sizes of clusters}
\description{
	'cluster.sizestat' is used to do simple statistics on sizes of clusters
	generated by 'cmp.cluster'. It will return a dataframe which maps a cluster
	size to  the number of clusters with that size. It is often used along
	with 'cluster.visualize'.
}
\usage{
cluster.sizestat(cls, cluster.result=1)
}
\arguments{
  \item{cls}{The clustering result returned by 'cmp.cluster'}
  \item{cluster.result}{If multiple cutoff values are used in clustering process, this argument tells which cutoff value is to be considered here.}
}
\details{
    'cluster.sizestat' depends on the format that is returned by 'cmp.cluster' - it
    will treat the first column as the indecies, and the second column as the
    cluster sizes of effective clustering. Because of this, when multiple
    cutoffs are used when 'cmp.cluster' is called, 'cluster.sizestat' will only
    consider the clustering result of the first cutoff. If you want to work on
    an alternative cutoff, you have to manually reorder/remove columns.
}
\value{
    Returns a data frame of two columns.
    \item{cluster size}{This column lists cluster sizes}
    \item{count}{This column lists number of clusters of a cluster size}
}
\author{Y. Eddie Cao}
\seealso{\code{\link{cmp.cluster}}, \code{\link{cluster.visualize}}}
\examples{
## Load sample SD file
# data(sdfsample); sdfset <- sdfsample

## Generate atom pair descriptor database for searching
# apset <- sdf2ap(sdfset) 

## Loads same atom pair sample data set provided by library
data(apset) 

## Binning clustering using variable similarity cutoffs.
cluster <- cmp.cluster(db=apset, cutoff = c(0.65, 0.5))

## Statistics on sizes of clusters
cluster.sizestat(cluster[,c(1,2,3)])
cluster.sizestat(cluster[,c(1,4,5)])
}
\keyword{utilities}

\name{browseJob}
\alias{browseJob}
\title{
Open ChemMine Tools Job in Web Browser
}
\description{
Launches a web browser to view the results of a ChemMine Tools web job with an interactive online viewer.
Note that this reassigns the job to the current logged in user within the browser, so it becomes no longer
accessible by the \code{result} and \code{status} functions. Any results should be saved within R before launching a browser.
}
\usage{
browseJob(object)
}
\arguments{
  \item{object}{
A \code{jobToken} job as returned by the function \code{launchCMTool}
}
}
\value{
Returns an URL string which can be used to access the job results. The function also attempts to open the url with the \code{browseURL} function. As this URL can only be used once, the returned string is only useful if the \code{browseURL} function fails to open a browser.
}
\references{
See ChemMine Tools at \url{http://chemmine.ucr.edu}.
}
\author{
Tyler William H Backman
}

\seealso{
Functions: \code{toolDetails}, \code{listCMTools}, \code{launchCMTool}, \code{result}, \code{status}
}
\examples{
\dontrun{
## list available tools
listCMTools()

## get detailed instructions on using a tool
toolDetails("Fingerprint Search")

## download compound 2244 from PubChem
job1 <- launchCMTool("pubchemID2SDF", 2244)

## check job status and download result
status(job1)
result1 <- result(job1)

## open job in web browser
browseJob(job1)
}
}
\keyword{ utilities }

\name{bufferResultSet}
\alias{bufferResultSet}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
	Buffer Query Results
}
\description{
	Allow query results to be processed in batches for efficiency.
}
\usage{
bufferResultSet(rs, rsProcessor, batchSize = 1000,closeRS=FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{rs}{
		A DBIResult object, usually from \code{dbSendQuery}.
	}
  \item{rsProcessor}{
	  Each batch will be passed as a data frame to this function for processing.
	}
  \item{batchSize}{
		The number of rows to read in each batch
	}
	\item{closeRS}{
		Should the result set be closed by this function when it is done?
	}
}
\value{
	No value.
}
\author{
	Kevin Horan
}
\examples{
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

## The function is currently defined as
function (rs, rsProcessor, batchSize = 1000) 
{
    while (TRUE) {
        chunk = fetch(rs, n = batchSize)
        if (dim(chunk)[1] == 0) 
            break
        rsProcessor(chunk)
    }
  }
}

\name{draw_sdf}
\alias{draw_sdf}
\title{
	draw_sdf
}
\description{
	Draws an sdf object in the 2D plane using ggplot2 library. Permits customization of bond colors and atom colors.
}
\usage{
	draw_sdf(sdf, filename = "test.jpg", alpha_edge = 0.5, alpha_node = 1, numbered = FALSE, font_size = 5, node_vertical_offset = 0, node_background_color = FALSE, bgcolor = rgb(1, 1, 1, 1), bgraster = NULL, node_policy = default_node_policy(), edge_policy = default_edge_policy(), bond_dist_offset = 0.05, fmcsR_sdf = NULL)
}
\arguments{
  \item{sdf}{
		An instance of a SDF or list of SDFs
	}
  \item{filename}{
		Filename to save image to. Defaults to 'test.jpg'. If set to NULL, does not save image.
	}
  \item{alpha_edge}{
		alpha of bonds in your image. Defaults to 0.5. 0 is fully transparent, 1 is fully opaque.
	}
  \item{alpha_node}{
		alpha of atoms in your image. Defaults to 1.0.
	}
  \item{numbered}{
		If 1 or TRUE, displays numbering of atoms at their location. If 2, displays a second numbering style.
	}
  \item{font_size}{
		Controls size of text to be displayed at atom locations. Beware when plotting multiple SDFs in one image. Ggplot will still scale fonts as if text is being plotted in one image.
	}
  \item{node_vertical_offset}{
		Upward shift of atom text. Upward shit is in SDF units, not ggplot units.
	}
  \item{bgcolor}{
		An rgb(r,g,b,alpha) or similar object. produces a background of the specified color.
	}
  \item{node_background_color}{
		 A common color as a text string (e.g. 'white', 'pink') or an rgb(r,g,b,alpha).  Draws a filled circle of the color specified before drawing text over each node.
	}
  \item{bgraster}{
		A readPNG object or a path to an object that can be understood using readPNG. Will be used as background.
	}
  \item{node_policy}{
		Mapping that defines how atom strings should be displayed. Simplest would be c('default'='black')
	}
  \item{edge_policy}{
		Mapping that defines how bonds should be displayed. Simplest is c('default'='black'), though this will display all Hydrogen bonds as well.
	}
  \item{bond_dist_offset}{
		Defines space between double or triple bonds, in SDF units.
	}
  \item{fmcsR_sdf}{
		A second SDF object to run fmcsR on. 
	}
}
\details{
	Requires ggplot2. Additional features require grid, gridExtra, fmcsR, or png. Most matrix operations vectorized.
}
\value{
	Returns a ggplot2 object. Calling draw_sdf(...) rather than assigning it will result in R trying to print a ggplot2 object.
}
\author{
	John A. Sharifi
}


\examples{
	library(ChemmineR) 		# if not already imported
	data(sdfsample)
	draw_sdf(sdfsample[[1]])
}

\name{getIds-deprecated}
\alias{getIds}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Import Compounds from PubChem
}
\description{
Accepts one or more PubChem compound ids
and downloads the corresponding compounds from PubChem Power User Gateway (PUG)
returning results in an \code{SDFset} container. The ChemMine Tools web service
is used as an intermediate, to translate queries from plain HTTP POST to
a PUG SOAP query.
}
\usage{
getIds(cids)
}

\arguments{
  \item{cids}{
  	  A \code{numeric} object which contains one or more PubChem cids
}
}
\value{
\item{SDFset}{ for details see ?"SDFset-class"}
}
\references{
PubChem PUG SOAP: http://pubchem.ncbi.nlm.nih.gov/pug_soap/pug_soap_help.html

Chemmine web service: http://chemmine.ucr.edu

PubChem help: http://pubchem.ncbi.nlm.nih.gov/search/help_search.html
}
\author{
Tyler Backman
}

\examples{
\dontrun{
## fetch 2 compounds from PubChem
compounds <- getIds(c(111,123))}
}

\keyword{ utilities }

\name{bondblock}
\alias{bondblock}
\alias{bondblock<-}
\alias{bondblock-methods}
\title{
Return bond block
}
\description{
Returns bond block(s) from an object of class SDF or SDFset.
}
\usage{
bondblock(x)
}
\arguments{
  \item{x}{
object of class \code{SDF} or \code{SDFset}
}
}
\details{
...
}
\value{
\code{matrix} if \code{SDF} is provided or \code{list} of matrices if \code{SDFset} is provided
}
\references{
...
}
\author{
Thomas Girke
}

\seealso{
\code{header}, \code{atomcount}, \code{atomblock}, \code{datablock}, \code{cid}, \code{sdfid} 
}
\examples{
## SDF/SDFset instances
data(sdfsample)
sdfset <- sdfsample
sdf <- sdfset[[1]]

## Extract bond block
bondblock(sdf)
bondblock(sdfset[1:4])

## Replacement methods
sdfset[[1]][[3]][1,1] <- 999
sdfset[[1]]
bondblock(sdfset)[1:2] <- bondblock(sdfset)[3:4]
bondblock(sdfset[[1]]) == bondblock(sdfset[[3]]) 
view(sdfset[1:2])
}

\keyword{ utilities }

\name{cmp.search}
\alias{cmp.search}
\title{Search a descriptor database for compounds similar to query compound}
\description{
	Given descriptor of a query compound and a database of compound
	descriptors, search for compounds that are similar to the query
	compound. User can limit the output by supplying a cutoff similarity
	score or a cutoff that limits the number of returned compounds. The
	function can also return the scores together with the compounds.
}
\usage{
    cmp.search(db, query, type=1, cutoff = 0.5, return.score = FALSE, quiet = FALSE,
		    mode = 1,visualize = FALSE, visualize.browse = TRUE, visualize.query = NULL)
}
\arguments{
	\item{db}{The compound descriptor database returned by 'cmp.parse'.}
	\item{query}{The query descriptor, which is usually returned by 
        'cmp.parse1'.}
	\item{type}{Returns results in form of position indices (type=1), 
        named vector with compound IDs (type=2) or data frame (type=3).}
	\item{cutoff}{The cutoff similarity (when cutoff <= 1) or the number of
	maximum compounds to be returned (when cutoff > 1).}
	\item{return.score}{Whether to return similarity scores. If set to
	TRUE, a data frame will be returned; otherwise, only the compounds'
	indices in the database will be returned in the order of decreasing
	scores.}
	\item{quiet}{Whether to disable progress information.}
	\item{mode}{Mode used when computing similarity scores. This value is
	passed to 'cmp.similarity'.}
	\item{visualize}{
	}
	\item{visualize.browse}{
	}
	\item{visualize.query}{
	}
}
\details{
	'cmp.search' will go through all the compound descriptors in the
	database and calculate the similarity between the query compound and
	compounds in the database. When cutoff similarity score is set,
	compounds having a similarity score higher than the cutoff will be
	returned. When maximum number of compounds to return is set to N via
	'cutoff', the compounds having the highest N similarity scores will be
	returned.
}
\value{
  When 'return.score' is set to FALSE, a vector of matching compounds' indices
  in the database will be returned. Otherwise, a data frame will be returned:
  \item{ids}{The indices of matching compounds in the database.}
  \item{scores}{The similarity scores between the matching compounds and the
  query compound}
}
\references{Chen X and Reynolds CH (2002). "Performance of similarity measures
in 2D fragment-based similarity searching: comparison of structural descriptors
and similarity coefficients", in \emph{J Chem Inf Comput Sci}.}
\author{Y. Eddie Cao, Li-Chang Cheng}
\seealso{\code{\link{cmp.parse1}}, \code{\link{cmp.parse}},
	\code{\link{cmp.search}}, \code{\link{cmp.cluster}},
	\code{\link{cmp.similarity}}, \code{\link{sdf.visualize}}}
\examples{
## Load sample SD file
# data(sdfsample); sdfset <- sdfsample

## Generate atom pair descriptor database for searching
# apset <- sdf2ap(sdfset) 

## Loads same atom pair sample data set provided by library
data(apset) 
db <- apset
query <- db[1]

## Ooptinally, save the db for future use
save(db, file="db.rda", compress=TRUE)

## Search for similar compounds using similarity cutoff
cmp.search(db, query, cutoff=0.2, type=1) # returns index
cmp.search(db, query, cutoff=0.2, type=2) # returns named vector
cmp.search(db, query, cutoff=0.2, type=3) # returns data frame

## in the next session, you may use load a saved db and do the search:
load("db.rda")
cmp.search(db, query, cutoff=3)
## you may also use the loaded db to do clustering:
cmp.cluster(db, cutoff=0.35)
}
\keyword{utilities}

\name{fpSim}
\alias{fpSim}
\title{
Fingerprint Search 
}
\description{ Search function for fingerprints, such as PubChem or atom pair fingerprints.
	Enables structure similarity comparisons, searching and clustering.
}
\usage{
fpSim(x, y, sorted=TRUE, method="Tanimoto", 
		addone=1, cutoff=0, top="all", alpha=1, beta=1,
		parameters=NULL,scoreType="similarity")
}
\arguments{
  \item{x}{
Query molecule of class \code{numeric}, \code{FP} or \code{FPset} (of length one) containing binary fingerprint data. Both \code{x} and \code{y} need to have the same number of bits and should contain the same type of fingerprints.
}
  \item{y}{
Subject molecule(s) of class \code{numeric}, \code{matrix}, \code{FP} or \code{FPset} containing binary fingerprint data.
}
  \item{sorted}{
return results sorted or unsorted
}
  \item{method}{ Similarity coefficient to return. One can choose here from several
	  predefined similarity measures: "Tanimoto" (default), "Euclidean", "Tversky" or
	  "Dice". Alternatively, one can pass on any custom similarity function containing the
	  arguments a, b, c and d. For instance, one can define "myfct <- function(a, b, c, d)
	  c/(alpha*a + beta*b + c)" and then pass on \code{method=myfct}. The variable 'c' is
	  the number of "on-bits" common in both compounds, 'd' is the number of "off-bits"
	  common in both compounds, and 'a' and 'b' are the number of "on-bits" that are unique
	  in one or the other compound, respectively.

	  The predefined methods will run a C++ version of this function which is about twice as
	  fast as the R version. When a custom similarity function is given however, it will fall 
	  back to using the R version. 
}
  \item{addone}{
		Value to add to numerator and denominator of similarity coefficient to avoid devision by zero when fingerprint(s) contain only "off-bits" (zeros). Note: if \code{addone > 0} then fingerprints with no "on-bits" will receive the highest similarity score. Typically, this occurs only with extremely small molecules.
	}
  \item{cutoff}{
		allows to restrict results to hits above a similarity cutoff value; default \code{cutoff=0} returns results for all compounds in \code{y}.
	}
  \item{top}{
		allows to restrict number of subject molecules to return; default \code{top="all"} returns results for all compounds in \code{y} above \code{cutoff} value.
	}
  \item{alpha}{
		Only used when method="Tversky". Allows to specify the weighting variable 'alpha' of the Tversky index: c/(alpha*a + beta*b + c)
	}
  \item{beta}{
		Only used when method="Tversky". Allows to specify the weighting variable 'beta' of the Tversky index. 
	}
	\item{parameters}{
		Parameters for computing Z-scores, E-values, and p-values. Pass this data if you want these
		scores returned. This data can be generated with the \code{\link{genParameters}} function.
	}
	\item{scoreType}{
		If using the \code{parameters} argument, this argument specified which type of score the
		\code{cutoff} and \code{sorted} arguments should be applied to. It should be one of "similarity" (default),
		"zscore", "evalue", or "pvalue".
	}
}
\value{
Returns \code{numeric vector} with similarity coefficients as values and compound identifiers as names. 
}
\references{
Tanimoto similarity coefficient: Tanimoto TT (1957) IBM Internal Report 17th Nov see also Jaccard P (1901) Bulletin del la Societe Vaudoisedes Sciences Naturelles 37, 241-272.

PubChem fingerprint specification: ftp://ftp.ncbi.nih.gov/pubchem/specifications/pubchem_fingerprints.txt
}
\author{
Thomas Girke, Kevin Horan
}

\seealso{
Functions: \code{fp2bit} 
}
\examples{
## Load PubChem SDFset sample
data(sdfsample); sdfset <- sdfsample
cid(sdfset) <- sdfid(sdfset)

## Convert base 64 encoded fingerprints to character vector or binary matrix
fpset <- fp2bit(sdfset)

## Alternatively, one can use atom pair fingerprints 
\dontrun{
fpset <- desc2fp(sdf2ap(sdfset))
}

## Pairwise compound structure comparisons
fpSim(x=fpset[1], y=fpset[2], method="Tanimoto")

## Structure similarity searching: x is query and y is fingerprint database  
fpSim(x=fpset[1], y=fpset) 

## Controlling the output
fpSim(x=fpset[1], y=fpset, method="Tversky", cutoff=0.4, top=4, alpha=0.5, beta=1) 

## Use custom distance function
myfct <- function(a, b, c, d) c/(a+b+c+d)
fpSim(x=fpset[1], y=fpset, method=myfct) 

## Compute fingerprint-based Tanimoto similarity matrix 
simMA <- sapply(cid(fpset), function(x) fpSim(x=fpset[x], fpset, sorted=FALSE)) 

## Hierarchical clustering with simMA as input
hc <- hclust(as.dist(1-simMA), method="single")

## Plot hierarchical clustering tree
plot(as.dendrogram(hc), edgePar=list(col=4, lwd=2), horiz=TRUE) 
}
\keyword{utilities}

\name{cmp.duplicated}
\alias{cmp.duplicated}
\title{quickly detect compound duplication in a descriptor database}
\description{
    'cmp.duplicated' detects duplicated compounds from a descriptor
        database generated by 'cmp.parse'. Two compounds are said to
        duplicate each other when their descriptors are the same. 
}
\usage{
    cmp.duplicated(db, sort = FALSE, type=1)
}
\arguments{
  \item{db}{The desciptor database, in the format returned by 'cmp.parse'.}
  \item{sort}{Whether to sort the descriptors for a compound. See details.}
  \item{type}{Returns results as vector (type=1) or data frame (type=2).}
}
\details{
    'cmp.duplicated' will take the descriptors in the descriptor database,
    concatenate all descriptors for the same compound into a string, and use
    this string as the identification of a compound. If two compounds share
    the same identification string,  they are said to duplicate each other.

    'cmp.duplicated' assume the the database passed in as argument to follow
    the format generated by 'cmp.parse'. That is, 'db' is a list,
    'db$descdb' is a list, and each entry of 'db$descdb' is an array of numeric
    values that give descriptors for one compound.

    By default, 'cmp.duplicated' will assume the descriptors for a compound is
    already sorted. That is each entry in 'db\$descdb' is a sorted array. This
    is true for database generated by 'cmp.parse'. If you generate the database
    using some other tools, you might want to enable sorting.
        
}
\value{
    Returns a logic array, telling whether a compound in the database is a
    duplication of a compound appearing before this one. For example, if the
    i-th element of the array is TRUE, it means that the i-th compound in the
    database is a duplication of a compound listed before this compound in the
    database.

    The returned array can be used to remove duplication. Simply use it to
    index the descriptor database.

    If you are interested in what compound is duplicated, you can do a search
    in the database with cutoff set to 1.
}
\author{Y. Eddie Cao}
\seealso{\code{\link{cmp.parse}}, \code{\link{cmp.search}}}
\examples{
## Load sample SD file
# data(sdfsample); sdfset <- sdfsample

## Generate atom pair descriptor database for searching
# apset <- sdf2ap(sdfset) 

## Loads same atom pair sample data set provided by library
data(apset) 
db <- apset

## Manually create a duplication (here compound 1 and 10)
db[10] <- db[1]

## Find duplication
dup <- cmp.duplicated(db)
dup
cid(db[dup])

## Remove all duplications 
db <- db[!dup]
}
\keyword{utilities}

\name{validSDF}
\alias{validSDF}
\title{
Validity check of SDFset
}
\description{
Performs validity check of SDFs stored in \code{SDFset} objects. Currently, the function tests whether the atom block and the bond block in each \code{SDF} component of an \code{SDFset} have at least \code{Nabcol} and \code{Nbbcol} columns (default is 3 for both). In additions, it tests for the presence of NA values in the atom and bond blocks. The function returns a logical vector with \code{TRUE} values for valid compounds and \code{FALSE} values for invalid ones.
}
\usage{
validSDF(x, Nabcol = 3, Nbbcol = 3, logic = "&", checkNA=TRUE)
}
\arguments{
  \item{x}{
\code{x} object of class \code{SDFset}
}
  \item{Nabcol}{
minimum number of columns in atom block
}
  \item{Nbbcol}{
minimum number of columns in bond block
}
  \item{logic}{
logical connection (& or |) among Nabcol and Nbbcol cutoffs 
}
  \item{checkNA}{
checks for NA values in atom and bond blocks
}
}
\details{
The function is important to remove invalid compounds from \code{SDFset} containers.
}
\value{
\code{logical} vector of length \code{x} with \code{TRUE} for valid compounds and \code{FALSE} for invalid compounds.
}
\references{
...
}
\author{
Thomas Girke
}
\seealso{
Functions: \code{read.SDFset}
}
\examples{
## SDFset instance
data(sdfsample)
sdfset <- sdfsample

## Detect and remove invalid SDFs in SDFset. 
valid <- validSDF(sdfset)
which(!valid) # Returns index for invalid SDFs
sdfset <- sdfset[valid] # Returns only valid SDFs.
}
\keyword{ utilities }

\name{read.AP}
\alias{read.AP}
\title{
Read Atom Pair/Fingerprint Strings
}
\description{
Function to convert atom pairs (AP) or fingerprints (e.g. AP fingerprints) stored as character strings to \code{APset} or \code{FPset} objects (e.g. generated by \code{sdfStream}). Alternatively, one can provide the AP or fingerprint strings in a named character vector.
}
\usage{
read.AP(x, type, colid, isFile = class(x) == "character" & length(x) == 1)
}
\arguments{
  \item{x}{
name of file from where to read the AP/APFP character strings; or named character vector containing the AP/APFP strings
}
  \item{type}{
\code{type="ap"} for AP character string input, and \code{type="fp"} for fingerprint character string input
}
  \item{colid}{
column containing AP/FP character strings if \code{x} is a file
}
	\item{isFile}{
		Is \code{x} a file name or not?
	}
}
\details{
...
}
\value{
object of class \code{APset} or \code{FPset}
}
\references{
...
}
\author{
Thomas Girke
}
\seealso{
\code{sdf2ap}, \code{sdfStream}
}
\examples{
## Load sample data
library(ChemmineR)
data(sdfsample); sdfset <- sdfsample
\dontrun{write.SDF(sdfset, "test.sdf")

## Define descriptor set in a simple function
desc <- function(sdfset) {
        cbind(SDFID=sdfid(sdfset), 
              # datablock2ma(datablocklist=datablock(sdfset)), 
              MW=MW(sdfset), 
              groups(sdfset),
              APFP=desc2fp(x=sdf2ap(sdfset), descnames=1024, type="character"), 
              AP=sdf2ap(sdfset, type="character"),
              rings(sdfset, type="count", upper=6, arom=TRUE)
        )
}

## Run sdfStream with desc function and write results to a file called 'matrix.xls'
sdfStream(input="test.sdf", output="matrix.xls", fct=desc, Nlines=1000)

## Select molecules from SD File using line index from sdfStream
indexDF <- read.delim("matrix.xls", row.names=1)[,1:4]
indexDFsub <- indexDF[indexDF$MW < 400, ] # Selects molecules with MW < 400
sdfset <- read.SDFindex(file="test.sdf", index=indexDFsub, type="SDFset")

## Write result directly to SD file without storing larger numbers of molecules in memory
read.SDFindex(file="test.sdf", index=indexDFsub, type="file", outfile="sub.sdf")

## Read AP/APFP strings from file into APset or FP object
apset <- read.AP(x="matrix.xls", type="ap", colid="AP")
apfp <- read.AP(x="matrix.xls", type="apfp", colid="APFP")

## Alternatively, one can provide the AP/APFP strings in a named character vector
apset <- read.AP(x=sdf2ap(sdfset[1:20], type="character"), type="ap")
apfp <- read.AP(x=desc2fp(x=sdf2ap(sdfset[1:20]), descnames=1024, type="character"), type="apfp")
}
}
\keyword{ utilities }

\name{atomcount}
\alias{atomcount}
\alias{atomcountMA}
\alias{MW}
\alias{MF}
\title{
Molecular property functions
}
\description{
Functions to compute molecular properties: weight, formula, atom frequencies, etc. 
}
\usage{
atomcount(x, addH = FALSE, ...)

atomcountMA(x, ...)

MW(x, mw=atomprop, ...)

MF(x, ...)
}
\arguments{
\item{x}{
object of class \code{SDFset} or \code{SDF}
}
\item{mw}{
\code{data.frame} with atomic weights; imported by default with data(atomprop); supports custom data sets
}
\item{addH}{
'addH = TRUE' should be passed on to any of these function to add hydrogens that are often not specified in SD files
}
\item{\dots}{
Arguments to be passed to/from other methods.
}
}
\details{
...
}
\value{
\item{named vector}{\code{MW} and \code{MF}}
\item{list}{\code{atomcount}}
\item{matrix}{\code{atomcountMA}}
}
\references{
Standard atomic weights (2005) from: http://iupac.org/publications/pac/78/11/2051/
}
\author{
Thomas Girke
}

\seealso{
Functions: \code{datablock}, \code{datablocktag}
}
\examples{

## Instance of SDFset class
data(sdfsample)
sdfset <- sdfsample

## Compute properties; to consider missing hydrogens, set 'addH = TRUE'
MW(sdfset[1:4], addH = FALSE)
MF(sdfset[1:4], addH = FALSE)
atomcount(sdfset[1:4], addH = FALSE)
propma <- atomcountMA(sdfset[1:4], addH = FALSE)
boxplot(propma, main="Atom Frequency")

## Example for injecting a custom matrix/data frame into the data block of an
## SDFset and then writing it to an SD file
props <- data.frame(MF=MF(sdfset), MW=MW(sdfset), atomcountMA(sdfset))
datablock(sdfset) <- props
view(sdfset[1:4])
# write.SDF(sdfset[1:4], file="sub.sdf", sig=TRUE, cid=TRUE)

}

\keyword{ utilities }

\name{APset-class}
\Rdversion{1.1}
\docType{class}
\alias{APset-class}
\alias{[,APset-method}
\alias{[[,APset-method}
\alias{[[<-,APset-method}
\alias{[<-,APset-method}
\alias{ap,APset-method}
\alias{c,APset-method}
\alias{cid,APset-method}
\alias{cid<-,APset-method}
\alias{coerce,APset,AP-method}
\alias{coerce,APset,list-method}
\alias{coerce,list,APset-method}
\alias{length,APset-method}
\alias{show,APset-method}
\alias{view,APset-method}

\title{Class "APset"}
\description{
List-like container for storing the atom pair descriptors of a many compounds as objects of class \code{AP}. This container is used for structure similarity searching of compounds.
}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("APset", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{AP}:}{Object of class \code{"list"} }
    \item{\code{ID}:}{Object of class \code{"character"} }
  }
}
\section{Methods}{
  \describe{
    \item{[}{\code{signature(x = "APset")}: subsetting of class with bracket operator }
    \item{[[}{\code{signature(x = "APset")}: returns single component as \code{AP} object }
    \item{[[<-}{\code{signature(x = "APset")}: replacement method for single \code{AP} component }
    \item{[<-}{\code{signature(x = "APset")}: replacement method for several \code{AP} components }
    \item{ap}{\code{signature(x = "APset")}: returns atom pair list from AP slot }
    \item{c}{\code{signature(x = "APset")}: concatenates two \code{APset} containers }
    \item{cid}{\code{signature(x = "APset")}: returns all compound identifiers from ID slot }
    \item{cid<-}{\code{signature(x = "APset")}: replacement method for compound identifiers in ID slot }
    \item{coerce}{\code{signature(from = "APset", to = "AP")}: \code{as(apset, "AP")} }
    \item{coerce}{\code{signature(from = "APset", to = "list")}: \code{as(apset, "list")}  }
    \item{coerce}{\code{signature(from = "list", to = "APset")}: \code{as(list, "APset")}  }
    \item{length}{\code{signature(x = "APset")}: returns number of entries stored in object }
    \item{show}{\code{signature(object = "APset")}: prints summary of \code{APset}  }
    \item{view}{\code{signature(x = "APset")}: prints extended summary of \code{APset} }
	 }
}
\references{
Chen X and Reynolds CH (2002). "Performance of similarity measures
in 2D fragment-based similarity searching: comparison of structural descriptors
and similarity coefficients", in J Chem Inf Comput Sci.
}
\author{
Thomas Girke
}

\seealso{
Related classes: SDF, SDFset, SDFstr, AP, FPset, FP. 

Functions: \code{SDF2apcmp}, \code{apset2descdb}, \code{cmp.search}, \code{cmp.similarity}
}
\examples{
showClass("APset")

## Instance of SDFset class
data(sdfsample)
sdfset <- sdfsample[1:50]
sdf <- sdfsample[[1]]

## Compute atom pair library
ap <- sdf2ap(sdf)
(apset <- sdf2ap(sdfset))
view(apset[1:4])

## Return main components of APset object
cid(apset[1:4]) # compound IDs
ap(apset[1:4]) # atom pair descriptors

## Return atom pairs in human readable format
db.explain(apset[1]) 

## Coerce APset to other objects 
apset2descdb(apset) # returns old list-style AP database
tmp <- as(apset, "list") # returns list
as(tmp, "APset") # converst list back to APset

## Compound similarity searching with APset
cmp.search(apset, apset[1], type=3, cutoff=0.2) 
plot(sdfset[names(cmp.search(apset, apset[6], type=2, cutoff=0.4))])

## Identify compounds with identical AP sets 
cmp.duplicated(apset, type=2)

## Structure similarity clustering 
cmp.cluster(db=apset, cutoff = c(0.65, 0.5))[1:20,]

}
\keyword{classes}

\name{smartsSearchOB}
\alias{smartsSearchOB}
\title{
	SMARTS Search OB
}
\description{
	Perform searches for SMARTS patterns using Open Babel (requires
	ChemmineOB package to be installed).
}
\usage{
smartsSearchOB(sdfset, smartsPattern, uniqueMatches = TRUE)
}
\arguments{
  \item{sdfset}{
	  An SDFset of the compounds you want to search
}
  \item{smartsPattern}{
	  The SMARTS pattern as a string.
}
  \item{uniqueMatches}{
	  If true, only return the number of distinct matches, otherwise
	  return the number of all matches. 
}
}
\value{
	Returns a vector of counts, one for each input compound. 
}
\author{
	Kevin Horan
}


\examples{
	\dontrun{
		library(ChemmineOB)
		data(sdfsample)
		#look for rotable bonds
		rotableBonds = smartsSearchOB(sdfsample[1:5],"[!$(*#*)&!D1]-!@[!$(*#*)&!D1]",uniqueMatches=FALSE)
	}
}

\name{dbTransaction}
\alias{dbTransaction}
\title{
	DB Transaction
}
\description{
	Run any db statements inside a transaction. If any error is raised the transaction will
	be rolled back, otherwise it will be committed at the end. 
}
\usage{
dbTransaction(conn, expr)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{conn}{
	  A database connection object, such as is returned by \code{\link{initDb}}.
	}

  \item{expr}{
		Any block of code.
	}
}
\value{
	The value of the given block of code will be returned upon successfully commiting the	
	transaction. Otherwise an error will be raised.
}
\author{
	Kevin Horan
}
\examples{
	
   conn = initDb("test15.db")
	dbTransaction(conn,{
		# any db code here
	})
}

\name{sdf2ap}
\alias{sdf2ap}
\title{
Atom pair library
}
\description{
Creates from a \code{SDFset} a searchable atom pair library that is stored in a container of class \code{APset}.
}
\usage{
sdf2ap(sdfset, type = "AP",uniquePairs=TRUE)
}
\arguments{
  \item{sdfset}{
		Objects of classes \code{SDFset} or \code{SDF}
	}
  \item{type}{
		if \code{type="AP"}, the function returns \code{APset}/\code{AP} objects; if \code{type="character"}, it returns the result as a \code{character} vector of length one. The latter is useful for storing AP data in tabular files.
	}

	\item{uniquePairs}{
		When the same atom pair occurs more than once in a single compound, should the 
		names be unique or not? Setting this to true will take slightly longer to compute.
	}
}
\details{
...
}
\value{
\item{APset}{ if input is \code{SDFset}}
\item{AP}{ if input is \code{SDF}}
}
\references{
Chen X and Reynolds CH (2002). "Performance of similarity measures
in 2D fragment-based similarity searching: comparison of structural descriptors
and similarity coefficients", J Chem Inf Comput Sci.
}
\author{
Thomas Girke
}

\seealso{
Functions: \code{desc2fp}, \code{SDF2apcmp}, \code{apset2descdb}, \code{cmp.search}, \code{cmp.similarity}

Related classes: SDF, SDFset, SDFstr, APset. 
}
\examples{

## Instance of SDFset class
data(sdfsample)
sdfset <- sdfsample[1:50]
sdf <- sdfsample[[1]]

## Compute atom pair library
ap <- sdf2ap(sdf)
(apset <- sdf2ap(sdfset))
view(apset[1:4])

## Return main components of APset object
cid(apset[1:4]) # compound IDs
ap(apset[1:4]) # atom pair descriptors

## Return atom pairs in human readable format
db.explain(apset[1]) 

## Coerce APset to other objects 
apset2descdb(apset) # returns old list-style AP database
tmp <- as(apset, "list") # returns list
as(tmp, "APset") # converst list back to APset

## Compound similarity searching with APset
cmp.search(apset, apset[1], type=3, cutoff=0.2) 
plot(sdfset[names(cmp.search(apset, apset[6], type=2, cutoff=0.4))])

## Identify compounds with identical AP sets 
cmp.duplicated(apset, type=2)

## Structure similarity clustering 
cmp.cluster(db=apset, cutoff = c(0.65, 0.5))[1:20,]

}

\keyword{ utilities }

\name{parBatchByIndex}
\alias{parBatchByIndex}
\title{
	Parallel Batch By Index
}
\description{
	Takes an index set, breaks it into batches and runs the given function on each batch
	in parallel using the given cluster. See \code{\link{batchByIndex}} for the non-parallel version.

	When doing a select were the condition is a large number of ids it is not always possible
	to include them in a single SQL statement. This function will break the list of ids into chunks 
	and allow the indexProcessor to deal with just a small number of ids.
}
\usage{
parBatchByIndex(allIndices, indexProcessor, reduce, cl, batchSize = 1e+05)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{allIndices}{
		A vector of values that will be broken into batches and passed as an argument to the
		\code{indexProcessor} function.
	}
  \item{indexProcessor}{
  		A function that takes one batch if indices. It is called once for each batch, possibly in
		parallel. The return value of this function is collected into a list and passed to the
		\code{reduce} function after all jobs have finished.
	}
  \item{reduce}{
  		This function is run after all jobs have finished. It is called with a list of return values from
		the \code{indexProcessor} function runs.  The order of batchs is maintained. The return value of the \code{reduce}
		function is then returned.

		The idea is that this function merges all the results together into one result.
	}
  \item{cl}{
  		A SNOW cluster to run jobs on.
	}
  \item{batchSize}{
		The size of each batch. The last batch may be smaller than this value.
	}
}
\value{
	The return value of the \code{reduce} function is returned.
}
\author{
	Kevin Horan
}
\seealso{
\code{\link{batchByIndex}}
}
\examples{
	\dontrun{

		cl = makeCluster(2) # create a SNOW cluster

		#function to run a query for each batch of indexes
		job = function(indexBatch)
				dbGetQuery(dbConnection, paste("SELECT weight FROM table WHERE id IN (",paste(indexBatch,collapse=","),")"))

		# function to combine all the results, in this case by summing them up
		reduce = function(results) sum(unlist(results))

		indices = 1:10000

		#run queries in parallel and then sum the results
		totalWeight = parBatchByIndex(indices,job,reduce,cl, 1000)

	}
}

\name{getAtomAttr}
\alias{getAtomAttr}
\title{
	getAtomAttr
}
\description{
	On V3000 formatted compounds, returns the value of the given tag on the given atom number.
}
\usage{
getAtomAttr(x,atomId,tag)
}
\arguments{
  \item{x}{
		An \code{SDFset} of \code{ExtSDF} objects. \code{ExtSDF} objects are created with
		\code{read.SDFset} with \code{extendedAttributes=TRUE} when reading V3000 sdf files.
	}
  \item{atomId}{
	  The index of the atom to fetch the tag value from.
	}
	\item{tag}{
		The name of the tag to fetch the value of on the given atom.
	}
}
\value{
	The value of the given tag on the given atom.
}
\author{
	Kevin Horan
}
\examples{
	\dontrun{
		getAtomAttr(v3Sdfs,10,"CHG")
	}
}

\name{db.explain}
\alias{db.explain}
\title{Explain an atom-pair descriptor or an array of atom-pair descriptors}
\description{
'db.explain' will take an atom-pair descriptor in numeric or a set of such descriptors, and interpret what they represent in a more human readable way.
}
\usage{
db.explain(desc)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{desc}{The descriptor or the array/vector of descriptors}
}
\details{
	'desc' can be a single numeric giving a single descriptor or can be
	any container data type, such as vector or array, such that
	'length(desc)' returns 2 or larger.
}
\value{
    Return a character vector describing the descriptors.	
}

\seealso{\code{\link{cmp.parse}}}
\examples{
## Load sample SD file
# data(sdfsample); sdfset <- sdfsample

## Generate atom pair descriptor database for searching
# apset <- sdf2ap(sdfset) 

## Loads same atom pair sample data set provided by library
data(apset) 
db <- apset

## Return atom pairs of first compound in human readable format
db.explain(db[1])
}
\keyword{utilities}

\name{db.subset}
\alias{db.subset}
\title{Subset a descriptor database and return a sub-database for the selected compounds}
\description{
'db.subset' will take a descriptor database generated by 'cmp.parse' and an
array of indecies, and return a new database for compounds
corresponding to these indecies. The returned value is a descriptor database as returned by the \code{\link{cmp.parse}} function.
}
\usage{
db.subset(db, cmps)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{db}{The database generated by 'cmp.parse'}
  \item{cmps}{An array of indecies that correspond to a set of selected
	  compounds from the database}
}
\details{
	'db.subset' creates a sub-database from 'db' by only including
	infomration that is relevant to compounds indexed by 'cmps'.
}
\value{
	Return a descriptor database for the selected compounds. The format of the database is compatible with the one returned by \code{\link{cmp.parse}}.
}

\seealso{\code{\link{cmp.parse}}, \code{\link{sdf.subset}}}
\examples{
## Note: this functionality has become obsolete since the introduction of the 
## 'apset' S4 class.

## Load sample SD file
# data(sdfsample); sdfset <- sdfsample

## Generate atom pair descriptor database for searching
# apset <- sdf2ap(sdfset) 

## Loads same atom pair sample data set provided by library
data(apset) 
db <- apset
olddb <- apset2descdb(db)

## Create a sub-database for the 1st and 2nd compound in that SDF
db_sub <- db.subset(olddb, c(1, 2))

}
\keyword{utilities}

\name{status}
\alias{status}
\title{
Get Status of a ChemMine Tools Job
}
\description{
Returns the status of a launched ChemMine Tools job as represented by a \code{jobToken} object.
}
\usage{
status(object)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{object}{
A \code{jobToken} job as returned by the function \code{launchCMTool}
}
}
\value{
The status of the specified job is returned as a string. Possible values include "RUNNING", "FINISHED", or "FAILED".
}
\references{
See ChemMine Tools at \url{http://chemmine.ucr.edu}.
}
\author{
Tyler William H Backman
}

\seealso{
Functions: \code{toolDetails}, \code{listCMTools}, \code{launchCMTool}, \code{browseJob}, \code{result}
}
\examples{
\dontrun{
## list available tools
listCMTools()

## get detailed instructions on using a tool
toolDetails("Fingerprint Search")

## download compound 2244 from PubChem
job1 <- launchCMTool("pubchemID2SDF", 2244)

## check job status and download result
status(job1)
result1 <- result(job1)
}
}
\keyword{ utilities }

\name{apfp}
\alias{apfp}
\docType{data}
\title{
Frequent Atom Pairs
}
\description{
Ranked set of 4096 most frequent atom pairs observed in the compound collection from DrugBank with a MW < 1000. Their atom pairs were generated with the \code{sdf2ap} function. The provided data frame is sorted row-wise by atom pair frequency and only the 4096 most frequent atom pairs are included. This data set can be used as predefined atom pair selection when computing atom pair fingerprints with the \code{desc2fp} function.
}
\usage{data(apfp)}
\format{
  Object of class \code{data.frame}. First column contains atom pair (AP) IDs and the second column their frequency in DrugBank compounds.
}
\details{
Object stores 4096 most frequent atom pairs generated from DrugBank compounds.
}
\source{
DrugBank: http://www.drugbank.ca/
}
\references{
Chen X and Reynolds CH (2002). "Performance of similarity measures
in 2D fragment-based similarity searching: comparison of structural descriptors
and similarity coefficients", J Chem Inf Comput Sci.
}
\examples{
data(apfp)
apfp[1:4,]
}
\keyword{datasets}

\name{jarvisPatrick_c}
\alias{jarvisPatrick_c}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
	Jarvis Patrick Clustering in C code
}
\description{
	This not meant to be used directly, use \code{\link{jarvisPatrick}} instead. It is exposed so other
	libraries can make use of it.
}
\usage{
jarvisPatrick_c(neighbors,minNbrs,fast=TRUE,bothDirections=FALSE,linkage = "single")
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{neighbors}{
	  A matrix of integers. Non integer matricies will be coerced. 
	  Each row represensts one element, indexed 1 to N. The values in row
	  i should be the index value of the neighbors of i. Thus, each value should 
	  itself be a valid row index. 
}
  \item{minNbrs}{
	  The minimum number of common neibhbors needed for two elements to be merged.
}
  \item{fast}{
	  If true, only the neibhors given in each row are checked to see if they share \code{minNbrs} 
	  neighbors in common. If false, all pairs of elements are compared. For a matrix of size NxM,
	  the first method yeilds a running time of O(NM), while the second yeilds a running time of O(N^2).
}
  \item{bothDirections}{
	  If true, two elements must contain each other in their neighbor list in order to be merged.
	  If false and fast is true, then only one element must contain the other as a neighbor. If
	  false and fast is false, than neither element must contain the other as a neighbor, though
	  in all cases there must still be at least \code{minNbrs} neibhros in common.
}
	\item{linkage}{
		See \code{\link{jarvisPatrick}} for details.
	}
}
\value{
	A cluster array with no names.
}
\author{
	Kevin Horan
}

\name{rings}
\alias{rings}
\title{
Ring and Aromaticity Perception
}
\description{
Identifies all possible rings in molecules using the exhaustive ring perception
algorithm from Hanser et al (1996). In addition, the function can return all
smallest possible rings as well as aromaticity information for each ring.

Note that large molecules can cause this function to run for an extremely long 
amount of time. Use the \code{upper} parameter to limit the ring size if run time
is a problem. 
}
\usage{
rings(x, upper = Inf, type = "all", arom = FALSE, inner = FALSE)
}
\arguments{
  \item{x}{
\code{SDF} or \code{SDFset} containers
}
  \item{upper}{
		allows to specify an upper length limit for ring predictions. The default setting \code{upper=Inf} will return all possible rings. Smaller
		length limits will reduce the search space resulting in shortened compute times.  
  }
  \item{type}{
		if \code{type="all"}, the function returns each ring of a compound as character vector of atom symbols that are numbered by their position
		in the atom block of an \code{SDF/SDFset} object. Note: the example below shows how to plot structures with the same numbering information
		for visual inspection. If \code{type="arom"}, only aromatic rings are returned, while \code{type="count"} returns the ring and/or
		aromaticity counts for each compound in a matrix.  
  }
  \item{arom}{
		if \code{arom="TRUE"}, ring aromaticity information will be computed. If \code{type="all"}, the output is a logical vector where 'TRUE'
		values indicate aromatic rings in the associated ring list. If \code{type="arom"}, then the function returns only aromatic rings. A ring
		is considered aromatic if it meets the following requirements: (i) all atoms in the ring need to be sp2 hybridized. This means each atom
		has to have a double bond or at least one lone electron pair and it needs to be attached to an sp2 hybridized atom. (ii) In addition,
		Hueckel's rule '4n + 2' needs to be true, where 'n' is either zero or any positive integer.   

		Note that setting \code{arom="TRUE"} will also set \code{uppper=Inf}.
  }
  \item{inner}{
		if \code{inner="TRUE"}, only inner (smallest possible) rings will be returned. They are identified by first computing all possible rings
		and then selecting only the inner rings. Note: this requires the setting \code{upper=Inf}. If only rings below a certain size limit (e.g.
		6) are of interest, then it will be more time efficient to set this limmit under the \code{upper} argument than identifying all smallest
		rings.  
  }
}
\details{
...
}
\value{
The settings \code{type="all"} and \code{type="arom"} return \code{lists}, and \code{type="count"} returns a \code{matrix}. 
}
\references{
Hanser, Jauffret and Kaufmann (1996) A New Algorithm for Exhaustive Ring Perception in a Molecular Graph.
Journal of Chemical Information and Computer Sciences, 36: 1146-1152.
URL: http://pubs.acs.org/doi/abs/10.1021/ci960322f
}
\author{
Thomas Girke
}
\seealso{
...
}
\examples{
## Instances of SDFset class
data(sdfsample)
sdfset <- sdfsample

## Return all possible rings for a single compound 
rings(sdfset[1], upper=Inf, type="all", arom=FALSE, inner=FALSE)
plot(sdfset[1], print=FALSE, atomnum=TRUE, no_print_atoms="H") 

## Return all possible rings for several compounds plus their 
## aromaticity information
rings(sdfset[1:4], upper=Inf, type="all", arom=TRUE, inner=FALSE)

## Return rings with no more than 6 atoms
rings(sdfset[1:4], upper=6, type="all", arom=TRUE, inner=FALSE)

## Return rings with no more than 6 atoms that are also armomatic
rings(sdfset[1:4], upper=6, type="arom", arom=TRUE, inner=FALSE)

## Return shortest possible rings (no complex rings)
rings(sdfset[1:4], upper=Inf, type="all", arom=TRUE, inner=TRUE)

## Count shortest possible rings
rings(sdfset[1:4], upper=Inf, type="count", arom=TRUE, inner=TRUE)
}
\keyword{ utilities }

\name{pubchemName2CID}
\alias{pubchemName2CID}
\title{
	Translate compound name to pubchem compound id
}
\description{
	Takes any compound name and queries pubchem to find its pubchem id (CID).
}
\usage{
pubchemName2CID(name)
}

\arguments{
  \item{name}{
	  Any compound name, used to query pubchem to find the compound. 
}
}
\value{
	The result is the pubchem compound id. If the name is not found, NA will be returned.
}
\references{
PubChem PUG REST: https://pubchem.ncbi.nlm.nih.gov/pug_rest/PUG_REST_Tutorial.html

}
\author{
	Kevin Horan
}

\examples{
\dontrun{
## fetch 2 compounds from PubChem
cid <- pubchemName2CID("CHEMBL460363")
}
}

\keyword{ utilities }

\name{smisample}
\alias{smisample}
\docType{data}
\title{
SMILES file in \code{SMIset} object
}
\description{
First 100 compounds from PubChem SD file (Compound_00650001_00675000.sdf.gz) converted to SMILES format
}
\usage{data(smisample)}
\format{
  Object of class \code{smiset}
}
\details{
Object stores 100 molecules from a sample SMILES file.
}
\source{
ftp://ftp.ncbi.nih.gov/pubchem/Compound/CURRENT-Full/SDF/Compound_00650001_00675000.sdf.gz
}
\references{
SMILES (Simplified molecular-input line-entry system) format definition:
http://en.wikipedia.org/wiki/Simplified_molecular-input_line-entry_system
}
\examples{
data(smisample)
smiset <- smisample
view(smiset[1:4])
}
\keyword{datasets}

\name{write.SDF}
\alias{write.SDF}
\title{
SDF export function
}
\description{
Writes one or many molecules stored in a \code{SDFset}, \code{SDFstr} or \code{SDF} object to SD file.
}
\usage{
write.SDF(sdf, file, cid = FALSE, ...)
}
\arguments{
  \item{sdf}{
object of class \code{SDFset}, \code{SDFstr} or \code{SDF}
}
  \item{file}{
name of SD file to write to
}
  \item{cid}{
if \code{cid = TRUE} and an \code{SDFset} object is provide as input, then the compound IDs in the ID slot of the \code{SDFset} are used for compound naming
}
  \item{\dots}{
the optional arguments of the \code{sdf2str} function can be provided here, including \code{head, ab, bb, db}; details are provided in the help page for the \code{sdf2str} function
}
}
\details{
If the \code{write.SDF} function is supplied with an \code{SDFset} object, then it uses internally the \code{sdf2str} function to allow customizing the resulting SD file. For this all optional arguments of the \code{sdf2str} function can be passed on to \code{write.SDF}.
}

\references{
SDF format definition: http://www.symyx.com/downloads/public/ctfile/ctfile.jsp
}
\author{
Thomas Girke
}

\seealso{
Import function: \code{read.SDFset}, \code{read.SDFstr}
}
\examples{
## Instance of SDFset class
data(sdfsample); sdfset <- sdfsample

## Write objects of classes SDFset/SDFstr/SDF to file
# write.SDF(sdfset[1:4], file="sub.sdf")

## Example for writing customized SDFset to file containing
## ChemmineR signature, IDs from SDFset and no data block
# write.SDF(sdfset[1:4], file="sub.sdf", sig=TRUE, cid=TRUE, db=NULL)

## Example for injecting a custom matrix/data frame into the data block of an
## SDFset and then writing it to an SD file
props <- data.frame(MF=MF(sdfset), MW=MW(sdfset), atomcountMA(sdfset))
datablock(sdfset) <- props
view(sdfset[1:4])
# write.SDF(sdfset[1:4], file="sub.sdf", sig=TRUE, cid=TRUE)
}

\keyword{ utilities }

\name{pubchemInchi2cid}
\alias{pubchemInchi2cid}
\title{
Query pubchem by InChI sttrings and return CIDs
}
\description{
Use PubChem API to get CIDs by InChI sttrings. This function sends 
 one request per InChI. For courtesy, it is not recommended to parellelize this function. 

}
\usage{
pubchemInchi2cid(inchis, verbose = TRUE)
}

\arguments{
  \item{inchis}{
	  Character vector of InChI strings
  }
  \item{verbose}{
	  Logical, show verbose information?
  }
}
\value{
a numeric vector of CIDs with names. Successful requests will have empty 
 names, requests with invalid InChI strings will have name "invalid" and requests 
 with valid InChI but not found in PubChem will have name "not_found"

}
\references{
PubChem PUG REST: https://pubchem.ncbi.nlm.nih.gov/pug_rest/PUG_REST_Tutorial.html

}
\author{
	Le Zhang
}

\examples{
	\dontrun{
	  inchis <- c(
         "InChI=1S/C15H26O/c1-9(2)11-6-5-10(3)15-8-7-14(4,16)13(15)12(11)15/h9-13,16H,5-8H2,1-4H3/t10-,11+,12-,13+,14+,15-/m1/s1", 
         "InChI=1S/C3H8/c1-3-2/h3H2,1-2H3", 
         "InChI=1S/C15H20Br2O2/c1-2-12(17)13-7-3-4-8-14-15(19-13)10-11(18-14)6-5-9-16/h3-4,6,9,11-15H,2,7-8,10H2,1H3/t5-,11-,12+,13+,14-,15-/m1/s1",
         "InChI=abc"
     )
     pubchemInchi2cid(inchis)

	}
}

\keyword{ utilities }

\name{findCompoundsByName}
\alias{findCompoundsByName}
\title{
	Find compound by name
}
\description{
	Find the ids of compounds given the names.
}
\usage{
findCompoundsByName(conn, names, keepOrder = FALSE, allowMissing = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{conn}{
	  A database connection object, such as is returned by \code{\link{initDb}}.
   }
  \item{names}{
     A list of names of compounds to search for. The names are those that would be
     returned by \code{\link{sdfid}}. An error will be raised if any names
     are not found.

   }
  \item{keepOrder}{
     If true, the order of the output compound ids will be the same as the 
     input names. This imposes a performance hit that can be significant for
     large datasets, thus it should be left FALSE unless needed.
   }
	\item{allowMissing}{
		When this is false an error will be raised when names queried were not found in the database. 
		If true, just those that are found will be returned with no error or warning.
	}
}
\value{
   Returns the compound ids for compounds with the given name. The output
   order is not guaranteed unless keepOrder is set to TRUE.
   An error will be raised if any name cannot be found.
}
\author{
   Kevin Horan
}

\examples{
   #create and initialize a new SQLite database
   conn = initDb("test4.db")

	data(sdfsample)

	#just load the data with no features or descriptors
	ids=loadSdf(conn,sdfsample)

   # find id of compound 650003
   findCompoundsByName(conn,c("650003"))
	unlink("test4.db")
}

\name{cid}
\alias{cid}
\alias{cid<-}
\title{
Return compound IDs
}
\description{
Returns the compound identifiers from the ID slot of an \code{SDFset} object. 
}
\usage{
cid(x)
}
\arguments{
  \item{x}{
object of class \code{SDFset} or \code{APset}
}
}
\details{
...
}
\value{
\code{character} vector}

\references{
...
}
\author{
Thomas Girke
}
\seealso{
\code{atomblock}, \code{atomcount}, \code{bondblock}, \code{datablock}, \code{header}, \code{sdfid} 
}
\examples{
## SDFset/APset instances
data(sdfsample)
sdfset <- sdfsample
apset <- sdf2ap(sdfset[1:4])

## Extract compound IDs from SDFset/APset
cid(sdfset[1:4])
cid(apset[1:4])

## Extract IDs defined in SD file
sdfid(sdfset[1:4])

## Assigning compound IDs and keeping them unique
unique_ids <- makeUnique(sdfid(sdfset))
cid(sdfset) <- unique_ids 
cid(sdfset[1:4])

## Replacement Method
cid(sdfset) <- as.character(1:100)

}

\keyword{ utilities }

\name{datablock2ma}
\alias{datablock2ma}
\alias{splitNumChar}
\title{
SDF data blocks to matrix
}
\description{
Convert data blocks in \code{SDFset} to character matrix with
\code{datablock2ma}, then store its numeric columns as numeric matrix and its
character columns as character matrix.  }
\usage{
datablock2ma(datablocklist, cleanup = " \\\(.*", ...)   

splitNumChar(blockmatrix)

}
\arguments{
  \item{datablocklist}{
\code{list} of data block vectors; can be created with \code{datablock(sdfset)}
}
  \item{blockmatrix}{
\code{matrix} returned by \code{datablock2ma} 
}
  \item{cleanup}{
\code{character} pattern to be used to clean up the name fields of the data block vectors; the exact pattern matches are replaced by nothing (deleted).
}
  \item{\dots}{
option to pass on additional arguments
}
}
\details{
...
}
\value{
\item{datablock2ma}{\code{character matrix}}
\item{splitNumChar}{\code{list} with two components, a numeric matrix and a character matrix}
}
\references{
...
}
\author{
Thomas Girke
}

\seealso{
Classes: \code{SDFset}
}
\examples{

## SDFset instance
data(sdfsample)
sdfset <- sdfsample

# Convert data block to matrix  
blockmatrix <- datablock2ma(datablocklist=datablock(sdfset)) 
blockmatrix[1:4, 1:4]

# Split matrix to numeric matrix and character matrix
numchar <- splitNumChar(blockmatrix=blockmatrix)
names(numchar)
numchar[[1]][1:4,] 
numchar[[2]][1:4,] 
}

\keyword{ utilities }

\name{connections}
\alias{DUD}
\alias{DrugBank}
\title{
	Database Connections
}
\description{
	Get a connection to one of the pre-build compound databases.
	The DrugBank database is distributed in the ChemmineDrugs package.

	The DUD database will be downloaded the first time it is called.
	It will download a 1.8GB zipped file which will expand to abut 9GB.
	A directory to store the database in can be passed to the \code{DUD()} function.

}
\usage{
DUD(destinationDir=".")

DrugBank()
}
\arguments{
  \item{destinationDir}{
	  The directory to store the downloaded DUD database in.
	}
}

\value{
	A connection object to the ether the DUD or DrugBank database.
	This object must be passed to other functions which make use of the connection.
}
\author{
	Kevin Horan
}

\examples{
	dbConn = DrugBank()
}

\name{cmp.cluster}
\alias{cmp.cluster}
\title{cluster compounds using a descriptor database}
\description{
	'cmp.cluster' uses structural compound descriptors and clusters the
		compounds based on their pairwise distances. \code{cmp.cluster} uses
		single linkage to measure distance between clusters when it
		merges clusters. It accepts both a single cutoff and a
		cutoff vector. By using a cutoff vector, it can generate results
		similar to hierarchical clustering after tree cutting.
}
\usage{
cmp.cluster(db, cutoff, is.similarity = TRUE, save.distances = FALSE,
        use.distances = NULL, quiet = FALSE, ...)
}
\arguments{
  \item{db}{The desciptor database, in the format returned by 'cmp.parse'.}
  \item{cutoff}{The clustering cutoff. Can be a single value or a vector. The
      cutoff gives the maximum distance between two compounds in order to
      group them in the same cluster.}
  \item{is.similarity}{Set when the cutoff supplied is a similarity cutoff.
      This cutoff is the minimum similarity value between two compounds such
      that they will be grouped in the same cluster.}
  \item{save.distances}{whether to save distance for future clustering. See
	  details below.}
  \item{use.distances}{Supply pre-computed distance matrix.}
  \item{quiet}{Whether to suppress the progress information.}
  \item{...}{Further arguments to be passed to \code{cmp.similarity}.}
}
\details{
    \code{cmp.cluster} will compute distances on the fly if \code{use.distances} is not set.
    Furthermore, if \code{save.distances} is not set, the distance values computed will never be
    stored and any distance between two compounds is guaranteed not to be
    computed twice. Using this method, \code{cmp.cluster} can deal with large databases
    when a distance matrix in memory is not feasible. The speed of the clustering
    function should be slowed when using a transient distance calculation.
	
    When \code{save.distances} is set, \code{cmp.cluster} will be forced to compute the
    distance matrix and save it in memory before the clustering. This is
    useful when additional clusterings are required in the future without re-computed 
    the distance matrix. Set \code{save.distances} to TRUE if you
    only want to force the clustering to use this 2-step approach; otherwise,
    set it to the filename under which you want the distance matrix to be
    saved. After you save it, when you need to reuse the distance matrix, you
    can 'load' it, and supply it to \code{cmp.cluster} via the \code{use.distances} argument.

    \code{cmp.cluster} supports a vector of several cutoffs. When you have multiple cutoffs,
    \code{cmp.cluster} still guarantees that pairwise distances will never be
    recomputed, and no copy of distances is kept in memory. It is guaranteed to
    be as fast as calling \code{cmp.cluster} with a single cutoff that results in the
    longest processing time, plus some small overhead linear in processing
    time.
}
\value{
    Returns a \code{data.frame}. Besides a variable giving compound ID, each of the
    other variables in the data frame will either give the cluster IDs of
    compounds under some clustering cutoff, or the size of clusters that the
    compounds belong to. When N cutoffs are given, in total 2*N+1 variables
    will be generated, with N of them giving the cluster ID of each compound
    under each of the N cutoffs, and the other N of them giving the cluster
    size under each of the N cutoffs. The rows are sorted by cluster sizes.
}
\author{Y. Eddie Cao, Li-Chang Cheng}
\seealso{\code{\link{cmp.parse1}}, \code{\link{cmp.parse}}, \code{\link{cmp.search}}, \code{\link{cmp.similarity}}}
\examples{
## Load sample SD file
# data(sdfsample); sdfset <- sdfsample

## Generate atom pair descriptor database for searching
# apset <- sdf2ap(sdfset) 

## Loads atom pair and atom pair fingerprint samples provided by library
data(apset) 
db <- apset
fpset <- desc2fp(apset)

## Clustering of 'APset' object with multiple cutoffs
clusters <- cmp.cluster(db=apset, cutoff=c(0.5, 0.85))

## Clustering of 'FPset' object with multiple cutoffs. This method allows to call 
## various similarity methods provided by the fpSim function.
clusters2 <- cmp.cluster(fpset, cutoff=c(0.5, 0.7), method="Tversky") 

## Saves the distance matrix before clustering:
clusters <- cmp.cluster(db, cutoff=0.65, save.distances="distmat.rda")
# Later one reload the matrix and pass it the clustering function. 
load("distmat.rda")
clusters <- cmp.cluster(db, cutoff=0.60, use.distances=distmat)
}
\keyword{utilities}

\name{ap}
\alias{ap}
\alias{ap-methods}
\title{
Return atom pair component of \code{AP/APset}
}
\description{
Returns atom pair component of objects of class \code{AP} or \code{APset} as list of vectors.
}
\usage{
ap(x)
}
\arguments{
  \item{x}{
Object of class \code{AP} and \code{APset}
}
}
\details{
...
}
\value{
\item{List}{ with one to many of following components:}
\item{numeric}{ atom pairs }
}
\references{
Chen X and Reynolds CH (2002). "Performance of similarity measures
in 2D fragment-based similarity searching: comparison of structural descriptors
and similarity coefficients", J Chem Inf Comput Sci.
}
\author{
Thomas Girke
}
\seealso{
Functions: \code{SDF2apcmp}, \code{apset2descdb}, \code{cmp.search}, \code{cmp.similarity}
}
\examples{

## Instance of SDFset class
data(sdfsample)
sdfset <- sdfsample[1:50]
sdf <- sdfset[[1]]

## Compute atom pair library
ap <- sdf2ap(sdf)
(apset <- sdf2ap(sdfset))
view(apset[1:4])

## Return main components of APset object
cid(apset[1:4]) # compound IDs
ap(apset[1:4]) # atom pair descriptors

## Return atom pairs in human readable format
db.explain(apset[1]) 

}

\keyword{ utilities }

\name{smiles2sdf}
\alias{smiles2sdf}
\alias{smiles2sdfOB}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Convert SMILES (\code{character}) to \code{SDFset}
}
\description{
	Accepts a named vector or \code{SMIset} of 
	SMILES (Simplified Molecular Input Line Entry Specification) strings and
	returns its equivalent as an \code{SDFset} container. 
	
	This function runs in two modes. If ChemmineOB is available then it will use OpenBabel
	to convert all the given smiles into an SDFset with 2D coordinates. Otherwise
	the compound is submitted to the ChemMine Tools web service for conversion
	with the Open Babel Open Source Chemistry Toolbox. In this case only the first element
	will be used since this is a very slow operation.
}
\usage{
	smiles2sdf(smiles)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{smiles}{
	  A named vector of SMILES strings. The names will be used to name the SDF objects.
}
}
\value{
	\item{SDFset}{ for details see ?"SDFset-class"}
}
\references{
Chemmine web service: http://chemmine.ucr.edu

Open Babel: http://openbabel.org

SMILES Format: http://en.wikipedia.org/wiki/Chemical_file_format#SMILES
}
\author{
Tyler Backman, Kevin Horan
}

\examples{
\dontrun{
## convert to sdf
data(smisample)
(sdf <- smiles2sdf(smisample[1:4]))
}
}
\keyword{ utilities }

\name{pubchemCidToSDF}
\alias{pubchemCidToSDF}
\title{
Import Compounds from PubChem
}
\description{
Accepts one or more PubChem compound ids
and downloads the corresponding compounds from PubChem Power User Gateway (PUG)
returning results in an \code{SDFset} container. 
}
\usage{
pubchemCidToSDF(cids)
}

\arguments{
  \item{cids}{
  	  A \code{numeric} object which contains one or more PubChem cids
}
}
\value{
\item{SDFset}{ for details see ?"SDFset-class"}
}
\references{
PubChem PUG REST: https://pubchem.ncbi.nlm.nih.gov/pug_rest/PUG_REST_Tutorial.html

}
\author{
	Kevin Horan
}

\examples{
\dontrun{
## fetch 2 compounds from PubChem
compounds <- pubchemCidToSDF(c(111,123))}
}

\keyword{ utilities }

\name{nearestNeighbors}
\alias{nearestNeighbors}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
   Nearest Neighbors
}
\description{
   Computes the nearest neighbors of descriptors in an FPset or APset object for use with the \code{\link{jarvisPatrick}} clustering
   function. Only one of \code{numNbrs} or \code{cutoff} should be given, \code{cutoff} will take precedence if
   both are given. If \code{numNbrs} is given, then that many neighbors will be returned for each item in the set.
   If \code{cutoff} is given, then, for each item X, every neighbor that has a similarity value greater than or equal to 
   the cutoff will be returned in the neighbor list for X.
}
\usage{
   nearestNeighbors(x, numNbrs = NULL, cutoff = NULL, ...)
}
\arguments{
  \item{x}{
     Either an FPset or an APset.
   }
  \item{numNbrs}{
     Number of neighbors to find for each item. If not enough neighbors can be found the 
     matrix will be padded with NA.
   }
  \item{cutoff}{
      The minimum similarity value an item must have to another item in order to be included in that
      items neighbor list. This parameter takes precedence over \code{numNbrs}.
      This parameter allows to obtain tighter clustering results.
   }
  \item{\dots}{
     These parameters will be passed into the distance function used, either \code{cmp.similarity} or 
     \code{fpSim}, for APset and FPset, respectively.
   }
}
\value{
   The return value is a list with the following components:
   \item{indexes}{index values of nearest neighbors, for each item. If \code{cutoff} is
      used, this will be a list of lists, otherwise it will be a matrix}
   \item{names}{The names of each item in the set, as returned by cid}
   \item{similarities}{The similarity values of each neighbor to the item for that row. 
      This will also be either a list of lists or a matrix, depending on whether or not
      \code{cutoff} was used. Each similarity values corresponds to the id number in the 
      same position in the indexes entry}
}
\author{
   Kevin Horan
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
   \code{\link{jarvisPatrick}}
   \code{\link{trimNeighbors}}
}
\examples{
   data(sdfsample)
   ap = sdf2ap(sdfsample)
   nnm = nearestNeighbors(ap,cutoff=0.5)
   clustering = jarvisPatrick(nnm,k=2,mode="a1b")
}

\name{cluster.visualize}
\alias{cluster.visualize}
\title{visualize clustering result using multi-dimensional scaling}
\description{
	'cluster.visualize' takes clustering result returned by 'cmp.cluster' and generate multi-dimensional scaling plot for visualization purpose.
}
\usage{
cluster.visualize(db, cls, size.cutoff, distmat=NULL, color.vector=NULL, non.interactive="", cluster.result=1, dimensions=2, quiet=FALSE, highlight.compounds=NULL, highlight.color=NULL, ...)
}
\arguments{
  \item{db}{The desciptor database, in the format returned by 'cmp.parse'.}
  \item{cls}{The clustering result returned by 'cmp.cluster'.}
  \item{size.cutoff}{The cutoff size for clusters considered in this visualization. Clusters of size smaller than the cutoff will not be considered.}
  \item{distmat}{A distance matrix that corresponds to the 'db'. If not provided, it will be computed on-the-fly in an efficient manner.}
  \item{color.vector}{Colors to be used in the plot. If the number of colors in the vector is not enough for the plot, colors will be reused. If not provided, color will be generated and randomly sampled from 'rainbow'.}
  \item{non.interactive}{If provided, will enable the non-interactive mode, and the plot will be in an eps file named after this value.}
  \item{cluster.result}{Used to select the clustering result if multiple clustering results are present in 'cls'.}
  \item{dimensions}{Dimensionality to be used in visualization. See details.}
  \item{quiet}{Whether to supress the progress bar.}
  \item{highlight.compounds}{A vector of compound IDs, corresponding to compounds to be highlighted in the plot. A highlighted compound is represented as a filled circle.}
  \item{highlight.color}{Color used for highlighted compounds. If not set, a highlighted compounds will have the same color as that used for other compounds in the same cluster.}
  \item{...}{Further arguments will be passed to 'cmp.similarity' to calculate similarity matrix.}
}
\details{
	'cluster.visualize' internally calls the 'cmdscale' function to
	generate a set of points in 2-D for the compounds in selected clusters.
	Note that for compounds in clusters smaller than the cutoff size, they
	will not be considered in this calculation - their entries in 'distmat'
	will be discarded if 'distmat' is provided, and distances involving
	them will not be computed if 'distmat' is not provided.

	To determine the value for 'size.cutoff', you can use
	'cluster.sizestat' to see the size distribution of clusters.

	Because 'cmp.cluster' function allows you to perform multiple clustering
	processes simultaneously with different cutoff values, the 'cls' parameter
	may point to a data frame containing multiple clustering results. The user 
	can use 'cluster.result' to specify which result to use. By default, this
	is set to 1, and the first clustering result will be used in visualization.
	Whatever the value is, in interactive mode (described below), all clustering
	result will be displayed when a compound is selected in the interactive plot.

	If the colors provided in 'color.vector' are not enough to distinguish
	clusters by colors, the function will silently reuse the colors,
	resulting multiple clusters colored in the same color. We suggest you
	use 'cluster.sizestat' to see how many clusters will be selected using
	your 'size.cutoff', or simply provide no 'color.vector'.

	If 'non.interative' is not set, the final plot is interactive. You will
	be able to select points by clicking them. When you click on any point,
	information about the compound represented by that point will be displayed.
	This includes the cluster ID, cluster size, compound index in the SDF
	and compound name if any. You can then perform another
	selection. To exit this process, right click on X11 device or press ESC
	in non-X11 device (Quartz and Windows).

	By default, 'dimensions' is set to 2, and the built-in 'plot' function will
	be used for plotting. If you need to do 3-Dimensional plotting, set 'dimensions'
	to 3, and pass the returned value to 3D plot utilities, such as 'scatterplot3d'
	or 'rggobi'. This package does not perform 3D plot on its own.
}
\value{
	This function returns a data frame of MDS coordinates and clustering
	result. This value can be passed to 3D plot utilities such as
	'scatterplot3d' and 'rggobi'.

	The last column of the output gives whether the compounds have been
clicked in the interactive mode.
}
\author{Y. Eddie Cao}
\seealso{\code{\link{cmp.parse}}, \code{\link{cmp.cluster}}, \code{\link{cluster.sizestat}}}
\examples{
## Load sample SD file
# data(sdfsample); sdfset <- sdfsample

## Generate atom pair descriptor database for searching
# apset <- sdf2ap(sdfset) 

## Loads same atom pair sample data set provided by library
data(apset) 
db <- apset

## cluster db with 2 cutoffs
clusters <- cmp.cluster(db, cutoff=c(0.5, 0.4))

## Return size stats
sizestat <- cluster.sizestat(clusters)

## Visualize results, using a cutoff of 3, write to file 'test.eps'
coord <- cluster.visualize(db, clusters, 2, non.interactive="test.eps")

\dontrun{
## visualize it in interactive mode, using a cutoff of 3 and the 2nd clustering result
coord <- cluster.visualize(db, clusters, cluster.result=2, 3)

## 3D visualization with scatterplot3d
coord <- cluster.visualize(db, clusters, 3, dimensions=3)
library(scatterplot3d)
scatterplot3d(coord)

}
}
\keyword{utilities}

\name{searchString-deprecated}
\alias{searchString}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
PubChem Similarity (Fingerprint) SMILES Search 
}
\description{
Accepts one SMILES string (Simplified Molecular Input Line Entry Specification)
and performs a >0.95 similarity PubChem fingerprint search, returning the 
hits in an \code{SDFset} container. The ChemMine Tools web service
is used as an intermediate, to translate queries from plain HTTP POST to
a PubChem Power User Gateway (PUG) query.
}
\usage{
searchString(smiles)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{smiles}{
  	  A \code{character} object which contains one SMILES string
}
}
\value{
\item{SDFset}{ for details see ?"SDFset-class"}
}
\references{
PubChem PUG SOAP: http://pubchem.ncbi.nlm.nih.gov/pug_soap/pug_soap_help.html

Chemmine web service: http://chemmine.ucr.edu

PubChem help: http://pubchem.ncbi.nlm.nih.gov/search/help_search.html

SMILES Format: http://en.wikipedia.org/wiki/Chemical_file_format#SMILES
}
\author{
Tyler Backman
}

\examples{
\dontrun{
## search a compound on PubChem
compounds <- searchString("CC(=O)OC1=CC=CC=C1C(=O)O")}
}

\keyword{ utilities }

\name{jarvisPatrick}
\alias{jarvisPatrick}
\title{
Jarvis-Patrick Clustering
}
\description{ 

	Function to perform Jarvis-Patrick clustering. The algorithm requires a
	nearest neighbor table, which consists of neighbors for each item
	in the dataset. This information is then used to join items into clusters
	with the following requirements: 
		(a) they are contained in each other's neighbor list
		(b) they share at least 'k' nearest neighbors
	The nearest neighbor table can be computed with \code{\link{nearestNeighbors}}. 
	For standard Jarvis-Patrick clustering, this function takes the number of neighbors to keep for each item.
	It also has the option of passing a cutoff similarity value instead of the number of neighbors. In this mode, all 
	neighbors which meet the cutoff criteria will be included in the table. 
	This is a setting that is not part of the original Jarvis-Patrick algorithm. It
	allows to generate tighter clusters and to minimize some limitations of this method, such as joining completely
	unrelated items when clustering small data sets. Other extensions, such as the \code{linkage} parameter, can also
	help improve the clustering quality.
}
\usage{
jarvisPatrick(nnm,  k, mode="a1a2b", linkage="single") 
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{nnm}{
      A nearest neighbor table, as produced by \code{\link{nearestNeighbors}}.
	}
  \item{k}{ 
	  Minimum number of nearest neighbors two rows (items) in the nearest neighbor table need to have in common to
	  join them into the same cluster. 
	}
  \item{mode}{ 
	  If \code{mode = "a1a2b"} (default), the clustering is run with both requirements (a) and (b); if
	  \code{mode = "a1b"} then (a) is relaxed to a unidirectional requirement; and if \code{mode = "b"} then only
	  requirement (b) is used. The size of the clusters generated by the different methods increases in this order:
	  "a1a2b" < "a1b" < "b". The run time of method "a1a2b" follows a close to linear relationship, while it is nearly
	  quadratic for the much more exhaustive method "b". Only methods "a1a2b" and "a1b" are suitable for clustering
	  very large data sets (e.g. >50,000 items) in a reasonable amount of time.   
	}
	\item{linkage}{
		Can be one of "single", "average", or "complete", for single linkage, average linkage and complete linkage
		merge requirements, respectively. In the context of Jarvis-Patrick, average linkage means that at least half 
		of the pairs between the clusters under consideration must pass the merge requirement. Similarly, for complete
		linkage, all pairs must pass the merge requirement. Single linkage is the normal case for Jarvis-Patrick and
		just means that at least one pair must meet the requirement.
	}
}
\details{
...
}
\value{ 
	Depending on the setting under the \code{type} argument, the function returns the clustering result in a
	\code{named vector} or a nearest neighbor table as \code{matrix}.
}
\references{ 
	Jarvis RA, Patrick EA (1973) Clustering Using a Similarity Measure Based on Shared Near Neighbors. IEEE
	Transactions on Computers, C22, 1025-1034. URLs: http://davide.eynard.it/teaching/2012_PAMI/JP.pdf,
	http://www.btluke.com/jpclust.html, http://www.daylight.com/dayhtml/doc/cluster/index.pdf
}
\author{
Thomas Girke
}
\note{
...
}
\seealso{
Functions: \code{cmp.cluster}
   \code{\link{trimNeighbors}}
   \code{\link{nearestNeighbors}}
}
\examples{
## Load/create sample APset and FPset 
data(apset)
fpset <- desc2fp(apset)

## Standard Jarvis-Patrick clustering on APset/FPset objects
jarvisPatrick(nearestNeighbors(apset,numNbrs=6), k=5, mode="a1a2b")
jarvisPatrick(nearestNeighbors(fpset,numNbrs=6), k=5, mode="a1a2b")

## Jarvis-Patrick clustering only with requirement (b) 
jarvisPatrick(nearestNeighbors(fpset,numNbrs=6), k=5, mode="b")

## Modified Jarvis-Patrick clustering with minimum similarity 'cutoff' 
## value (here Tanimoto coefficient)
jarvisPatrick(nearestNeighbors(fpset,cutoff=0.6, method="Tanimoto"), k=2 )

## Output nearest neighbor table (matrix)
nnm <- nearestNeighbors(fpset,numNbrs=6)

## Perform clustering on precomputed nearest neighbor table
jarvisPatrick(nnm, k=5)
}
\keyword{utilities}

\name{SDFstr-class}
\Rdversion{1.1}
\docType{class}
\alias{SDFstr-class}
\alias{[,SDFstr-method}
\alias{[[,SDFstr-method}
\alias{[[<-,SDFstr-method}
\alias{[<-,SDFstr-method}
\alias{coerce,character,SDFstr-method}
\alias{coerce,list,SDFstr-method}
\alias{coerce,SDFstr,list-method}
\alias{coerce,SDFstr,SDFset-method}
\alias{length,SDFstr-method}
\alias{sdfstr2list,SDFstr-method}
\alias{sdfstr2list<-,SDFstr-method}
\alias{show,SDFstr-method}

\title{Class "SDFstr"}
\description{
List-like container for storing one or many molecules from an SD (or MOL) file.
Each component of an \code{SDFstr} object stores the SD data line by line from
a single molecule in a character vector. The \code{SDFstr} class is an
intermediate container to import SD files into the more important \code{SDFset}
object or to export the data back from an \code{SDFset} container to a valid SD
file.  }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("SDFstr", ...)}.
%%  ~~ describe objects here ~~ 
}
\section{Slots}{
  \describe{
    \item{\code{a}:}{Object of class \code{"list"} with \code{character} components}
  }
}
\section{Methods}{
  \describe{
    \item{[}{\code{signature(x = "SDFstr")}: subsetting of class with bracket operator }
    \item{[[}{\code{signature(x = "SDFstr")}: returns single component as character vector}
    \item{[[<-}{\code{signature(x = "SDFstr")}: replacement method for single \code{SDFstr} component}
    \item{[<-}{\code{signature(x = "SDFstr")}: replacement method for several \code{SDFstr} components}
    \item{coerce}{\code{signature(from = "character", to = "SDFstr")}: \code{as(character, "SDFstr")} }
    \item{coerce}{\code{signature(from = "list", to = "SDFstr")}: \code{as(list, "SDFstr")}}
    \item{coerce}{\code{signature(from = "SDF", to = "SDFstr")}: \code{as(sdf, "SDFstr")}}
    \item{coerce}{\code{signature(from = "SDFset", to = "SDFstr")}: \code{as(sdfset, "SDFstr")}}
    \item{coerce}{\code{signature(from = "SDFstr", to = "list")}: \code{as(sdfstr, "list")}}
    \item{coerce}{\code{signature(from = "SDFstr", to = "SDFset")}: \code{as(sdfstr, "SDFset")}}
    \item{length}{\code{signature(x = "SDFstr")}: returns length of \code{SDFstr}}
    \item{sdfstr2list}{\code{signature(x = "SDFstr")}: accessor method to return \code{SDFstr} as \code{list}}
    \item{sdfstr2list<-}{\code{signature(x = "SDFstr")}: replacement method for several \code{SDFstr} components }
    \item{show}{\code{signature(object = "SDFstr")}: prints summary of \code{SDFstr}}
	 }
}
\references{
SDF format definition: http://www.symyx.com/downloads/public/ctfile/ctfile.jsp
}
\author{
Thomas Girke
}
\seealso{
Related classes: SDFset, AP, APset

Import function: read.SDFstr("some_SDF_file")
}
\examples{
showClass("SDFstr")

## Instances of SDFstr class
data(sdfsample); sdfset <- sdfsample
sdfstr <- as(sdfset, "SDFstr")
sdfstr[1:4] # print summary of container content 
sdfstr[[1]] # returns character vector

## Import: sdfstr <- read.SDFstr("some_SDF_file")
## Export: write.SDF(sdfstr, "some_file.sdf")

}
\keyword{classes}

\name{sdfstr2list}
\alias{sdfstr2list}
\alias{sdfstr2list<-}
\alias{sdfstr2list-methods}
\title{
\code{SDFstr} to \code{list}
}
\description{
Returns objects of class \code{SDFstr} as \code{list}.
}
\usage{
sdfstr2list(x)
}
\arguments{
  \item{x}{
object of class \code{SDFstr}
}
}
\details{
...
}
\value{
\item{list}{with many of the following components:}
\item{character}{SDF content of one molecule vectorized line by line}
}
\references{
SDF format definition: http://www.symyx.com/downloads/public/ctfile/ctfile.jsp
}
\author{
Thomas Girke
}

\seealso{
Functions: \code{sdf2list}, \code{sdf2str}, \code{SDFset2list}, \code{SDFset2SDF}
}
\examples{
## Instance of SDFstr class
data(sdfsample); sdfset <- sdfsample
sdfstr <- as(sdfset, "SDFstr")

## Return as list
sdfstr2list(sdfstr)
as(sdfstr, "list") # similar result
}
\keyword{ utilities }

\name{largestComponent}
\alias{largestComponent}
\title{
	Largest Component	
}
\description{
	If a single compound in an SDF file contains more than one disconnected
	component, this function will return an SDF with only the largest component,
	removing all other components. This will be applied to each SDF in the given
	SDFset.
}
\usage{
	largestComponent(sdfSet)
}
\arguments{
  \item{sdfSet}{
	  any SDFset object.
	}
}
\value{
	a new SDFset containing only single component compounds.
}
\author{
	Kevin Horan
}
\examples{
	\dontrun{
		sdf = smiles2sdf(c("Cl.CCC1C2CC3C4C5(CC(C2C5O)N3C1O)C6=CC=CC=C6N4C	TEST"))
		lg = largestComponent(sdf)
	}

}

\name{addNewFeatures}
\alias{addNewFeatures}
\title{
   Add New Features
}
\description{
   Adds new features to a database without adding any
   data. Note that if you are loading new data anyway, it
   is much more efficient to use the loadSdf function and
   include the new features then. This function will have
   to read all compounds out of the database first.
}
\usage{
addNewFeatures(conn, featureGenerator)
}
\arguments{
  \item{conn}{
	  A database connection object, such as is returned by \code{\link{initDb}}.
   }
  \item{featureGenerator}{
      A function which returns a data frame containing the
      new features. It may also contain features which are
      already in the database, these will simply be
      ignored. See the description of \code{fct} in
      \code{\link{loadSdf}} for details.
   }
}
\value{
   No value is returned.
}
\author{
   Kevin Horan
}

\seealso{
   \code{\link{loadSdf}} 
}
\examples{
   #create and initialize a new SQLite database
   conn = initDb("test.db")

	data(sdfsample)

	#just load the data with no features or descriptors
	ids=loadSdf(conn,sdfsample)
   addNewFeatures(conn, function(sdfset) 
					data.frame(MW = MW(sdfset),  
               rings(sdfset,type="count",upper=6, arom=TRUE))
			 )

	unlink("test.db")

}

\name{sdfStream}
\alias{sdfStream}
\title{
Streaming through large SD files
}
\description{
Streaming function to compute descriptors for large SD Files without consuming much memory. In addition to descriptor values, it returns a line index that defines the positions of each molecule in the source SD File. This line index can be used by the \code{read.SDFindex} function to retrieve specific compounds of interest from large SD Files without reading the entire file into memory.
}
\usage{
sdfStream(input, output, append=FALSE, fct, Nlines = 10000, startline=1, restartNlines=10000, silent = FALSE, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{input}{
file name of input SD file 
}
  \item{output}{
file name of tabular descriptor file
}
  \item{append}{
if \code{append=FALSE}, a new output file will be created, if one with the same name exists it will be overwritten; whereas \code{append=TRUE} will appended to this file.
}
  \item{fct}{
Function to select descriptor sets; any combination of descriptors, supported by \code{ChemmineR}, can be chosen here, as long as they can be represented in tabular format.
}
  \item{Nlines}{
Number of lines to read from input SD File at a time; the memory consumption will be proportional to this value.
}
  \item{startline}{
For restarting sdfStream at specific line assigned to \code{startline} argument. If assigned \code{startline} value does not match the first line of a molecule in the SD file then it will be reset to the start position of the next molecule in the SD file.
}
  \item{restartNlines}{
Number of lines to parse when \code{startline > 1} in order to identify proper molecule start position. The default value of 10,000 is usually a good choice.
}
  \item{silent}{
if \code{silent=FALSE}, the processing status will be printed to the screen, while \code{silent=TRUE} suppresses this output.
}
  \item{\dots}{
Arguments to be passed to/from other methods.
}
}
\details{
...
}
\value{
Writes a descriptor matrix to a tabular file. The first and last line number (position index) of each molecule is specified in the first two columns of the tabular output file, respectively.
}
\references{
SDF format definition: http://www.symyx.com/downloads/public/ctfile/ctfile.jsp
}
\author{
Thomas Girke
}
\seealso{
Import/export functions: \code{read.AP}, \code{read.SDFset}, \code{read.SDFstr}, \code{read.SDFstr}, \code{read.SDFset}, \code{write.SDFsplit}
}
\examples{
## Load sample data
library(ChemmineR)
data(sdfsample); sdfset <- sdfsample
\dontrun{write.SDF(sdfset, "test.sdf")

## Define descriptor set in a simple function
desc <- function(sdfset) {
        cbind(SDFID=sdfid(sdfset), 
              # datablock2ma(datablocklist=datablock(sdfset)), 
              MW=MW(sdfset), 
              groups(sdfset), 
              # AP=sdf2ap(sdfset, type="character"),
              rings(sdfset, type="count", upper=6, arom=TRUE)
        )
}

## Run sdfStream with desc function and write results to a file called 'matrix.xls'
sdfStream(input="test.sdf", output="matrix.xls", append=FALSE, fct=desc, Nlines=1000)

## Same as before but starting in SD file at line number 950
sdfStream(input="test.sdf", output="matrix.xls", append=FALSE, fct=desc, Nlines=1000, startline=950)

## Select molecules from SD File using line index from sdfStream
indexDF <- read.delim("matrix.xls", row.names=1)[,1:4]
indexDFsub <- indexDF[indexDF$MW < 400, ] # Selects molecules with MW < 400
sdfset <- read.SDFindex(file="test.sdf", index=indexDFsub, type="SDFset")

## Write result directly to SD file without storing larger numbers of molecules in memory
read.SDFindex(file="test.sdf", index=indexDFsub, type="file", outfile="sub.sdf")

## Read atom pair string representation from file into APset
apset <- read.AP(file="matrix.xls", colid="AP")
cid(apsdf) <- as.character(indexDF$SDFID)  
}
}
\keyword{ utilities }

\name{openBabelPlot}
\alias{openBabelPlot}
\alias{openBabelPlot}
\title{
	Plot compound structures
}
\description{
	Plots compound structure(s) for molecules stored in SDF and SDFset containers.
}
\usage{
	openBabelPlot(sdfset, height=600, noHbonds = TRUE, regenCoords=FALSE)
}

\arguments{
	\item{sdfset}{
		Object of class \code{SDFset} 
	}
	\item{height}{
		The height of the image in pixels. The generated image is always square, so this will also
		be the width. 
	}
	\item{noHbonds}{
		If \code{TRUE}, then the C-hydrogens and their bonds - explicitly defined in an SDF - are excluded from the plot.
	}
	\item{regenCoords}{
		If ChemmineOB is installed and this option is TRUE, then Open
		Babel will be used to re-generate the 2D coords for each
		compound before plotting it. This often results in a nicer
		layout. If you want to save the results of the coord
		re-generation, call the \code{\link{regenerateCoords}} function
		first yourself and save the result.
	}
}
\details{
	The function \code{openBablePlot} depicts a 2D compound structure based
	on the XY-coordinates specified in the atom block of an SDF.
	If more than one compound is given in the SDFset, they will be arranged in a grid layout.
} 
\author{
	Kevin Horan
}

\seealso{
	\code{sdf.visualize}
}
\examples{
	\dontrun{
	## Import SDFset sample set
	data(sdfsample)
	(sdfset <- sdfsample)

	## Plot single compound structure
	openBabelPlot(sdfset[1])

	## Plot several compounds structures
	openBabelPlot(sdfset[1:4])
	}

}

\keyword{ aplot  }
\keyword{ utilities }

\name{atomprop}
\alias{atomprop}
\docType{data}
\title{
Standard atomic weights
}
\description{
Data frame with atom names, symbols, standard atomic weights, group number and period number.
}
\usage{data(atomprop)}
\format{
  The format is a data frame with 117 rows and 6 columns.
}
\source{
Columns 1 to 4 from: http://iupac.org/publications/pac/78/11/2051/
Columns 5 to 6 from: http://en.wikipedia.org/wiki/List_of_elements
}
\references{
Pure Appl. Chem., 2006, Vol. 78, No. 11, pp. 2051-2066
}
\examples{
data(atomprop)
atomprop[1:4,]
}
\keyword{datasets}

\name{fold}
\alias{fold}
\title{
	Fold
}
\description{
	Fold a fingerprint. This takes the second half of the fingerprints
	and combines with the first half with a logical 'OR' operation. The
	result is a fingerprint with half as many bits.
}
\usage{
fold(x, count = 1, bits = NULL)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{The fingerprint(s) to fold. This can be either an \code{FP}
	  or an \code{FPset} object.
	}
  \item{count}{
	  The number of times to fold this fingerprint. Folding will stop
	  early if the fingerprint is reduced down to 1 bit before reaching
	  the requested fold count.
	}
  \item{bits}{
	  Fold this fingerprint until it is \code{bits} bits long. An
	  exception will be thrown if \code{bits} is not reachable.
	}
}
\value{
	The new, folded, fingerprint.
}
\author{
	Kevin Horan
}
\examples{
	fp = new("FP",fp=c(1,0,1,1, 0,0,1,0))
	foldedFp = fold(fp,bits=4)
}

\name{sdfsample}
\alias{sdfsample}
\docType{data}
\title{
SD file in \code{SDFset} object
}
\description{
First 100 compounds from PubChem SD file: Compound_00650001_00675000.sdf.gz
}
\usage{data(sdfsample)}
\format{
  Object of class \code{sdfset}
}
\details{
Object stores 100 molecules from a sample SD file.
}
\source{
ftp://ftp.ncbi.nih.gov/pubchem/Compound/CURRENT-Full/SDF/Compound_00650001_00675000.sdf.gz
}
\references{
SDF format definition: http://www.symyx.com/downloads/public/ctfile/ctfile.jsp
}
\examples{
data(sdfsample)
sdfset <- sdfsample
view(sdfset[1:4])
}
\keyword{datasets}

\name{datablock}
\alias{datablock}
\alias{datablock<-}
\alias{datablocktag}
\alias{datablock-methods}
\title{
Return data block
}
\description{
Returns data block(s) from an object of class SDF or SDFset.
}
\usage{
datablock(x)

datablocktag(x, tag)
}
\arguments{
\item{x}{
object of class \code{SDF} or \code{SDFset}
}
\item{tag}{
\code{numeric} position (index) or \code{character} name of entry in data block vector
}
}
\details{
...
}
\value{
named \code{character} vector if \code{SDF} is provided or \code{list} of named \code{character} vectors if \code{SDFset} is provided
}
\references{
...
}
\author{
Thomas Girke
}
\seealso{
\code{atomblock}, \code{atomcount}, \code{bondblock}, \code{header}, \code{cid}, \code{sdfid} 
}
\examples{
## SDF/SDFset instances
data(sdfsample)
sdfset <- sdfsample
sdf <- sdfset[[1]]

## Extract data block
datablock(sdf)
datablock(sdfset[1:4])
datablocktag(sdfset, tag="PUBCHEM_OPENEYE_CAN_SMILES")

## Replacement methods
sdfset[[1]][[1]][1] <- "test"
sdfset[[1]]
datablock(sdfset)[1] <- datablock(sdfset[2])  
view(sdfset[1:2])

## Example for injecting a custom matrix/data frame into the data block of an
## SDFset and then writing it to an SD file
props <- data.frame(MF=MF(sdfset), MW=MW(sdfset), atomcountMA(sdfset))
datablock(sdfset) <- props
view(sdfset[1:4])
# write.SDF(sdfset[1:4], file="sub.sdf", sig=TRUE, cid=TRUE)

}

\keyword{ utilities }

\name{canonicalize}
\alias{canonicalize}
\title{
	Canonicalize
}
\description{
	Canonicalizes the atom numbering of a compound. The implimentation
	of this function is in Open Babel and requires the ChemmineOB
	package to function. 
}
\usage{
canonicalize(sdf)
}
\arguments{
  \item{sdf}{
	  Any sdfset object.
	}
}
\value{
	A new SDFset in which all compounds have been canonicalized
}
\references{
	http://openbabel.org/api/2.3/canonical_code_algorithm.shtml
}
\author{
	Kevin Horan
}
\seealso{
\code{\link{canonicalNumbering}}
}

\examples{
	\dontrun{
	data(sdfsample)
	canonicalSdf = canonicalize(sdfsample[1])
	}
}
\keyword{canonical}
\keyword{morgan}
